package mods.fossil.client;

import net.minecraft.client.Minecraft;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

public class CfgLoader
{
    private static final File cfgdir = new File(Minecraft.getMinecraft().mcDataDir, "/config/");
    private static final File cfgfile = new File(cfgdir, "ModFossil.cfg");
    public static final Properties props = new Properties();

    public static Properties loadConfig() throws IOException
    {
        cfgdir.mkdir();

        if (!cfgfile.exists() && !cfgfile.createNewFile())
        {
            return null;
        }
        else if (cfgfile.canRead())
        {
            FileInputStream var0 = new FileInputStream(cfgfile);
            props.load(var0);
            var0.close();
            return props;
        }
        else
        {
            return null;
        }
    }

    public static void saveConfig(Properties var0) throws IOException
    {
        cfgdir.mkdir();

        if (cfgfile.exists() || cfgfile.createNewFile())
        {
            if (cfgfile.canWrite())
            {
                FileOutputStream var1 = new FileOutputStream(cfgfile);
                var0.store(var1, "ModFossil Config");
                var1.close();
            }
        }
    }
}
