package mods.fossil.fossilAI;

import mods.fossil.Fossil;
import mods.fossil.entity.mob.EntityDinosaur;
import mods.fossil.fossilEnums.EnumOrderType;
import mods.fossil.fossilEnums.EnumSituation;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.item.ItemStack;
import net.minecraft.util.DamageSource;

public class DinoAIStarvation extends EntityAIBase
{
    EntityDinosaur mover = null;

    public DinoAIStarvation(EntityDinosaur var1)
    {
        this.mover = var1;
    }

    /**
     * Returns whether the EntityAIBase should begin execution.
     */
    public boolean shouldExecute()
    {
        //if (FossilOptions.DinoHunger)
        //{
        this.mover.decreaseHungerTick();
        return this.mover.getHungerTick() <= 0 && Fossil.FossilOptions.Dinos_Starve;// && this.mover.worldObj.difficultySetting > 0;
        //}
        //return false;
    }

    /**
     * Execute a one shot task or start executing a continuous task
     */
    public void startExecuting()
    {
        //this.mover.getClass();
        this.mover.setHungerTick(300);
        this.mover.decreaseHunger();

        if (!this.mover.worldObj.isRemote)
        {
            if (this.mover.IsDeadlyHungry())
            {
                if (this.mover.OrderStatus != EnumOrderType.FreeMove)
                {
                    this.mover.OrderStatus = EnumOrderType.FreeMove;
                    this.mover.SendStatusMessage(EnumSituation.StarveEsc);
                }
                else
                {
                    this.mover.SendStatusMessage(EnumSituation.Hungry);
                }
            }

            if (this.mover.ItemInMouth != null) //The Dino has something in its mouth and gets hungry
            {
                if (this.mover.SelfType.FoodItemList.CheckItemById(this.mover.ItemInMouth.itemID))
                {
                    //its food
                    if (this.mover.IsHungry() || this.mover.SelfType.MaxHunger - this.mover.getHunger() > this.mover.SelfType.FoodItemList.getItemFood(this.mover.ItemInMouth.itemID))
                    {
                        //it's hungry or there is enough place in the stomach free
                        this.mover.setHunger(this.mover.getHunger() + this.mover.SelfType.FoodItemList.getItemFood(this.mover.ItemInMouth.itemID));
                        this.mover.ItemInMouth = null;
                    }
                }
                else
                {
                    //no food
                    if (this.mover.IsHungry())
                    {
                        //The Dino gets hungry and because of that spits the object out of the mouth
                        this.mover.entityDropItem(new ItemStack(this.mover.ItemInMouth.itemID, 1, 0), 0.5F);
                        this.mover.ItemInMouth = null;
                    }
                }
            }

            if (this.mover.getHunger() <= 0)
            {
                this.handleStarvation();
            }
        }
    }

    private void handleStarvation()
    {
        if (this.mover.getHealth() <= 5)
        {
            this.mover.SendStatusMessage(EnumSituation.Starve);
        }

        this.mover.attackEntityFrom(DamageSource.starve, 5);
    }
}
