package mods.fossil.gens.structure;

import mods.fossil.Fossil;
import net.minecraft.block.Block;
import net.minecraft.world.World;
import net.minecraft.world.gen.feature.WorldGenerator;

import java.util.Random;

public class WorldGeneratorAcademy extends WorldGenerator
{
    protected int[] GetValidSpawnBlocks()
    {
        return new int[]
               {
                   Block.grass.blockID,
                   Block.dirt.blockID,
                   Block.sand.blockID
               };
    }

    public boolean LocationIsValidSpawn(World world, int i, int j, int k)
    {
        int distanceToAir = 1;
        int checkID = world.getBlockId(i, j, k);

        while (checkID != 0)
        {
            distanceToAir++;
            checkID = world.getBlockId(i, j + distanceToAir, k);
        }

        if (distanceToAir > 3)
        {
            return false;
        }

        j += distanceToAir - 1;
        int blockID = world.getBlockId(i, j, k);
        int blockIDAbove = world.getBlockId(i, j + 1, k);
        int blockIDBelow = world.getBlockId(i, j - 1, k);

        for (int x : GetValidSpawnBlocks())
        {
            if (blockIDAbove != 0)
            {
                return false;
            }

            if (blockID == x)
            {
                return true;
            }
            else if (blockID == Block.snow.blockID && blockIDBelow == x)
            {
                return true;
            }
        }

        return false;
    }

    public WorldGeneratorAcademy() { }

    public boolean generate(World world, Random rand, int i, int j, int k)
    {
        //check that each corner is one of the valid spawn blocks
        if (!LocationIsValidSpawn(world, i, j, k) || !LocationIsValidSpawn(world, i + 23, j, k) || !LocationIsValidSpawn(world, i + 23, j, k + 26) || !LocationIsValidSpawn(world, i, j, k + 26))
        {
            return false;
        }

        System.out.println("Generating Academy at " + i + ", " + k);
        j -= 1;
        world.setBlock(i + 0, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 0, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 0, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 0, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 4, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 5, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 6, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 7, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 8, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 9, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 10, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 11, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 12, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 13, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 14, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 15, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 16, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 17, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 18, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 19, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 20, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 21, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 22, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 23, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 24, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 0, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 0, j + 3, k + 0, 0);
        world.setBlock(i + 0, j + 3, k + 2, 0);
        world.setBlock(i + 0, j + 3, k + 3, 0);
        world.setBlock(i + 0, j + 3, k + 5, 0);
        world.setBlock(i + 0, j + 3, k + 13, 0);
        world.setBlock(i + 0, j + 3, k + 24, 0);
        world.setBlock(i + 0, j + 4, k + 0, 0);
        world.setBlock(i + 0, j + 4, k + 1, 0);
        world.setBlock(i + 0, j + 4, k + 2, 0);
        world.setBlock(i + 0, j + 4, k + 3, 0);
        world.setBlock(i + 0, j + 4, k + 4, 0);
        world.setBlock(i + 0, j + 4, k + 5, 0);
        world.setBlock(i + 0, j + 4, k + 6, 0);
        world.setBlock(i + 0, j + 4, k + 7, 0);
        world.setBlock(i + 0, j + 4, k + 8, 0);
        world.setBlock(i + 0, j + 4, k + 9, 0);
        world.setBlock(i + 0, j + 4, k + 10, 0);
        world.setBlock(i + 0, j + 4, k + 11, 0);
        world.setBlock(i + 0, j + 4, k + 12, 0);
        world.setBlock(i + 0, j + 4, k + 13, 0);
        world.setBlock(i + 0, j + 4, k + 14, 0);
        world.setBlock(i + 0, j + 4, k + 15, 0);
        world.setBlock(i + 0, j + 4, k + 16, 0);
        world.setBlock(i + 0, j + 4, k + 17, 0);
        world.setBlock(i + 0, j + 4, k + 18, 0);
        world.setBlock(i + 0, j + 4, k + 19, 0);
        world.setBlock(i + 0, j + 4, k + 20, 0);
        world.setBlock(i + 0, j + 4, k + 21, 0);
        world.setBlock(i + 0, j + 4, k + 22, 0);
        world.setBlock(i + 0, j + 4, k + 23, 0);
        world.setBlock(i + 0, j + 4, k + 24, 0);
        world.setBlock(i + 0, j + 4, k + 25, 0);
        world.setBlock(i + 0, j + 4, k + 26, 0);
        world.setBlock(i + 0, j + 5, k + 0, 0);
        world.setBlock(i + 0, j + 5, k + 1, 0);
        world.setBlock(i + 0, j + 5, k + 2, 0);
        world.setBlock(i + 0, j + 5, k + 3, 0);
        world.setBlock(i + 0, j + 5, k + 4, 0);
        world.setBlock(i + 0, j + 5, k + 5, 0);
        world.setBlock(i + 0, j + 5, k + 6, 0);
        world.setBlock(i + 0, j + 5, k + 7, 0);
        world.setBlock(i + 0, j + 5, k + 8, 0);
        world.setBlock(i + 0, j + 5, k + 9, 0);
        world.setBlock(i + 0, j + 5, k + 10, 0);
        world.setBlock(i + 0, j + 5, k + 11, 0);
        world.setBlock(i + 0, j + 5, k + 12, 0);
        world.setBlock(i + 0, j + 5, k + 13, 0);
        world.setBlock(i + 0, j + 5, k + 14, 0);
        world.setBlock(i + 0, j + 5, k + 15, 0);
        world.setBlock(i + 0, j + 5, k + 16, 0);
        world.setBlock(i + 0, j + 5, k + 17, 0);
        world.setBlock(i + 0, j + 5, k + 18, 0);
        world.setBlock(i + 0, j + 5, k + 19, 0);
        world.setBlock(i + 0, j + 5, k + 20, 0);
        world.setBlock(i + 0, j + 5, k + 21, 0);
        world.setBlock(i + 0, j + 5, k + 22, 0);
        world.setBlock(i + 0, j + 5, k + 23, 0);
        world.setBlock(i + 0, j + 5, k + 24, 0);
        world.setBlock(i + 0, j + 5, k + 25, 0);
        world.setBlock(i + 0, j + 5, k + 26, 0);
        world.setBlock(i + 0, j + 6, k + 0, 0);
        world.setBlock(i + 0, j + 6, k + 1, 0);
        world.setBlock(i + 0, j + 6, k + 2, 0);
        world.setBlock(i + 0, j + 6, k + 3, 0);
        world.setBlock(i + 0, j + 6, k + 4, 0);
        world.setBlock(i + 0, j + 6, k + 5, 0);
        world.setBlock(i + 0, j + 6, k + 6, 0);
        world.setBlock(i + 0, j + 6, k + 7, 0);
        world.setBlock(i + 0, j + 6, k + 8, 0);
        world.setBlock(i + 0, j + 6, k + 9, 0);
        world.setBlock(i + 0, j + 6, k + 10, 0);
        world.setBlock(i + 0, j + 6, k + 11, 0);
        world.setBlock(i + 0, j + 6, k + 12, 0);
        world.setBlock(i + 0, j + 6, k + 13, 0);
        world.setBlock(i + 0, j + 6, k + 14, 0);
        world.setBlock(i + 0, j + 6, k + 15, 0);
        world.setBlock(i + 0, j + 6, k + 16, 0);
        world.setBlock(i + 0, j + 6, k + 17, 0);
        world.setBlock(i + 0, j + 6, k + 18, 0);
        world.setBlock(i + 0, j + 6, k + 19, 0);
        world.setBlock(i + 0, j + 6, k + 20, 0);
        world.setBlock(i + 0, j + 6, k + 21, 0);
        world.setBlock(i + 0, j + 6, k + 22, 0);
        world.setBlock(i + 0, j + 6, k + 23, 0);
        world.setBlock(i + 0, j + 6, k + 24, 0);
        world.setBlock(i + 0, j + 6, k + 25, 0);
        world.setBlock(i + 0, j + 6, k + 26, 0);
        world.setBlock(i + 0, j + 7, k + 0, 0);
        world.setBlock(i + 0, j + 7, k + 1, 0);
        world.setBlock(i + 0, j + 7, k + 2, 0);
        world.setBlock(i + 0, j + 7, k + 3, 0);
        world.setBlock(i + 0, j + 7, k + 4, 0);
        world.setBlock(i + 0, j + 7, k + 5, 0);
        world.setBlock(i + 0, j + 7, k + 6, 0);
        world.setBlock(i + 0, j + 7, k + 7, 0);
        world.setBlock(i + 0, j + 7, k + 8, 0);
        world.setBlock(i + 0, j + 7, k + 9, 0);
        world.setBlock(i + 0, j + 7, k + 10, 0);
        world.setBlock(i + 0, j + 7, k + 11, 0);
        world.setBlock(i + 0, j + 7, k + 12, 0);
        world.setBlock(i + 0, j + 7, k + 13, 0);
        world.setBlock(i + 0, j + 7, k + 14, 0);
        world.setBlock(i + 0, j + 7, k + 15, 0);
        world.setBlock(i + 0, j + 7, k + 16, 0);
        world.setBlock(i + 0, j + 7, k + 17, 0);
        world.setBlock(i + 0, j + 7, k + 18, 0);
        world.setBlock(i + 0, j + 7, k + 19, 0);
        world.setBlock(i + 0, j + 7, k + 20, 0);
        world.setBlock(i + 0, j + 7, k + 21, 0);
        world.setBlock(i + 0, j + 7, k + 22, 0);
        world.setBlock(i + 0, j + 7, k + 23, 0);
        world.setBlock(i + 0, j + 7, k + 24, 0);
        world.setBlock(i + 0, j + 7, k + 25, 0);
        world.setBlock(i + 0, j + 7, k + 26, 0);
        world.setBlock(i + 0, j + 8, k + 0, 0);
        world.setBlock(i + 0, j + 8, k + 1, 0);
        world.setBlock(i + 0, j + 8, k + 2, 0);
        world.setBlock(i + 0, j + 8, k + 3, 0);
        world.setBlock(i + 0, j + 8, k + 4, 0);
        world.setBlock(i + 0, j + 8, k + 5, 0);
        world.setBlock(i + 0, j + 8, k + 6, 0);
        world.setBlock(i + 0, j + 8, k + 7, 0);
        world.setBlock(i + 0, j + 8, k + 8, 0);
        world.setBlock(i + 0, j + 8, k + 9, 0);
        world.setBlock(i + 0, j + 8, k + 10, 0);
        world.setBlock(i + 0, j + 8, k + 11, 0);
        world.setBlock(i + 0, j + 8, k + 12, 0);
        world.setBlock(i + 0, j + 8, k + 13, 0);
        world.setBlock(i + 0, j + 8, k + 14, 0);
        world.setBlock(i + 0, j + 8, k + 15, 0);
        world.setBlock(i + 0, j + 8, k + 16, 0);
        world.setBlock(i + 0, j + 8, k + 17, 0);
        world.setBlock(i + 0, j + 8, k + 18, 0);
        world.setBlock(i + 0, j + 8, k + 19, 0);
        world.setBlock(i + 0, j + 8, k + 20, 0);
        world.setBlock(i + 0, j + 8, k + 21, 0);
        world.setBlock(i + 0, j + 8, k + 22, 0);
        world.setBlock(i + 0, j + 8, k + 23, 0);
        world.setBlock(i + 0, j + 8, k + 24, 0);
        world.setBlock(i + 0, j + 8, k + 25, 0);
        world.setBlock(i + 0, j + 8, k + 26, 0);
        world.setBlock(i + 0, j + 9, k + 0, 0);
        world.setBlock(i + 0, j + 9, k + 1, 0);
        world.setBlock(i + 0, j + 9, k + 2, 0);
        world.setBlock(i + 0, j + 9, k + 3, 0);
        world.setBlock(i + 0, j + 9, k + 4, 0);
        world.setBlock(i + 0, j + 9, k + 5, 0);
        world.setBlock(i + 0, j + 9, k + 6, 0);
        world.setBlock(i + 0, j + 9, k + 7, 0);
        world.setBlock(i + 0, j + 9, k + 8, 0);
        world.setBlock(i + 0, j + 9, k + 9, 0);
        world.setBlock(i + 0, j + 9, k + 10, 0);
        world.setBlock(i + 0, j + 9, k + 11, 0);
        world.setBlock(i + 0, j + 9, k + 12, 0);
        world.setBlock(i + 0, j + 9, k + 13, 0);
        world.setBlock(i + 0, j + 9, k + 14, 0);
        world.setBlock(i + 0, j + 9, k + 15, 0);
        world.setBlock(i + 0, j + 9, k + 16, 0);
        world.setBlock(i + 0, j + 9, k + 17, 0);
        world.setBlock(i + 0, j + 9, k + 18, 0);
        world.setBlock(i + 0, j + 9, k + 19, 0);
        world.setBlock(i + 0, j + 9, k + 20, 0);
        world.setBlock(i + 0, j + 9, k + 21, 0);
        world.setBlock(i + 0, j + 9, k + 22, 0);
        world.setBlock(i + 0, j + 9, k + 23, 0);
        world.setBlock(i + 0, j + 9, k + 24, 0);
        world.setBlock(i + 0, j + 9, k + 25, 0);
        world.setBlock(i + 0, j + 9, k + 26, 0);
        world.setBlock(i + 0, j + 10, k + 0, 0);
        world.setBlock(i + 0, j + 10, k + 1, 0);
        world.setBlock(i + 0, j + 10, k + 2, 0);
        world.setBlock(i + 0, j + 10, k + 3, 0);
        world.setBlock(i + 0, j + 10, k + 4, 0);
        world.setBlock(i + 0, j + 10, k + 5, 0);
        world.setBlock(i + 0, j + 10, k + 6, 0);
        world.setBlock(i + 0, j + 10, k + 7, 0);
        world.setBlock(i + 0, j + 10, k + 8, 0);
        world.setBlock(i + 0, j + 10, k + 9, 0);
        world.setBlock(i + 0, j + 10, k + 10, 0);
        world.setBlock(i + 0, j + 10, k + 11, 0);
        world.setBlock(i + 0, j + 10, k + 12, 0);
        world.setBlock(i + 0, j + 10, k + 13, 0);
        world.setBlock(i + 0, j + 10, k + 14, 0);
        world.setBlock(i + 0, j + 10, k + 15, 0);
        world.setBlock(i + 0, j + 10, k + 16, 0);
        world.setBlock(i + 0, j + 10, k + 17, 0);
        world.setBlock(i + 0, j + 10, k + 18, 0);
        world.setBlock(i + 0, j + 10, k + 19, 0);
        world.setBlock(i + 0, j + 10, k + 20, 0);
        world.setBlock(i + 0, j + 10, k + 21, 0);
        world.setBlock(i + 0, j + 10, k + 22, 0);
        world.setBlock(i + 0, j + 10, k + 23, 0);
        world.setBlock(i + 0, j + 10, k + 24, 0);
        world.setBlock(i + 0, j + 10, k + 25, 0);
        world.setBlock(i + 0, j + 10, k + 26, 0);
        world.setBlock(i + 0, j + 11, k + 0, 0);
        world.setBlock(i + 0, j + 11, k + 1, 0);
        world.setBlock(i + 0, j + 11, k + 2, 0);
        world.setBlock(i + 0, j + 11, k + 3, 0);
        world.setBlock(i + 0, j + 11, k + 4, 0);
        world.setBlock(i + 0, j + 11, k + 5, 0);
        world.setBlock(i + 0, j + 11, k + 6, 0);
        world.setBlock(i + 0, j + 11, k + 7, 0);
        world.setBlock(i + 0, j + 11, k + 8, 0);
        world.setBlock(i + 0, j + 11, k + 9, 0);
        world.setBlock(i + 0, j + 11, k + 10, 0);
        world.setBlock(i + 0, j + 11, k + 11, 0);
        world.setBlock(i + 0, j + 11, k + 12, 0);
        world.setBlock(i + 0, j + 11, k + 13, 0);
        world.setBlock(i + 0, j + 11, k + 14, 0);
        world.setBlock(i + 0, j + 11, k + 15, 0);
        world.setBlock(i + 0, j + 11, k + 16, 0);
        world.setBlock(i + 0, j + 11, k + 17, 0);
        world.setBlock(i + 0, j + 11, k + 18, 0);
        world.setBlock(i + 0, j + 11, k + 19, 0);
        world.setBlock(i + 0, j + 11, k + 20, 0);
        world.setBlock(i + 0, j + 11, k + 21, 0);
        world.setBlock(i + 0, j + 11, k + 22, 0);
        world.setBlock(i + 0, j + 11, k + 23, 0);
        world.setBlock(i + 0, j + 11, k + 24, 0);
        world.setBlock(i + 0, j + 11, k + 25, 0);
        world.setBlock(i + 0, j + 11, k + 26, 0);
        world.setBlock(i + 0, j + 12, k + 0, 0);
        world.setBlock(i + 0, j + 12, k + 1, 0);
        world.setBlock(i + 0, j + 12, k + 2, 0);
        world.setBlock(i + 0, j + 12, k + 3, 0);
        world.setBlock(i + 0, j + 12, k + 4, 0);
        world.setBlock(i + 0, j + 12, k + 5, 0);
        world.setBlock(i + 0, j + 12, k + 6, 0);
        world.setBlock(i + 0, j + 12, k + 7, 0);
        world.setBlock(i + 0, j + 12, k + 8, 0);
        world.setBlock(i + 0, j + 12, k + 9, 0);
        world.setBlock(i + 0, j + 12, k + 10, 0);
        world.setBlock(i + 0, j + 12, k + 11, 0);
        world.setBlock(i + 0, j + 12, k + 12, 0);
        world.setBlock(i + 0, j + 12, k + 13, 0);
        world.setBlock(i + 0, j + 12, k + 14, 0);
        world.setBlock(i + 0, j + 12, k + 15, 0);
        world.setBlock(i + 0, j + 12, k + 16, 0);
        world.setBlock(i + 0, j + 12, k + 17, 0);
        world.setBlock(i + 0, j + 12, k + 18, 0);
        world.setBlock(i + 0, j + 12, k + 19, 0);
        world.setBlock(i + 0, j + 12, k + 20, 0);
        world.setBlock(i + 0, j + 12, k + 21, 0);
        world.setBlock(i + 0, j + 12, k + 22, 0);
        world.setBlock(i + 0, j + 12, k + 23, 0);
        world.setBlock(i + 0, j + 12, k + 24, 0);
        world.setBlock(i + 0, j + 12, k + 25, 0);
        world.setBlock(i + 0, j + 12, k + 26, 0);
        world.setBlock(i + 0, j + 13, k + 0, 0);
        world.setBlock(i + 0, j + 13, k + 1, 0);
        world.setBlock(i + 0, j + 13, k + 2, 0);
        world.setBlock(i + 0, j + 13, k + 3, 0);
        world.setBlock(i + 0, j + 13, k + 4, 0);
        world.setBlock(i + 0, j + 13, k + 5, 0);
        world.setBlock(i + 0, j + 13, k + 6, 0);
        world.setBlock(i + 0, j + 13, k + 7, 0);
        world.setBlock(i + 0, j + 13, k + 8, 0);
        world.setBlock(i + 0, j + 13, k + 9, 0);
        world.setBlock(i + 0, j + 13, k + 10, 0);
        world.setBlock(i + 0, j + 13, k + 11, 0);
        world.setBlock(i + 0, j + 13, k + 12, 0);
        world.setBlock(i + 0, j + 13, k + 13, 0);
        world.setBlock(i + 0, j + 13, k + 14, 0);
        world.setBlock(i + 0, j + 13, k + 15, 0);
        world.setBlock(i + 0, j + 13, k + 16, 0);
        world.setBlock(i + 0, j + 13, k + 17, 0);
        world.setBlock(i + 0, j + 13, k + 18, 0);
        world.setBlock(i + 0, j + 13, k + 19, 0);
        world.setBlock(i + 0, j + 13, k + 20, 0);
        world.setBlock(i + 0, j + 13, k + 21, 0);
        world.setBlock(i + 0, j + 13, k + 22, 0);
        world.setBlock(i + 0, j + 13, k + 23, 0);
        world.setBlock(i + 0, j + 13, k + 24, 0);
        world.setBlock(i + 0, j + 13, k + 25, 0);
        world.setBlock(i + 0, j + 13, k + 26, 0);
        world.setBlock(i + 0, j + 14, k + 0, 0);
        world.setBlock(i + 0, j + 14, k + 1, 0);
        world.setBlock(i + 0, j + 14, k + 2, 0);
        world.setBlock(i + 0, j + 14, k + 3, 0);
        world.setBlock(i + 0, j + 14, k + 4, 0);
        world.setBlock(i + 0, j + 14, k + 5, 0);
        world.setBlock(i + 0, j + 14, k + 6, 0);
        world.setBlock(i + 0, j + 14, k + 7, 0);
        world.setBlock(i + 0, j + 14, k + 8, 0);
        world.setBlock(i + 0, j + 14, k + 9, 0);
        world.setBlock(i + 0, j + 14, k + 10, 0);
        world.setBlock(i + 0, j + 14, k + 11, 0);
        world.setBlock(i + 0, j + 14, k + 12, 0);
        world.setBlock(i + 0, j + 14, k + 13, 0);
        world.setBlock(i + 0, j + 14, k + 14, 0);
        world.setBlock(i + 0, j + 14, k + 15, 0);
        world.setBlock(i + 0, j + 14, k + 16, 0);
        world.setBlock(i + 0, j + 14, k + 17, 0);
        world.setBlock(i + 0, j + 14, k + 18, 0);
        world.setBlock(i + 0, j + 14, k + 19, 0);
        world.setBlock(i + 0, j + 14, k + 20, 0);
        world.setBlock(i + 0, j + 14, k + 21, 0);
        world.setBlock(i + 0, j + 14, k + 22, 0);
        world.setBlock(i + 0, j + 14, k + 23, 0);
        world.setBlock(i + 0, j + 14, k + 24, 0);
        world.setBlock(i + 0, j + 14, k + 25, 0);
        world.setBlock(i + 0, j + 14, k + 26, 0);
        world.setBlock(i + 0, j + 15, k + 0, 0);
        world.setBlock(i + 0, j + 15, k + 1, 0);
        world.setBlock(i + 0, j + 15, k + 2, 0);
        world.setBlock(i + 0, j + 15, k + 3, 0);
        world.setBlock(i + 0, j + 15, k + 4, 0);
        world.setBlock(i + 0, j + 15, k + 5, 0);
        world.setBlock(i + 0, j + 15, k + 6, 0);
        world.setBlock(i + 0, j + 15, k + 7, 0);
        world.setBlock(i + 0, j + 15, k + 8, 0);
        world.setBlock(i + 0, j + 15, k + 9, 0);
        world.setBlock(i + 0, j + 15, k + 10, 0);
        world.setBlock(i + 0, j + 15, k + 11, 0);
        world.setBlock(i + 0, j + 15, k + 12, 0);
        world.setBlock(i + 0, j + 15, k + 13, 0);
        world.setBlock(i + 0, j + 15, k + 14, 0);
        world.setBlock(i + 0, j + 15, k + 15, 0);
        world.setBlock(i + 0, j + 15, k + 16, 0);
        world.setBlock(i + 0, j + 15, k + 17, 0);
        world.setBlock(i + 0, j + 15, k + 18, 0);
        world.setBlock(i + 0, j + 15, k + 19, 0);
        world.setBlock(i + 0, j + 15, k + 20, 0);
        world.setBlock(i + 0, j + 15, k + 21, 0);
        world.setBlock(i + 0, j + 15, k + 22, 0);
        world.setBlock(i + 0, j + 15, k + 23, 0);
        world.setBlock(i + 0, j + 15, k + 24, 0);
        world.setBlock(i + 0, j + 15, k + 25, 0);
        world.setBlock(i + 0, j + 15, k + 26, 0);
        world.setBlock(i + 0, j + 16, k + 0, 0);
        world.setBlock(i + 0, j + 16, k + 1, 0);
        world.setBlock(i + 0, j + 16, k + 2, 0);
        world.setBlock(i + 0, j + 16, k + 3, 0);
        world.setBlock(i + 0, j + 16, k + 4, 0);
        world.setBlock(i + 0, j + 16, k + 5, 0);
        world.setBlock(i + 0, j + 16, k + 6, 0);
        world.setBlock(i + 0, j + 16, k + 7, 0);
        world.setBlock(i + 0, j + 16, k + 8, 0);
        world.setBlock(i + 0, j + 16, k + 9, 0);
        world.setBlock(i + 0, j + 16, k + 10, 0);
        world.setBlock(i + 0, j + 16, k + 11, 0);
        world.setBlock(i + 0, j + 16, k + 12, 0);
        world.setBlock(i + 0, j + 16, k + 13, 0);
        world.setBlock(i + 0, j + 16, k + 14, 0);
        world.setBlock(i + 0, j + 16, k + 15, 0);
        world.setBlock(i + 0, j + 16, k + 16, 0);
        world.setBlock(i + 0, j + 16, k + 17, 0);
        world.setBlock(i + 0, j + 16, k + 18, 0);
        world.setBlock(i + 0, j + 16, k + 19, 0);
        world.setBlock(i + 0, j + 16, k + 20, 0);
        world.setBlock(i + 0, j + 16, k + 21, 0);
        world.setBlock(i + 0, j + 16, k + 22, 0);
        world.setBlock(i + 0, j + 16, k + 23, 0);
        world.setBlock(i + 0, j + 16, k + 24, 0);
        world.setBlock(i + 0, j + 16, k + 25, 0);
        world.setBlock(i + 0, j + 16, k + 26, 0);
        world.setBlock(i + 0, j + 17, k + 0, 0);
        world.setBlock(i + 0, j + 17, k + 1, 0);
        world.setBlock(i + 0, j + 17, k + 2, 0);
        world.setBlock(i + 0, j + 17, k + 3, 0);
        world.setBlock(i + 0, j + 17, k + 4, 0);
        world.setBlock(i + 0, j + 17, k + 5, 0);
        world.setBlock(i + 0, j + 17, k + 6, 0);
        world.setBlock(i + 0, j + 17, k + 7, 0);
        world.setBlock(i + 0, j + 17, k + 8, 0);
        world.setBlock(i + 0, j + 17, k + 9, 0);
        world.setBlock(i + 0, j + 17, k + 10, 0);
        world.setBlock(i + 0, j + 17, k + 11, 0);
        world.setBlock(i + 0, j + 17, k + 12, 0);
        world.setBlock(i + 0, j + 17, k + 13, 0);
        world.setBlock(i + 0, j + 17, k + 14, 0);
        world.setBlock(i + 0, j + 17, k + 15, 0);
        world.setBlock(i + 0, j + 17, k + 16, 0);
        world.setBlock(i + 0, j + 17, k + 17, 0);
        world.setBlock(i + 0, j + 17, k + 18, 0);
        world.setBlock(i + 0, j + 17, k + 19, 0);
        world.setBlock(i + 0, j + 17, k + 20, 0);
        world.setBlock(i + 0, j + 17, k + 21, 0);
        world.setBlock(i + 0, j + 17, k + 22, 0);
        world.setBlock(i + 0, j + 17, k + 23, 0);
        world.setBlock(i + 0, j + 17, k + 24, 0);
        world.setBlock(i + 0, j + 17, k + 25, 0);
        world.setBlock(i + 0, j + 17, k + 26, 0);
        world.setBlock(i + 0, j + 18, k + 0, 0);
        world.setBlock(i + 0, j + 18, k + 1, 0);
        world.setBlock(i + 0, j + 18, k + 2, 0);
        world.setBlock(i + 0, j + 18, k + 3, 0);
        world.setBlock(i + 0, j + 18, k + 4, 0);
        world.setBlock(i + 0, j + 18, k + 5, 0);
        world.setBlock(i + 0, j + 18, k + 6, 0);
        world.setBlock(i + 0, j + 18, k + 7, 0);
        world.setBlock(i + 0, j + 18, k + 8, 0);
        world.setBlock(i + 0, j + 18, k + 9, 0);
        world.setBlock(i + 0, j + 18, k + 10, 0);
        world.setBlock(i + 0, j + 18, k + 11, 0);
        world.setBlock(i + 0, j + 18, k + 12, 0);
        world.setBlock(i + 0, j + 18, k + 13, 0);
        world.setBlock(i + 0, j + 18, k + 14, 0);
        world.setBlock(i + 0, j + 18, k + 15, 0);
        world.setBlock(i + 0, j + 18, k + 16, 0);
        world.setBlock(i + 0, j + 18, k + 17, 0);
        world.setBlock(i + 0, j + 18, k + 18, 0);
        world.setBlock(i + 0, j + 18, k + 19, 0);
        world.setBlock(i + 0, j + 18, k + 20, 0);
        world.setBlock(i + 0, j + 18, k + 21, 0);
        world.setBlock(i + 0, j + 18, k + 22, 0);
        world.setBlock(i + 0, j + 18, k + 23, 0);
        world.setBlock(i + 0, j + 18, k + 24, 0);
        world.setBlock(i + 0, j + 18, k + 25, 0);
        world.setBlock(i + 0, j + 18, k + 26, 0);
        world.setBlock(i + 0, j + 19, k + 0, 0);
        world.setBlock(i + 0, j + 19, k + 1, 0);
        world.setBlock(i + 0, j + 19, k + 2, 0);
        world.setBlock(i + 0, j + 19, k + 3, 0);
        world.setBlock(i + 0, j + 19, k + 4, 0);
        world.setBlock(i + 0, j + 19, k + 5, 0);
        world.setBlock(i + 0, j + 19, k + 6, 0);
        world.setBlock(i + 0, j + 19, k + 7, 0);
        world.setBlock(i + 0, j + 19, k + 8, 0);
        world.setBlock(i + 0, j + 19, k + 9, 0);
        world.setBlock(i + 0, j + 19, k + 10, 0);
        world.setBlock(i + 0, j + 19, k + 11, 0);
        world.setBlock(i + 0, j + 19, k + 12, 0);
        world.setBlock(i + 0, j + 19, k + 13, 0);
        world.setBlock(i + 0, j + 19, k + 14, 0);
        world.setBlock(i + 0, j + 19, k + 15, 0);
        world.setBlock(i + 0, j + 19, k + 16, 0);
        world.setBlock(i + 0, j + 19, k + 17, 0);
        world.setBlock(i + 0, j + 19, k + 18, 0);
        world.setBlock(i + 0, j + 19, k + 19, 0);
        world.setBlock(i + 0, j + 19, k + 20, 0);
        world.setBlock(i + 0, j + 19, k + 21, 0);
        world.setBlock(i + 0, j + 19, k + 22, 0);
        world.setBlock(i + 0, j + 19, k + 23, 0);
        world.setBlock(i + 0, j + 19, k + 24, 0);
        world.setBlock(i + 0, j + 19, k + 25, 0);
        world.setBlock(i + 0, j + 19, k + 26, 0);
        world.setBlock(i + 0, j + 20, k + 0, 0);
        world.setBlock(i + 0, j + 20, k + 1, 0);
        world.setBlock(i + 0, j + 20, k + 2, 0);
        world.setBlock(i + 0, j + 20, k + 3, 0);
        world.setBlock(i + 0, j + 20, k + 4, 0);
        world.setBlock(i + 0, j + 20, k + 5, 0);
        world.setBlock(i + 0, j + 20, k + 6, 0);
        world.setBlock(i + 0, j + 20, k + 7, 0);
        world.setBlock(i + 0, j + 20, k + 8, 0);
        world.setBlock(i + 0, j + 20, k + 9, 0);
        world.setBlock(i + 0, j + 20, k + 10, 0);
        world.setBlock(i + 0, j + 20, k + 11, 0);
        world.setBlock(i + 0, j + 20, k + 12, 0);
        world.setBlock(i + 0, j + 20, k + 13, 0);
        world.setBlock(i + 0, j + 20, k + 14, 0);
        world.setBlock(i + 0, j + 20, k + 15, 0);
        world.setBlock(i + 0, j + 20, k + 16, 0);
        world.setBlock(i + 0, j + 20, k + 17, 0);
        world.setBlock(i + 0, j + 20, k + 18, 0);
        world.setBlock(i + 0, j + 20, k + 19, 0);
        world.setBlock(i + 0, j + 20, k + 20, 0);
        world.setBlock(i + 0, j + 20, k + 21, 0);
        world.setBlock(i + 0, j + 20, k + 22, 0);
        world.setBlock(i + 0, j + 20, k + 23, 0);
        world.setBlock(i + 0, j + 20, k + 24, 0);
        world.setBlock(i + 0, j + 20, k + 25, 0);
        world.setBlock(i + 0, j + 20, k + 26, 0);
        world.setBlock(i + 0, j + 21, k + 0, 0);
        world.setBlock(i + 0, j + 21, k + 1, 0);
        world.setBlock(i + 0, j + 21, k + 2, 0);
        world.setBlock(i + 0, j + 21, k + 3, 0);
        world.setBlock(i + 0, j + 21, k + 4, 0);
        world.setBlock(i + 0, j + 21, k + 5, 0);
        world.setBlock(i + 0, j + 21, k + 6, 0);
        world.setBlock(i + 0, j + 21, k + 7, 0);
        world.setBlock(i + 0, j + 21, k + 8, 0);
        world.setBlock(i + 0, j + 21, k + 9, 0);
        world.setBlock(i + 0, j + 21, k + 10, 0);
        world.setBlock(i + 0, j + 21, k + 11, 0);
        world.setBlock(i + 0, j + 21, k + 12, 0);
        world.setBlock(i + 0, j + 21, k + 13, 0);
        world.setBlock(i + 0, j + 21, k + 14, 0);
        world.setBlock(i + 0, j + 21, k + 15, 0);
        world.setBlock(i + 0, j + 21, k + 16, 0);
        world.setBlock(i + 0, j + 21, k + 17, 0);
        world.setBlock(i + 0, j + 21, k + 18, 0);
        world.setBlock(i + 0, j + 21, k + 19, 0);
        world.setBlock(i + 0, j + 21, k + 20, 0);
        world.setBlock(i + 0, j + 21, k + 21, 0);
        world.setBlock(i + 0, j + 21, k + 22, 0);
        world.setBlock(i + 0, j + 21, k + 23, 0);
        world.setBlock(i + 0, j + 21, k + 24, 0);
        world.setBlock(i + 0, j + 21, k + 25, 0);
        world.setBlock(i + 0, j + 21, k + 26, 0);
        world.setBlock(i + 0, j + 22, k + 0, 0);
        world.setBlock(i + 0, j + 22, k + 1, 0);
        world.setBlock(i + 0, j + 22, k + 2, 0);
        world.setBlock(i + 0, j + 22, k + 3, 0);
        world.setBlock(i + 0, j + 22, k + 4, 0);
        world.setBlock(i + 0, j + 22, k + 5, 0);
        world.setBlock(i + 0, j + 22, k + 6, 0);
        world.setBlock(i + 0, j + 22, k + 7, 0);
        world.setBlock(i + 0, j + 22, k + 8, 0);
        world.setBlock(i + 0, j + 22, k + 9, 0);
        world.setBlock(i + 0, j + 22, k + 10, 0);
        world.setBlock(i + 0, j + 22, k + 11, 0);
        world.setBlock(i + 0, j + 22, k + 12, 0);
        world.setBlock(i + 0, j + 22, k + 13, 0);
        world.setBlock(i + 0, j + 22, k + 14, 0);
        world.setBlock(i + 0, j + 22, k + 15, 0);
        world.setBlock(i + 0, j + 22, k + 16, 0);
        world.setBlock(i + 0, j + 22, k + 17, 0);
        world.setBlock(i + 0, j + 22, k + 18, 0);
        world.setBlock(i + 0, j + 22, k + 19, 0);
        world.setBlock(i + 0, j + 22, k + 20, 0);
        world.setBlock(i + 0, j + 22, k + 21, 0);
        world.setBlock(i + 0, j + 22, k + 22, 0);
        world.setBlock(i + 0, j + 22, k + 23, 0);
        world.setBlock(i + 0, j + 22, k + 24, 0);
        world.setBlock(i + 0, j + 22, k + 25, 0);
        world.setBlock(i + 0, j + 22, k + 26, 0);
        world.setBlock(i + 0, j + 23, k + 0, 0);
        world.setBlock(i + 0, j + 23, k + 1, 0);
        world.setBlock(i + 0, j + 23, k + 2, 0);
        world.setBlock(i + 0, j + 23, k + 3, 0);
        world.setBlock(i + 0, j + 23, k + 4, 0);
        world.setBlock(i + 0, j + 23, k + 5, 0);
        world.setBlock(i + 0, j + 23, k + 6, 0);
        world.setBlock(i + 0, j + 23, k + 7, 0);
        world.setBlock(i + 0, j + 23, k + 8, 0);
        world.setBlock(i + 0, j + 23, k + 9, 0);
        world.setBlock(i + 0, j + 23, k + 10, 0);
        world.setBlock(i + 0, j + 23, k + 11, 0);
        world.setBlock(i + 0, j + 23, k + 12, 0);
        world.setBlock(i + 0, j + 23, k + 13, 0);
        world.setBlock(i + 0, j + 23, k + 14, 0);
        world.setBlock(i + 0, j + 23, k + 15, 0);
        world.setBlock(i + 0, j + 23, k + 16, 0);
        world.setBlock(i + 0, j + 23, k + 17, 0);
        world.setBlock(i + 0, j + 23, k + 18, 0);
        world.setBlock(i + 0, j + 23, k + 19, 0);
        world.setBlock(i + 0, j + 23, k + 20, 0);
        world.setBlock(i + 0, j + 23, k + 21, 0);
        world.setBlock(i + 0, j + 23, k + 22, 0);
        world.setBlock(i + 0, j + 23, k + 23, 0);
        world.setBlock(i + 0, j + 23, k + 24, 0);
        world.setBlock(i + 0, j + 23, k + 25, 0);
        world.setBlock(i + 0, j + 23, k + 26, 0);
        world.setBlock(i + 0, j + 24, k + 0, 0);
        world.setBlock(i + 0, j + 24, k + 1, 0);
        world.setBlock(i + 0, j + 24, k + 2, 0);
        world.setBlock(i + 0, j + 24, k + 3, 0);
        world.setBlock(i + 0, j + 24, k + 4, 0);
        world.setBlock(i + 0, j + 24, k + 5, 0);
        world.setBlock(i + 0, j + 24, k + 6, 0);
        world.setBlock(i + 0, j + 24, k + 7, 0);
        world.setBlock(i + 0, j + 24, k + 8, 0);
        world.setBlock(i + 0, j + 24, k + 9, 0);
        world.setBlock(i + 0, j + 24, k + 10, 0);
        world.setBlock(i + 0, j + 24, k + 11, 0);
        world.setBlock(i + 0, j + 24, k + 12, 0);
        world.setBlock(i + 0, j + 24, k + 13, 0);
        world.setBlock(i + 0, j + 24, k + 14, 0);
        world.setBlock(i + 0, j + 24, k + 15, 0);
        world.setBlock(i + 0, j + 24, k + 16, 0);
        world.setBlock(i + 0, j + 24, k + 17, 0);
        world.setBlock(i + 0, j + 24, k + 18, 0);
        world.setBlock(i + 0, j + 24, k + 19, 0);
        world.setBlock(i + 0, j + 24, k + 20, 0);
        world.setBlock(i + 0, j + 24, k + 21, 0);
        world.setBlock(i + 0, j + 24, k + 22, 0);
        world.setBlock(i + 0, j + 24, k + 23, 0);
        world.setBlock(i + 0, j + 24, k + 24, 0);
        world.setBlock(i + 0, j + 24, k + 25, 0);
        world.setBlock(i + 0, j + 24, k + 26, 0);
        world.setBlock(i + 0, j + 25, k + 0, 0);
        world.setBlock(i + 0, j + 25, k + 1, 0);
        world.setBlock(i + 0, j + 25, k + 2, 0);
        world.setBlock(i + 0, j + 25, k + 3, 0);
        world.setBlock(i + 0, j + 25, k + 4, 0);
        world.setBlock(i + 0, j + 25, k + 5, 0);
        world.setBlock(i + 0, j + 25, k + 6, 0);
        world.setBlock(i + 0, j + 25, k + 7, 0);
        world.setBlock(i + 0, j + 25, k + 8, 0);
        world.setBlock(i + 0, j + 25, k + 9, 0);
        world.setBlock(i + 0, j + 25, k + 10, 0);
        world.setBlock(i + 0, j + 25, k + 11, 0);
        world.setBlock(i + 0, j + 25, k + 12, 0);
        world.setBlock(i + 0, j + 25, k + 13, 0);
        world.setBlock(i + 0, j + 25, k + 14, 0);
        world.setBlock(i + 0, j + 25, k + 15, 0);
        world.setBlock(i + 0, j + 25, k + 16, 0);
        world.setBlock(i + 0, j + 25, k + 17, 0);
        world.setBlock(i + 0, j + 25, k + 18, 0);
        world.setBlock(i + 0, j + 25, k + 19, 0);
        world.setBlock(i + 0, j + 25, k + 20, 0);
        world.setBlock(i + 0, j + 25, k + 21, 0);
        world.setBlock(i + 0, j + 25, k + 22, 0);
        world.setBlock(i + 0, j + 25, k + 23, 0);
        world.setBlock(i + 0, j + 25, k + 24, 0);
        world.setBlock(i + 0, j + 25, k + 25, 0);
        world.setBlock(i + 0, j + 25, k + 26, 0);
        world.setBlock(i + 1, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 1, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 1, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 1, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 4, Block.dirt.blockID);
        world.setBlock(i + 1, j + 2, k + 5, Block.dirt.blockID);
        world.setBlock(i + 1, j + 2, k + 6, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 7, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 8, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 9, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 10, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 11, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 12, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 13, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 2, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 2, k + 16, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 17, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 18, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 19, Block.dirt.blockID);
        world.setBlock(i + 1, j + 2, k + 20, Block.dirt.blockID);
        world.setBlock(i + 1, j + 2, k + 21, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 22, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 23, Block.grass.blockID);
        world.setBlock(i + 1, j + 2, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 2, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 1, j + 3, k + 2, 0);
        world.setBlock(i + 1, j + 3, k + 3, 0);
        world.setBlock(i + 1, j + 3, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 3, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 3, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 3, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 3, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 3, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 3, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 4, k + 0, 0);
        world.setBlock(i + 1, j + 4, k + 1, 0);
        world.setBlock(i + 1, j + 4, k + 2, 0);
        world.setBlock(i + 1, j + 4, k + 3, 0);
        world.setBlock(i + 1, j + 4, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 4, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 4, k + 6, 0);
        world.setBlock(i + 1, j + 4, k + 7, 0);
        world.setBlock(i + 1, j + 4, k + 8, 0);
        world.setBlock(i + 1, j + 4, k + 9, 0);
        world.setBlock(i + 1, j + 4, k + 10, 0);
        world.setBlock(i + 1, j + 4, k + 11, 0);
        world.setBlock(i + 1, j + 4, k + 12, 0);
        world.setBlock(i + 1, j + 4, k + 13, 0);
        world.setBlock(i + 1, j + 4, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 4, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 4, k + 16, 0);
        world.setBlock(i + 1, j + 4, k + 17, 0);
        world.setBlock(i + 1, j + 4, k + 18, 0);
        world.setBlock(i + 1, j + 4, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 4, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 4, k + 21, 0);
        world.setBlock(i + 1, j + 4, k + 22, 0);
        world.setBlock(i + 1, j + 4, k + 23, 0);
        world.setBlock(i + 1, j + 4, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 4, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 4, k + 26, 0);
        world.setBlock(i + 1, j + 5, k + 0, 0);
        world.setBlock(i + 1, j + 5, k + 1, 0);
        world.setBlock(i + 1, j + 5, k + 2, 0);
        world.setBlock(i + 1, j + 5, k + 3, 0);
        world.setBlock(i + 1, j + 5, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 5, k + 6, 0);
        world.setBlock(i + 1, j + 5, k + 7, 0);
        world.setBlock(i + 1, j + 5, k + 8, 0);
        world.setBlock(i + 1, j + 5, k + 9, 0);
        world.setBlock(i + 1, j + 5, k + 10, 0);
        world.setBlock(i + 1, j + 5, k + 11, 0);
        world.setBlock(i + 1, j + 5, k + 12, 0);
        world.setBlock(i + 1, j + 5, k + 13, 0);
        world.setBlock(i + 1, j + 5, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 5, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 5, k + 16, 0);
        world.setBlock(i + 1, j + 5, k + 17, 0);
        world.setBlock(i + 1, j + 5, k + 18, 0);
        world.setBlock(i + 1, j + 5, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 5, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 5, k + 21, 0);
        world.setBlock(i + 1, j + 5, k + 22, 0);
        world.setBlock(i + 1, j + 5, k + 23, 0);
        world.setBlock(i + 1, j + 5, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 5, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 5, k + 26, 0);
        world.setBlock(i + 1, j + 6, k + 0, 0);
        world.setBlock(i + 1, j + 6, k + 1, 0);
        world.setBlock(i + 1, j + 6, k + 2, 0);
        world.setBlock(i + 1, j + 6, k + 3, 0);
        world.setBlock(i + 1, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 6, k + 6, 0);
        world.setBlock(i + 1, j + 6, k + 7, 0);
        world.setBlock(i + 1, j + 6, k + 8, 0);
        world.setBlock(i + 1, j + 6, k + 9, 0);
        world.setBlock(i + 1, j + 6, k + 10, 0);
        world.setBlock(i + 1, j + 6, k + 11, 0);
        world.setBlock(i + 1, j + 6, k + 12, 0);
        world.setBlock(i + 1, j + 6, k + 13, 0);
        world.setBlock(i + 1, j + 6, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 6, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 6, k + 16, 0);
        world.setBlock(i + 1, j + 6, k + 17, 0);
        world.setBlock(i + 1, j + 6, k + 18, 0);
        world.setBlock(i + 1, j + 6, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 6, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 6, k + 21, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 6, k + 22, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 6, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 6, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 6, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 6, k + 26, 0);
        world.setBlock(i + 1, j + 7, k + 0, 0);
        world.setBlock(i + 1, j + 7, k + 1, 0);
        world.setBlock(i + 1, j + 7, k + 2, 0);
        world.setBlock(i + 1, j + 7, k + 3, 0);
        world.setBlock(i + 1, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 7, k + 6, 0);
        world.setBlock(i + 1, j + 7, k + 7, 0);
        world.setBlock(i + 1, j + 7, k + 8, 0);
        world.setBlock(i + 1, j + 7, k + 9, 0);
        world.setBlock(i + 1, j + 7, k + 10, 0);
        world.setBlock(i + 1, j + 7, k + 11, 0);
        world.setBlock(i + 1, j + 7, k + 12, 0);
        world.setBlock(i + 1, j + 7, k + 13, 0);
        world.setBlock(i + 1, j + 7, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 7, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 7, k + 16, 0);
        world.setBlock(i + 1, j + 7, k + 17, 0);
        world.setBlock(i + 1, j + 7, k + 18, 0);
        world.setBlock(i + 1, j + 7, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 7, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 7, k + 21, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 7, k + 22, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 7, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 7, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 7, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 7, k + 26, 0);
        world.setBlock(i + 1, j + 8, k + 0, 0);
        world.setBlock(i + 1, j + 8, k + 1, 0);
        world.setBlock(i + 1, j + 8, k + 2, 0);
        world.setBlock(i + 1, j + 8, k + 3, 0);
        world.setBlock(i + 1, j + 8, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 8, k + 6, 0);
        world.setBlock(i + 1, j + 8, k + 7, 0);
        world.setBlock(i + 1, j + 8, k + 8, 0);
        world.setBlock(i + 1, j + 8, k + 9, 0);
        world.setBlock(i + 1, j + 8, k + 10, 0);
        world.setBlock(i + 1, j + 8, k + 11, 0);
        world.setBlock(i + 1, j + 8, k + 12, 0);
        world.setBlock(i + 1, j + 8, k + 13, 0);
        world.setBlock(i + 1, j + 8, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 8, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 8, k + 16, 0);
        world.setBlock(i + 1, j + 8, k + 17, 0);
        world.setBlock(i + 1, j + 8, k + 18, 0);
        world.setBlock(i + 1, j + 8, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 8, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 8, k + 21, 0);
        world.setBlock(i + 1, j + 8, k + 22, 0);
        world.setBlock(i + 1, j + 8, k + 23, 0);
        world.setBlock(i + 1, j + 8, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 8, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 8, k + 26, 0);
        world.setBlock(i + 1, j + 9, k + 0, 0);
        world.setBlock(i + 1, j + 9, k + 1, 0);
        world.setBlock(i + 1, j + 9, k + 2, 0);
        world.setBlock(i + 1, j + 9, k + 3, 0);
        world.setBlock(i + 1, j + 9, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 7, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 8, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 9, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 10, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 11, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 12, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 13, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 16, Block.web.blockID);
        world.setBlock(i + 1, j + 9, k + 17, Block.web.blockID);
        world.setBlock(i + 1, j + 9, k + 18, 0);
        world.setBlock(i + 1, j + 9, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 21, 0);
        world.setBlock(i + 1, j + 9, k + 22, 0);
        world.setBlock(i + 1, j + 9, k + 23, 0);
        world.setBlock(i + 1, j + 9, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 9, k + 26, 0);
        world.setBlock(i + 1, j + 10, k + 0, 0);
        world.setBlock(i + 1, j + 10, k + 1, 0);
        world.setBlock(i + 1, j + 10, k + 2, 0);
        world.setBlock(i + 1, j + 10, k + 3, 0);
        world.setBlock(i + 1, j + 10, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 7, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 8, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 9, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 10, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 11, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 12, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 13, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 16, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 17, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 18, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 21, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 22, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 10, k + 26, 0);
        world.setBlock(i + 1, j + 11, k + 0, 0);
        world.setBlock(i + 1, j + 11, k + 1, 0);
        world.setBlock(i + 1, j + 11, k + 2, 0);
        world.setBlock(i + 1, j + 11, k + 3, 0);
        world.setBlock(i + 1, j + 11, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 6, 0);
        world.setBlock(i + 1, j + 11, k + 7, 0);
        world.setBlock(i + 1, j + 11, k + 8, 0);
        world.setBlock(i + 1, j + 11, k + 9, 0);
        world.setBlock(i + 1, j + 11, k + 10, 0);
        world.setBlock(i + 1, j + 11, k + 11, 0);
        world.setBlock(i + 1, j + 11, k + 12, 0);
        world.setBlock(i + 1, j + 11, k + 13, 0);
        world.setBlock(i + 1, j + 11, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 16, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 17, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 18, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 21, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 22, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 11, k + 26, 0);
        world.setBlock(i + 1, j + 12, k + 0, 0);
        world.setBlock(i + 1, j + 12, k + 1, 0);
        world.setBlock(i + 1, j + 12, k + 2, 0);
        world.setBlock(i + 1, j + 12, k + 3, 0);
        world.setBlock(i + 1, j + 12, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 12, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 12, k + 6, 0);
        world.setBlock(i + 1, j + 12, k + 7, 0);
        world.setBlock(i + 1, j + 12, k + 8, 0);
        world.setBlock(i + 1, j + 12, k + 9, 0);
        world.setBlock(i + 1, j + 12, k + 10, 0);
        world.setBlock(i + 1, j + 12, k + 11, 0);
        world.setBlock(i + 1, j + 12, k + 12, 0);
        world.setBlock(i + 1, j + 12, k + 13, 0);
        world.setBlock(i + 1, j + 12, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 12, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 12, k + 16, 0);
        world.setBlock(i + 1, j + 12, k + 17, 0);
        world.setBlock(i + 1, j + 12, k + 18, 0);
        world.setBlock(i + 1, j + 12, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 12, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 12, k + 21, 0);
        world.setBlock(i + 1, j + 12, k + 22, 0);
        world.setBlock(i + 1, j + 12, k + 23, 0);
        world.setBlock(i + 1, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 12, k + 26, 0);
        world.setBlock(i + 1, j + 13, k + 0, 0);
        world.setBlock(i + 1, j + 13, k + 1, 0);
        world.setBlock(i + 1, j + 13, k + 2, 0);
        world.setBlock(i + 1, j + 13, k + 3, 0);
        world.setBlock(i + 1, j + 13, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 13, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 13, k + 6, Block.web.blockID);
        world.setBlock(i + 1, j + 13, k + 7, 0);
        world.setBlock(i + 1, j + 13, k + 8, 0);
        world.setBlock(i + 1, j + 13, k + 9, 0);
        world.setBlock(i + 1, j + 13, k + 10, 0);
        world.setBlock(i + 1, j + 13, k + 11, 0);
        world.setBlock(i + 1, j + 13, k + 12, 0);
        world.setBlock(i + 1, j + 13, k + 13, 0);
        world.setBlock(i + 1, j + 13, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 13, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 13, k + 16, 0);
        world.setBlock(i + 1, j + 13, k + 17, 0);
        world.setBlock(i + 1, j + 13, k + 18, 0);
        world.setBlock(i + 1, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 13, k + 21, 0);
        world.setBlock(i + 1, j + 13, k + 22, 0);
        world.setBlock(i + 1, j + 13, k + 23, 0);
        world.setBlock(i + 1, j + 13, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 13, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 13, k + 26, 0);
        world.setBlock(i + 1, j + 14, k + 0, 0);
        world.setBlock(i + 1, j + 14, k + 1, 0);
        world.setBlock(i + 1, j + 14, k + 2, 0);
        world.setBlock(i + 1, j + 14, k + 3, 0);
        world.setBlock(i + 1, j + 14, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 14, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 14, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 14, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 14, k + 16, 0);
        world.setBlock(i + 1, j + 14, k + 17, 0);
        world.setBlock(i + 1, j + 14, k + 18, 0);
        world.setBlock(i + 1, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 14, k + 21, 0);
        world.setBlock(i + 1, j + 14, k + 22, 0);
        world.setBlock(i + 1, j + 14, k + 23, 0);
        world.setBlock(i + 1, j + 14, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 14, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 1, j + 14, k + 26, 0);
        world.setBlock(i + 1, j + 15, k + 0, 0);
        world.setBlock(i + 1, j + 15, k + 1, 0);
        world.setBlock(i + 1, j + 15, k + 2, 0);
        world.setBlock(i + 1, j + 15, k + 3, 0);
        world.setBlock(i + 1, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 16, 0);
        world.setBlock(i + 1, j + 15, k + 17, 0);
        world.setBlock(i + 1, j + 15, k + 18, 0);
        world.setBlock(i + 1, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 21, 0);
        world.setBlock(i + 1, j + 15, k + 22, 0);
        world.setBlock(i + 1, j + 15, k + 23, 0);
        world.setBlock(i + 1, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 15, k + 26, 0);
        world.setBlock(i + 1, j + 16, k + 0, 0);
        world.setBlock(i + 1, j + 16, k + 1, 0);
        world.setBlock(i + 1, j + 16, k + 2, 0);
        world.setBlock(i + 1, j + 16, k + 3, 0);
        world.setBlock(i + 1, j + 16, k + 4, 0);
        world.setBlock(i + 1, j + 16, k + 5, 0);
        world.setBlock(i + 1, j + 16, k + 6, 0);
        world.setBlock(i + 1, j + 16, k + 7, 0);
        world.setBlock(i + 1, j + 16, k + 8, 0);
        world.setBlock(i + 1, j + 16, k + 9, 0);
        world.setBlock(i + 1, j + 16, k + 10, 0);
        world.setBlock(i + 1, j + 16, k + 11, 0);
        world.setBlock(i + 1, j + 16, k + 12, 0);
        world.setBlock(i + 1, j + 16, k + 13, 0);
        world.setBlock(i + 1, j + 16, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 16, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 16, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 16, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 16, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 16, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 16, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 16, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 16, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 16, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 1, j + 16, k + 26, 0);
        world.setBlock(i + 1, j + 17, k + 0, 0);
        world.setBlock(i + 1, j + 17, k + 1, 0);
        world.setBlock(i + 1, j + 17, k + 2, 0);
        world.setBlock(i + 1, j + 17, k + 3, 0);
        world.setBlock(i + 1, j + 17, k + 4, 0);
        world.setBlock(i + 1, j + 17, k + 5, 0);
        world.setBlock(i + 1, j + 17, k + 6, 0);
        world.setBlock(i + 1, j + 17, k + 7, 0);
        world.setBlock(i + 1, j + 17, k + 8, 0);
        world.setBlock(i + 1, j + 17, k + 9, 0);
        world.setBlock(i + 1, j + 17, k + 10, 0);
        world.setBlock(i + 1, j + 17, k + 11, 0);
        world.setBlock(i + 1, j + 17, k + 12, 0);
        world.setBlock(i + 1, j + 17, k + 13, 0);
        world.setBlock(i + 1, j + 17, k + 14, 0);
        world.setBlock(i + 1, j + 17, k + 15, 0);
        world.setBlock(i + 1, j + 17, k + 16, 0);
        world.setBlock(i + 1, j + 17, k + 17, 0);
        world.setBlock(i + 1, j + 17, k + 18, 0);
        world.setBlock(i + 1, j + 17, k + 19, 0);
        world.setBlock(i + 1, j + 17, k + 20, 0);
        world.setBlock(i + 1, j + 17, k + 21, 0);
        world.setBlock(i + 1, j + 17, k + 22, 0);
        world.setBlock(i + 1, j + 17, k + 23, 0);
        world.setBlock(i + 1, j + 17, k + 24, 0);
        world.setBlock(i + 1, j + 17, k + 25, 0);
        world.setBlock(i + 1, j + 17, k + 26, 0);
        world.setBlock(i + 1, j + 18, k + 0, 0);
        world.setBlock(i + 1, j + 18, k + 1, 0);
        world.setBlock(i + 1, j + 18, k + 2, 0);
        world.setBlock(i + 1, j + 18, k + 3, 0);
        world.setBlock(i + 1, j + 18, k + 4, 0);
        world.setBlock(i + 1, j + 18, k + 5, 0);
        world.setBlock(i + 1, j + 18, k + 6, 0);
        world.setBlock(i + 1, j + 18, k + 7, 0);
        world.setBlock(i + 1, j + 18, k + 8, 0);
        world.setBlock(i + 1, j + 18, k + 9, 0);
        world.setBlock(i + 1, j + 18, k + 10, 0);
        world.setBlock(i + 1, j + 18, k + 11, 0);
        world.setBlock(i + 1, j + 18, k + 12, 0);
        world.setBlock(i + 1, j + 18, k + 13, 0);
        world.setBlock(i + 1, j + 18, k + 14, 0);
        world.setBlock(i + 1, j + 18, k + 15, 0);
        world.setBlock(i + 1, j + 18, k + 16, 0);
        world.setBlock(i + 1, j + 18, k + 17, 0);
        world.setBlock(i + 1, j + 18, k + 18, 0);
        world.setBlock(i + 1, j + 18, k + 19, 0);
        world.setBlock(i + 1, j + 18, k + 20, 0);
        world.setBlock(i + 1, j + 18, k + 21, 0);
        world.setBlock(i + 1, j + 18, k + 22, 0);
        world.setBlock(i + 1, j + 18, k + 23, 0);
        world.setBlock(i + 1, j + 18, k + 24, 0);
        world.setBlock(i + 1, j + 18, k + 25, 0);
        world.setBlock(i + 1, j + 18, k + 26, 0);
        world.setBlock(i + 1, j + 19, k + 0, 0);
        world.setBlock(i + 1, j + 19, k + 1, 0);
        world.setBlock(i + 1, j + 19, k + 2, 0);
        world.setBlock(i + 1, j + 19, k + 3, 0);
        world.setBlock(i + 1, j + 19, k + 4, 0);
        world.setBlock(i + 1, j + 19, k + 5, 0);
        world.setBlock(i + 1, j + 19, k + 6, 0);
        world.setBlock(i + 1, j + 19, k + 7, 0);
        world.setBlock(i + 1, j + 19, k + 8, 0);
        world.setBlock(i + 1, j + 19, k + 9, 0);
        world.setBlock(i + 1, j + 19, k + 10, 0);
        world.setBlock(i + 1, j + 19, k + 11, 0);
        world.setBlock(i + 1, j + 19, k + 12, 0);
        world.setBlock(i + 1, j + 19, k + 13, 0);
        world.setBlock(i + 1, j + 19, k + 14, 0);
        world.setBlock(i + 1, j + 19, k + 15, 0);
        world.setBlock(i + 1, j + 19, k + 16, 0);
        world.setBlock(i + 1, j + 19, k + 17, 0);
        world.setBlock(i + 1, j + 19, k + 18, 0);
        world.setBlock(i + 1, j + 19, k + 19, 0);
        world.setBlock(i + 1, j + 19, k + 20, 0);
        world.setBlock(i + 1, j + 19, k + 21, 0);
        world.setBlock(i + 1, j + 19, k + 22, 0);
        world.setBlock(i + 1, j + 19, k + 23, 0);
        world.setBlock(i + 1, j + 19, k + 24, 0);
        world.setBlock(i + 1, j + 19, k + 25, 0);
        world.setBlock(i + 1, j + 19, k + 26, 0);
        world.setBlock(i + 1, j + 20, k + 0, 0);
        world.setBlock(i + 1, j + 20, k + 1, 0);
        world.setBlock(i + 1, j + 20, k + 2, 0);
        world.setBlock(i + 1, j + 20, k + 3, 0);
        world.setBlock(i + 1, j + 20, k + 4, 0);
        world.setBlock(i + 1, j + 20, k + 5, 0);
        world.setBlock(i + 1, j + 20, k + 6, 0);
        world.setBlock(i + 1, j + 20, k + 7, 0);
        world.setBlock(i + 1, j + 20, k + 8, 0);
        world.setBlock(i + 1, j + 20, k + 9, 0);
        world.setBlock(i + 1, j + 20, k + 10, 0);
        world.setBlock(i + 1, j + 20, k + 11, 0);
        world.setBlock(i + 1, j + 20, k + 12, 0);
        world.setBlock(i + 1, j + 20, k + 13, 0);
        world.setBlock(i + 1, j + 20, k + 14, 0);
        world.setBlock(i + 1, j + 20, k + 15, 0);
        world.setBlock(i + 1, j + 20, k + 16, 0);
        world.setBlock(i + 1, j + 20, k + 17, 0);
        world.setBlock(i + 1, j + 20, k + 18, 0);
        world.setBlock(i + 1, j + 20, k + 19, 0);
        world.setBlock(i + 1, j + 20, k + 20, 0);
        world.setBlock(i + 1, j + 20, k + 21, 0);
        world.setBlock(i + 1, j + 20, k + 22, 0);
        world.setBlock(i + 1, j + 20, k + 23, 0);
        world.setBlock(i + 1, j + 20, k + 24, 0);
        world.setBlock(i + 1, j + 20, k + 25, 0);
        world.setBlock(i + 1, j + 20, k + 26, 0);
        world.setBlock(i + 1, j + 21, k + 0, 0);
        world.setBlock(i + 1, j + 21, k + 1, 0);
        world.setBlock(i + 1, j + 21, k + 2, 0);
        world.setBlock(i + 1, j + 21, k + 3, 0);
        world.setBlock(i + 1, j + 21, k + 4, 0);
        world.setBlock(i + 1, j + 21, k + 5, 0);
        world.setBlock(i + 1, j + 21, k + 6, 0);
        world.setBlock(i + 1, j + 21, k + 7, 0);
        world.setBlock(i + 1, j + 21, k + 8, 0);
        world.setBlock(i + 1, j + 21, k + 9, 0);
        world.setBlock(i + 1, j + 21, k + 10, 0);
        world.setBlock(i + 1, j + 21, k + 11, 0);
        world.setBlock(i + 1, j + 21, k + 12, 0);
        world.setBlock(i + 1, j + 21, k + 13, 0);
        world.setBlock(i + 1, j + 21, k + 14, 0);
        world.setBlock(i + 1, j + 21, k + 15, 0);
        world.setBlock(i + 1, j + 21, k + 16, 0);
        world.setBlock(i + 1, j + 21, k + 17, 0);
        world.setBlock(i + 1, j + 21, k + 18, 0);
        world.setBlock(i + 1, j + 21, k + 19, 0);
        world.setBlock(i + 1, j + 21, k + 20, 0);
        world.setBlock(i + 1, j + 21, k + 21, 0);
        world.setBlock(i + 1, j + 21, k + 22, 0);
        world.setBlock(i + 1, j + 21, k + 23, 0);
        world.setBlock(i + 1, j + 21, k + 24, 0);
        world.setBlock(i + 1, j + 21, k + 25, 0);
        world.setBlock(i + 1, j + 21, k + 26, 0);
        world.setBlock(i + 1, j + 22, k + 0, 0);
        world.setBlock(i + 1, j + 22, k + 1, 0);
        world.setBlock(i + 1, j + 22, k + 2, 0);
        world.setBlock(i + 1, j + 22, k + 3, 0);
        world.setBlock(i + 1, j + 22, k + 4, 0);
        world.setBlock(i + 1, j + 22, k + 5, 0);
        world.setBlock(i + 1, j + 22, k + 6, 0);
        world.setBlock(i + 1, j + 22, k + 7, 0);
        world.setBlock(i + 1, j + 22, k + 8, 0);
        world.setBlock(i + 1, j + 22, k + 9, 0);
        world.setBlock(i + 1, j + 22, k + 10, 0);
        world.setBlock(i + 1, j + 22, k + 11, 0);
        world.setBlock(i + 1, j + 22, k + 12, 0);
        world.setBlock(i + 1, j + 22, k + 13, 0);
        world.setBlock(i + 1, j + 22, k + 14, 0);
        world.setBlock(i + 1, j + 22, k + 15, 0);
        world.setBlock(i + 1, j + 22, k + 16, 0);
        world.setBlock(i + 1, j + 22, k + 17, 0);
        world.setBlock(i + 1, j + 22, k + 18, 0);
        world.setBlock(i + 1, j + 22, k + 19, 0);
        world.setBlock(i + 1, j + 22, k + 20, 0);
        world.setBlock(i + 1, j + 22, k + 21, 0);
        world.setBlock(i + 1, j + 22, k + 22, 0);
        world.setBlock(i + 1, j + 22, k + 23, 0);
        world.setBlock(i + 1, j + 22, k + 24, 0);
        world.setBlock(i + 1, j + 22, k + 25, 0);
        world.setBlock(i + 1, j + 22, k + 26, 0);
        world.setBlock(i + 1, j + 23, k + 0, 0);
        world.setBlock(i + 1, j + 23, k + 1, 0);
        world.setBlock(i + 1, j + 23, k + 2, 0);
        world.setBlock(i + 1, j + 23, k + 3, 0);
        world.setBlock(i + 1, j + 23, k + 4, 0);
        world.setBlock(i + 1, j + 23, k + 5, 0);
        world.setBlock(i + 1, j + 23, k + 6, 0);
        world.setBlock(i + 1, j + 23, k + 7, 0);
        world.setBlock(i + 1, j + 23, k + 8, 0);
        world.setBlock(i + 1, j + 23, k + 9, 0);
        world.setBlock(i + 1, j + 23, k + 10, 0);
        world.setBlock(i + 1, j + 23, k + 11, 0);
        world.setBlock(i + 1, j + 23, k + 12, 0);
        world.setBlock(i + 1, j + 23, k + 13, 0);
        world.setBlock(i + 1, j + 23, k + 14, 0);
        world.setBlock(i + 1, j + 23, k + 15, 0);
        world.setBlock(i + 1, j + 23, k + 16, 0);
        world.setBlock(i + 1, j + 23, k + 17, 0);
        world.setBlock(i + 1, j + 23, k + 18, 0);
        world.setBlock(i + 1, j + 23, k + 19, 0);
        world.setBlock(i + 1, j + 23, k + 20, 0);
        world.setBlock(i + 1, j + 23, k + 21, 0);
        world.setBlock(i + 1, j + 23, k + 22, 0);
        world.setBlock(i + 1, j + 23, k + 23, 0);
        world.setBlock(i + 1, j + 23, k + 24, 0);
        world.setBlock(i + 1, j + 23, k + 25, 0);
        world.setBlock(i + 1, j + 23, k + 26, 0);
        world.setBlock(i + 1, j + 24, k + 0, 0);
        world.setBlock(i + 1, j + 24, k + 1, 0);
        world.setBlock(i + 1, j + 24, k + 2, 0);
        world.setBlock(i + 1, j + 24, k + 3, 0);
        world.setBlock(i + 1, j + 24, k + 4, 0);
        world.setBlock(i + 1, j + 24, k + 5, 0);
        world.setBlock(i + 1, j + 24, k + 6, 0);
        world.setBlock(i + 1, j + 24, k + 7, 0);
        world.setBlock(i + 1, j + 24, k + 8, 0);
        world.setBlock(i + 1, j + 24, k + 9, 0);
        world.setBlock(i + 1, j + 24, k + 10, 0);
        world.setBlock(i + 1, j + 24, k + 11, 0);
        world.setBlock(i + 1, j + 24, k + 12, 0);
        world.setBlock(i + 1, j + 24, k + 13, 0);
        world.setBlock(i + 1, j + 24, k + 14, 0);
        world.setBlock(i + 1, j + 24, k + 15, 0);
        world.setBlock(i + 1, j + 24, k + 16, 0);
        world.setBlock(i + 1, j + 24, k + 17, 0);
        world.setBlock(i + 1, j + 24, k + 18, 0);
        world.setBlock(i + 1, j + 24, k + 19, 0);
        world.setBlock(i + 1, j + 24, k + 20, 0);
        world.setBlock(i + 1, j + 24, k + 21, 0);
        world.setBlock(i + 1, j + 24, k + 22, 0);
        world.setBlock(i + 1, j + 24, k + 23, 0);
        world.setBlock(i + 1, j + 24, k + 24, 0);
        world.setBlock(i + 1, j + 24, k + 25, 0);
        world.setBlock(i + 1, j + 24, k + 26, 0);
        world.setBlock(i + 1, j + 25, k + 0, 0);
        world.setBlock(i + 1, j + 25, k + 1, 0);
        world.setBlock(i + 1, j + 25, k + 2, 0);
        world.setBlock(i + 1, j + 25, k + 3, 0);
        world.setBlock(i + 1, j + 25, k + 4, 0);
        world.setBlock(i + 1, j + 25, k + 5, 0);
        world.setBlock(i + 1, j + 25, k + 6, 0);
        world.setBlock(i + 1, j + 25, k + 7, 0);
        world.setBlock(i + 1, j + 25, k + 8, 0);
        world.setBlock(i + 1, j + 25, k + 9, 0);
        world.setBlock(i + 1, j + 25, k + 10, 0);
        world.setBlock(i + 1, j + 25, k + 11, 0);
        world.setBlock(i + 1, j + 25, k + 12, 0);
        world.setBlock(i + 1, j + 25, k + 13, 0);
        world.setBlock(i + 1, j + 25, k + 14, 0);
        world.setBlock(i + 1, j + 25, k + 15, 0);
        world.setBlock(i + 1, j + 25, k + 16, 0);
        world.setBlock(i + 1, j + 25, k + 17, 0);
        world.setBlock(i + 1, j + 25, k + 18, 0);
        world.setBlock(i + 1, j + 25, k + 19, 0);
        world.setBlock(i + 1, j + 25, k + 20, 0);
        world.setBlock(i + 1, j + 25, k + 21, 0);
        world.setBlock(i + 1, j + 25, k + 22, 0);
        world.setBlock(i + 1, j + 25, k + 23, 0);
        world.setBlock(i + 1, j + 25, k + 24, 0);
        world.setBlock(i + 1, j + 25, k + 25, 0);
        world.setBlock(i + 1, j + 25, k + 26, 0);
        world.setBlock(i + 2, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 2, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 2, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 2, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 2, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 2, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 2, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 2, j + 2, k + 4, Block.dirt.blockID);
        world.setBlock(i + 2, j + 2, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 2, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 2, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 2, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 2, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 2, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 2, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 2, j + 3, k + 3, 0);
        world.setBlock(i + 2, j + 3, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 3, k + 6, Block.stoneBrick.blockID, 1, 0);
        world.setBlock(i + 2, j + 3, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 3, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 3, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 3, k + 10, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 2, j + 3, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 3, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 3, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 3, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 3, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 3, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 3, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 3, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 3, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 3, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 3, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 3, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 3, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 3, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 3, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 4, k + 0, 0);
        world.setBlock(i + 2, j + 4, k + 1, 0);
        world.setBlock(i + 2, j + 4, k + 2, 0);
        world.setBlock(i + 2, j + 4, k + 3, 0);
        world.setBlock(i + 2, j + 4, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 4, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 4, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 13, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 2, j + 4, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 4, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 4, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 4, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 4, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 4, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 4, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 4, k + 26, 0);
        world.setBlock(i + 2, j + 5, k + 0, 0);
        world.setBlock(i + 2, j + 5, k + 1, 0);
        world.setBlock(i + 2, j + 5, k + 2, 0);
        generate2(world, rand, i, j, k);
        return true;
    }

    public boolean generate2(World world, Random rand, int i, int j, int k)
    {
        world.setBlock(i + 2, j + 5, k + 3, 0);
        world.setBlock(i + 2, j + 5, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 5, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 5, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 5, k + 8, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 5, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 5, k + 10, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 5, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 5, k + 12, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 5, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 5, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 5, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 5, k + 16, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 5, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 5, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 5, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 5, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 5, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 5, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 5, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 5, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 5, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 5, k + 26, 0);
        world.setBlock(i + 2, j + 6, k + 0, 0);
        world.setBlock(i + 2, j + 6, k + 1, 0);
        world.setBlock(i + 2, j + 6, k + 2, 0);
        world.setBlock(i + 2, j + 6, k + 3, 0);
        world.setBlock(i + 2, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 6, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 6, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 6, k + 8, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 6, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 6, k + 10, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 6, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 6, k + 12, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 6, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 6, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 6, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 6, k + 16, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 6, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 6, k + 18, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 6, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 6, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 6, k + 21, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 6, k + 22, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 6, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 6, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 6, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 6, k + 26, 0);
        world.setBlock(i + 2, j + 7, k + 0, 0);
        world.setBlock(i + 2, j + 7, k + 1, 0);
        world.setBlock(i + 2, j + 7, k + 2, 0);
        world.setBlock(i + 2, j + 7, k + 3, 0);
        world.setBlock(i + 2, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 7, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 7, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 7, k + 8, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 7, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 7, k + 10, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 7, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 7, k + 12, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 7, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 7, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 7, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 7, k + 16, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 7, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 7, k + 18, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 7, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 7, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 7, k + 21, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 7, k + 22, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 7, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 7, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 7, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 7, k + 26, 0);
        world.setBlock(i + 2, j + 8, k + 0, 0);
        world.setBlock(i + 2, j + 8, k + 1, 0);
        world.setBlock(i + 2, j + 8, k + 2, 0);
        world.setBlock(i + 2, j + 8, k + 3, 0);
        world.setBlock(i + 2, j + 8, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 8, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 8, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 8, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 8, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 8, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 8, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 8, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 8, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 8, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 8, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 8, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 8, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 8, k + 18, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 8, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 8, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 8, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 8, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 8, k + 23, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 8, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 8, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 8, k + 26, 0);
        world.setBlock(i + 2, j + 9, k + 0, 0);
        world.setBlock(i + 2, j + 9, k + 1, 0);
        world.setBlock(i + 2, j + 9, k + 2, 0);
        world.setBlock(i + 2, j + 9, k + 3, 0);
        world.setBlock(i + 2, j + 9, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 7, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 8, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 9, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 10, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 11, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 12, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 13, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 9, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 9, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 9, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 9, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 9, k + 23, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 9, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 9, k + 26, 0);
        world.setBlock(i + 2, j + 10, k + 0, 0);
        world.setBlock(i + 2, j + 10, k + 1, 0);
        world.setBlock(i + 2, j + 10, k + 2, 0);
        world.setBlock(i + 2, j + 10, k + 3, 0);
        world.setBlock(i + 2, j + 10, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 7, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 8, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 9, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 10, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 11, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 12, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 13, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 16, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 17, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 18, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 21, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 22, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 10, k + 26, 0);
        world.setBlock(i + 2, j + 11, k + 0, 0);
        world.setBlock(i + 2, j + 11, k + 1, 0);
        world.setBlock(i + 2, j + 11, k + 2, 0);
        world.setBlock(i + 2, j + 11, k + 3, 0);
        world.setBlock(i + 2, j + 11, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 11, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 11, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 11, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 11, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 11, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 11, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 11, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 11, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 16, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 17, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 18, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 21, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 22, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 11, k + 26, 0);
        world.setBlock(i + 2, j + 12, k + 0, 0);
        world.setBlock(i + 2, j + 12, k + 1, 0);
        world.setBlock(i + 2, j + 12, k + 2, 0);
        world.setBlock(i + 2, j + 12, k + 3, 0);
        world.setBlock(i + 2, j + 12, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 12, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 12, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 12, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 12, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 12, k + 26, 0);
        world.setBlock(i + 2, j + 13, k + 0, 0);
        world.setBlock(i + 2, j + 13, k + 1, 0);
        world.setBlock(i + 2, j + 13, k + 2, 0);
        world.setBlock(i + 2, j + 13, k + 3, 0);
        world.setBlock(i + 2, j + 13, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 13, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 13, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 13, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 13, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 13, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 13, k + 26, 0);
        world.setBlock(i + 2, j + 14, k + 0, 0);
        world.setBlock(i + 2, j + 14, k + 1, 0);
        world.setBlock(i + 2, j + 14, k + 2, 0);
        world.setBlock(i + 2, j + 14, k + 3, 0);
        world.setBlock(i + 2, j + 14, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 14, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 14, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 14, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 14, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 14, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 2, j + 14, k + 26, 0);
        world.setBlock(i + 2, j + 15, k + 0, 0);
        world.setBlock(i + 2, j + 15, k + 1, 0);
        world.setBlock(i + 2, j + 15, k + 2, 0);
        world.setBlock(i + 2, j + 15, k + 3, 0);
        world.setBlock(i + 2, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 15, k + 5, 0);
        world.setBlock(i + 2, j + 15, k + 6, 0);
        world.setBlock(i + 2, j + 15, k + 7, 0);
        world.setBlock(i + 2, j + 15, k + 8, 0);
        world.setBlock(i + 2, j + 15, k + 9, 0);
        world.setBlock(i + 2, j + 15, k + 10, 0);
        world.setBlock(i + 2, j + 15, k + 11, 0);
        world.setBlock(i + 2, j + 15, k + 12, 0);
        world.setBlock(i + 2, j + 15, k + 13, 0);
        world.setBlock(i + 2, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 15, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 15, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 15, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 15, k + 26, 0);
        world.setBlock(i + 2, j + 16, k + 0, 0);
        world.setBlock(i + 2, j + 16, k + 1, 0);
        world.setBlock(i + 2, j + 16, k + 2, 0);
        world.setBlock(i + 2, j + 16, k + 3, 0);
        world.setBlock(i + 2, j + 16, k + 4, 0);
        world.setBlock(i + 2, j + 16, k + 5, 0);
        world.setBlock(i + 2, j + 16, k + 6, 0);
        world.setBlock(i + 2, j + 16, k + 7, 0);
        world.setBlock(i + 2, j + 16, k + 8, 0);
        world.setBlock(i + 2, j + 16, k + 9, 0);
        world.setBlock(i + 2, j + 16, k + 10, 0);
        world.setBlock(i + 2, j + 16, k + 11, 0);
        world.setBlock(i + 2, j + 16, k + 12, 0);
        world.setBlock(i + 2, j + 16, k + 13, 0);
        world.setBlock(i + 2, j + 16, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 16, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 16, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 16, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 16, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 16, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 16, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 16, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 16, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 16, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 16, k + 26, 0);
        world.setBlock(i + 2, j + 17, k + 0, 0);
        world.setBlock(i + 2, j + 17, k + 1, 0);
        world.setBlock(i + 2, j + 17, k + 2, 0);
        world.setBlock(i + 2, j + 17, k + 3, 0);
        world.setBlock(i + 2, j + 17, k + 4, 0);
        world.setBlock(i + 2, j + 17, k + 5, 0);
        world.setBlock(i + 2, j + 17, k + 6, 0);
        world.setBlock(i + 2, j + 17, k + 7, 0);
        world.setBlock(i + 2, j + 17, k + 8, 0);
        world.setBlock(i + 2, j + 17, k + 9, 0);
        world.setBlock(i + 2, j + 17, k + 10, 0);
        world.setBlock(i + 2, j + 17, k + 11, 0);
        world.setBlock(i + 2, j + 17, k + 12, 0);
        world.setBlock(i + 2, j + 17, k + 13, 0);
        world.setBlock(i + 2, j + 17, k + 14, 0);
        world.setBlock(i + 2, j + 17, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 17, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 17, k + 17, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 17, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 17, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 17, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 17, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 17, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 17, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 17, k + 26, 0);
        world.setBlock(i + 2, j + 18, k + 0, 0);
        world.setBlock(i + 2, j + 18, k + 1, 0);
        world.setBlock(i + 2, j + 18, k + 2, 0);
        world.setBlock(i + 2, j + 18, k + 3, 0);
        world.setBlock(i + 2, j + 18, k + 4, 0);
        world.setBlock(i + 2, j + 18, k + 5, 0);
        world.setBlock(i + 2, j + 18, k + 6, 0);
        world.setBlock(i + 2, j + 18, k + 7, 0);
        world.setBlock(i + 2, j + 18, k + 8, 0);
        world.setBlock(i + 2, j + 18, k + 9, 0);
        world.setBlock(i + 2, j + 18, k + 10, 0);
        world.setBlock(i + 2, j + 18, k + 11, 0);
        world.setBlock(i + 2, j + 18, k + 12, 0);
        world.setBlock(i + 2, j + 18, k + 13, 0);
        world.setBlock(i + 2, j + 18, k + 14, 0);
        world.setBlock(i + 2, j + 18, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 18, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 18, k + 17, Block.thinGlass.blockID);
        world.setBlock(i + 2, j + 18, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 18, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 18, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 18, k + 22, 0);
        world.setBlock(i + 2, j + 18, k + 23, 0);
        world.setBlock(i + 2, j + 18, k + 24, 0);
        world.setBlock(i + 2, j + 18, k + 25, 0);
        world.setBlock(i + 2, j + 18, k + 26, 0);
        world.setBlock(i + 2, j + 19, k + 0, 0);
        world.setBlock(i + 2, j + 19, k + 1, 0);
        world.setBlock(i + 2, j + 19, k + 2, 0);
        world.setBlock(i + 2, j + 19, k + 3, 0);
        world.setBlock(i + 2, j + 19, k + 4, 0);
        world.setBlock(i + 2, j + 19, k + 5, 0);
        world.setBlock(i + 2, j + 19, k + 6, 0);
        world.setBlock(i + 2, j + 19, k + 7, 0);
        world.setBlock(i + 2, j + 19, k + 8, 0);
        world.setBlock(i + 2, j + 19, k + 9, 0);
        world.setBlock(i + 2, j + 19, k + 10, 0);
        world.setBlock(i + 2, j + 19, k + 11, 0);
        world.setBlock(i + 2, j + 19, k + 12, 0);
        world.setBlock(i + 2, j + 19, k + 13, 0);
        world.setBlock(i + 2, j + 19, k + 14, 0);
        world.setBlock(i + 2, j + 19, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 19, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 19, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 19, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 19, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 19, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 2, j + 19, k + 22, 0);
        world.setBlock(i + 2, j + 19, k + 23, 0);
        world.setBlock(i + 2, j + 19, k + 24, 0);
        world.setBlock(i + 2, j + 19, k + 25, 0);
        world.setBlock(i + 2, j + 19, k + 26, 0);
        world.setBlock(i + 2, j + 20, k + 0, 0);
        world.setBlock(i + 2, j + 20, k + 1, 0);
        world.setBlock(i + 2, j + 20, k + 2, 0);
        world.setBlock(i + 2, j + 20, k + 3, 0);
        world.setBlock(i + 2, j + 20, k + 4, 0);
        world.setBlock(i + 2, j + 20, k + 5, 0);
        world.setBlock(i + 2, j + 20, k + 6, 0);
        world.setBlock(i + 2, j + 20, k + 7, 0);
        world.setBlock(i + 2, j + 20, k + 8, 0);
        world.setBlock(i + 2, j + 20, k + 9, 0);
        world.setBlock(i + 2, j + 20, k + 10, 0);
        world.setBlock(i + 2, j + 20, k + 11, 0);
        world.setBlock(i + 2, j + 20, k + 12, 0);
        world.setBlock(i + 2, j + 20, k + 13, 0);
        world.setBlock(i + 2, j + 20, k + 14, 0);
        world.setBlock(i + 2, j + 20, k + 15, 0);
        world.setBlock(i + 2, j + 20, k + 16, 0);
        world.setBlock(i + 2, j + 20, k + 17, 0);
        world.setBlock(i + 2, j + 20, k + 18, 0);
        world.setBlock(i + 2, j + 20, k + 19, 0);
        world.setBlock(i + 2, j + 20, k + 20, 0);
        world.setBlock(i + 2, j + 20, k + 21, 0);
        world.setBlock(i + 2, j + 20, k + 22, 0);
        world.setBlock(i + 2, j + 20, k + 23, 0);
        world.setBlock(i + 2, j + 20, k + 24, 0);
        world.setBlock(i + 2, j + 20, k + 25, 0);
        world.setBlock(i + 2, j + 20, k + 26, 0);
        world.setBlock(i + 2, j + 21, k + 0, 0);
        world.setBlock(i + 2, j + 21, k + 1, 0);
        world.setBlock(i + 2, j + 21, k + 2, 0);
        world.setBlock(i + 2, j + 21, k + 3, 0);
        world.setBlock(i + 2, j + 21, k + 4, 0);
        world.setBlock(i + 2, j + 21, k + 5, 0);
        world.setBlock(i + 2, j + 21, k + 6, 0);
        world.setBlock(i + 2, j + 21, k + 7, 0);
        world.setBlock(i + 2, j + 21, k + 8, 0);
        world.setBlock(i + 2, j + 21, k + 9, 0);
        world.setBlock(i + 2, j + 21, k + 10, 0);
        world.setBlock(i + 2, j + 21, k + 11, 0);
        world.setBlock(i + 2, j + 21, k + 12, 0);
        world.setBlock(i + 2, j + 21, k + 13, 0);
        world.setBlock(i + 2, j + 21, k + 14, 0);
        world.setBlock(i + 2, j + 21, k + 15, 0);
        world.setBlock(i + 2, j + 21, k + 16, 0);
        world.setBlock(i + 2, j + 21, k + 17, 0);
        world.setBlock(i + 2, j + 21, k + 18, 0);
        world.setBlock(i + 2, j + 21, k + 19, 0);
        world.setBlock(i + 2, j + 21, k + 20, 0);
        world.setBlock(i + 2, j + 21, k + 21, 0);
        world.setBlock(i + 2, j + 21, k + 22, 0);
        world.setBlock(i + 2, j + 21, k + 23, 0);
        world.setBlock(i + 2, j + 21, k + 24, 0);
        world.setBlock(i + 2, j + 21, k + 25, 0);
        world.setBlock(i + 2, j + 21, k + 26, 0);
        world.setBlock(i + 2, j + 22, k + 0, 0);
        world.setBlock(i + 2, j + 22, k + 1, 0);
        world.setBlock(i + 2, j + 22, k + 2, 0);
        world.setBlock(i + 2, j + 22, k + 3, 0);
        world.setBlock(i + 2, j + 22, k + 4, 0);
        world.setBlock(i + 2, j + 22, k + 5, 0);
        world.setBlock(i + 2, j + 22, k + 6, 0);
        world.setBlock(i + 2, j + 22, k + 7, 0);
        world.setBlock(i + 2, j + 22, k + 8, 0);
        world.setBlock(i + 2, j + 22, k + 9, 0);
        world.setBlock(i + 2, j + 22, k + 10, 0);
        world.setBlock(i + 2, j + 22, k + 11, 0);
        world.setBlock(i + 2, j + 22, k + 12, 0);
        world.setBlock(i + 2, j + 22, k + 13, 0);
        world.setBlock(i + 2, j + 22, k + 14, 0);
        world.setBlock(i + 2, j + 22, k + 15, 0);
        world.setBlock(i + 2, j + 22, k + 16, 0);
        world.setBlock(i + 2, j + 22, k + 17, 0);
        world.setBlock(i + 2, j + 22, k + 18, 0);
        world.setBlock(i + 2, j + 22, k + 19, 0);
        world.setBlock(i + 2, j + 22, k + 20, 0);
        world.setBlock(i + 2, j + 22, k + 21, 0);
        world.setBlock(i + 2, j + 22, k + 22, 0);
        world.setBlock(i + 2, j + 22, k + 23, 0);
        world.setBlock(i + 2, j + 22, k + 24, 0);
        world.setBlock(i + 2, j + 22, k + 25, 0);
        world.setBlock(i + 2, j + 22, k + 26, 0);
        world.setBlock(i + 2, j + 23, k + 0, 0);
        world.setBlock(i + 2, j + 23, k + 1, 0);
        world.setBlock(i + 2, j + 23, k + 2, 0);
        world.setBlock(i + 2, j + 23, k + 3, 0);
        world.setBlock(i + 2, j + 23, k + 4, 0);
        world.setBlock(i + 2, j + 23, k + 5, 0);
        world.setBlock(i + 2, j + 23, k + 6, 0);
        world.setBlock(i + 2, j + 23, k + 7, 0);
        world.setBlock(i + 2, j + 23, k + 8, 0);
        world.setBlock(i + 2, j + 23, k + 9, 0);
        world.setBlock(i + 2, j + 23, k + 10, 0);
        world.setBlock(i + 2, j + 23, k + 11, 0);
        world.setBlock(i + 2, j + 23, k + 12, 0);
        world.setBlock(i + 2, j + 23, k + 13, 0);
        world.setBlock(i + 2, j + 23, k + 14, 0);
        world.setBlock(i + 2, j + 23, k + 15, 0);
        world.setBlock(i + 2, j + 23, k + 16, 0);
        world.setBlock(i + 2, j + 23, k + 17, 0);
        world.setBlock(i + 2, j + 23, k + 18, 0);
        world.setBlock(i + 2, j + 23, k + 19, 0);
        world.setBlock(i + 2, j + 23, k + 20, 0);
        world.setBlock(i + 2, j + 23, k + 21, 0);
        world.setBlock(i + 2, j + 23, k + 22, 0);
        world.setBlock(i + 2, j + 23, k + 23, 0);
        world.setBlock(i + 2, j + 23, k + 24, 0);
        world.setBlock(i + 2, j + 23, k + 25, 0);
        world.setBlock(i + 2, j + 23, k + 26, 0);
        world.setBlock(i + 2, j + 24, k + 0, 0);
        world.setBlock(i + 2, j + 24, k + 1, 0);
        world.setBlock(i + 2, j + 24, k + 2, 0);
        world.setBlock(i + 2, j + 24, k + 3, 0);
        world.setBlock(i + 2, j + 24, k + 4, 0);
        world.setBlock(i + 2, j + 24, k + 5, 0);
        world.setBlock(i + 2, j + 24, k + 6, 0);
        world.setBlock(i + 2, j + 24, k + 7, 0);
        world.setBlock(i + 2, j + 24, k + 8, 0);
        world.setBlock(i + 2, j + 24, k + 9, 0);
        world.setBlock(i + 2, j + 24, k + 10, 0);
        world.setBlock(i + 2, j + 24, k + 11, 0);
        world.setBlock(i + 2, j + 24, k + 12, 0);
        world.setBlock(i + 2, j + 24, k + 13, 0);
        world.setBlock(i + 2, j + 24, k + 14, 0);
        world.setBlock(i + 2, j + 24, k + 15, 0);
        world.setBlock(i + 2, j + 24, k + 16, 0);
        world.setBlock(i + 2, j + 24, k + 17, 0);
        world.setBlock(i + 2, j + 24, k + 18, 0);
        world.setBlock(i + 2, j + 24, k + 19, 0);
        world.setBlock(i + 2, j + 24, k + 20, 0);
        world.setBlock(i + 2, j + 24, k + 21, 0);
        world.setBlock(i + 2, j + 24, k + 22, 0);
        world.setBlock(i + 2, j + 24, k + 23, 0);
        world.setBlock(i + 2, j + 24, k + 24, 0);
        world.setBlock(i + 2, j + 24, k + 25, 0);
        world.setBlock(i + 2, j + 24, k + 26, 0);
        world.setBlock(i + 2, j + 25, k + 0, 0);
        world.setBlock(i + 2, j + 25, k + 1, 0);
        world.setBlock(i + 2, j + 25, k + 2, 0);
        world.setBlock(i + 2, j + 25, k + 3, 0);
        world.setBlock(i + 2, j + 25, k + 4, 0);
        world.setBlock(i + 2, j + 25, k + 5, 0);
        world.setBlock(i + 2, j + 25, k + 6, 0);
        world.setBlock(i + 2, j + 25, k + 7, 0);
        world.setBlock(i + 2, j + 25, k + 8, 0);
        world.setBlock(i + 2, j + 25, k + 9, 0);
        world.setBlock(i + 2, j + 25, k + 10, 0);
        world.setBlock(i + 2, j + 25, k + 11, 0);
        world.setBlock(i + 2, j + 25, k + 12, 0);
        world.setBlock(i + 2, j + 25, k + 13, 0);
        world.setBlock(i + 2, j + 25, k + 14, 0);
        world.setBlock(i + 2, j + 25, k + 15, 0);
        world.setBlock(i + 2, j + 25, k + 16, 0);
        world.setBlock(i + 2, j + 25, k + 17, 0);
        world.setBlock(i + 2, j + 25, k + 18, 0);
        world.setBlock(i + 2, j + 25, k + 19, 0);
        world.setBlock(i + 2, j + 25, k + 20, 0);
        world.setBlock(i + 2, j + 25, k + 21, 0);
        world.setBlock(i + 2, j + 25, k + 22, 0);
        world.setBlock(i + 2, j + 25, k + 23, 0);
        world.setBlock(i + 2, j + 25, k + 24, 0);
        world.setBlock(i + 2, j + 25, k + 25, 0);
        world.setBlock(i + 2, j + 25, k + 26, 0);
        world.setBlock(i + 3, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 3, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 3, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 3, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 3, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 3, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 3, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 3, j + 2, k + 4, Block.grass.blockID);
        world.setBlock(i + 3, j + 2, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 6, Block.stoneBrick.blockID, 1, 0);
        world.setBlock(i + 3, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 2, k + 21, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 3, j + 2, k + 22, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 3, j + 2, k + 23, Block.stoneBrick.blockID, 1, 0);
        world.setBlock(i + 3, j + 2, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 2, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 3, j + 3, k + 2, 0);
        world.setBlock(i + 3, j + 3, k + 3, 0);
        world.setBlock(i + 3, j + 3, k + 5, Block.stoneBrick.blockID, 1, 0);
        world.setBlock(i + 3, j + 3, k + 7, 0);
        world.setBlock(i + 3, j + 3, k + 8, 0);
        world.setBlock(i + 3, j + 3, k + 9, 0);
        world.setBlock(i + 3, j + 3, k + 10, 0);
        world.setBlock(i + 3, j + 3, k + 11, 0);
        world.setBlock(i + 3, j + 3, k + 12, 0);
        world.setBlock(i + 3, j + 3, k + 13, 0);
        world.setBlock(i + 3, j + 3, k + 14, 0);
        world.setBlock(i + 3, j + 3, k + 15, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 3, j + 3, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 3, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 3, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 3, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 3, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 3, k + 21, Block.chest.blockID, 5, 0);
        world.setBlock(i + 3, j + 3, k + 22, 0);
        world.setBlock(i + 3, j + 3, k + 23, Block.chest.blockID, 5, 0);
        world.setBlock(i + 3, j + 3, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 3, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 4, k + 0, 0);
        world.setBlock(i + 3, j + 4, k + 1, 0);
        world.setBlock(i + 3, j + 4, k + 2, 0);
        world.setBlock(i + 3, j + 4, k + 3, 0);
        world.setBlock(i + 3, j + 4, k + 4, 0);
        world.setBlock(i + 3, j + 4, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 4, k + 6, 0);
        world.setBlock(i + 3, j + 4, k + 7, 0);
        world.setBlock(i + 3, j + 4, k + 8, 0);
        world.setBlock(i + 3, j + 4, k + 9, 0);
        world.setBlock(i + 3, j + 4, k + 10, 0);
        world.setBlock(i + 3, j + 4, k + 11, 0);
        world.setBlock(i + 3, j + 4, k + 12, 0);
        world.setBlock(i + 3, j + 4, k + 13, 0);
        world.setBlock(i + 3, j + 4, k + 14, 0);
        world.setBlock(i + 3, j + 4, k + 15, 0);
        world.setBlock(i + 3, j + 4, k + 16, 0);
        world.setBlock(i + 3, j + 4, k + 17, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 3, j + 4, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 4, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 4, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 4, k + 21, Block.chest.blockID, 5, 0);
        world.setBlock(i + 3, j + 4, k + 22, 0);
        world.setBlock(i + 3, j + 4, k + 23, Block.chest.blockID, 5, 0);
        world.setBlock(i + 3, j + 4, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 4, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 4, k + 26, 0);
        world.setBlock(i + 3, j + 5, k + 0, 0);
        world.setBlock(i + 3, j + 5, k + 1, 0);
        world.setBlock(i + 3, j + 5, k + 2, 0);
        world.setBlock(i + 3, j + 5, k + 3, 0);
        world.setBlock(i + 3, j + 5, k + 4, 0);
        world.setBlock(i + 3, j + 5, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 5, k + 6, 0);
        world.setBlock(i + 3, j + 5, k + 7, 0);
        world.setBlock(i + 3, j + 5, k + 8, 0);
        world.setBlock(i + 3, j + 5, k + 9, 0);
        world.setBlock(i + 3, j + 5, k + 10, 0);
        world.setBlock(i + 3, j + 5, k + 11, 0);
        world.setBlock(i + 3, j + 5, k + 12, 0);
        world.setBlock(i + 3, j + 5, k + 13, 0);
        world.setBlock(i + 3, j + 5, k + 14, 0);
        world.setBlock(i + 3, j + 5, k + 15, 0);
        world.setBlock(i + 3, j + 5, k + 16, 0);
        world.setBlock(i + 3, j + 5, k + 17, 0);
        world.setBlock(i + 3, j + 5, k + 18, 0);
        world.setBlock(i + 3, j + 5, k + 19, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 3, j + 5, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 5, k + 21, 0);
        world.setBlock(i + 3, j + 5, k + 22, 0);
        world.setBlock(i + 3, j + 5, k + 23, 0);
        world.setBlock(i + 3, j + 5, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 5, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 5, k + 26, 0);
        world.setBlock(i + 3, j + 6, k + 0, 0);
        world.setBlock(i + 3, j + 6, k + 1, 0);
        world.setBlock(i + 3, j + 6, k + 2, 0);
        world.setBlock(i + 3, j + 6, k + 3, 0);
        world.setBlock(i + 3, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 6, k + 6, 0);
        world.setBlock(i + 3, j + 6, k + 7, 0);
        world.setBlock(i + 3, j + 6, k + 8, 0);
        world.setBlock(i + 3, j + 6, k + 9, Block.glowStone.blockID);
        world.setBlock(i + 3, j + 6, k + 10, 0);
        world.setBlock(i + 3, j + 6, k + 11, Block.glowStone.blockID);
        world.setBlock(i + 3, j + 6, k + 12, 0);
        world.setBlock(i + 3, j + 6, k + 13, 0);
        world.setBlock(i + 3, j + 6, k + 14, 0);
        world.setBlock(i + 3, j + 6, k + 15, 0);
        world.setBlock(i + 3, j + 6, k + 16, 0);
        world.setBlock(i + 3, j + 6, k + 17, 0);
        world.setBlock(i + 3, j + 6, k + 18, 0);
        world.setBlock(i + 3, j + 6, k + 19, 0);
        world.setBlock(i + 3, j + 6, k + 20, 0);
        world.setBlock(i + 3, j + 6, k + 21, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 3, j + 6, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 6, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 6, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 6, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 6, k + 26, 0);
        world.setBlock(i + 3, j + 7, k + 0, 0);
        world.setBlock(i + 3, j + 7, k + 1, 0);
        world.setBlock(i + 3, j + 7, k + 2, 0);
        world.setBlock(i + 3, j + 7, k + 3, 0);
        world.setBlock(i + 3, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 7, k + 6, 0);
        world.setBlock(i + 3, j + 7, k + 7, 0);
        world.setBlock(i + 3, j + 7, k + 8, 0);
        world.setBlock(i + 3, j + 7, k + 9, Block.fence.blockID);
        world.setBlock(i + 3, j + 7, k + 10, 0);
        world.setBlock(i + 3, j + 7, k + 11, Block.fence.blockID);
        world.setBlock(i + 3, j + 7, k + 12, 0);
        world.setBlock(i + 3, j + 7, k + 13, 0);
        world.setBlock(i + 3, j + 7, k + 14, 0);
        world.setBlock(i + 3, j + 7, k + 15, 0);
        world.setBlock(i + 3, j + 7, k + 16, 0);
        world.setBlock(i + 3, j + 7, k + 17, 0);
        world.setBlock(i + 3, j + 7, k + 18, 0);
        world.setBlock(i + 3, j + 7, k + 19, 0);
        world.setBlock(i + 3, j + 7, k + 20, 0);
        world.setBlock(i + 3, j + 7, k + 21, 0);
        world.setBlock(i + 3, j + 7, k + 22, 0);
        world.setBlock(i + 3, j + 7, k + 23, 0);
        world.setBlock(i + 3, j + 7, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 7, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 7, k + 26, 0);
        world.setBlock(i + 3, j + 8, k + 0, 0);
        world.setBlock(i + 3, j + 8, k + 1, 0);
        world.setBlock(i + 3, j + 8, k + 2, 0);
        world.setBlock(i + 3, j + 8, k + 3, 0);
        world.setBlock(i + 3, j + 8, k + 4, Block.web.blockID);
        world.setBlock(i + 3, j + 8, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 8, k + 6, Block.web.blockID);
        world.setBlock(i + 3, j + 8, k + 7, 0);
        world.setBlock(i + 3, j + 8, k + 8, 0);
        world.setBlock(i + 3, j + 8, k + 9, 0);
        world.setBlock(i + 3, j + 8, k + 10, 0);
        world.setBlock(i + 3, j + 8, k + 11, 0);
        world.setBlock(i + 3, j + 8, k + 12, 0);
        world.setBlock(i + 3, j + 8, k + 13, 0);
        world.setBlock(i + 3, j + 8, k + 14, 0);
        world.setBlock(i + 3, j + 8, k + 15, 0);
        world.setBlock(i + 3, j + 8, k + 16, 0);
        world.setBlock(i + 3, j + 8, k + 17, Block.glowStone.blockID);
        world.setBlock(i + 3, j + 8, k + 18, 0);
        world.setBlock(i + 3, j + 8, k + 19, 0);
        world.setBlock(i + 3, j + 8, k + 20, 0);
        world.setBlock(i + 3, j + 8, k + 21, 0);
        world.setBlock(i + 3, j + 8, k + 22, 0);
        world.setBlock(i + 3, j + 8, k + 23, 0);
        world.setBlock(i + 3, j + 8, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 8, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 8, k + 26, 0);
        world.setBlock(i + 3, j + 9, k + 0, 0);
        world.setBlock(i + 3, j + 9, k + 1, 0);
        world.setBlock(i + 3, j + 9, k + 2, 0);
        world.setBlock(i + 3, j + 9, k + 3, 0);
        world.setBlock(i + 3, j + 9, k + 4, 0);
        world.setBlock(i + 3, j + 9, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 19, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 3, j + 9, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 9, k + 21, 0);
        world.setBlock(i + 3, j + 9, k + 22, 0);
        world.setBlock(i + 3, j + 9, k + 23, 0);
        world.setBlock(i + 3, j + 9, k + 24, Block.glowStone.blockID);
        world.setBlock(i + 3, j + 9, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 9, k + 26, 0);
        world.setBlock(i + 3, j + 10, k + 0, 0);
        world.setBlock(i + 3, j + 10, k + 1, 0);
        world.setBlock(i + 3, j + 10, k + 2, 0);
        world.setBlock(i + 3, j + 10, k + 3, 0);
        world.setBlock(i + 3, j + 10, k + 4, 0);
        world.setBlock(i + 3, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 10, k + 6, Block.bookShelf.blockID);
        world.setBlock(i + 3, j + 10, k + 7, Block.bookShelf.blockID);
        world.setBlock(i + 3, j + 10, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 10, k + 9, Block.bookShelf.blockID);
        world.setBlock(i + 3, j + 10, k + 10, Block.bookShelf.blockID);
        world.setBlock(i + 3, j + 10, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 10, k + 12, Block.furnaceIdle.blockID, 5, 0);
        world.setBlock(i + 3, j + 10, k + 13, 0);
        world.setBlock(i + 3, j + 10, k + 14, 0);
        world.setBlock(i + 3, j + 10, k + 16, 0);
        world.setBlock(i + 3, j + 10, k + 17, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 3, j + 10, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 10, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 10, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 10, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 10, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 10, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 10, k + 26, 0);
        world.setBlock(i + 3, j + 11, k + 0, 0);
        world.setBlock(i + 3, j + 11, k + 1, 0);
        world.setBlock(i + 3, j + 11, k + 2, 0);
        world.setBlock(i + 3, j + 11, k + 3, 0);
        world.setBlock(i + 3, j + 11, k + 4, 0);
        world.setBlock(i + 3, j + 11, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 11, k + 6, Block.bookShelf.blockID);
        world.setBlock(i + 3, j + 11, k + 7, Block.bookShelf.blockID);
        world.setBlock(i + 3, j + 11, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 11, k + 9, Block.bookShelf.blockID);
        world.setBlock(i + 3, j + 11, k + 10, Block.bookShelf.blockID);
        world.setBlock(i + 3, j + 11, k + 11, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 3, j + 11, k + 12, 0);
        world.setBlock(i + 3, j + 11, k + 13, 0);
        world.setBlock(i + 3, j + 11, k + 14, 0);
        world.setBlock(i + 3, j + 11, k + 16, 0);
        world.setBlock(i + 3, j + 11, k + 17, 0);
        world.setBlock(i + 3, j + 11, k + 18, 0);
        world.setBlock(i + 3, j + 11, k + 19, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 3, j + 11, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 11, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 11, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 11, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 11, k + 26, 0);
        world.setBlock(i + 3, j + 12, k + 0, 0);
        world.setBlock(i + 3, j + 12, k + 1, 0);
        world.setBlock(i + 3, j + 12, k + 2, 0);
        world.setBlock(i + 3, j + 12, k + 3, 0);
        world.setBlock(i + 3, j + 12, k + 4, 0);
        world.setBlock(i + 3, j + 12, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 12, k + 6, Block.bookShelf.blockID);
        world.setBlock(i + 3, j + 12, k + 7, Block.bookShelf.blockID);
        world.setBlock(i + 3, j + 12, k + 8, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 3, j + 12, k + 9, Block.bookShelf.blockID);
        world.setBlock(i + 3, j + 12, k + 10, Block.bookShelf.blockID);
        world.setBlock(i + 3, j + 12, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 12, k + 12, 0);
        world.setBlock(i + 3, j + 12, k + 13, 0);
        world.setBlock(i + 3, j + 12, k + 14, 0);
        world.setBlock(i + 3, j + 12, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 12, k + 16, 0);
        world.setBlock(i + 3, j + 12, k + 17, 0);
        world.setBlock(i + 3, j + 12, k + 18, 0);
        world.setBlock(i + 3, j + 12, k + 19, 0);
        world.setBlock(i + 3, j + 12, k + 20, 0);
        world.setBlock(i + 3, j + 12, k + 21, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 3, j + 12, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 12, k + 26, 0);
        world.setBlock(i + 3, j + 13, k + 0, 0);
        world.setBlock(i + 3, j + 13, k + 1, 0);
        world.setBlock(i + 3, j + 13, k + 2, 0);
        world.setBlock(i + 3, j + 13, k + 3, 0);
        world.setBlock(i + 3, j + 13, k + 4, 0);
        world.setBlock(i + 3, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 13, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 13, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 13, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 13, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 13, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 13, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 13, k + 12, Block.glowStone.blockID);
        world.setBlock(i + 3, j + 13, k + 13, 0);
        world.setBlock(i + 3, j + 13, k + 14, 0);
        world.setBlock(i + 3, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 13, k + 17, Block.glowStone.blockID);
        world.setBlock(i + 3, j + 13, k + 18, 0);
        world.setBlock(i + 3, j + 13, k + 19, 0);
        world.setBlock(i + 3, j + 13, k + 20, 0);
        world.setBlock(i + 3, j + 13, k + 21, 0);
        world.setBlock(i + 3, j + 13, k + 22, 0);
        world.setBlock(i + 3, j + 13, k + 23, 0);
        world.setBlock(i + 3, j + 13, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 13, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 13, k + 26, 0);
        world.setBlock(i + 3, j + 14, k + 0, 0);
        world.setBlock(i + 3, j + 14, k + 1, 0);
        world.setBlock(i + 3, j + 14, k + 2, 0);
        world.setBlock(i + 3, j + 14, k + 3, 0);
        world.setBlock(i + 3, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 14, k + 20, 0);
        world.setBlock(i + 3, j + 14, k + 21, 0);
        world.setBlock(i + 3, j + 14, k + 22, 0);
        world.setBlock(i + 3, j + 14, k + 23, 0);
        world.setBlock(i + 3, j + 14, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 14, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 3, j + 14, k + 26, 0);
        world.setBlock(i + 3, j + 15, k + 0, 0);
        world.setBlock(i + 3, j + 15, k + 1, 0);
        world.setBlock(i + 3, j + 15, k + 2, 0);
        world.setBlock(i + 3, j + 15, k + 3, 0);
        world.setBlock(i + 3, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 15, k + 5, 0);
        world.setBlock(i + 3, j + 15, k + 6, 0);
        world.setBlock(i + 3, j + 15, k + 7, 0);
        world.setBlock(i + 3, j + 15, k + 8, 0);
        world.setBlock(i + 3, j + 15, k + 9, 0);
        world.setBlock(i + 3, j + 15, k + 10, 0);
        world.setBlock(i + 3, j + 15, k + 11, 0);
        world.setBlock(i + 3, j + 15, k + 12, 0);
        world.setBlock(i + 3, j + 15, k + 13, 0);
        world.setBlock(i + 3, j + 15, k + 14, 0);
        world.setBlock(i + 3, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 15, k + 22, 0);
        world.setBlock(i + 3, j + 15, k + 23, 0);
        world.setBlock(i + 3, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 15, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 15, k + 26, 0);
        world.setBlock(i + 3, j + 16, k + 0, 0);
        world.setBlock(i + 3, j + 16, k + 1, 0);
        world.setBlock(i + 3, j + 16, k + 2, 0);
        world.setBlock(i + 3, j + 16, k + 3, 0);
        world.setBlock(i + 3, j + 16, k + 4, 0);
        world.setBlock(i + 3, j + 16, k + 5, 0);
        world.setBlock(i + 3, j + 16, k + 6, 0);
        world.setBlock(i + 3, j + 16, k + 7, 0);
        world.setBlock(i + 3, j + 16, k + 8, 0);
        world.setBlock(i + 3, j + 16, k + 9, 0);
        world.setBlock(i + 3, j + 16, k + 10, 0);
        world.setBlock(i + 3, j + 16, k + 11, 0);
        world.setBlock(i + 3, j + 16, k + 12, 0);
        world.setBlock(i + 3, j + 16, k + 13, 0);
        world.setBlock(i + 3, j + 16, k + 14, 0);
        world.setBlock(i + 3, j + 16, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 16, k + 16, Block.bed.blockID, 9, 0);
        world.setBlock(i + 3, j + 16, k + 17, 0);
        world.setBlock(i + 3, j + 16, k + 18, 0);
        world.setBlock(i + 3, j + 16, k + 19, 0);
        world.setBlock(i + 3, j + 16, k + 20, 0);
        world.setBlock(i + 3, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 16, k + 22, 0);
        world.setBlock(i + 3, j + 16, k + 23, 0);
        world.setBlock(i + 3, j + 16, k + 24, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 3, j + 16, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 16, k + 26, 0);
        world.setBlock(i + 3, j + 17, k + 0, 0);
        world.setBlock(i + 3, j + 17, k + 1, 0);
        world.setBlock(i + 3, j + 17, k + 2, 0);
        world.setBlock(i + 3, j + 17, k + 3, 0);
        world.setBlock(i + 3, j + 17, k + 4, 0);
        world.setBlock(i + 3, j + 17, k + 5, 0);
        world.setBlock(i + 3, j + 17, k + 6, 0);
        world.setBlock(i + 3, j + 17, k + 7, 0);
        world.setBlock(i + 3, j + 17, k + 8, 0);
        world.setBlock(i + 3, j + 17, k + 9, 0);
        world.setBlock(i + 3, j + 17, k + 10, 0);
        world.setBlock(i + 3, j + 17, k + 11, 0);
        world.setBlock(i + 3, j + 17, k + 12, 0);
        world.setBlock(i + 3, j + 17, k + 13, 0);
        world.setBlock(i + 3, j + 17, k + 14, 0);
        world.setBlock(i + 3, j + 17, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 17, k + 16, 0);
        world.setBlock(i + 3, j + 17, k + 17, 0);
        world.setBlock(i + 3, j + 17, k + 18, 0);
        world.setBlock(i + 3, j + 17, k + 19, 0);
        world.setBlock(i + 3, j + 17, k + 20, 0);
        world.setBlock(i + 3, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 17, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 17, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 17, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 17, k + 26, 0);
        world.setBlock(i + 3, j + 18, k + 0, 0);
        world.setBlock(i + 3, j + 18, k + 1, 0);
        world.setBlock(i + 3, j + 18, k + 2, 0);
        world.setBlock(i + 3, j + 18, k + 3, 0);
        world.setBlock(i + 3, j + 18, k + 4, 0);
        world.setBlock(i + 3, j + 18, k + 5, 0);
        world.setBlock(i + 3, j + 18, k + 6, 0);
        world.setBlock(i + 3, j + 18, k + 7, 0);
        world.setBlock(i + 3, j + 18, k + 8, 0);
        world.setBlock(i + 3, j + 18, k + 9, 0);
        world.setBlock(i + 3, j + 18, k + 10, 0);
        world.setBlock(i + 3, j + 18, k + 11, 0);
        world.setBlock(i + 3, j + 18, k + 12, 0);
        world.setBlock(i + 3, j + 18, k + 13, 0);
        world.setBlock(i + 3, j + 18, k + 14, 0);
        world.setBlock(i + 3, j + 18, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 18, k + 16, 0);
        world.setBlock(i + 3, j + 18, k + 17, 0);
        world.setBlock(i + 3, j + 18, k + 18, Block.glowStone.blockID);
        world.setBlock(i + 3, j + 18, k + 19, 0);
        world.setBlock(i + 3, j + 18, k + 20, 0);
        world.setBlock(i + 3, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 18, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 18, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 18, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 18, k + 26, 0);
        world.setBlock(i + 3, j + 19, k + 0, 0);
        world.setBlock(i + 3, j + 19, k + 1, 0);
        world.setBlock(i + 3, j + 19, k + 2, 0);
        world.setBlock(i + 3, j + 19, k + 3, 0);
        world.setBlock(i + 3, j + 19, k + 4, 0);
        world.setBlock(i + 3, j + 19, k + 5, 0);
        world.setBlock(i + 3, j + 19, k + 6, 0);
        world.setBlock(i + 3, j + 19, k + 7, 0);
        world.setBlock(i + 3, j + 19, k + 8, 0);
        world.setBlock(i + 3, j + 19, k + 9, 0);
        world.setBlock(i + 3, j + 19, k + 10, 0);
        world.setBlock(i + 3, j + 19, k + 11, 0);
        world.setBlock(i + 3, j + 19, k + 12, 0);
        world.setBlock(i + 3, j + 19, k + 13, 0);
        world.setBlock(i + 3, j + 19, k + 14, 0);
        world.setBlock(i + 3, j + 19, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 19, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 19, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 19, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 19, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 19, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 3, j + 19, k + 22, 0);
        world.setBlock(i + 3, j + 19, k + 23, 0);
        world.setBlock(i + 3, j + 19, k + 24, 0);
        world.setBlock(i + 3, j + 19, k + 25, 0);
        world.setBlock(i + 3, j + 19, k + 26, 0);
        world.setBlock(i + 3, j + 20, k + 0, 0);
        world.setBlock(i + 3, j + 20, k + 1, 0);
        world.setBlock(i + 3, j + 20, k + 2, 0);
        world.setBlock(i + 3, j + 20, k + 3, 0);
        world.setBlock(i + 3, j + 20, k + 4, 0);
        world.setBlock(i + 3, j + 20, k + 5, 0);
        world.setBlock(i + 3, j + 20, k + 6, 0);
        world.setBlock(i + 3, j + 20, k + 7, 0);
        world.setBlock(i + 3, j + 20, k + 8, 0);
        world.setBlock(i + 3, j + 20, k + 9, 0);
        world.setBlock(i + 3, j + 20, k + 10, 0);
        world.setBlock(i + 3, j + 20, k + 11, 0);
        world.setBlock(i + 3, j + 20, k + 12, 0);
        world.setBlock(i + 3, j + 20, k + 13, 0);
        world.setBlock(i + 3, j + 20, k + 14, 0);
        world.setBlock(i + 3, j + 20, k + 15, 0);
        world.setBlock(i + 3, j + 20, k + 16, 0);
        world.setBlock(i + 3, j + 20, k + 17, 0);
        world.setBlock(i + 3, j + 20, k + 18, 0);
        world.setBlock(i + 3, j + 20, k + 19, 0);
        world.setBlock(i + 3, j + 20, k + 20, 0);
        world.setBlock(i + 3, j + 20, k + 21, 0);
        world.setBlock(i + 3, j + 20, k + 22, 0);
        world.setBlock(i + 3, j + 20, k + 23, 0);
        world.setBlock(i + 3, j + 20, k + 24, 0);
        world.setBlock(i + 3, j + 20, k + 25, 0);
        world.setBlock(i + 3, j + 20, k + 26, 0);
        world.setBlock(i + 3, j + 21, k + 0, 0);
        world.setBlock(i + 3, j + 21, k + 1, 0);
        world.setBlock(i + 3, j + 21, k + 2, 0);
        world.setBlock(i + 3, j + 21, k + 3, 0);
        world.setBlock(i + 3, j + 21, k + 4, 0);
        world.setBlock(i + 3, j + 21, k + 5, 0);
        world.setBlock(i + 3, j + 21, k + 6, 0);
        world.setBlock(i + 3, j + 21, k + 7, 0);
        world.setBlock(i + 3, j + 21, k + 8, 0);
        world.setBlock(i + 3, j + 21, k + 9, 0);
        world.setBlock(i + 3, j + 21, k + 10, 0);
        world.setBlock(i + 3, j + 21, k + 11, 0);
        world.setBlock(i + 3, j + 21, k + 12, 0);
        world.setBlock(i + 3, j + 21, k + 13, 0);
        world.setBlock(i + 3, j + 21, k + 14, 0);
        world.setBlock(i + 3, j + 21, k + 15, 0);
        world.setBlock(i + 3, j + 21, k + 16, 0);
        world.setBlock(i + 3, j + 21, k + 17, 0);
        world.setBlock(i + 3, j + 21, k + 18, 0);
        world.setBlock(i + 3, j + 21, k + 19, 0);
        world.setBlock(i + 3, j + 21, k + 20, 0);
        world.setBlock(i + 3, j + 21, k + 21, 0);
        world.setBlock(i + 3, j + 21, k + 22, 0);
        world.setBlock(i + 3, j + 21, k + 23, 0);
        world.setBlock(i + 3, j + 21, k + 24, 0);
        world.setBlock(i + 3, j + 21, k + 25, 0);
        world.setBlock(i + 3, j + 21, k + 26, 0);
        world.setBlock(i + 3, j + 22, k + 0, 0);
        world.setBlock(i + 3, j + 22, k + 1, 0);
        world.setBlock(i + 3, j + 22, k + 2, 0);
        world.setBlock(i + 3, j + 22, k + 3, 0);
        world.setBlock(i + 3, j + 22, k + 4, 0);
        world.setBlock(i + 3, j + 22, k + 5, 0);
        world.setBlock(i + 3, j + 22, k + 6, 0);
        world.setBlock(i + 3, j + 22, k + 7, 0);
        world.setBlock(i + 3, j + 22, k + 8, 0);
        world.setBlock(i + 3, j + 22, k + 9, 0);
        world.setBlock(i + 3, j + 22, k + 10, 0);
        world.setBlock(i + 3, j + 22, k + 11, 0);
        world.setBlock(i + 3, j + 22, k + 12, 0);
        world.setBlock(i + 3, j + 22, k + 13, 0);
        world.setBlock(i + 3, j + 22, k + 14, 0);
        world.setBlock(i + 3, j + 22, k + 15, 0);
        world.setBlock(i + 3, j + 22, k + 16, 0);
        world.setBlock(i + 3, j + 22, k + 17, 0);
        world.setBlock(i + 3, j + 22, k + 18, 0);
        world.setBlock(i + 3, j + 22, k + 19, 0);
        world.setBlock(i + 3, j + 22, k + 20, 0);
        world.setBlock(i + 3, j + 22, k + 21, 0);
        world.setBlock(i + 3, j + 22, k + 22, 0);
        world.setBlock(i + 3, j + 22, k + 23, 0);
        world.setBlock(i + 3, j + 22, k + 24, 0);
        world.setBlock(i + 3, j + 22, k + 25, 0);
        world.setBlock(i + 3, j + 22, k + 26, 0);
        world.setBlock(i + 3, j + 23, k + 0, 0);
        world.setBlock(i + 3, j + 23, k + 1, 0);
        world.setBlock(i + 3, j + 23, k + 2, 0);
        world.setBlock(i + 3, j + 23, k + 3, 0);
        world.setBlock(i + 3, j + 23, k + 4, 0);
        world.setBlock(i + 3, j + 23, k + 5, 0);
        world.setBlock(i + 3, j + 23, k + 6, 0);
        world.setBlock(i + 3, j + 23, k + 7, 0);
        world.setBlock(i + 3, j + 23, k + 8, 0);
        world.setBlock(i + 3, j + 23, k + 9, 0);
        world.setBlock(i + 3, j + 23, k + 10, 0);
        world.setBlock(i + 3, j + 23, k + 11, 0);
        world.setBlock(i + 3, j + 23, k + 12, 0);
        world.setBlock(i + 3, j + 23, k + 13, 0);
        world.setBlock(i + 3, j + 23, k + 14, 0);
        world.setBlock(i + 3, j + 23, k + 15, 0);
        world.setBlock(i + 3, j + 23, k + 16, 0);
        world.setBlock(i + 3, j + 23, k + 17, 0);
        world.setBlock(i + 3, j + 23, k + 18, 0);
        world.setBlock(i + 3, j + 23, k + 19, 0);
        world.setBlock(i + 3, j + 23, k + 20, 0);
        world.setBlock(i + 3, j + 23, k + 21, 0);
        world.setBlock(i + 3, j + 23, k + 22, 0);
        world.setBlock(i + 3, j + 23, k + 23, 0);
        world.setBlock(i + 3, j + 23, k + 24, 0);
        world.setBlock(i + 3, j + 23, k + 25, 0);
        world.setBlock(i + 3, j + 23, k + 26, 0);
        world.setBlock(i + 3, j + 24, k + 0, 0);
        world.setBlock(i + 3, j + 24, k + 1, 0);
        world.setBlock(i + 3, j + 24, k + 2, 0);
        world.setBlock(i + 3, j + 24, k + 3, 0);
        world.setBlock(i + 3, j + 24, k + 4, 0);
        world.setBlock(i + 3, j + 24, k + 5, 0);
        world.setBlock(i + 3, j + 24, k + 6, 0);
        world.setBlock(i + 3, j + 24, k + 7, 0);
        world.setBlock(i + 3, j + 24, k + 8, 0);
        world.setBlock(i + 3, j + 24, k + 9, 0);
        world.setBlock(i + 3, j + 24, k + 10, 0);
        world.setBlock(i + 3, j + 24, k + 11, 0);
        world.setBlock(i + 3, j + 24, k + 12, 0);
        world.setBlock(i + 3, j + 24, k + 13, 0);
        world.setBlock(i + 3, j + 24, k + 14, 0);
        world.setBlock(i + 3, j + 24, k + 15, 0);
        world.setBlock(i + 3, j + 24, k + 16, 0);
        world.setBlock(i + 3, j + 24, k + 17, 0);
        world.setBlock(i + 3, j + 24, k + 18, 0);
        world.setBlock(i + 3, j + 24, k + 19, 0);
        world.setBlock(i + 3, j + 24, k + 20, 0);
        world.setBlock(i + 3, j + 24, k + 21, 0);
        world.setBlock(i + 3, j + 24, k + 22, 0);
        world.setBlock(i + 3, j + 24, k + 23, 0);
        world.setBlock(i + 3, j + 24, k + 24, 0);
        world.setBlock(i + 3, j + 24, k + 25, 0);
        world.setBlock(i + 3, j + 24, k + 26, 0);
        world.setBlock(i + 3, j + 25, k + 0, 0);
        world.setBlock(i + 3, j + 25, k + 1, 0);
        world.setBlock(i + 3, j + 25, k + 2, 0);
        world.setBlock(i + 3, j + 25, k + 3, 0);
        world.setBlock(i + 3, j + 25, k + 4, 0);
        world.setBlock(i + 3, j + 25, k + 5, 0);
        world.setBlock(i + 3, j + 25, k + 6, 0);
        world.setBlock(i + 3, j + 25, k + 7, 0);
        world.setBlock(i + 3, j + 25, k + 8, 0);
        world.setBlock(i + 3, j + 25, k + 9, 0);
        world.setBlock(i + 3, j + 25, k + 10, 0);
        world.setBlock(i + 3, j + 25, k + 11, 0);
        world.setBlock(i + 3, j + 25, k + 12, 0);
        world.setBlock(i + 3, j + 25, k + 13, 0);
        world.setBlock(i + 3, j + 25, k + 14, 0);
        world.setBlock(i + 3, j + 25, k + 15, 0);
        world.setBlock(i + 3, j + 25, k + 16, 0);
        world.setBlock(i + 3, j + 25, k + 17, 0);
        world.setBlock(i + 3, j + 25, k + 18, 0);
        world.setBlock(i + 3, j + 25, k + 19, 0);
        world.setBlock(i + 3, j + 25, k + 20, 0);
        world.setBlock(i + 3, j + 25, k + 21, 0);
        world.setBlock(i + 3, j + 25, k + 22, 0);
        world.setBlock(i + 3, j + 25, k + 23, 0);
        world.setBlock(i + 3, j + 25, k + 24, 0);
        world.setBlock(i + 3, j + 25, k + 25, 0);
        world.setBlock(i + 3, j + 25, k + 26, 0);
        world.setBlock(i + 4, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 4, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 4, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 4, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 4, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 4, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 4, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 4, j + 2, k + 4, Block.grass.blockID);
        world.setBlock(i + 4, j + 2, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 13, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 4, j + 2, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 21, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 4, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 4, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 4, j + 3, k + 1, 0);
        world.setBlock(i + 4, j + 3, k + 3, 0);
        world.setBlock(i + 4, j + 3, k + 4, 0);
        world.setBlock(i + 4, j + 3, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 3, k + 6, 0);
        world.setBlock(i + 4, j + 3, k + 7, 0);
        world.setBlock(i + 4, j + 3, k + 8, 0);
        world.setBlock(i + 4, j + 3, k + 9, 0);
        world.setBlock(i + 4, j + 3, k + 10, 0);
        world.setBlock(i + 4, j + 3, k + 11, 0);
        world.setBlock(i + 4, j + 3, k + 12, 0);
        world.setBlock(i + 4, j + 3, k + 13, 0);
        world.setBlock(i + 4, j + 3, k + 14, 0);
        world.setBlock(i + 4, j + 3, k + 15, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 4, j + 3, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 3, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 3, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 3, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 3, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 3, k + 21, 0);
        world.setBlock(i + 4, j + 3, k + 22, 0);
        world.setBlock(i + 4, j + 3, k + 23, 0);
        world.setBlock(i + 4, j + 3, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 4, k + 0, 0);
        world.setBlock(i + 4, j + 4, k + 1, 0);
        world.setBlock(i + 4, j + 4, k + 2, 0);
        world.setBlock(i + 4, j + 4, k + 3, 0);
        world.setBlock(i + 4, j + 4, k + 4, 0);
        world.setBlock(i + 4, j + 4, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 4, j + 4, k + 6, 0);
        world.setBlock(i + 4, j + 4, k + 7, 0);
        world.setBlock(i + 4, j + 4, k + 8, 0);
        world.setBlock(i + 4, j + 4, k + 9, 0);
        world.setBlock(i + 4, j + 4, k + 10, 0);
        world.setBlock(i + 4, j + 4, k + 11, 0);
        world.setBlock(i + 4, j + 4, k + 12, 0);
        world.setBlock(i + 4, j + 4, k + 13, 0);
        world.setBlock(i + 4, j + 4, k + 14, 0);
        world.setBlock(i + 4, j + 4, k + 15, 0);
        world.setBlock(i + 4, j + 4, k + 16, 0);
        world.setBlock(i + 4, j + 4, k + 17, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 4, j + 4, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 4, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 4, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 4, k + 21, 0);
        world.setBlock(i + 4, j + 4, k + 22, 0);
        world.setBlock(i + 4, j + 4, k + 23, 0);
        world.setBlock(i + 4, j + 4, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 4, k + 25, 0);
        world.setBlock(i + 4, j + 4, k + 26, 0);
        world.setBlock(i + 4, j + 5, k + 0, 0);
        world.setBlock(i + 4, j + 5, k + 1, 0);
        world.setBlock(i + 4, j + 5, k + 2, 0);
        world.setBlock(i + 4, j + 5, k + 3, 0);
        world.setBlock(i + 4, j + 5, k + 4, 0);
        world.setBlock(i + 4, j + 5, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 4, j + 5, k + 6, 0);
        world.setBlock(i + 4, j + 5, k + 7, 0);
        world.setBlock(i + 4, j + 5, k + 8, 0);
        world.setBlock(i + 4, j + 5, k + 9, 0);
        world.setBlock(i + 4, j + 5, k + 10, 0);
        world.setBlock(i + 4, j + 5, k + 11, 0);
        world.setBlock(i + 4, j + 5, k + 12, 0);
        world.setBlock(i + 4, j + 5, k + 13, 0);
        world.setBlock(i + 4, j + 5, k + 14, 0);
        world.setBlock(i + 4, j + 5, k + 15, 0);
        world.setBlock(i + 4, j + 5, k + 16, 0);
        world.setBlock(i + 4, j + 5, k + 17, 0);
        world.setBlock(i + 4, j + 5, k + 18, 0);
        world.setBlock(i + 4, j + 5, k + 19, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 4, j + 5, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 5, k + 21, 0);
        world.setBlock(i + 4, j + 5, k + 22, 0);
        world.setBlock(i + 4, j + 5, k + 23, 0);
        world.setBlock(i + 4, j + 5, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 5, k + 25, 0);
        world.setBlock(i + 4, j + 5, k + 26, 0);
        world.setBlock(i + 4, j + 6, k + 0, 0);
        world.setBlock(i + 4, j + 6, k + 1, 0);
        world.setBlock(i + 4, j + 6, k + 2, 0);
        world.setBlock(i + 4, j + 6, k + 3, 0);
        world.setBlock(i + 4, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 4, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 4, j + 6, k + 6, 0);
        world.setBlock(i + 4, j + 6, k + 7, 0);
        world.setBlock(i + 4, j + 6, k + 8, 0);
        world.setBlock(i + 4, j + 6, k + 9, 0);
        world.setBlock(i + 4, j + 6, k + 10, 0);
        world.setBlock(i + 4, j + 6, k + 11, 0);
        world.setBlock(i + 4, j + 6, k + 12, 0);
        world.setBlock(i + 4, j + 6, k + 13, 0);
        world.setBlock(i + 4, j + 6, k + 14, 0);
        world.setBlock(i + 4, j + 6, k + 15, 0);
        world.setBlock(i + 4, j + 6, k + 16, 0);
        world.setBlock(i + 4, j + 6, k + 17, 0);
        world.setBlock(i + 4, j + 6, k + 18, 0);
        world.setBlock(i + 4, j + 6, k + 19, 0);
        world.setBlock(i + 4, j + 6, k + 20, 0);
        world.setBlock(i + 4, j + 6, k + 21, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 4, j + 6, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 6, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 6, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 6, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 6, k + 26, 0);
        world.setBlock(i + 4, j + 7, k + 0, 0);
        world.setBlock(i + 4, j + 7, k + 1, 0);
        world.setBlock(i + 4, j + 7, k + 2, 0);
        world.setBlock(i + 4, j + 7, k + 3, 0);
        world.setBlock(i + 4, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 4, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 4, j + 7, k + 6, Block.web.blockID);
        world.setBlock(i + 4, j + 7, k + 7, 0);
        world.setBlock(i + 4, j + 7, k + 8, 0);
        world.setBlock(i + 4, j + 7, k + 9, 0);
        world.setBlock(i + 4, j + 7, k + 10, 0);
        world.setBlock(i + 4, j + 7, k + 11, 0);
        world.setBlock(i + 4, j + 7, k + 12, 0);
        world.setBlock(i + 4, j + 7, k + 13, 0);
        world.setBlock(i + 4, j + 7, k + 14, 0);
        world.setBlock(i + 4, j + 7, k + 15, 0);
        world.setBlock(i + 4, j + 7, k + 16, 0);
        world.setBlock(i + 4, j + 7, k + 17, 0);
        world.setBlock(i + 4, j + 7, k + 18, 0);
        world.setBlock(i + 4, j + 7, k + 19, 0);
        world.setBlock(i + 4, j + 7, k + 20, 0);
        world.setBlock(i + 4, j + 7, k + 21, 0);
        world.setBlock(i + 4, j + 7, k + 22, 0);
        world.setBlock(i + 4, j + 7, k + 23, 0);
        world.setBlock(i + 4, j + 7, k + 24, 0);
        world.setBlock(i + 4, j + 7, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 7, k + 26, 0);
        world.setBlock(i + 4, j + 8, k + 0, 0);
        world.setBlock(i + 4, j + 8, k + 1, 0);
        world.setBlock(i + 4, j + 8, k + 2, 0);
        world.setBlock(i + 4, j + 8, k + 3, 0);
        world.setBlock(i + 4, j + 8, k + 4, 0);
        world.setBlock(i + 4, j + 8, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 8, k + 6, 0);
        world.setBlock(i + 4, j + 8, k + 7, 0);
        world.setBlock(i + 4, j + 8, k + 8, 0);
        world.setBlock(i + 4, j + 8, k + 9, 0);
        world.setBlock(i + 4, j + 8, k + 10, 0);
        world.setBlock(i + 4, j + 8, k + 11, 0);
        world.setBlock(i + 4, j + 8, k + 12, 0);
        world.setBlock(i + 4, j + 8, k + 13, 0);
        world.setBlock(i + 4, j + 8, k + 14, 0);
        world.setBlock(i + 4, j + 8, k + 15, 0);
        world.setBlock(i + 4, j + 8, k + 16, 0);
        world.setBlock(i + 4, j + 8, k + 17, 0);
        world.setBlock(i + 4, j + 8, k + 18, 0);
        world.setBlock(i + 4, j + 8, k + 19, 0);
        world.setBlock(i + 4, j + 8, k + 20, 0);
        world.setBlock(i + 4, j + 8, k + 21, 0);
        world.setBlock(i + 4, j + 8, k + 22, 0);
        world.setBlock(i + 4, j + 8, k + 23, 0);
        world.setBlock(i + 4, j + 8, k + 24, 0);
        world.setBlock(i + 4, j + 8, k + 25, Block.thinGlass.blockID);
        world.setBlock(i + 4, j + 8, k + 26, 0);
        world.setBlock(i + 4, j + 9, k + 0, 0);
        world.setBlock(i + 4, j + 9, k + 1, 0);
        generate3(world, rand, i, j, k);
        return true;
    }

    public boolean generate3(World world, Random rand, int i, int j, int k)
    {
        world.setBlock(i + 4, j + 9, k + 2, 0);
        world.setBlock(i + 4, j + 9, k + 3, 0);
        world.setBlock(i + 4, j + 9, k + 4, 0);
        world.setBlock(i + 4, j + 9, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 4, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 4, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 17, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 4, j + 9, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 9, k + 21, 0);
        world.setBlock(i + 4, j + 9, k + 22, 0);
        world.setBlock(i + 4, j + 9, k + 23, 0);
        world.setBlock(i + 4, j + 9, k + 24, 0);
        world.setBlock(i + 4, j + 9, k + 25, Block.thinGlass.blockID);
        world.setBlock(i + 4, j + 9, k + 26, 0);
        world.setBlock(i + 4, j + 10, k + 0, 0);
        world.setBlock(i + 4, j + 10, k + 1, 0);
        world.setBlock(i + 4, j + 10, k + 2, 0);
        world.setBlock(i + 4, j + 10, k + 3, 0);
        world.setBlock(i + 4, j + 10, k + 4, 0);
        world.setBlock(i + 4, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 10, k + 6, 0);
        world.setBlock(i + 4, j + 10, k + 7, 0);
        world.setBlock(i + 4, j + 10, k + 8, Block.enchantmentTable.blockID);
        world.setBlock(i + 4, j + 10, k + 9, 0);
        world.setBlock(i + 4, j + 10, k + 10, 0);
        world.setBlock(i + 4, j + 10, k + 11, 0);
        world.setBlock(i + 4, j + 10, k + 12, 0);
        world.setBlock(i + 4, j + 10, k + 13, 0);
        world.setBlock(i + 4, j + 10, k + 14, 0);
        world.setBlock(i + 4, j + 10, k + 15, 0);
        world.setBlock(i + 4, j + 10, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 10, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 10, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 10, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 10, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 10, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 10, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 10, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 4, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 4, j + 10, k + 26, 0);
        world.setBlock(i + 4, j + 11, k + 0, 0);
        world.setBlock(i + 4, j + 11, k + 1, 0);
        world.setBlock(i + 4, j + 11, k + 2, 0);
        world.setBlock(i + 4, j + 11, k + 3, 0);
        world.setBlock(i + 4, j + 11, k + 4, 0);
        world.setBlock(i + 4, j + 11, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 4, j + 11, k + 6, 0);
        world.setBlock(i + 4, j + 11, k + 7, 0);
        world.setBlock(i + 4, j + 11, k + 8, 0);
        world.setBlock(i + 4, j + 11, k + 9, 0);
        world.setBlock(i + 4, j + 11, k + 10, 0);
        world.setBlock(i + 4, j + 11, k + 11, 0);
        world.setBlock(i + 4, j + 11, k + 12, 0);
        world.setBlock(i + 4, j + 11, k + 13, 0);
        world.setBlock(i + 4, j + 11, k + 14, 0);
        world.setBlock(i + 4, j + 11, k + 15, 0);
        world.setBlock(i + 4, j + 11, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 11, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 11, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 11, k + 19, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 4, j + 11, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 11, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 11, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 11, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 4, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 4, j + 11, k + 26, 0);
        world.setBlock(i + 4, j + 12, k + 0, 0);
        world.setBlock(i + 4, j + 12, k + 1, 0);
        world.setBlock(i + 4, j + 12, k + 2, 0);
        world.setBlock(i + 4, j + 12, k + 3, 0);
        world.setBlock(i + 4, j + 12, k + 4, 0);
        world.setBlock(i + 4, j + 12, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 4, j + 12, k + 6, 0);
        world.setBlock(i + 4, j + 12, k + 7, 0);
        world.setBlock(i + 4, j + 12, k + 8, 0);
        world.setBlock(i + 4, j + 12, k + 9, 0);
        world.setBlock(i + 4, j + 12, k + 10, 0);
        world.setBlock(i + 4, j + 12, k + 11, 0);
        world.setBlock(i + 4, j + 12, k + 12, 0);
        world.setBlock(i + 4, j + 12, k + 13, 0);
        world.setBlock(i + 4, j + 12, k + 14, 0);
        world.setBlock(i + 4, j + 12, k + 15, Block.glowStone.blockID);
        world.setBlock(i + 4, j + 12, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 12, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 12, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 12, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 12, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 12, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 12, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 4, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 4, j + 12, k + 26, 0);
        world.setBlock(i + 4, j + 13, k + 0, 0);
        world.setBlock(i + 4, j + 13, k + 1, 0);
        world.setBlock(i + 4, j + 13, k + 2, 0);
        world.setBlock(i + 4, j + 13, k + 3, 0);
        world.setBlock(i + 4, j + 13, k + 4, 0);
        world.setBlock(i + 4, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 13, k + 6, Block.web.blockID);
        world.setBlock(i + 4, j + 13, k + 7, 0);
        world.setBlock(i + 4, j + 13, k + 8, 0);
        world.setBlock(i + 4, j + 13, k + 9, 0);
        world.setBlock(i + 4, j + 13, k + 10, 0);
        world.setBlock(i + 4, j + 13, k + 11, 0);
        world.setBlock(i + 4, j + 13, k + 12, 0);
        world.setBlock(i + 4, j + 13, k + 13, 0);
        world.setBlock(i + 4, j + 13, k + 14, 0);
        world.setBlock(i + 4, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 13, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 13, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 13, k + 22, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 4, j + 13, k + 23, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 4, j + 13, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 13, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 13, k + 26, 0);
        world.setBlock(i + 4, j + 14, k + 0, 0);
        world.setBlock(i + 4, j + 14, k + 1, 0);
        world.setBlock(i + 4, j + 14, k + 2, 0);
        world.setBlock(i + 4, j + 14, k + 3, 0);
        world.setBlock(i + 4, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 22, 0);
        world.setBlock(i + 4, j + 14, k + 23, 0);
        world.setBlock(i + 4, j + 14, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 14, k + 26, 0);
        world.setBlock(i + 4, j + 15, k + 0, 0);
        world.setBlock(i + 4, j + 15, k + 1, 0);
        world.setBlock(i + 4, j + 15, k + 2, 0);
        world.setBlock(i + 4, j + 15, k + 3, 0);
        world.setBlock(i + 4, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 15, k + 5, 0);
        world.setBlock(i + 4, j + 15, k + 6, 0);
        world.setBlock(i + 4, j + 15, k + 7, 0);
        world.setBlock(i + 4, j + 15, k + 8, 0);
        world.setBlock(i + 4, j + 15, k + 9, 0);
        world.setBlock(i + 4, j + 15, k + 10, 0);
        world.setBlock(i + 4, j + 15, k + 11, 0);
        world.setBlock(i + 4, j + 15, k + 12, 0);
        world.setBlock(i + 4, j + 15, k + 13, 0);
        world.setBlock(i + 4, j + 15, k + 14, 0);
        world.setBlock(i + 4, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 15, k + 22, 0);
        world.setBlock(i + 4, j + 15, k + 23, 0);
        world.setBlock(i + 4, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 15, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 15, k + 26, 0);
        world.setBlock(i + 4, j + 16, k + 0, 0);
        world.setBlock(i + 4, j + 16, k + 1, 0);
        world.setBlock(i + 4, j + 16, k + 2, 0);
        world.setBlock(i + 4, j + 16, k + 3, 0);
        world.setBlock(i + 4, j + 16, k + 4, 0);
        world.setBlock(i + 4, j + 16, k + 5, 0);
        world.setBlock(i + 4, j + 16, k + 6, 0);
        world.setBlock(i + 4, j + 16, k + 7, 0);
        world.setBlock(i + 4, j + 16, k + 8, 0);
        world.setBlock(i + 4, j + 16, k + 9, 0);
        world.setBlock(i + 4, j + 16, k + 10, 0);
        world.setBlock(i + 4, j + 16, k + 11, 0);
        world.setBlock(i + 4, j + 16, k + 12, 0);
        world.setBlock(i + 4, j + 16, k + 13, 0);
        world.setBlock(i + 4, j + 16, k + 14, 0);
        world.setBlock(i + 4, j + 16, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 16, k + 16, Block.bed.blockID, 1, 0);
        world.setBlock(i + 4, j + 16, k + 17, 0);
        world.setBlock(i + 4, j + 16, k + 18, 0);
        world.setBlock(i + 4, j + 16, k + 19, Block.bed.blockID);
        world.setBlock(i + 4, j + 16, k + 20, Block.bed.blockID, 8, 0);
        world.setBlock(i + 4, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 16, k + 22, 0);
        world.setBlock(i + 4, j + 16, k + 23, 0);
        world.setBlock(i + 4, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 16, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 16, k + 26, 0);
        world.setBlock(i + 4, j + 17, k + 0, 0);
        world.setBlock(i + 4, j + 17, k + 1, 0);
        world.setBlock(i + 4, j + 17, k + 2, 0);
        world.setBlock(i + 4, j + 17, k + 3, 0);
        world.setBlock(i + 4, j + 17, k + 4, 0);
        world.setBlock(i + 4, j + 17, k + 5, 0);
        world.setBlock(i + 4, j + 17, k + 6, 0);
        world.setBlock(i + 4, j + 17, k + 7, 0);
        world.setBlock(i + 4, j + 17, k + 8, 0);
        world.setBlock(i + 4, j + 17, k + 9, 0);
        world.setBlock(i + 4, j + 17, k + 10, 0);
        world.setBlock(i + 4, j + 17, k + 11, 0);
        world.setBlock(i + 4, j + 17, k + 12, 0);
        world.setBlock(i + 4, j + 17, k + 13, 0);
        world.setBlock(i + 4, j + 17, k + 14, 0);
        world.setBlock(i + 4, j + 17, k + 15, Block.thinGlass.blockID);
        world.setBlock(i + 4, j + 17, k + 16, 0);
        world.setBlock(i + 4, j + 17, k + 17, 0);
        world.setBlock(i + 4, j + 17, k + 18, 0);
        world.setBlock(i + 4, j + 17, k + 19, 0);
        world.setBlock(i + 4, j + 17, k + 20, 0);
        world.setBlock(i + 4, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 17, k + 22, 0);
        world.setBlock(i + 4, j + 17, k + 23, 0);
        world.setBlock(i + 4, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 17, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 17, k + 26, 0);
        world.setBlock(i + 4, j + 18, k + 0, 0);
        world.setBlock(i + 4, j + 18, k + 1, 0);
        world.setBlock(i + 4, j + 18, k + 2, 0);
        world.setBlock(i + 4, j + 18, k + 3, 0);
        world.setBlock(i + 4, j + 18, k + 4, 0);
        world.setBlock(i + 4, j + 18, k + 5, 0);
        world.setBlock(i + 4, j + 18, k + 6, 0);
        world.setBlock(i + 4, j + 18, k + 7, 0);
        world.setBlock(i + 4, j + 18, k + 8, 0);
        world.setBlock(i + 4, j + 18, k + 9, 0);
        world.setBlock(i + 4, j + 18, k + 10, 0);
        world.setBlock(i + 4, j + 18, k + 11, 0);
        world.setBlock(i + 4, j + 18, k + 12, 0);
        world.setBlock(i + 4, j + 18, k + 13, 0);
        world.setBlock(i + 4, j + 18, k + 14, 0);
        world.setBlock(i + 4, j + 18, k + 15, Block.thinGlass.blockID);
        world.setBlock(i + 4, j + 18, k + 16, 0);
        world.setBlock(i + 4, j + 18, k + 17, 0);
        world.setBlock(i + 4, j + 18, k + 18, 0);
        world.setBlock(i + 4, j + 18, k + 19, 0);
        world.setBlock(i + 4, j + 18, k + 20, 0);
        world.setBlock(i + 4, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 18, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 18, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 18, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 18, k + 26, 0);
        world.setBlock(i + 4, j + 19, k + 0, 0);
        world.setBlock(i + 4, j + 19, k + 1, 0);
        world.setBlock(i + 4, j + 19, k + 2, 0);
        world.setBlock(i + 4, j + 19, k + 3, 0);
        world.setBlock(i + 4, j + 19, k + 4, 0);
        world.setBlock(i + 4, j + 19, k + 5, 0);
        world.setBlock(i + 4, j + 19, k + 6, 0);
        world.setBlock(i + 4, j + 19, k + 7, 0);
        world.setBlock(i + 4, j + 19, k + 8, 0);
        world.setBlock(i + 4, j + 19, k + 9, 0);
        world.setBlock(i + 4, j + 19, k + 10, 0);
        world.setBlock(i + 4, j + 19, k + 11, 0);
        world.setBlock(i + 4, j + 19, k + 12, 0);
        world.setBlock(i + 4, j + 19, k + 13, 0);
        world.setBlock(i + 4, j + 19, k + 14, 0);
        world.setBlock(i + 4, j + 19, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 19, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 19, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 19, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 19, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 19, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 19, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 19, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 19, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 4, j + 19, k + 26, 0);
        world.setBlock(i + 4, j + 20, k + 0, 0);
        world.setBlock(i + 4, j + 20, k + 1, 0);
        world.setBlock(i + 4, j + 20, k + 2, 0);
        world.setBlock(i + 4, j + 20, k + 3, 0);
        world.setBlock(i + 4, j + 20, k + 4, 0);
        world.setBlock(i + 4, j + 20, k + 5, 0);
        world.setBlock(i + 4, j + 20, k + 6, 0);
        world.setBlock(i + 4, j + 20, k + 7, 0);
        world.setBlock(i + 4, j + 20, k + 8, 0);
        world.setBlock(i + 4, j + 20, k + 9, 0);
        world.setBlock(i + 4, j + 20, k + 10, 0);
        world.setBlock(i + 4, j + 20, k + 11, 0);
        world.setBlock(i + 4, j + 20, k + 12, 0);
        world.setBlock(i + 4, j + 20, k + 13, 0);
        world.setBlock(i + 4, j + 20, k + 14, 0);
        world.setBlock(i + 4, j + 20, k + 15, 0);
        world.setBlock(i + 4, j + 20, k + 16, 0);
        world.setBlock(i + 4, j + 20, k + 17, 0);
        world.setBlock(i + 4, j + 20, k + 18, 0);
        world.setBlock(i + 4, j + 20, k + 19, 0);
        world.setBlock(i + 4, j + 20, k + 20, 0);
        world.setBlock(i + 4, j + 20, k + 21, 0);
        world.setBlock(i + 4, j + 20, k + 22, 0);
        world.setBlock(i + 4, j + 20, k + 23, 0);
        world.setBlock(i + 4, j + 20, k + 24, 0);
        world.setBlock(i + 4, j + 20, k + 25, 0);
        world.setBlock(i + 4, j + 20, k + 26, 0);
        world.setBlock(i + 4, j + 21, k + 0, 0);
        world.setBlock(i + 4, j + 21, k + 1, 0);
        world.setBlock(i + 4, j + 21, k + 2, 0);
        world.setBlock(i + 4, j + 21, k + 3, 0);
        world.setBlock(i + 4, j + 21, k + 4, 0);
        world.setBlock(i + 4, j + 21, k + 5, 0);
        world.setBlock(i + 4, j + 21, k + 6, 0);
        world.setBlock(i + 4, j + 21, k + 7, 0);
        world.setBlock(i + 4, j + 21, k + 8, 0);
        world.setBlock(i + 4, j + 21, k + 9, 0);
        world.setBlock(i + 4, j + 21, k + 10, 0);
        world.setBlock(i + 4, j + 21, k + 11, 0);
        world.setBlock(i + 4, j + 21, k + 12, 0);
        world.setBlock(i + 4, j + 21, k + 13, 0);
        world.setBlock(i + 4, j + 21, k + 14, 0);
        world.setBlock(i + 4, j + 21, k + 15, 0);
        world.setBlock(i + 4, j + 21, k + 16, 0);
        world.setBlock(i + 4, j + 21, k + 17, 0);
        world.setBlock(i + 4, j + 21, k + 18, 0);
        world.setBlock(i + 4, j + 21, k + 19, 0);
        world.setBlock(i + 4, j + 21, k + 20, 0);
        world.setBlock(i + 4, j + 21, k + 21, 0);
        world.setBlock(i + 4, j + 21, k + 22, 0);
        world.setBlock(i + 4, j + 21, k + 23, 0);
        world.setBlock(i + 4, j + 21, k + 24, 0);
        world.setBlock(i + 4, j + 21, k + 25, 0);
        world.setBlock(i + 4, j + 21, k + 26, 0);
        world.setBlock(i + 4, j + 22, k + 0, 0);
        world.setBlock(i + 4, j + 22, k + 1, 0);
        world.setBlock(i + 4, j + 22, k + 2, 0);
        world.setBlock(i + 4, j + 22, k + 3, 0);
        world.setBlock(i + 4, j + 22, k + 4, 0);
        world.setBlock(i + 4, j + 22, k + 5, 0);
        world.setBlock(i + 4, j + 22, k + 6, 0);
        world.setBlock(i + 4, j + 22, k + 7, 0);
        world.setBlock(i + 4, j + 22, k + 8, 0);
        world.setBlock(i + 4, j + 22, k + 9, 0);
        world.setBlock(i + 4, j + 22, k + 10, 0);
        world.setBlock(i + 4, j + 22, k + 11, 0);
        world.setBlock(i + 4, j + 22, k + 12, 0);
        world.setBlock(i + 4, j + 22, k + 13, 0);
        world.setBlock(i + 4, j + 22, k + 14, 0);
        world.setBlock(i + 4, j + 22, k + 15, 0);
        world.setBlock(i + 4, j + 22, k + 16, 0);
        world.setBlock(i + 4, j + 22, k + 17, 0);
        world.setBlock(i + 4, j + 22, k + 18, 0);
        world.setBlock(i + 4, j + 22, k + 19, 0);
        world.setBlock(i + 4, j + 22, k + 20, 0);
        world.setBlock(i + 4, j + 22, k + 21, 0);
        world.setBlock(i + 4, j + 22, k + 22, 0);
        world.setBlock(i + 4, j + 22, k + 23, 0);
        world.setBlock(i + 4, j + 22, k + 24, 0);
        world.setBlock(i + 4, j + 22, k + 25, 0);
        world.setBlock(i + 4, j + 22, k + 26, 0);
        world.setBlock(i + 4, j + 23, k + 0, 0);
        world.setBlock(i + 4, j + 23, k + 1, 0);
        world.setBlock(i + 4, j + 23, k + 2, 0);
        world.setBlock(i + 4, j + 23, k + 3, 0);
        world.setBlock(i + 4, j + 23, k + 4, 0);
        world.setBlock(i + 4, j + 23, k + 5, 0);
        world.setBlock(i + 4, j + 23, k + 6, 0);
        world.setBlock(i + 4, j + 23, k + 7, 0);
        world.setBlock(i + 4, j + 23, k + 8, 0);
        world.setBlock(i + 4, j + 23, k + 9, 0);
        world.setBlock(i + 4, j + 23, k + 10, 0);
        world.setBlock(i + 4, j + 23, k + 11, 0);
        world.setBlock(i + 4, j + 23, k + 12, 0);
        world.setBlock(i + 4, j + 23, k + 13, 0);
        world.setBlock(i + 4, j + 23, k + 14, 0);
        world.setBlock(i + 4, j + 23, k + 15, 0);
        world.setBlock(i + 4, j + 23, k + 16, 0);
        world.setBlock(i + 4, j + 23, k + 17, 0);
        world.setBlock(i + 4, j + 23, k + 18, 0);
        world.setBlock(i + 4, j + 23, k + 19, 0);
        world.setBlock(i + 4, j + 23, k + 20, 0);
        world.setBlock(i + 4, j + 23, k + 21, 0);
        world.setBlock(i + 4, j + 23, k + 22, 0);
        world.setBlock(i + 4, j + 23, k + 23, 0);
        world.setBlock(i + 4, j + 23, k + 24, 0);
        world.setBlock(i + 4, j + 23, k + 25, 0);
        world.setBlock(i + 4, j + 23, k + 26, 0);
        world.setBlock(i + 4, j + 24, k + 0, 0);
        world.setBlock(i + 4, j + 24, k + 1, 0);
        world.setBlock(i + 4, j + 24, k + 2, 0);
        world.setBlock(i + 4, j + 24, k + 3, 0);
        world.setBlock(i + 4, j + 24, k + 4, 0);
        world.setBlock(i + 4, j + 24, k + 5, 0);
        world.setBlock(i + 4, j + 24, k + 6, 0);
        world.setBlock(i + 4, j + 24, k + 7, 0);
        world.setBlock(i + 4, j + 24, k + 8, 0);
        world.setBlock(i + 4, j + 24, k + 9, 0);
        world.setBlock(i + 4, j + 24, k + 10, 0);
        world.setBlock(i + 4, j + 24, k + 11, 0);
        world.setBlock(i + 4, j + 24, k + 12, 0);
        world.setBlock(i + 4, j + 24, k + 13, 0);
        world.setBlock(i + 4, j + 24, k + 14, 0);
        world.setBlock(i + 4, j + 24, k + 15, 0);
        world.setBlock(i + 4, j + 24, k + 16, 0);
        world.setBlock(i + 4, j + 24, k + 17, 0);
        world.setBlock(i + 4, j + 24, k + 18, 0);
        world.setBlock(i + 4, j + 24, k + 19, 0);
        world.setBlock(i + 4, j + 24, k + 20, 0);
        world.setBlock(i + 4, j + 24, k + 21, 0);
        world.setBlock(i + 4, j + 24, k + 22, 0);
        world.setBlock(i + 4, j + 24, k + 23, 0);
        world.setBlock(i + 4, j + 24, k + 24, 0);
        world.setBlock(i + 4, j + 24, k + 25, 0);
        world.setBlock(i + 4, j + 24, k + 26, 0);
        world.setBlock(i + 4, j + 25, k + 0, 0);
        world.setBlock(i + 4, j + 25, k + 1, 0);
        world.setBlock(i + 4, j + 25, k + 2, 0);
        world.setBlock(i + 4, j + 25, k + 3, 0);
        world.setBlock(i + 4, j + 25, k + 4, 0);
        world.setBlock(i + 4, j + 25, k + 5, 0);
        world.setBlock(i + 4, j + 25, k + 6, 0);
        world.setBlock(i + 4, j + 25, k + 7, 0);
        world.setBlock(i + 4, j + 25, k + 8, 0);
        world.setBlock(i + 4, j + 25, k + 9, 0);
        world.setBlock(i + 4, j + 25, k + 10, 0);
        world.setBlock(i + 4, j + 25, k + 11, 0);
        world.setBlock(i + 4, j + 25, k + 12, 0);
        world.setBlock(i + 4, j + 25, k + 13, 0);
        world.setBlock(i + 4, j + 25, k + 14, 0);
        world.setBlock(i + 4, j + 25, k + 15, 0);
        world.setBlock(i + 4, j + 25, k + 16, 0);
        world.setBlock(i + 4, j + 25, k + 17, 0);
        world.setBlock(i + 4, j + 25, k + 18, 0);
        world.setBlock(i + 4, j + 25, k + 19, 0);
        world.setBlock(i + 4, j + 25, k + 20, 0);
        world.setBlock(i + 4, j + 25, k + 21, 0);
        world.setBlock(i + 4, j + 25, k + 22, 0);
        world.setBlock(i + 4, j + 25, k + 23, 0);
        world.setBlock(i + 4, j + 25, k + 24, 0);
        world.setBlock(i + 4, j + 25, k + 25, 0);
        world.setBlock(i + 4, j + 25, k + 26, 0);
        world.setBlock(i + 5, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 5, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 5, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 5, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 5, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 5, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 5, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 5, j + 2, k + 4, Block.dirt.blockID);
        world.setBlock(i + 5, j + 2, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 2, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 2, k + 8, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 5, j + 2, k + 9, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 5, j + 2, k + 10, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 5, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 5, j + 2, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 5, j + 2, k + 13, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 5, j + 2, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 2, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 2, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 2, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 2, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 2, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 2, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 2, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 5, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 5, j + 3, k + 0, 0);
        world.setBlock(i + 5, j + 3, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 3, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 3, k + 7, 0);
        world.setBlock(i + 5, j + 3, k + 8, 0);
        world.setBlock(i + 5, j + 3, k + 9, 0);
        world.setBlock(i + 5, j + 3, k + 10, 0);
        world.setBlock(i + 5, j + 3, k + 11, 0);
        world.setBlock(i + 5, j + 3, k + 12, 0);
        world.setBlock(i + 5, j + 3, k + 13, 0);
        world.setBlock(i + 5, j + 3, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 3, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 3, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 3, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 3, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 3, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 3, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 3, k + 21, 0);
        world.setBlock(i + 5, j + 3, k + 22, 0);
        world.setBlock(i + 5, j + 3, k + 23, Block.chest.blockID, 2, 0);
        world.setBlock(i + 5, j + 3, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 4, k + 0, 0);
        world.setBlock(i + 5, j + 4, k + 1, 0);
        world.setBlock(i + 5, j + 4, k + 2, 0);
        world.setBlock(i + 5, j + 4, k + 3, 0);
        world.setBlock(i + 5, j + 4, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 4, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 4, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 4, k + 7, 0);
        world.setBlock(i + 5, j + 4, k + 8, 0);
        world.setBlock(i + 5, j + 4, k + 9, 0);
        world.setBlock(i + 5, j + 4, k + 10, 0);
        world.setBlock(i + 5, j + 4, k + 11, 0);
        world.setBlock(i + 5, j + 4, k + 12, 0);
        world.setBlock(i + 5, j + 4, k + 13, 0);
        world.setBlock(i + 5, j + 4, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 4, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 4, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 4, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 4, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 4, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 4, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 4, k + 21, 0);
        world.setBlock(i + 5, j + 4, k + 22, 0);
        world.setBlock(i + 5, j + 4, k + 23, Block.chest.blockID, 2, 0);
        world.setBlock(i + 5, j + 4, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 4, k + 25, 0);
        world.setBlock(i + 5, j + 4, k + 26, 0);
        world.setBlock(i + 5, j + 5, k + 0, 0);
        world.setBlock(i + 5, j + 5, k + 1, 0);
        world.setBlock(i + 5, j + 5, k + 2, 0);
        world.setBlock(i + 5, j + 5, k + 3, 0);
        world.setBlock(i + 5, j + 5, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 5, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 5, k + 7, 0);
        world.setBlock(i + 5, j + 5, k + 8, 0);
        world.setBlock(i + 5, j + 5, k + 9, 0);
        world.setBlock(i + 5, j + 5, k + 10, 0);
        world.setBlock(i + 5, j + 5, k + 11, 0);
        world.setBlock(i + 5, j + 5, k + 12, 0);
        world.setBlock(i + 5, j + 5, k + 13, 0);
        world.setBlock(i + 5, j + 5, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 5, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 5, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 5, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 5, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 5, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 5, k + 20, Block.glowStone.blockID);
        world.setBlock(i + 5, j + 5, k + 21, 0);
        world.setBlock(i + 5, j + 5, k + 22, 0);
        world.setBlock(i + 5, j + 5, k + 23, 0);
        world.setBlock(i + 5, j + 5, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 5, k + 25, 0);
        world.setBlock(i + 5, j + 5, k + 26, 0);
        world.setBlock(i + 5, j + 6, k + 0, 0);
        world.setBlock(i + 5, j + 6, k + 1, 0);
        world.setBlock(i + 5, j + 6, k + 2, 0);
        world.setBlock(i + 5, j + 6, k + 3, 0);
        world.setBlock(i + 5, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 6, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 6, k + 7, 0);
        world.setBlock(i + 5, j + 6, k + 8, 0);
        world.setBlock(i + 5, j + 6, k + 9, 0);
        world.setBlock(i + 5, j + 6, k + 10, 0);
        world.setBlock(i + 5, j + 6, k + 11, 0);
        world.setBlock(i + 5, j + 6, k + 12, 0);
        world.setBlock(i + 5, j + 6, k + 13, 0);
        world.setBlock(i + 5, j + 6, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 6, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 6, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 6, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 6, k + 18, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 5, j + 6, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 6, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 6, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 6, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 6, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 6, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 6, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 6, k + 26, 0);
        world.setBlock(i + 5, j + 7, k + 0, 0);
        world.setBlock(i + 5, j + 7, k + 1, 0);
        world.setBlock(i + 5, j + 7, k + 2, 0);
        world.setBlock(i + 5, j + 7, k + 3, 0);
        world.setBlock(i + 5, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 7, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 7, k + 7, 0);
        world.setBlock(i + 5, j + 7, k + 8, 0);
        world.setBlock(i + 5, j + 7, k + 9, 0);
        world.setBlock(i + 5, j + 7, k + 10, 0);
        world.setBlock(i + 5, j + 7, k + 11, 0);
        world.setBlock(i + 5, j + 7, k + 12, 0);
        world.setBlock(i + 5, j + 7, k + 13, 0);
        world.setBlock(i + 5, j + 7, k + 14, Block.netherrack.blockID);
        world.setBlock(i + 5, j + 7, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 7, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 7, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 7, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 7, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 7, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 7, k + 21, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 5, j + 7, k + 22, 0);
        world.setBlock(i + 5, j + 7, k + 23, 0);
        world.setBlock(i + 5, j + 7, k + 24, 0);
        world.setBlock(i + 5, j + 7, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 7, k + 26, 0);
        world.setBlock(i + 5, j + 8, k + 0, 0);
        world.setBlock(i + 5, j + 8, k + 1, 0);
        world.setBlock(i + 5, j + 8, k + 2, 0);
        world.setBlock(i + 5, j + 8, k + 3, 0);
        world.setBlock(i + 5, j + 8, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 8, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 8, k + 7, 0);
        world.setBlock(i + 5, j + 8, k + 8, 0);
        world.setBlock(i + 5, j + 8, k + 9, 0);
        world.setBlock(i + 5, j + 8, k + 10, 0);
        world.setBlock(i + 5, j + 8, k + 11, 0);
        world.setBlock(i + 5, j + 8, k + 12, 0);
        world.setBlock(i + 5, j + 8, k + 13, 0);
        world.setBlock(i + 5, j + 8, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 8, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 8, k + 16, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 8, k + 17, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 8, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 8, k + 19, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 5, j + 8, k + 20, 0);
        world.setBlock(i + 5, j + 8, k + 21, 0);
        world.setBlock(i + 5, j + 8, k + 22, 0);
        world.setBlock(i + 5, j + 8, k + 23, 0);
        world.setBlock(i + 5, j + 8, k + 24, 0);
        world.setBlock(i + 5, j + 8, k + 25, Block.thinGlass.blockID);
        world.setBlock(i + 5, j + 8, k + 26, 0);
        world.setBlock(i + 5, j + 9, k + 0, 0);
        world.setBlock(i + 5, j + 9, k + 1, 0);
        world.setBlock(i + 5, j + 9, k + 2, 0);
        world.setBlock(i + 5, j + 9, k + 3, 0);
        world.setBlock(i + 5, j + 9, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 9, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 9, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 9, k + 7, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 9, k + 8, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 9, k + 9, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 9, k + 10, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 9, k + 11, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 9, k + 12, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 9, k + 13, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 9, k + 17, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 5, j + 9, k + 18, 0);
        world.setBlock(i + 5, j + 9, k + 19, 0);
        world.setBlock(i + 5, j + 9, k + 20, 0);
        world.setBlock(i + 5, j + 9, k + 21, 0);
        world.setBlock(i + 5, j + 9, k + 22, 0);
        world.setBlock(i + 5, j + 9, k + 23, 0);
        world.setBlock(i + 5, j + 9, k + 24, 0);
        world.setBlock(i + 5, j + 9, k + 25, Block.thinGlass.blockID);
        world.setBlock(i + 5, j + 9, k + 26, 0);
        world.setBlock(i + 5, j + 10, k + 0, 0);
        world.setBlock(i + 5, j + 10, k + 1, 0);
        world.setBlock(i + 5, j + 10, k + 2, 0);
        world.setBlock(i + 5, j + 10, k + 3, 0);
        world.setBlock(i + 5, j + 10, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 10, k + 5, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 5, j + 10, k + 6, 0);
        world.setBlock(i + 5, j + 10, k + 7, 0);
        world.setBlock(i + 5, j + 10, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 10, k + 9, 0);
        world.setBlock(i + 5, j + 10, k + 10, 0);
        world.setBlock(i + 5, j + 10, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 10, k + 12, 0);
        world.setBlock(i + 5, j + 10, k + 13, 0);
        world.setBlock(i + 5, j + 10, k + 14, 0);
        world.setBlock(i + 5, j + 10, k + 15, 0);
        world.setBlock(i + 5, j + 10, k + 16, 0);
        world.setBlock(i + 5, j + 10, k + 17, 0);
        world.setBlock(i + 5, j + 10, k + 18, 0);
        world.setBlock(i + 5, j + 10, k + 19, 0);
        world.setBlock(i + 5, j + 10, k + 20, 0);
        world.setBlock(i + 5, j + 10, k + 21, 0);
        world.setBlock(i + 5, j + 10, k + 22, 0);
        world.setBlock(i + 5, j + 10, k + 23, 0);
        world.setBlock(i + 5, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 10, k + 26, 0);
        world.setBlock(i + 5, j + 11, k + 0, 0);
        world.setBlock(i + 5, j + 11, k + 1, 0);
        world.setBlock(i + 5, j + 11, k + 2, 0);
        world.setBlock(i + 5, j + 11, k + 3, 0);
        world.setBlock(i + 5, j + 11, k + 4, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 5, j + 11, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 11, k + 6, 0);
        world.setBlock(i + 5, j + 11, k + 7, 0);
        world.setBlock(i + 5, j + 11, k + 8, 0);
        world.setBlock(i + 5, j + 11, k + 9, 0);
        world.setBlock(i + 5, j + 11, k + 10, 0);
        world.setBlock(i + 5, j + 11, k + 11, 0);
        world.setBlock(i + 5, j + 11, k + 12, 0);
        world.setBlock(i + 5, j + 11, k + 13, 0);
        world.setBlock(i + 5, j + 11, k + 14, 0);
        world.setBlock(i + 5, j + 11, k + 15, 0);
        world.setBlock(i + 5, j + 11, k + 16, 0);
        world.setBlock(i + 5, j + 11, k + 17, 0);
        world.setBlock(i + 5, j + 11, k + 18, 0);
        world.setBlock(i + 5, j + 11, k + 19, 0);
        world.setBlock(i + 5, j + 11, k + 20, 0);
        world.setBlock(i + 5, j + 11, k + 21, 0);
        world.setBlock(i + 5, j + 11, k + 22, Block.glowStone.blockID);
        world.setBlock(i + 5, j + 11, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 11, k + 26, 0);
        world.setBlock(i + 5, j + 12, k + 0, 0);
        world.setBlock(i + 5, j + 12, k + 1, 0);
        world.setBlock(i + 5, j + 12, k + 2, 0);
        world.setBlock(i + 5, j + 12, k + 3, 0);
        world.setBlock(i + 5, j + 12, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 12, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 12, k + 6, 0);
        world.setBlock(i + 5, j + 12, k + 7, 0);
        world.setBlock(i + 5, j + 12, k + 8, 0);
        world.setBlock(i + 5, j + 12, k + 9, 0);
        world.setBlock(i + 5, j + 12, k + 10, 0);
        world.setBlock(i + 5, j + 12, k + 11, 0);
        world.setBlock(i + 5, j + 12, k + 12, 0);
        world.setBlock(i + 5, j + 12, k + 13, 0);
        world.setBlock(i + 5, j + 12, k + 14, 0);
        world.setBlock(i + 5, j + 12, k + 15, 0);
        world.setBlock(i + 5, j + 12, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 12, k + 17, 0);
        world.setBlock(i + 5, j + 12, k + 18, 0);
        world.setBlock(i + 5, j + 12, k + 19, 0);
        world.setBlock(i + 5, j + 12, k + 20, 0);
        world.setBlock(i + 5, j + 12, k + 21, 0);
        world.setBlock(i + 5, j + 12, k + 22, Block.fence.blockID);
        world.setBlock(i + 5, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 5, j + 12, k + 26, 0);
        world.setBlock(i + 5, j + 13, k + 0, 0);
        world.setBlock(i + 5, j + 13, k + 1, 0);
        world.setBlock(i + 5, j + 13, k + 2, 0);
        world.setBlock(i + 5, j + 13, k + 3, 0);
        world.setBlock(i + 5, j + 13, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 13, k + 6, 0);
        world.setBlock(i + 5, j + 13, k + 7, 0);
        world.setBlock(i + 5, j + 13, k + 8, 0);
        world.setBlock(i + 5, j + 13, k + 9, 0);
        world.setBlock(i + 5, j + 13, k + 10, 0);
        world.setBlock(i + 5, j + 13, k + 11, 0);
        world.setBlock(i + 5, j + 13, k + 12, 0);
        world.setBlock(i + 5, j + 13, k + 13, 0);
        world.setBlock(i + 5, j + 13, k + 14, 0);
        world.setBlock(i + 5, j + 13, k + 15, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 5, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 13, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 13, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 13, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 13, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 13, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 13, k + 26, 0);
        world.setBlock(i + 5, j + 14, k + 0, 0);
        world.setBlock(i + 5, j + 14, k + 1, 0);
        world.setBlock(i + 5, j + 14, k + 2, 0);
        world.setBlock(i + 5, j + 14, k + 3, 0);
        world.setBlock(i + 5, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 22, 0);
        world.setBlock(i + 5, j + 14, k + 23, 0);
        world.setBlock(i + 5, j + 14, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 14, k + 26, 0);
        world.setBlock(i + 5, j + 15, k + 0, 0);
        world.setBlock(i + 5, j + 15, k + 1, 0);
        world.setBlock(i + 5, j + 15, k + 2, 0);
        world.setBlock(i + 5, j + 15, k + 3, 0);
        world.setBlock(i + 5, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 15, k + 5, 0);
        world.setBlock(i + 5, j + 15, k + 6, 0);
        world.setBlock(i + 5, j + 15, k + 7, 0);
        world.setBlock(i + 5, j + 15, k + 8, 0);
        world.setBlock(i + 5, j + 15, k + 9, 0);
        world.setBlock(i + 5, j + 15, k + 10, 0);
        world.setBlock(i + 5, j + 15, k + 11, 0);
        world.setBlock(i + 5, j + 15, k + 12, 0);
        world.setBlock(i + 5, j + 15, k + 13, 0);
        world.setBlock(i + 5, j + 15, k + 14, 0);
        world.setBlock(i + 5, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 15, k + 22, 0);
        world.setBlock(i + 5, j + 15, k + 23, 0);
        world.setBlock(i + 5, j + 15, k + 24, 0);
        world.setBlock(i + 5, j + 15, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 15, k + 26, 0);
        world.setBlock(i + 5, j + 16, k + 0, 0);
        world.setBlock(i + 5, j + 16, k + 1, 0);
        world.setBlock(i + 5, j + 16, k + 2, 0);
        world.setBlock(i + 5, j + 16, k + 3, 0);
        world.setBlock(i + 5, j + 16, k + 4, 0);
        world.setBlock(i + 5, j + 16, k + 5, 0);
        world.setBlock(i + 5, j + 16, k + 6, 0);
        world.setBlock(i + 5, j + 16, k + 7, 0);
        world.setBlock(i + 5, j + 16, k + 8, 0);
        world.setBlock(i + 5, j + 16, k + 9, 0);
        world.setBlock(i + 5, j + 16, k + 10, 0);
        world.setBlock(i + 5, j + 16, k + 11, 0);
        world.setBlock(i + 5, j + 16, k + 12, 0);
        world.setBlock(i + 5, j + 16, k + 13, 0);
        world.setBlock(i + 5, j + 16, k + 14, 0);
        world.setBlock(i + 5, j + 16, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 16, k + 16, 0);
        world.setBlock(i + 5, j + 16, k + 17, 0);
        world.setBlock(i + 5, j + 16, k + 18, 0);
        world.setBlock(i + 5, j + 16, k + 19, 0);
        world.setBlock(i + 5, j + 16, k + 20, 0);
        world.setBlock(i + 5, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 16, k + 22, 0);
        world.setBlock(i + 5, j + 16, k + 23, 0);
        world.setBlock(i + 5, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 16, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 16, k + 26, 0);
        world.setBlock(i + 5, j + 17, k + 0, 0);
        world.setBlock(i + 5, j + 17, k + 1, 0);
        world.setBlock(i + 5, j + 17, k + 2, 0);
        world.setBlock(i + 5, j + 17, k + 3, 0);
        world.setBlock(i + 5, j + 17, k + 4, 0);
        world.setBlock(i + 5, j + 17, k + 5, 0);
        world.setBlock(i + 5, j + 17, k + 6, 0);
        world.setBlock(i + 5, j + 17, k + 7, 0);
        world.setBlock(i + 5, j + 17, k + 8, 0);
        world.setBlock(i + 5, j + 17, k + 9, 0);
        world.setBlock(i + 5, j + 17, k + 10, 0);
        world.setBlock(i + 5, j + 17, k + 11, 0);
        world.setBlock(i + 5, j + 17, k + 12, 0);
        world.setBlock(i + 5, j + 17, k + 13, 0);
        world.setBlock(i + 5, j + 17, k + 14, 0);
        world.setBlock(i + 5, j + 17, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 17, k + 16, 0);
        world.setBlock(i + 5, j + 17, k + 17, 0);
        world.setBlock(i + 5, j + 17, k + 18, 0);
        world.setBlock(i + 5, j + 17, k + 19, 0);
        world.setBlock(i + 5, j + 17, k + 20, 0);
        world.setBlock(i + 5, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 17, k + 22, 0);
        world.setBlock(i + 5, j + 17, k + 23, 0);
        world.setBlock(i + 5, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 17, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 17, k + 26, 0);
        world.setBlock(i + 5, j + 18, k + 0, 0);
        world.setBlock(i + 5, j + 18, k + 1, 0);
        world.setBlock(i + 5, j + 18, k + 2, 0);
        world.setBlock(i + 5, j + 18, k + 3, 0);
        world.setBlock(i + 5, j + 18, k + 4, 0);
        world.setBlock(i + 5, j + 18, k + 5, 0);
        world.setBlock(i + 5, j + 18, k + 6, 0);
        world.setBlock(i + 5, j + 18, k + 7, 0);
        world.setBlock(i + 5, j + 18, k + 8, 0);
        world.setBlock(i + 5, j + 18, k + 9, 0);
        world.setBlock(i + 5, j + 18, k + 10, 0);
        world.setBlock(i + 5, j + 18, k + 11, 0);
        world.setBlock(i + 5, j + 18, k + 12, 0);
        world.setBlock(i + 5, j + 18, k + 13, 0);
        world.setBlock(i + 5, j + 18, k + 14, 0);
        world.setBlock(i + 5, j + 18, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 18, k + 16, 0);
        world.setBlock(i + 5, j + 18, k + 17, 0);
        world.setBlock(i + 5, j + 18, k + 18, 0);
        world.setBlock(i + 5, j + 18, k + 19, 0);
        world.setBlock(i + 5, j + 18, k + 20, 0);
        world.setBlock(i + 5, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 18, k + 22, 0);
        world.setBlock(i + 5, j + 18, k + 23, 0);
        world.setBlock(i + 5, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 18, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 18, k + 26, 0);
        world.setBlock(i + 5, j + 19, k + 0, 0);
        world.setBlock(i + 5, j + 19, k + 1, 0);
        world.setBlock(i + 5, j + 19, k + 2, 0);
        world.setBlock(i + 5, j + 19, k + 3, 0);
        world.setBlock(i + 5, j + 19, k + 4, 0);
        world.setBlock(i + 5, j + 19, k + 5, 0);
        world.setBlock(i + 5, j + 19, k + 6, 0);
        world.setBlock(i + 5, j + 19, k + 7, 0);
        world.setBlock(i + 5, j + 19, k + 8, 0);
        world.setBlock(i + 5, j + 19, k + 9, 0);
        world.setBlock(i + 5, j + 19, k + 10, 0);
        world.setBlock(i + 5, j + 19, k + 11, 0);
        world.setBlock(i + 5, j + 19, k + 12, 0);
        world.setBlock(i + 5, j + 19, k + 13, 0);
        world.setBlock(i + 5, j + 19, k + 14, 0);
        world.setBlock(i + 5, j + 19, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 19, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 19, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 19, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 19, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 19, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 19, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 19, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 19, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 5, j + 19, k + 26, 0);
        world.setBlock(i + 5, j + 20, k + 0, 0);
        world.setBlock(i + 5, j + 20, k + 1, 0);
        world.setBlock(i + 5, j + 20, k + 2, 0);
        world.setBlock(i + 5, j + 20, k + 3, 0);
        world.setBlock(i + 5, j + 20, k + 4, 0);
        world.setBlock(i + 5, j + 20, k + 5, 0);
        world.setBlock(i + 5, j + 20, k + 6, 0);
        world.setBlock(i + 5, j + 20, k + 7, 0);
        world.setBlock(i + 5, j + 20, k + 8, 0);
        world.setBlock(i + 5, j + 20, k + 9, 0);
        world.setBlock(i + 5, j + 20, k + 10, 0);
        world.setBlock(i + 5, j + 20, k + 11, 0);
        world.setBlock(i + 5, j + 20, k + 12, 0);
        world.setBlock(i + 5, j + 20, k + 13, 0);
        world.setBlock(i + 5, j + 20, k + 14, 0);
        world.setBlock(i + 5, j + 20, k + 15, 0);
        world.setBlock(i + 5, j + 20, k + 16, 0);
        world.setBlock(i + 5, j + 20, k + 17, 0);
        world.setBlock(i + 5, j + 20, k + 18, 0);
        world.setBlock(i + 5, j + 20, k + 19, 0);
        world.setBlock(i + 5, j + 20, k + 20, 0);
        world.setBlock(i + 5, j + 20, k + 21, 0);
        world.setBlock(i + 5, j + 20, k + 22, 0);
        world.setBlock(i + 5, j + 20, k + 23, 0);
        world.setBlock(i + 5, j + 20, k + 24, 0);
        world.setBlock(i + 5, j + 20, k + 25, 0);
        world.setBlock(i + 5, j + 20, k + 26, 0);
        world.setBlock(i + 5, j + 21, k + 0, 0);
        world.setBlock(i + 5, j + 21, k + 1, 0);
        world.setBlock(i + 5, j + 21, k + 2, 0);
        world.setBlock(i + 5, j + 21, k + 3, 0);
        world.setBlock(i + 5, j + 21, k + 4, 0);
        world.setBlock(i + 5, j + 21, k + 5, 0);
        world.setBlock(i + 5, j + 21, k + 6, 0);
        world.setBlock(i + 5, j + 21, k + 7, 0);
        world.setBlock(i + 5, j + 21, k + 8, 0);
        world.setBlock(i + 5, j + 21, k + 9, 0);
        world.setBlock(i + 5, j + 21, k + 10, 0);
        world.setBlock(i + 5, j + 21, k + 11, 0);
        world.setBlock(i + 5, j + 21, k + 12, 0);
        world.setBlock(i + 5, j + 21, k + 13, 0);
        world.setBlock(i + 5, j + 21, k + 14, 0);
        world.setBlock(i + 5, j + 21, k + 15, 0);
        world.setBlock(i + 5, j + 21, k + 16, 0);
        world.setBlock(i + 5, j + 21, k + 17, 0);
        world.setBlock(i + 5, j + 21, k + 18, 0);
        world.setBlock(i + 5, j + 21, k + 19, 0);
        world.setBlock(i + 5, j + 21, k + 20, 0);
        world.setBlock(i + 5, j + 21, k + 21, 0);
        world.setBlock(i + 5, j + 21, k + 22, 0);
        world.setBlock(i + 5, j + 21, k + 23, 0);
        world.setBlock(i + 5, j + 21, k + 24, 0);
        world.setBlock(i + 5, j + 21, k + 25, 0);
        world.setBlock(i + 5, j + 21, k + 26, 0);
        world.setBlock(i + 5, j + 22, k + 0, 0);
        world.setBlock(i + 5, j + 22, k + 1, 0);
        world.setBlock(i + 5, j + 22, k + 2, 0);
        world.setBlock(i + 5, j + 22, k + 3, 0);
        world.setBlock(i + 5, j + 22, k + 4, 0);
        world.setBlock(i + 5, j + 22, k + 5, 0);
        world.setBlock(i + 5, j + 22, k + 6, 0);
        world.setBlock(i + 5, j + 22, k + 7, 0);
        world.setBlock(i + 5, j + 22, k + 8, 0);
        world.setBlock(i + 5, j + 22, k + 9, 0);
        world.setBlock(i + 5, j + 22, k + 10, 0);
        world.setBlock(i + 5, j + 22, k + 11, 0);
        world.setBlock(i + 5, j + 22, k + 12, 0);
        world.setBlock(i + 5, j + 22, k + 13, 0);
        world.setBlock(i + 5, j + 22, k + 14, 0);
        world.setBlock(i + 5, j + 22, k + 15, 0);
        world.setBlock(i + 5, j + 22, k + 16, 0);
        world.setBlock(i + 5, j + 22, k + 17, 0);
        world.setBlock(i + 5, j + 22, k + 18, 0);
        world.setBlock(i + 5, j + 22, k + 19, 0);
        world.setBlock(i + 5, j + 22, k + 20, 0);
        world.setBlock(i + 5, j + 22, k + 21, 0);
        world.setBlock(i + 5, j + 22, k + 22, 0);
        world.setBlock(i + 5, j + 22, k + 23, 0);
        world.setBlock(i + 5, j + 22, k + 24, 0);
        world.setBlock(i + 5, j + 22, k + 25, 0);
        world.setBlock(i + 5, j + 22, k + 26, 0);
        world.setBlock(i + 5, j + 23, k + 0, 0);
        world.setBlock(i + 5, j + 23, k + 1, 0);
        world.setBlock(i + 5, j + 23, k + 2, 0);
        world.setBlock(i + 5, j + 23, k + 3, 0);
        world.setBlock(i + 5, j + 23, k + 4, 0);
        world.setBlock(i + 5, j + 23, k + 5, 0);
        world.setBlock(i + 5, j + 23, k + 6, 0);
        world.setBlock(i + 5, j + 23, k + 7, 0);
        world.setBlock(i + 5, j + 23, k + 8, 0);
        world.setBlock(i + 5, j + 23, k + 9, 0);
        world.setBlock(i + 5, j + 23, k + 10, 0);
        world.setBlock(i + 5, j + 23, k + 11, 0);
        world.setBlock(i + 5, j + 23, k + 12, 0);
        world.setBlock(i + 5, j + 23, k + 13, 0);
        world.setBlock(i + 5, j + 23, k + 14, 0);
        world.setBlock(i + 5, j + 23, k + 15, 0);
        world.setBlock(i + 5, j + 23, k + 16, 0);
        world.setBlock(i + 5, j + 23, k + 17, 0);
        world.setBlock(i + 5, j + 23, k + 18, 0);
        world.setBlock(i + 5, j + 23, k + 19, 0);
        world.setBlock(i + 5, j + 23, k + 20, 0);
        world.setBlock(i + 5, j + 23, k + 21, 0);
        world.setBlock(i + 5, j + 23, k + 22, 0);
        world.setBlock(i + 5, j + 23, k + 23, 0);
        world.setBlock(i + 5, j + 23, k + 24, 0);
        world.setBlock(i + 5, j + 23, k + 25, 0);
        world.setBlock(i + 5, j + 23, k + 26, 0);
        world.setBlock(i + 5, j + 24, k + 0, 0);
        world.setBlock(i + 5, j + 24, k + 1, 0);
        world.setBlock(i + 5, j + 24, k + 2, 0);
        world.setBlock(i + 5, j + 24, k + 3, 0);
        world.setBlock(i + 5, j + 24, k + 4, 0);
        world.setBlock(i + 5, j + 24, k + 5, 0);
        world.setBlock(i + 5, j + 24, k + 6, 0);
        world.setBlock(i + 5, j + 24, k + 7, 0);
        world.setBlock(i + 5, j + 24, k + 8, 0);
        world.setBlock(i + 5, j + 24, k + 9, 0);
        world.setBlock(i + 5, j + 24, k + 10, 0);
        world.setBlock(i + 5, j + 24, k + 11, 0);
        world.setBlock(i + 5, j + 24, k + 12, 0);
        world.setBlock(i + 5, j + 24, k + 13, 0);
        world.setBlock(i + 5, j + 24, k + 14, 0);
        world.setBlock(i + 5, j + 24, k + 15, 0);
        world.setBlock(i + 5, j + 24, k + 16, 0);
        world.setBlock(i + 5, j + 24, k + 17, 0);
        world.setBlock(i + 5, j + 24, k + 18, 0);
        world.setBlock(i + 5, j + 24, k + 19, 0);
        world.setBlock(i + 5, j + 24, k + 20, 0);
        world.setBlock(i + 5, j + 24, k + 21, 0);
        world.setBlock(i + 5, j + 24, k + 22, 0);
        world.setBlock(i + 5, j + 24, k + 23, 0);
        world.setBlock(i + 5, j + 24, k + 24, 0);
        world.setBlock(i + 5, j + 24, k + 25, 0);
        world.setBlock(i + 5, j + 24, k + 26, 0);
        world.setBlock(i + 5, j + 25, k + 0, 0);
        world.setBlock(i + 5, j + 25, k + 1, 0);
        world.setBlock(i + 5, j + 25, k + 2, 0);
        world.setBlock(i + 5, j + 25, k + 3, 0);
        world.setBlock(i + 5, j + 25, k + 4, 0);
        world.setBlock(i + 5, j + 25, k + 5, 0);
        world.setBlock(i + 5, j + 25, k + 6, 0);
        world.setBlock(i + 5, j + 25, k + 7, 0);
        world.setBlock(i + 5, j + 25, k + 8, 0);
        world.setBlock(i + 5, j + 25, k + 9, 0);
        world.setBlock(i + 5, j + 25, k + 10, 0);
        world.setBlock(i + 5, j + 25, k + 11, 0);
        world.setBlock(i + 5, j + 25, k + 12, 0);
        world.setBlock(i + 5, j + 25, k + 13, 0);
        world.setBlock(i + 5, j + 25, k + 14, 0);
        world.setBlock(i + 5, j + 25, k + 15, 0);
        world.setBlock(i + 5, j + 25, k + 16, 0);
        world.setBlock(i + 5, j + 25, k + 17, 0);
        world.setBlock(i + 5, j + 25, k + 18, 0);
        world.setBlock(i + 5, j + 25, k + 19, 0);
        world.setBlock(i + 5, j + 25, k + 20, 0);
        world.setBlock(i + 5, j + 25, k + 21, 0);
        world.setBlock(i + 5, j + 25, k + 22, 0);
        world.setBlock(i + 5, j + 25, k + 23, 0);
        world.setBlock(i + 5, j + 25, k + 24, 0);
        world.setBlock(i + 5, j + 25, k + 25, 0);
        world.setBlock(i + 5, j + 25, k + 26, 0);
        world.setBlock(i + 6, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 6, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 6, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 6, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 6, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 6, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 6, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 6, j + 2, k + 4, Block.dirt.blockID);
        world.setBlock(i + 6, j + 2, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 2, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 2, k + 8, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 6, j + 2, k + 9, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 6, j + 2, k + 10, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 6, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 6, j + 2, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 6, j + 2, k + 13, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 6, j + 2, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 2, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 2, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 2, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 2, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 2, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 2, k + 22, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 6, j + 2, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 2, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 6, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 6, j + 3, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 3, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 3, k + 7, 0);
        world.setBlock(i + 6, j + 3, k + 8, 0);
        world.setBlock(i + 6, j + 3, k + 9, 0);
        world.setBlock(i + 6, j + 3, k + 10, 0);
        world.setBlock(i + 6, j + 3, k + 11, 0);
        world.setBlock(i + 6, j + 3, k + 12, 0);
        world.setBlock(i + 6, j + 3, k + 13, 0);
        world.setBlock(i + 6, j + 3, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 3, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 3, k + 16, 0);
        world.setBlock(i + 6, j + 3, k + 17, 0);
        world.setBlock(i + 6, j + 3, k + 18, 0);
        world.setBlock(i + 6, j + 3, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 3, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 3, k + 21, 0);
        world.setBlock(i + 6, j + 3, k + 22, 0);
        world.setBlock(i + 6, j + 3, k + 23, Block.chest.blockID, 2, 0);
        world.setBlock(i + 6, j + 3, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 4, k + 0, 0);
        world.setBlock(i + 6, j + 4, k + 1, 0);
        world.setBlock(i + 6, j + 4, k + 2, 0);
        world.setBlock(i + 6, j + 4, k + 3, 0);
        world.setBlock(i + 6, j + 4, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 4, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 4, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 4, k + 7, 0);
        world.setBlock(i + 6, j + 4, k + 8, 0);
        world.setBlock(i + 6, j + 4, k + 9, 0);
        world.setBlock(i + 6, j + 4, k + 10, 0);
        world.setBlock(i + 6, j + 4, k + 11, 0);
        world.setBlock(i + 6, j + 4, k + 12, 0);
        world.setBlock(i + 6, j + 4, k + 13, 0);
        world.setBlock(i + 6, j + 4, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 4, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 4, k + 16, 0);
        world.setBlock(i + 6, j + 4, k + 17, 0);
        world.setBlock(i + 6, j + 4, k + 18, 0);
        world.setBlock(i + 6, j + 4, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 4, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 4, k + 21, 0);
        world.setBlock(i + 6, j + 4, k + 22, 0);
        world.setBlock(i + 6, j + 4, k + 23, Block.chest.blockID, 2, 0);
        world.setBlock(i + 6, j + 4, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 4, k + 25, 0);
        world.setBlock(i + 6, j + 4, k + 26, 0);
        world.setBlock(i + 6, j + 5, k + 0, 0);
        world.setBlock(i + 6, j + 5, k + 1, 0);
        world.setBlock(i + 6, j + 5, k + 2, 0);
        world.setBlock(i + 6, j + 5, k + 3, 0);
        world.setBlock(i + 6, j + 5, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 5, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 5, k + 7, 0);
        world.setBlock(i + 6, j + 5, k + 8, 0);
        world.setBlock(i + 6, j + 5, k + 9, 0);
        world.setBlock(i + 6, j + 5, k + 10, 0);
        world.setBlock(i + 6, j + 5, k + 11, 0);
        world.setBlock(i + 6, j + 5, k + 12, 0);
        world.setBlock(i + 6, j + 5, k + 13, 0);
        world.setBlock(i + 6, j + 5, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 5, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 5, k + 16, 0);
        world.setBlock(i + 6, j + 5, k + 17, 0);
        world.setBlock(i + 6, j + 5, k + 18, 0);
        world.setBlock(i + 6, j + 5, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 5, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 5, k + 21, 0);
        world.setBlock(i + 6, j + 5, k + 22, 0);
        world.setBlock(i + 6, j + 5, k + 23, 0);
        world.setBlock(i + 6, j + 5, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 5, k + 25, 0);
        world.setBlock(i + 6, j + 5, k + 26, 0);
        world.setBlock(i + 6, j + 6, k + 0, 0);
        world.setBlock(i + 6, j + 6, k + 1, 0);
        world.setBlock(i + 6, j + 6, k + 2, 0);
        world.setBlock(i + 6, j + 6, k + 3, 0);
        world.setBlock(i + 6, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 6, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 6, k + 7, Block.glowStone.blockID);
        world.setBlock(i + 6, j + 6, k + 8, 0);
        world.setBlock(i + 6, j + 6, k + 9, 0);
        world.setBlock(i + 6, j + 6, k + 10, 0);
        world.setBlock(i + 6, j + 6, k + 11, 0);
        world.setBlock(i + 6, j + 6, k + 12, 0);
        world.setBlock(i + 6, j + 6, k + 13, 0);
        world.setBlock(i + 6, j + 6, k + 14, Block.netherrack.blockID);
        world.setBlock(i + 6, j + 6, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 6, k + 16, 0);
        world.setBlock(i + 6, j + 6, k + 17, 0);
        world.setBlock(i + 6, j + 6, k + 18, 0);
        world.setBlock(i + 6, j + 6, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 6, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 6, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 6, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 6, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 6, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 6, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 6, k + 26, 0);
        world.setBlock(i + 6, j + 7, k + 0, 0);
        world.setBlock(i + 6, j + 7, k + 1, 0);
        world.setBlock(i + 6, j + 7, k + 2, 0);
        world.setBlock(i + 6, j + 7, k + 3, 0);
        world.setBlock(i + 6, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 7, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 7, k + 7, Block.fence.blockID);
        world.setBlock(i + 6, j + 7, k + 8, 0);
        world.setBlock(i + 6, j + 7, k + 9, 0);
        world.setBlock(i + 6, j + 7, k + 10, 0);
        world.setBlock(i + 6, j + 7, k + 11, 0);
        world.setBlock(i + 6, j + 7, k + 12, 0);
        world.setBlock(i + 6, j + 7, k + 13, 0);
        world.setBlock(i + 6, j + 7, k + 14, Block.netherrack.blockID);
        world.setBlock(i + 6, j + 7, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 7, k + 16, 0);
        world.setBlock(i + 6, j + 7, k + 17, 0);
        world.setBlock(i + 6, j + 7, k + 18, 0);
        world.setBlock(i + 6, j + 7, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 7, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 7, k + 21, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 6, j + 7, k + 22, 0);
        world.setBlock(i + 6, j + 7, k + 23, 0);
        world.setBlock(i + 6, j + 7, k + 24, 0);
        world.setBlock(i + 6, j + 7, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 7, k + 26, 0);
        world.setBlock(i + 6, j + 8, k + 0, 0);
        world.setBlock(i + 6, j + 8, k + 1, 0);
        world.setBlock(i + 6, j + 8, k + 2, 0);
        world.setBlock(i + 6, j + 8, k + 3, 0);
        world.setBlock(i + 6, j + 8, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 8, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 8, k + 7, 0);
        world.setBlock(i + 6, j + 8, k + 8, 0);
        world.setBlock(i + 6, j + 8, k + 9, 0);
        world.setBlock(i + 6, j + 8, k + 10, 0);
        world.setBlock(i + 6, j + 8, k + 11, 0);
        world.setBlock(i + 6, j + 8, k + 12, 0);
        world.setBlock(i + 6, j + 8, k + 13, 0);
        world.setBlock(i + 6, j + 8, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 8, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 8, k + 16, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 8, k + 17, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 8, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 8, k + 19, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 6, j + 8, k + 20, 0);
        world.setBlock(i + 6, j + 8, k + 21, 0);
        world.setBlock(i + 6, j + 8, k + 22, 0);
        world.setBlock(i + 6, j + 8, k + 23, 0);
        world.setBlock(i + 6, j + 8, k + 24, 0);
        world.setBlock(i + 6, j + 8, k + 25, Block.thinGlass.blockID);
        world.setBlock(i + 6, j + 8, k + 26, 0);
        world.setBlock(i + 6, j + 9, k + 0, 0);
        world.setBlock(i + 6, j + 9, k + 1, 0);
        world.setBlock(i + 6, j + 9, k + 2, 0);
        world.setBlock(i + 6, j + 9, k + 3, 0);
        world.setBlock(i + 6, j + 9, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 9, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 9, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 9, k + 7, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 9, k + 8, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 9, k + 9, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 9, k + 10, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 9, k + 11, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 9, k + 12, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 9, k + 13, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 9, k + 14, Block.netherrack.blockID);
        world.setBlock(i + 6, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 9, k + 17, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 6, j + 9, k + 18, 0);
        world.setBlock(i + 6, j + 9, k + 19, 0);
        world.setBlock(i + 6, j + 9, k + 20, 0);
        world.setBlock(i + 6, j + 9, k + 21, 0);
        world.setBlock(i + 6, j + 9, k + 22, 0);
        world.setBlock(i + 6, j + 9, k + 23, 0);
        world.setBlock(i + 6, j + 9, k + 24, 0);
        world.setBlock(i + 6, j + 9, k + 25, Block.thinGlass.blockID);
        world.setBlock(i + 6, j + 9, k + 26, 0);
        world.setBlock(i + 6, j + 10, k + 0, 0);
        world.setBlock(i + 6, j + 10, k + 1, 0);
        world.setBlock(i + 6, j + 10, k + 2, 0);
        world.setBlock(i + 6, j + 10, k + 3, 0);
        world.setBlock(i + 6, j + 10, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 10, k + 6, 0);
        world.setBlock(i + 6, j + 10, k + 7, 0);
        world.setBlock(i + 6, j + 10, k + 8, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 6, j + 10, k + 9, 0);
        world.setBlock(i + 6, j + 10, k + 10, 0);
        world.setBlock(i + 6, j + 10, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 10, k + 12, 0);
        world.setBlock(i + 6, j + 10, k + 13, 0);
        world.setBlock(i + 6, j + 10, k + 14, 0);
        world.setBlock(i + 6, j + 10, k + 15, 0);
        world.setBlock(i + 6, j + 10, k + 16, 0);
        world.setBlock(i + 6, j + 10, k + 17, 0);
        world.setBlock(i + 6, j + 10, k + 18, 0);
        world.setBlock(i + 6, j + 10, k + 19, 0);
        world.setBlock(i + 6, j + 10, k + 20, 0);
        world.setBlock(i + 6, j + 10, k + 21, 0);
        world.setBlock(i + 6, j + 10, k + 22, 0);
        world.setBlock(i + 6, j + 10, k + 23, 0);
        world.setBlock(i + 6, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 10, k + 26, 0);
        world.setBlock(i + 6, j + 11, k + 0, 0);
        world.setBlock(i + 6, j + 11, k + 1, 0);
        world.setBlock(i + 6, j + 11, k + 2, 0);
        world.setBlock(i + 6, j + 11, k + 3, 0);
        world.setBlock(i + 6, j + 11, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 11, k + 5, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 6, j + 11, k + 6, 0);
        world.setBlock(i + 6, j + 11, k + 7, 0);
        world.setBlock(i + 6, j + 11, k + 8, 0);
        world.setBlock(i + 6, j + 11, k + 9, 0);
        world.setBlock(i + 6, j + 11, k + 10, 0);
        world.setBlock(i + 6, j + 11, k + 11, 0);
        world.setBlock(i + 6, j + 11, k + 12, 0);
        world.setBlock(i + 6, j + 11, k + 13, 0);
        world.setBlock(i + 6, j + 11, k + 14, 0);
        world.setBlock(i + 6, j + 11, k + 15, 0);
        world.setBlock(i + 6, j + 11, k + 16, 0);
        world.setBlock(i + 6, j + 11, k + 17, 0);
        world.setBlock(i + 6, j + 11, k + 18, 0);
        world.setBlock(i + 6, j + 11, k + 19, 0);
        world.setBlock(i + 6, j + 11, k + 20, 0);
        world.setBlock(i + 6, j + 11, k + 21, 0);
        world.setBlock(i + 6, j + 11, k + 22, 0);
        world.setBlock(i + 6, j + 11, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 11, k + 26, 0);
        world.setBlock(i + 6, j + 12, k + 0, 0);
        world.setBlock(i + 6, j + 12, k + 1, 0);
        world.setBlock(i + 6, j + 12, k + 2, 0);
        world.setBlock(i + 6, j + 12, k + 3, 0);
        world.setBlock(i + 6, j + 12, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 12, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 12, k + 6, 0);
        world.setBlock(i + 6, j + 12, k + 7, 0);
        world.setBlock(i + 6, j + 12, k + 8, 0);
        world.setBlock(i + 6, j + 12, k + 9, 0);
        world.setBlock(i + 6, j + 12, k + 10, 0);
        world.setBlock(i + 6, j + 12, k + 11, 0);
        world.setBlock(i + 6, j + 12, k + 12, 0);
        world.setBlock(i + 6, j + 12, k + 13, 0);
        world.setBlock(i + 6, j + 12, k + 14, 0);
        world.setBlock(i + 6, j + 12, k + 15, 0);
        world.setBlock(i + 6, j + 12, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 12, k + 17, 0);
        world.setBlock(i + 6, j + 12, k + 18, 0);
        world.setBlock(i + 6, j + 12, k + 19, Block.web.blockID);
        world.setBlock(i + 6, j + 12, k + 20, 0);
        world.setBlock(i + 6, j + 12, k + 21, 0);
        world.setBlock(i + 6, j + 12, k + 22, 0);
        world.setBlock(i + 6, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 6, j + 12, k + 26, 0);
        world.setBlock(i + 6, j + 13, k + 0, 0);
        generate4(world, rand, i, j, k);
        return true;
    }

    public boolean generate4(World world, Random rand, int i, int j, int k)
    {
        world.setBlock(i + 6, j + 13, k + 1, 0);
        world.setBlock(i + 6, j + 13, k + 2, 0);
        world.setBlock(i + 6, j + 13, k + 3, 0);
        world.setBlock(i + 6, j + 13, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 6, 0);
        world.setBlock(i + 6, j + 13, k + 7, 0);
        world.setBlock(i + 6, j + 13, k + 8, 0);
        world.setBlock(i + 6, j + 13, k + 9, 0);
        world.setBlock(i + 6, j + 13, k + 10, 0);
        world.setBlock(i + 6, j + 13, k + 11, 0);
        world.setBlock(i + 6, j + 13, k + 12, 0);
        world.setBlock(i + 6, j + 13, k + 13, 0);
        world.setBlock(i + 6, j + 13, k + 14, 0);
        world.setBlock(i + 6, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 13, k + 26, 0);
        world.setBlock(i + 6, j + 14, k + 0, 0);
        world.setBlock(i + 6, j + 14, k + 1, 0);
        world.setBlock(i + 6, j + 14, k + 2, 0);
        world.setBlock(i + 6, j + 14, k + 3, 0);
        world.setBlock(i + 6, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 22, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 6, j + 14, k + 23, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 6, j + 14, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 14, k + 26, 0);
        world.setBlock(i + 6, j + 15, k + 0, 0);
        world.setBlock(i + 6, j + 15, k + 1, 0);
        world.setBlock(i + 6, j + 15, k + 2, 0);
        world.setBlock(i + 6, j + 15, k + 3, 0);
        world.setBlock(i + 6, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 15, k + 5, 0);
        world.setBlock(i + 6, j + 15, k + 6, 0);
        world.setBlock(i + 6, j + 15, k + 7, 0);
        world.setBlock(i + 6, j + 15, k + 8, 0);
        world.setBlock(i + 6, j + 15, k + 9, 0);
        world.setBlock(i + 6, j + 15, k + 10, 0);
        world.setBlock(i + 6, j + 15, k + 11, 0);
        world.setBlock(i + 6, j + 15, k + 12, 0);
        world.setBlock(i + 6, j + 15, k + 13, 0);
        world.setBlock(i + 6, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 15, k + 22, 0);
        world.setBlock(i + 6, j + 15, k + 23, 0);
        world.setBlock(i + 6, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 15, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 15, k + 26, 0);
        world.setBlock(i + 6, j + 16, k + 0, 0);
        world.setBlock(i + 6, j + 16, k + 1, 0);
        world.setBlock(i + 6, j + 16, k + 2, 0);
        world.setBlock(i + 6, j + 16, k + 3, 0);
        world.setBlock(i + 6, j + 16, k + 4, 0);
        world.setBlock(i + 6, j + 16, k + 5, 0);
        world.setBlock(i + 6, j + 16, k + 6, 0);
        world.setBlock(i + 6, j + 16, k + 7, 0);
        world.setBlock(i + 6, j + 16, k + 8, 0);
        world.setBlock(i + 6, j + 16, k + 9, 0);
        world.setBlock(i + 6, j + 16, k + 10, 0);
        world.setBlock(i + 6, j + 16, k + 11, 0);
        world.setBlock(i + 6, j + 16, k + 12, 0);
        world.setBlock(i + 6, j + 16, k + 13, 0);
        world.setBlock(i + 6, j + 16, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 16, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 16, k + 16, 0);
        world.setBlock(i + 6, j + 16, k + 17, 0);
        world.setBlock(i + 6, j + 16, k + 18, 0);
        world.setBlock(i + 6, j + 16, k + 19, Block.bed.blockID);
        world.setBlock(i + 6, j + 16, k + 20, Block.bed.blockID, 8, 0);
        world.setBlock(i + 6, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 16, k + 22, 0);
        world.setBlock(i + 6, j + 16, k + 23, 0);
        world.setBlock(i + 6, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 16, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 16, k + 26, 0);
        world.setBlock(i + 6, j + 17, k + 0, 0);
        world.setBlock(i + 6, j + 17, k + 1, 0);
        world.setBlock(i + 6, j + 17, k + 2, 0);
        world.setBlock(i + 6, j + 17, k + 3, 0);
        world.setBlock(i + 6, j + 17, k + 4, 0);
        world.setBlock(i + 6, j + 17, k + 5, 0);
        world.setBlock(i + 6, j + 17, k + 6, 0);
        world.setBlock(i + 6, j + 17, k + 7, 0);
        world.setBlock(i + 6, j + 17, k + 8, 0);
        world.setBlock(i + 6, j + 17, k + 9, 0);
        world.setBlock(i + 6, j + 17, k + 10, 0);
        world.setBlock(i + 6, j + 17, k + 11, 0);
        world.setBlock(i + 6, j + 17, k + 12, 0);
        world.setBlock(i + 6, j + 17, k + 13, 0);
        world.setBlock(i + 6, j + 17, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 17, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 17, k + 16, 0);
        world.setBlock(i + 6, j + 17, k + 17, 0);
        world.setBlock(i + 6, j + 17, k + 18, 0);
        world.setBlock(i + 6, j + 17, k + 19, 0);
        world.setBlock(i + 6, j + 17, k + 20, 0);
        world.setBlock(i + 6, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 17, k + 22, 0);
        world.setBlock(i + 6, j + 17, k + 23, 0);
        world.setBlock(i + 6, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 17, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 17, k + 26, 0);
        world.setBlock(i + 6, j + 18, k + 0, 0);
        world.setBlock(i + 6, j + 18, k + 1, 0);
        world.setBlock(i + 6, j + 18, k + 2, 0);
        world.setBlock(i + 6, j + 18, k + 3, 0);
        world.setBlock(i + 6, j + 18, k + 4, 0);
        world.setBlock(i + 6, j + 18, k + 5, 0);
        world.setBlock(i + 6, j + 18, k + 6, 0);
        world.setBlock(i + 6, j + 18, k + 7, 0);
        world.setBlock(i + 6, j + 18, k + 8, 0);
        world.setBlock(i + 6, j + 18, k + 9, 0);
        world.setBlock(i + 6, j + 18, k + 10, 0);
        world.setBlock(i + 6, j + 18, k + 11, 0);
        world.setBlock(i + 6, j + 18, k + 12, 0);
        world.setBlock(i + 6, j + 18, k + 13, 0);
        world.setBlock(i + 6, j + 18, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 18, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 18, k + 16, 0);
        world.setBlock(i + 6, j + 18, k + 17, 0);
        world.setBlock(i + 6, j + 18, k + 18, 0);
        world.setBlock(i + 6, j + 18, k + 19, 0);
        world.setBlock(i + 6, j + 18, k + 20, 0);
        world.setBlock(i + 6, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 18, k + 22, 0);
        world.setBlock(i + 6, j + 18, k + 23, 0);
        world.setBlock(i + 6, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 18, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 18, k + 26, 0);
        world.setBlock(i + 6, j + 19, k + 0, 0);
        world.setBlock(i + 6, j + 19, k + 1, 0);
        world.setBlock(i + 6, j + 19, k + 2, 0);
        world.setBlock(i + 6, j + 19, k + 3, 0);
        world.setBlock(i + 6, j + 19, k + 4, 0);
        world.setBlock(i + 6, j + 19, k + 5, 0);
        world.setBlock(i + 6, j + 19, k + 6, 0);
        world.setBlock(i + 6, j + 19, k + 7, 0);
        world.setBlock(i + 6, j + 19, k + 8, 0);
        world.setBlock(i + 6, j + 19, k + 9, 0);
        world.setBlock(i + 6, j + 19, k + 10, 0);
        world.setBlock(i + 6, j + 19, k + 11, 0);
        world.setBlock(i + 6, j + 19, k + 12, 0);
        world.setBlock(i + 6, j + 19, k + 13, 0);
        world.setBlock(i + 6, j + 19, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 19, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 19, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 19, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 19, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 19, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 19, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 19, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 19, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 19, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 19, k + 26, 0);
        world.setBlock(i + 6, j + 20, k + 0, 0);
        world.setBlock(i + 6, j + 20, k + 1, 0);
        world.setBlock(i + 6, j + 20, k + 2, 0);
        world.setBlock(i + 6, j + 20, k + 3, 0);
        world.setBlock(i + 6, j + 20, k + 4, 0);
        world.setBlock(i + 6, j + 20, k + 5, 0);
        world.setBlock(i + 6, j + 20, k + 6, 0);
        world.setBlock(i + 6, j + 20, k + 7, 0);
        world.setBlock(i + 6, j + 20, k + 8, 0);
        world.setBlock(i + 6, j + 20, k + 9, 0);
        world.setBlock(i + 6, j + 20, k + 10, 0);
        world.setBlock(i + 6, j + 20, k + 11, 0);
        world.setBlock(i + 6, j + 20, k + 12, 0);
        world.setBlock(i + 6, j + 20, k + 13, 0);
        world.setBlock(i + 6, j + 20, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 20, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 20, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 20, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 20, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 20, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 20, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 20, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 20, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 20, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 20, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 20, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 6, j + 20, k + 26, 0);
        world.setBlock(i + 6, j + 21, k + 0, 0);
        world.setBlock(i + 6, j + 21, k + 1, 0);
        world.setBlock(i + 6, j + 21, k + 2, 0);
        world.setBlock(i + 6, j + 21, k + 3, 0);
        world.setBlock(i + 6, j + 21, k + 4, 0);
        world.setBlock(i + 6, j + 21, k + 5, 0);
        world.setBlock(i + 6, j + 21, k + 6, 0);
        world.setBlock(i + 6, j + 21, k + 7, 0);
        world.setBlock(i + 6, j + 21, k + 8, 0);
        world.setBlock(i + 6, j + 21, k + 9, 0);
        world.setBlock(i + 6, j + 21, k + 10, 0);
        world.setBlock(i + 6, j + 21, k + 11, 0);
        world.setBlock(i + 6, j + 21, k + 12, 0);
        world.setBlock(i + 6, j + 21, k + 13, 0);
        world.setBlock(i + 6, j + 21, k + 14, 0);
        world.setBlock(i + 6, j + 21, k + 15, 0);
        world.setBlock(i + 6, j + 21, k + 16, 0);
        world.setBlock(i + 6, j + 21, k + 17, 0);
        world.setBlock(i + 6, j + 21, k + 18, 0);
        world.setBlock(i + 6, j + 21, k + 19, 0);
        world.setBlock(i + 6, j + 21, k + 20, 0);
        world.setBlock(i + 6, j + 21, k + 21, 0);
        world.setBlock(i + 6, j + 21, k + 22, 0);
        world.setBlock(i + 6, j + 21, k + 23, 0);
        world.setBlock(i + 6, j + 21, k + 24, 0);
        world.setBlock(i + 6, j + 21, k + 25, 0);
        world.setBlock(i + 6, j + 21, k + 26, 0);
        world.setBlock(i + 6, j + 22, k + 0, 0);
        world.setBlock(i + 6, j + 22, k + 1, 0);
        world.setBlock(i + 6, j + 22, k + 2, 0);
        world.setBlock(i + 6, j + 22, k + 3, 0);
        world.setBlock(i + 6, j + 22, k + 4, 0);
        world.setBlock(i + 6, j + 22, k + 5, 0);
        world.setBlock(i + 6, j + 22, k + 6, 0);
        world.setBlock(i + 6, j + 22, k + 7, 0);
        world.setBlock(i + 6, j + 22, k + 8, 0);
        world.setBlock(i + 6, j + 22, k + 9, 0);
        world.setBlock(i + 6, j + 22, k + 10, 0);
        world.setBlock(i + 6, j + 22, k + 11, 0);
        world.setBlock(i + 6, j + 22, k + 12, 0);
        world.setBlock(i + 6, j + 22, k + 13, 0);
        world.setBlock(i + 6, j + 22, k + 14, 0);
        world.setBlock(i + 6, j + 22, k + 15, 0);
        world.setBlock(i + 6, j + 22, k + 16, 0);
        world.setBlock(i + 6, j + 22, k + 17, 0);
        world.setBlock(i + 6, j + 22, k + 18, 0);
        world.setBlock(i + 6, j + 22, k + 19, 0);
        world.setBlock(i + 6, j + 22, k + 20, 0);
        world.setBlock(i + 6, j + 22, k + 21, 0);
        world.setBlock(i + 6, j + 22, k + 22, 0);
        world.setBlock(i + 6, j + 22, k + 23, 0);
        world.setBlock(i + 6, j + 22, k + 24, 0);
        world.setBlock(i + 6, j + 22, k + 25, 0);
        world.setBlock(i + 6, j + 22, k + 26, 0);
        world.setBlock(i + 6, j + 23, k + 0, 0);
        world.setBlock(i + 6, j + 23, k + 1, 0);
        world.setBlock(i + 6, j + 23, k + 2, 0);
        world.setBlock(i + 6, j + 23, k + 3, 0);
        world.setBlock(i + 6, j + 23, k + 4, 0);
        world.setBlock(i + 6, j + 23, k + 5, 0);
        world.setBlock(i + 6, j + 23, k + 6, 0);
        world.setBlock(i + 6, j + 23, k + 7, 0);
        world.setBlock(i + 6, j + 23, k + 8, 0);
        world.setBlock(i + 6, j + 23, k + 9, 0);
        world.setBlock(i + 6, j + 23, k + 10, 0);
        world.setBlock(i + 6, j + 23, k + 11, 0);
        world.setBlock(i + 6, j + 23, k + 12, 0);
        world.setBlock(i + 6, j + 23, k + 13, 0);
        world.setBlock(i + 6, j + 23, k + 14, 0);
        world.setBlock(i + 6, j + 23, k + 15, 0);
        world.setBlock(i + 6, j + 23, k + 16, 0);
        world.setBlock(i + 6, j + 23, k + 17, 0);
        world.setBlock(i + 6, j + 23, k + 18, 0);
        world.setBlock(i + 6, j + 23, k + 19, 0);
        world.setBlock(i + 6, j + 23, k + 20, 0);
        world.setBlock(i + 6, j + 23, k + 21, 0);
        world.setBlock(i + 6, j + 23, k + 22, 0);
        world.setBlock(i + 6, j + 23, k + 23, 0);
        world.setBlock(i + 6, j + 23, k + 24, 0);
        world.setBlock(i + 6, j + 23, k + 25, 0);
        world.setBlock(i + 6, j + 23, k + 26, 0);
        world.setBlock(i + 6, j + 24, k + 0, 0);
        world.setBlock(i + 6, j + 24, k + 1, 0);
        world.setBlock(i + 6, j + 24, k + 2, 0);
        world.setBlock(i + 6, j + 24, k + 3, 0);
        world.setBlock(i + 6, j + 24, k + 4, 0);
        world.setBlock(i + 6, j + 24, k + 5, 0);
        world.setBlock(i + 6, j + 24, k + 6, 0);
        world.setBlock(i + 6, j + 24, k + 7, 0);
        world.setBlock(i + 6, j + 24, k + 8, 0);
        world.setBlock(i + 6, j + 24, k + 9, 0);
        world.setBlock(i + 6, j + 24, k + 10, 0);
        world.setBlock(i + 6, j + 24, k + 11, 0);
        world.setBlock(i + 6, j + 24, k + 12, 0);
        world.setBlock(i + 6, j + 24, k + 13, 0);
        world.setBlock(i + 6, j + 24, k + 14, 0);
        world.setBlock(i + 6, j + 24, k + 15, 0);
        world.setBlock(i + 6, j + 24, k + 16, 0);
        world.setBlock(i + 6, j + 24, k + 17, 0);
        world.setBlock(i + 6, j + 24, k + 18, 0);
        world.setBlock(i + 6, j + 24, k + 19, 0);
        world.setBlock(i + 6, j + 24, k + 20, 0);
        world.setBlock(i + 6, j + 24, k + 21, 0);
        world.setBlock(i + 6, j + 24, k + 22, 0);
        world.setBlock(i + 6, j + 24, k + 23, 0);
        world.setBlock(i + 6, j + 24, k + 24, 0);
        world.setBlock(i + 6, j + 24, k + 25, 0);
        world.setBlock(i + 6, j + 24, k + 26, 0);
        world.setBlock(i + 6, j + 25, k + 0, 0);
        world.setBlock(i + 6, j + 25, k + 1, 0);
        world.setBlock(i + 6, j + 25, k + 2, 0);
        world.setBlock(i + 6, j + 25, k + 3, 0);
        world.setBlock(i + 6, j + 25, k + 4, 0);
        world.setBlock(i + 6, j + 25, k + 5, 0);
        world.setBlock(i + 6, j + 25, k + 6, 0);
        world.setBlock(i + 6, j + 25, k + 7, 0);
        world.setBlock(i + 6, j + 25, k + 8, 0);
        world.setBlock(i + 6, j + 25, k + 9, 0);
        world.setBlock(i + 6, j + 25, k + 10, 0);
        world.setBlock(i + 6, j + 25, k + 11, 0);
        world.setBlock(i + 6, j + 25, k + 12, 0);
        world.setBlock(i + 6, j + 25, k + 13, 0);
        world.setBlock(i + 6, j + 25, k + 14, 0);
        world.setBlock(i + 6, j + 25, k + 15, 0);
        world.setBlock(i + 6, j + 25, k + 16, 0);
        world.setBlock(i + 6, j + 25, k + 17, 0);
        world.setBlock(i + 6, j + 25, k + 18, 0);
        world.setBlock(i + 6, j + 25, k + 19, 0);
        world.setBlock(i + 6, j + 25, k + 20, 0);
        world.setBlock(i + 6, j + 25, k + 21, 0);
        world.setBlock(i + 6, j + 25, k + 22, 0);
        world.setBlock(i + 6, j + 25, k + 23, 0);
        world.setBlock(i + 6, j + 25, k + 24, 0);
        world.setBlock(i + 6, j + 25, k + 25, 0);
        world.setBlock(i + 6, j + 25, k + 26, 0);
        world.setBlock(i + 7, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 7, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 7, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 7, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 7, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 7, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 7, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 7, j + 2, k + 4, Block.grass.blockID);
        world.setBlock(i + 7, j + 2, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 2, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 2, k + 8, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 7, j + 2, k + 9, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 7, j + 2, k + 10, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 7, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 7, j + 2, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 7, j + 2, k + 13, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 7, j + 2, k + 14, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 7, j + 2, k + 15, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 7, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 2, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 2, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 2, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 2, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 2, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 2, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 2, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 7, j + 3, k + 0, 0);
        world.setBlock(i + 7, j + 3, k + 4, 0);
        world.setBlock(i + 7, j + 3, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 3, k + 6, 0);
        world.setBlock(i + 7, j + 3, k + 7, 0);
        world.setBlock(i + 7, j + 3, k + 8, 0);
        world.setBlock(i + 7, j + 3, k + 9, 0);
        world.setBlock(i + 7, j + 3, k + 10, 0);
        world.setBlock(i + 7, j + 3, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 7, j + 3, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 7, j + 3, k + 13, 0);
        world.setBlock(i + 7, j + 3, k + 14, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 7, j + 3, k + 15, Block.furnaceIdle.blockID, 5, 0);
        world.setBlock(i + 7, j + 3, k + 16, 0);
        world.setBlock(i + 7, j + 3, k + 17, 0);
        world.setBlock(i + 7, j + 3, k + 18, 0);
        world.setBlock(i + 7, j + 3, k + 19, 0);
        world.setBlock(i + 7, j + 3, k + 20, 0);
        world.setBlock(i + 7, j + 3, k + 21, 0);
        world.setBlock(i + 7, j + 3, k + 22, 0);
        world.setBlock(i + 7, j + 3, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 3, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 3, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 4, k + 0, 0);
        world.setBlock(i + 7, j + 4, k + 1, 0);
        world.setBlock(i + 7, j + 4, k + 2, 0);
        world.setBlock(i + 7, j + 4, k + 3, 0);
        world.setBlock(i + 7, j + 4, k + 4, 0);
        world.setBlock(i + 7, j + 4, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 4, k + 6, 0);
        world.setBlock(i + 7, j + 4, k + 7, 0);
        world.setBlock(i + 7, j + 4, k + 8, 0);
        world.setBlock(i + 7, j + 4, k + 9, 0);
        world.setBlock(i + 7, j + 4, k + 10, 0);
        world.setBlock(i + 7, j + 4, k + 11, 0);
        world.setBlock(i + 7, j + 4, k + 12, 0);
        world.setBlock(i + 7, j + 4, k + 13, 0);
        world.setBlock(i + 7, j + 4, k + 14, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 7, j + 4, k + 15, Block.furnaceIdle.blockID, 5, 0);
        world.setBlock(i + 7, j + 4, k + 16, 0);
        world.setBlock(i + 7, j + 4, k + 17, 0);
        world.setBlock(i + 7, j + 4, k + 18, 0);
        world.setBlock(i + 7, j + 4, k + 19, 0);
        world.setBlock(i + 7, j + 4, k + 20, 0);
        world.setBlock(i + 7, j + 4, k + 21, 0);
        world.setBlock(i + 7, j + 4, k + 22, 0);
        world.setBlock(i + 7, j + 4, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 4, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 4, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 4, k + 26, 0);
        world.setBlock(i + 7, j + 5, k + 0, 0);
        world.setBlock(i + 7, j + 5, k + 1, 0);
        world.setBlock(i + 7, j + 5, k + 2, 0);
        world.setBlock(i + 7, j + 5, k + 3, 0);
        world.setBlock(i + 7, j + 5, k + 4, 0);
        world.setBlock(i + 7, j + 5, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 5, k + 6, 0);
        world.setBlock(i + 7, j + 5, k + 7, 0);
        world.setBlock(i + 7, j + 5, k + 8, 0);
        world.setBlock(i + 7, j + 5, k + 9, 0);
        world.setBlock(i + 7, j + 5, k + 10, 0);
        world.setBlock(i + 7, j + 5, k + 11, 0);
        world.setBlock(i + 7, j + 5, k + 12, 0);
        world.setBlock(i + 7, j + 5, k + 13, 0);
        world.setBlock(i + 7, j + 5, k + 14, 0);
        world.setBlock(i + 7, j + 5, k + 15, 0);
        world.setBlock(i + 7, j + 5, k + 16, 0);
        world.setBlock(i + 7, j + 5, k + 17, 0);
        world.setBlock(i + 7, j + 5, k + 18, 0);
        world.setBlock(i + 7, j + 5, k + 19, 0);
        world.setBlock(i + 7, j + 5, k + 20, 0);
        world.setBlock(i + 7, j + 5, k + 21, 0);
        world.setBlock(i + 7, j + 5, k + 22, 0);
        world.setBlock(i + 7, j + 5, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 5, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 5, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 5, k + 26, 0);
        world.setBlock(i + 7, j + 6, k + 0, 0);
        world.setBlock(i + 7, j + 6, k + 1, 0);
        world.setBlock(i + 7, j + 6, k + 2, 0);
        world.setBlock(i + 7, j + 6, k + 3, 0);
        world.setBlock(i + 7, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 6, k + 6, 0);
        world.setBlock(i + 7, j + 6, k + 7, 0);
        world.setBlock(i + 7, j + 6, k + 8, 0);
        world.setBlock(i + 7, j + 6, k + 9, 0);
        world.setBlock(i + 7, j + 6, k + 10, 0);
        world.setBlock(i + 7, j + 6, k + 11, 0);
        world.setBlock(i + 7, j + 6, k + 12, 0);
        world.setBlock(i + 7, j + 6, k + 13, 0);
        world.setBlock(i + 7, j + 6, k + 14, Block.glowStone.blockID);
        world.setBlock(i + 7, j + 6, k + 15, 0);
        world.setBlock(i + 7, j + 6, k + 16, 0);
        world.setBlock(i + 7, j + 6, k + 17, 0);
        world.setBlock(i + 7, j + 6, k + 18, 0);
        world.setBlock(i + 7, j + 6, k + 19, Block.glowStone.blockID);
        world.setBlock(i + 7, j + 6, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 6, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 6, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 6, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 6, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 6, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 6, k + 26, 0);
        world.setBlock(i + 7, j + 7, k + 0, 0);
        world.setBlock(i + 7, j + 7, k + 1, 0);
        world.setBlock(i + 7, j + 7, k + 2, 0);
        world.setBlock(i + 7, j + 7, k + 3, 0);
        world.setBlock(i + 7, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 7, k + 6, 0);
        world.setBlock(i + 7, j + 7, k + 7, 0);
        world.setBlock(i + 7, j + 7, k + 8, 0);
        world.setBlock(i + 7, j + 7, k + 9, 0);
        world.setBlock(i + 7, j + 7, k + 10, 0);
        world.setBlock(i + 7, j + 7, k + 11, 0);
        world.setBlock(i + 7, j + 7, k + 12, 0);
        world.setBlock(i + 7, j + 7, k + 13, 0);
        world.setBlock(i + 7, j + 7, k + 14, Block.fence.blockID);
        world.setBlock(i + 7, j + 7, k + 15, 0);
        world.setBlock(i + 7, j + 7, k + 16, 0);
        world.setBlock(i + 7, j + 7, k + 17, 0);
        world.setBlock(i + 7, j + 7, k + 18, 0);
        world.setBlock(i + 7, j + 7, k + 19, Block.fence.blockID);
        world.setBlock(i + 7, j + 7, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 7, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 7, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 7, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 7, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 7, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 7, k + 26, 0);
        world.setBlock(i + 7, j + 8, k + 0, 0);
        world.setBlock(i + 7, j + 8, k + 1, 0);
        world.setBlock(i + 7, j + 8, k + 2, 0);
        world.setBlock(i + 7, j + 8, k + 3, 0);
        world.setBlock(i + 7, j + 8, k + 4, 0);
        world.setBlock(i + 7, j + 8, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 8, k + 6, 0);
        world.setBlock(i + 7, j + 8, k + 7, 0);
        world.setBlock(i + 7, j + 8, k + 8, 0);
        world.setBlock(i + 7, j + 8, k + 9, 0);
        world.setBlock(i + 7, j + 8, k + 10, 0);
        world.setBlock(i + 7, j + 8, k + 11, 0);
        world.setBlock(i + 7, j + 8, k + 12, 0);
        world.setBlock(i + 7, j + 8, k + 13, 0);
        world.setBlock(i + 7, j + 8, k + 14, 0);
        world.setBlock(i + 7, j + 8, k + 15, 0);
        world.setBlock(i + 7, j + 8, k + 16, 0);
        world.setBlock(i + 7, j + 8, k + 17, 0);
        world.setBlock(i + 7, j + 8, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 8, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 8, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 8, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 8, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 8, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 8, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 8, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 8, k + 26, 0);
        world.setBlock(i + 7, j + 9, k + 0, 0);
        world.setBlock(i + 7, j + 9, k + 1, 0);
        world.setBlock(i + 7, j + 9, k + 2, 0);
        world.setBlock(i + 7, j + 9, k + 3, 0);
        world.setBlock(i + 7, j + 9, k + 4, 0);
        world.setBlock(i + 7, j + 9, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 9, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 9, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 9, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 9, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 9, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 9, k + 26, 0);
        world.setBlock(i + 7, j + 10, k + 0, 0);
        world.setBlock(i + 7, j + 10, k + 1, 0);
        world.setBlock(i + 7, j + 10, k + 2, 0);
        world.setBlock(i + 7, j + 10, k + 3, 0);
        world.setBlock(i + 7, j + 10, k + 4, 0);
        world.setBlock(i + 7, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 10, k + 6, 0);
        world.setBlock(i + 7, j + 10, k + 7, 0);
        world.setBlock(i + 7, j + 10, k + 8, Block.chest.blockID, 2, 0);
        world.setBlock(i + 7, j + 10, k + 9, 0);
        world.setBlock(i + 7, j + 10, k + 10, 0);
        world.setBlock(i + 7, j + 10, k + 11, Block.chest.blockID, 2, 0);
        world.setBlock(i + 7, j + 10, k + 12, 0);
        world.setBlock(i + 7, j + 10, k + 13, 0);
        world.setBlock(i + 7, j + 10, k + 14, 0);
        world.setBlock(i + 7, j + 10, k + 15, 0);
        world.setBlock(i + 7, j + 10, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 10, k + 17, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 10, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 10, k + 19, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 10, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 10, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 10, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 10, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 10, k + 26, 0);
        world.setBlock(i + 7, j + 11, k + 0, 0);
        world.setBlock(i + 7, j + 11, k + 1, 0);
        world.setBlock(i + 7, j + 11, k + 2, 0);
        world.setBlock(i + 7, j + 11, k + 3, 0);
        world.setBlock(i + 7, j + 11, k + 4, 0);
        world.setBlock(i + 7, j + 11, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 11, k + 6, 0);
        world.setBlock(i + 7, j + 11, k + 7, 0);
        world.setBlock(i + 7, j + 11, k + 8, 0);
        world.setBlock(i + 7, j + 11, k + 9, 0);
        world.setBlock(i + 7, j + 11, k + 10, 0);
        world.setBlock(i + 7, j + 11, k + 11, 0);
        world.setBlock(i + 7, j + 11, k + 12, 0);
        world.setBlock(i + 7, j + 11, k + 13, 0);
        world.setBlock(i + 7, j + 11, k + 14, 0);
        world.setBlock(i + 7, j + 11, k + 15, 0);
        world.setBlock(i + 7, j + 11, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 11, k + 17, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 11, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 11, k + 19, Block.thinGlass.blockID);
        world.setBlock(i + 7, j + 11, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 11, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 11, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 11, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 11, k + 26, 0);
        world.setBlock(i + 7, j + 12, k + 0, 0);
        world.setBlock(i + 7, j + 12, k + 1, 0);
        world.setBlock(i + 7, j + 12, k + 2, 0);
        world.setBlock(i + 7, j + 12, k + 3, 0);
        world.setBlock(i + 7, j + 12, k + 4, 0);
        world.setBlock(i + 7, j + 12, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 12, k + 6, 0);
        world.setBlock(i + 7, j + 12, k + 7, 0);
        world.setBlock(i + 7, j + 12, k + 8, 0);
        world.setBlock(i + 7, j + 12, k + 9, 0);
        world.setBlock(i + 7, j + 12, k + 10, 0);
        world.setBlock(i + 7, j + 12, k + 11, 0);
        world.setBlock(i + 7, j + 12, k + 12, 0);
        world.setBlock(i + 7, j + 12, k + 13, 0);
        world.setBlock(i + 7, j + 12, k + 14, 0);
        world.setBlock(i + 7, j + 12, k + 15, 0);
        world.setBlock(i + 7, j + 12, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 12, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 12, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 12, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 12, k + 20, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 7, j + 12, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 12, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 12, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 12, k + 26, 0);
        world.setBlock(i + 7, j + 13, k + 0, 0);
        world.setBlock(i + 7, j + 13, k + 1, 0);
        world.setBlock(i + 7, j + 13, k + 2, 0);
        world.setBlock(i + 7, j + 13, k + 3, 0);
        world.setBlock(i + 7, j + 13, k + 4, 0);
        world.setBlock(i + 7, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 13, k + 6, 0);
        world.setBlock(i + 7, j + 13, k + 7, 0);
        world.setBlock(i + 7, j + 13, k + 8, 0);
        world.setBlock(i + 7, j + 13, k + 9, 0);
        world.setBlock(i + 7, j + 13, k + 10, 0);
        world.setBlock(i + 7, j + 13, k + 11, 0);
        world.setBlock(i + 7, j + 13, k + 12, 0);
        world.setBlock(i + 7, j + 13, k + 13, 0);
        world.setBlock(i + 7, j + 13, k + 14, 0);
        world.setBlock(i + 7, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 13, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 13, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 13, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 13, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 13, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 13, k + 26, 0);
        world.setBlock(i + 7, j + 14, k + 0, 0);
        world.setBlock(i + 7, j + 14, k + 1, 0);
        world.setBlock(i + 7, j + 14, k + 2, 0);
        world.setBlock(i + 7, j + 14, k + 3, 0);
        world.setBlock(i + 7, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 14, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 14, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 14, k + 26, 0);
        world.setBlock(i + 7, j + 15, k + 0, 0);
        world.setBlock(i + 7, j + 15, k + 1, 0);
        world.setBlock(i + 7, j + 15, k + 2, 0);
        world.setBlock(i + 7, j + 15, k + 3, 0);
        world.setBlock(i + 7, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 15, k + 5, 0);
        world.setBlock(i + 7, j + 15, k + 6, 0);
        world.setBlock(i + 7, j + 15, k + 7, 0);
        world.setBlock(i + 7, j + 15, k + 8, 0);
        world.setBlock(i + 7, j + 15, k + 9, 0);
        world.setBlock(i + 7, j + 15, k + 10, 0);
        world.setBlock(i + 7, j + 15, k + 11, 0);
        world.setBlock(i + 7, j + 15, k + 12, 0);
        world.setBlock(i + 7, j + 15, k + 13, 0);
        world.setBlock(i + 7, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 15, k + 22, 0);
        world.setBlock(i + 7, j + 15, k + 23, 0);
        world.setBlock(i + 7, j + 15, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 15, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 15, k + 26, 0);
        world.setBlock(i + 7, j + 16, k + 0, 0);
        world.setBlock(i + 7, j + 16, k + 1, 0);
        world.setBlock(i + 7, j + 16, k + 2, 0);
        world.setBlock(i + 7, j + 16, k + 3, 0);
        world.setBlock(i + 7, j + 16, k + 4, 0);
        world.setBlock(i + 7, j + 16, k + 5, 0);
        world.setBlock(i + 7, j + 16, k + 6, 0);
        world.setBlock(i + 7, j + 16, k + 7, 0);
        world.setBlock(i + 7, j + 16, k + 8, 0);
        world.setBlock(i + 7, j + 16, k + 9, 0);
        world.setBlock(i + 7, j + 16, k + 10, 0);
        world.setBlock(i + 7, j + 16, k + 11, 0);
        world.setBlock(i + 7, j + 16, k + 12, 0);
        world.setBlock(i + 7, j + 16, k + 13, 0);
        world.setBlock(i + 7, j + 16, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 16, k + 15, Block.bookShelf.blockID);
        world.setBlock(i + 7, j + 16, k + 16, 0);
        world.setBlock(i + 7, j + 16, k + 17, 0);
        world.setBlock(i + 7, j + 16, k + 18, 0);
        world.setBlock(i + 7, j + 16, k + 19, 0);
        world.setBlock(i + 7, j + 16, k + 20, 0);
        world.setBlock(i + 7, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 16, k + 22, 0);
        world.setBlock(i + 7, j + 16, k + 23, 0);
        world.setBlock(i + 7, j + 16, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 16, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 16, k + 26, 0);
        world.setBlock(i + 7, j + 17, k + 0, 0);
        world.setBlock(i + 7, j + 17, k + 1, 0);
        world.setBlock(i + 7, j + 17, k + 2, 0);
        world.setBlock(i + 7, j + 17, k + 3, 0);
        world.setBlock(i + 7, j + 17, k + 4, 0);
        world.setBlock(i + 7, j + 17, k + 5, 0);
        world.setBlock(i + 7, j + 17, k + 6, 0);
        world.setBlock(i + 7, j + 17, k + 7, 0);
        world.setBlock(i + 7, j + 17, k + 8, 0);
        world.setBlock(i + 7, j + 17, k + 9, 0);
        world.setBlock(i + 7, j + 17, k + 10, 0);
        world.setBlock(i + 7, j + 17, k + 11, 0);
        world.setBlock(i + 7, j + 17, k + 12, 0);
        world.setBlock(i + 7, j + 17, k + 13, 0);
        world.setBlock(i + 7, j + 17, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 17, k + 15, Block.bookShelf.blockID);
        world.setBlock(i + 7, j + 17, k + 16, 0);
        world.setBlock(i + 7, j + 17, k + 17, 0);
        world.setBlock(i + 7, j + 17, k + 18, 0);
        world.setBlock(i + 7, j + 17, k + 19, 0);
        world.setBlock(i + 7, j + 17, k + 20, 0);
        world.setBlock(i + 7, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 17, k + 22, 0);
        world.setBlock(i + 7, j + 17, k + 23, 0);
        world.setBlock(i + 7, j + 17, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 17, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 17, k + 26, 0);
        world.setBlock(i + 7, j + 18, k + 0, 0);
        world.setBlock(i + 7, j + 18, k + 1, 0);
        world.setBlock(i + 7, j + 18, k + 2, 0);
        world.setBlock(i + 7, j + 18, k + 3, 0);
        world.setBlock(i + 7, j + 18, k + 4, 0);
        world.setBlock(i + 7, j + 18, k + 5, 0);
        world.setBlock(i + 7, j + 18, k + 6, 0);
        world.setBlock(i + 7, j + 18, k + 7, 0);
        world.setBlock(i + 7, j + 18, k + 8, 0);
        world.setBlock(i + 7, j + 18, k + 9, 0);
        world.setBlock(i + 7, j + 18, k + 10, 0);
        world.setBlock(i + 7, j + 18, k + 11, 0);
        world.setBlock(i + 7, j + 18, k + 12, 0);
        world.setBlock(i + 7, j + 18, k + 13, 0);
        world.setBlock(i + 7, j + 18, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 18, k + 15, Block.bookShelf.blockID);
        world.setBlock(i + 7, j + 18, k + 16, 0);
        world.setBlock(i + 7, j + 18, k + 17, 0);
        world.setBlock(i + 7, j + 18, k + 18, 0);
        world.setBlock(i + 7, j + 18, k + 19, 0);
        world.setBlock(i + 7, j + 18, k + 20, 0);
        world.setBlock(i + 7, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 18, k + 22, 0);
        world.setBlock(i + 7, j + 18, k + 23, 0);
        world.setBlock(i + 7, j + 18, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 18, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 7, j + 18, k + 26, 0);
        world.setBlock(i + 7, j + 19, k + 0, 0);
        world.setBlock(i + 7, j + 19, k + 1, 0);
        world.setBlock(i + 7, j + 19, k + 2, 0);
        world.setBlock(i + 7, j + 19, k + 3, 0);
        world.setBlock(i + 7, j + 19, k + 4, 0);
        world.setBlock(i + 7, j + 19, k + 5, 0);
        world.setBlock(i + 7, j + 19, k + 6, 0);
        world.setBlock(i + 7, j + 19, k + 7, 0);
        world.setBlock(i + 7, j + 19, k + 8, 0);
        world.setBlock(i + 7, j + 19, k + 9, 0);
        world.setBlock(i + 7, j + 19, k + 10, 0);
        world.setBlock(i + 7, j + 19, k + 11, 0);
        world.setBlock(i + 7, j + 19, k + 12, 0);
        world.setBlock(i + 7, j + 19, k + 13, 0);
        world.setBlock(i + 7, j + 19, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 19, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 19, k + 16, Block.glowStone.blockID);
        world.setBlock(i + 7, j + 19, k + 17, 0);
        world.setBlock(i + 7, j + 19, k + 18, 0);
        world.setBlock(i + 7, j + 19, k + 19, 0);
        world.setBlock(i + 7, j + 19, k + 20, 0);
        world.setBlock(i + 7, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 19, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 19, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 19, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 19, k + 26, 0);
        world.setBlock(i + 7, j + 20, k + 0, 0);
        world.setBlock(i + 7, j + 20, k + 1, 0);
        world.setBlock(i + 7, j + 20, k + 2, 0);
        world.setBlock(i + 7, j + 20, k + 3, 0);
        world.setBlock(i + 7, j + 20, k + 4, 0);
        world.setBlock(i + 7, j + 20, k + 5, 0);
        world.setBlock(i + 7, j + 20, k + 6, 0);
        world.setBlock(i + 7, j + 20, k + 7, 0);
        world.setBlock(i + 7, j + 20, k + 8, 0);
        world.setBlock(i + 7, j + 20, k + 9, 0);
        world.setBlock(i + 7, j + 20, k + 10, 0);
        world.setBlock(i + 7, j + 20, k + 11, 0);
        world.setBlock(i + 7, j + 20, k + 12, 0);
        world.setBlock(i + 7, j + 20, k + 13, 0);
        world.setBlock(i + 7, j + 20, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 20, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 20, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 20, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 20, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 20, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 20, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 20, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 20, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 20, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 20, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 20, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 20, k + 26, 0);
        world.setBlock(i + 7, j + 21, k + 0, 0);
        world.setBlock(i + 7, j + 21, k + 1, 0);
        world.setBlock(i + 7, j + 21, k + 2, 0);
        world.setBlock(i + 7, j + 21, k + 3, 0);
        world.setBlock(i + 7, j + 21, k + 4, 0);
        world.setBlock(i + 7, j + 21, k + 5, 0);
        world.setBlock(i + 7, j + 21, k + 6, 0);
        world.setBlock(i + 7, j + 21, k + 7, 0);
        world.setBlock(i + 7, j + 21, k + 8, 0);
        world.setBlock(i + 7, j + 21, k + 9, 0);
        world.setBlock(i + 7, j + 21, k + 10, 0);
        world.setBlock(i + 7, j + 21, k + 11, 0);
        world.setBlock(i + 7, j + 21, k + 12, 0);
        world.setBlock(i + 7, j + 21, k + 13, 0);
        world.setBlock(i + 7, j + 21, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 21, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 21, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 21, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 21, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 21, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 21, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 21, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 21, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 21, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 21, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 21, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 7, j + 21, k + 26, 0);
        world.setBlock(i + 7, j + 22, k + 0, 0);
        world.setBlock(i + 7, j + 22, k + 1, 0);
        world.setBlock(i + 7, j + 22, k + 2, 0);
        world.setBlock(i + 7, j + 22, k + 3, 0);
        world.setBlock(i + 7, j + 22, k + 4, 0);
        world.setBlock(i + 7, j + 22, k + 5, 0);
        world.setBlock(i + 7, j + 22, k + 6, 0);
        world.setBlock(i + 7, j + 22, k + 7, 0);
        world.setBlock(i + 7, j + 22, k + 8, 0);
        world.setBlock(i + 7, j + 22, k + 9, 0);
        world.setBlock(i + 7, j + 22, k + 10, 0);
        world.setBlock(i + 7, j + 22, k + 11, 0);
        world.setBlock(i + 7, j + 22, k + 12, 0);
        world.setBlock(i + 7, j + 22, k + 13, 0);
        world.setBlock(i + 7, j + 22, k + 14, 0);
        world.setBlock(i + 7, j + 22, k + 15, 0);
        world.setBlock(i + 7, j + 22, k + 16, 0);
        world.setBlock(i + 7, j + 22, k + 17, 0);
        world.setBlock(i + 7, j + 22, k + 18, 0);
        world.setBlock(i + 7, j + 22, k + 19, 0);
        world.setBlock(i + 7, j + 22, k + 20, 0);
        world.setBlock(i + 7, j + 22, k + 21, 0);
        world.setBlock(i + 7, j + 22, k + 22, 0);
        world.setBlock(i + 7, j + 22, k + 23, 0);
        world.setBlock(i + 7, j + 22, k + 24, 0);
        world.setBlock(i + 7, j + 22, k + 25, 0);
        world.setBlock(i + 7, j + 22, k + 26, 0);
        world.setBlock(i + 7, j + 23, k + 0, 0);
        world.setBlock(i + 7, j + 23, k + 1, 0);
        world.setBlock(i + 7, j + 23, k + 2, 0);
        world.setBlock(i + 7, j + 23, k + 3, 0);
        world.setBlock(i + 7, j + 23, k + 4, 0);
        world.setBlock(i + 7, j + 23, k + 5, 0);
        world.setBlock(i + 7, j + 23, k + 6, 0);
        world.setBlock(i + 7, j + 23, k + 7, 0);
        world.setBlock(i + 7, j + 23, k + 8, 0);
        world.setBlock(i + 7, j + 23, k + 9, 0);
        world.setBlock(i + 7, j + 23, k + 10, 0);
        world.setBlock(i + 7, j + 23, k + 11, 0);
        world.setBlock(i + 7, j + 23, k + 12, 0);
        world.setBlock(i + 7, j + 23, k + 13, 0);
        world.setBlock(i + 7, j + 23, k + 14, 0);
        world.setBlock(i + 7, j + 23, k + 15, 0);
        world.setBlock(i + 7, j + 23, k + 16, 0);
        world.setBlock(i + 7, j + 23, k + 17, 0);
        world.setBlock(i + 7, j + 23, k + 18, 0);
        world.setBlock(i + 7, j + 23, k + 19, 0);
        world.setBlock(i + 7, j + 23, k + 20, 0);
        world.setBlock(i + 7, j + 23, k + 21, 0);
        world.setBlock(i + 7, j + 23, k + 22, 0);
        world.setBlock(i + 7, j + 23, k + 23, 0);
        world.setBlock(i + 7, j + 23, k + 24, 0);
        world.setBlock(i + 7, j + 23, k + 25, 0);
        world.setBlock(i + 7, j + 23, k + 26, 0);
        world.setBlock(i + 7, j + 24, k + 0, 0);
        world.setBlock(i + 7, j + 24, k + 1, 0);
        world.setBlock(i + 7, j + 24, k + 2, 0);
        world.setBlock(i + 7, j + 24, k + 3, 0);
        world.setBlock(i + 7, j + 24, k + 4, 0);
        world.setBlock(i + 7, j + 24, k + 5, 0);
        world.setBlock(i + 7, j + 24, k + 6, 0);
        world.setBlock(i + 7, j + 24, k + 7, 0);
        world.setBlock(i + 7, j + 24, k + 8, 0);
        world.setBlock(i + 7, j + 24, k + 9, 0);
        world.setBlock(i + 7, j + 24, k + 10, 0);
        world.setBlock(i + 7, j + 24, k + 11, 0);
        world.setBlock(i + 7, j + 24, k + 12, 0);
        world.setBlock(i + 7, j + 24, k + 13, 0);
        world.setBlock(i + 7, j + 24, k + 14, 0);
        world.setBlock(i + 7, j + 24, k + 15, 0);
        world.setBlock(i + 7, j + 24, k + 16, 0);
        world.setBlock(i + 7, j + 24, k + 17, 0);
        world.setBlock(i + 7, j + 24, k + 18, 0);
        world.setBlock(i + 7, j + 24, k + 19, 0);
        world.setBlock(i + 7, j + 24, k + 20, 0);
        world.setBlock(i + 7, j + 24, k + 21, 0);
        world.setBlock(i + 7, j + 24, k + 22, 0);
        world.setBlock(i + 7, j + 24, k + 23, 0);
        world.setBlock(i + 7, j + 24, k + 24, 0);
        world.setBlock(i + 7, j + 24, k + 25, 0);
        world.setBlock(i + 7, j + 24, k + 26, 0);
        world.setBlock(i + 7, j + 25, k + 0, 0);
        world.setBlock(i + 7, j + 25, k + 1, 0);
        world.setBlock(i + 7, j + 25, k + 2, 0);
        world.setBlock(i + 7, j + 25, k + 3, 0);
        world.setBlock(i + 7, j + 25, k + 4, 0);
        world.setBlock(i + 7, j + 25, k + 5, 0);
        world.setBlock(i + 7, j + 25, k + 6, 0);
        world.setBlock(i + 7, j + 25, k + 7, 0);
        world.setBlock(i + 7, j + 25, k + 8, 0);
        world.setBlock(i + 7, j + 25, k + 9, 0);
        world.setBlock(i + 7, j + 25, k + 10, 0);
        world.setBlock(i + 7, j + 25, k + 11, 0);
        world.setBlock(i + 7, j + 25, k + 12, 0);
        world.setBlock(i + 7, j + 25, k + 13, 0);
        world.setBlock(i + 7, j + 25, k + 14, 0);
        world.setBlock(i + 7, j + 25, k + 15, 0);
        world.setBlock(i + 7, j + 25, k + 16, 0);
        world.setBlock(i + 7, j + 25, k + 17, 0);
        world.setBlock(i + 7, j + 25, k + 18, 0);
        world.setBlock(i + 7, j + 25, k + 19, 0);
        world.setBlock(i + 7, j + 25, k + 20, 0);
        world.setBlock(i + 7, j + 25, k + 21, 0);
        world.setBlock(i + 7, j + 25, k + 22, 0);
        world.setBlock(i + 7, j + 25, k + 23, 0);
        world.setBlock(i + 7, j + 25, k + 24, 0);
        world.setBlock(i + 7, j + 25, k + 25, 0);
        world.setBlock(i + 7, j + 25, k + 26, 0);
        world.setBlock(i + 8, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 8, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 1, k + 10, Block.glowStone.blockID);
        world.setBlock(i + 8, j + 1, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 8, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 8, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 8, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 8, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 8, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 8, j + 2, k + 4, Block.grass.blockID);
        world.setBlock(i + 8, j + 2, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 2, k + 6, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 8, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 2, k + 8, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 8, j + 2, k + 9, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 8, j + 2, k + 10, Block.glass.blockID);
        world.setBlock(i + 8, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 8, j + 2, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 8, j + 2, k + 13, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 8, j + 2, k + 14, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 8, j + 2, k + 15, Block.cobblestone.blockID);
        world.setBlock(i + 8, j + 2, k + 16, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 8, j + 2, k + 17, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 8, j + 2, k + 18, Block.cobblestone.blockID);
        world.setBlock(i + 8, j + 2, k + 19, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 8, j + 2, k + 20, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 8, j + 2, k + 21, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 8, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 2, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 2, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 2, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 8, j + 3, k + 0, 0);
        world.setBlock(i + 8, j + 3, k + 3, 0);
        world.setBlock(i + 8, j + 3, k + 4, 0);
        world.setBlock(i + 8, j + 3, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 3, k + 6, 0);
        world.setBlock(i + 8, j + 3, k + 7, 0);
        world.setBlock(i + 8, j + 3, k + 8, 0);
        world.setBlock(i + 8, j + 3, k + 9, 0);
        world.setBlock(i + 8, j + 3, k + 10, 0);
        world.setBlock(i + 8, j + 3, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 8, j + 3, k + 12, 0);
        world.setBlock(i + 8, j + 3, k + 13, 0);
        world.setBlock(i + 8, j + 3, k + 14, 0);
        world.setBlock(i + 8, j + 3, k + 15, 0);
        world.setBlock(i + 8, j + 3, k + 16, 0);
        world.setBlock(i + 8, j + 3, k + 17, 0);
        world.setBlock(i + 8, j + 3, k + 18, 0);
        world.setBlock(i + 8, j + 3, k + 19, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 8, j + 3, k + 20, 0);
        world.setBlock(i + 8, j + 3, k + 21, 0);
        world.setBlock(i + 8, j + 3, k + 22, 0);
        world.setBlock(i + 8, j + 3, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 3, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 3, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 4, k + 0, 0);
        world.setBlock(i + 8, j + 4, k + 1, 0);
        world.setBlock(i + 8, j + 4, k + 2, 0);
        world.setBlock(i + 8, j + 4, k + 3, 0);
        world.setBlock(i + 8, j + 4, k + 4, 0);
        world.setBlock(i + 8, j + 4, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 8, j + 4, k + 6, 0);
        world.setBlock(i + 8, j + 4, k + 7, 0);
        world.setBlock(i + 8, j + 4, k + 8, 0);
        world.setBlock(i + 8, j + 4, k + 9, 0);
        world.setBlock(i + 8, j + 4, k + 10, 0);
        world.setBlock(i + 8, j + 4, k + 11, 0);
        world.setBlock(i + 8, j + 4, k + 12, 0);
        world.setBlock(i + 8, j + 4, k + 13, 0);
        world.setBlock(i + 8, j + 4, k + 14, 0);
        world.setBlock(i + 8, j + 4, k + 15, 0);
        world.setBlock(i + 8, j + 4, k + 16, 0);
        world.setBlock(i + 8, j + 4, k + 17, 0);
        world.setBlock(i + 8, j + 4, k + 18, 0);
        world.setBlock(i + 8, j + 4, k + 19, Fossil.blockcultivateIdle.blockID);
        world.setBlock(i + 8, j + 4, k + 20, 0);
        world.setBlock(i + 8, j + 4, k + 21, 0);
        world.setBlock(i + 8, j + 4, k + 22, 0);
        world.setBlock(i + 8, j + 4, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 4, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 4, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 4, k + 26, 0);
        world.setBlock(i + 8, j + 5, k + 0, 0);
        world.setBlock(i + 8, j + 5, k + 1, 0);
        world.setBlock(i + 8, j + 5, k + 2, 0);
        world.setBlock(i + 8, j + 5, k + 3, 0);
        world.setBlock(i + 8, j + 5, k + 4, 0);
        world.setBlock(i + 8, j + 5, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 8, j + 5, k + 6, 0);
        world.setBlock(i + 8, j + 5, k + 7, 0);
        world.setBlock(i + 8, j + 5, k + 8, 0);
        world.setBlock(i + 8, j + 5, k + 9, 0);
        world.setBlock(i + 8, j + 5, k + 10, 0);
        world.setBlock(i + 8, j + 5, k + 11, 0);
        world.setBlock(i + 8, j + 5, k + 12, 0);
        world.setBlock(i + 8, j + 5, k + 13, 0);
        world.setBlock(i + 8, j + 5, k + 14, 0);
        world.setBlock(i + 8, j + 5, k + 15, 0);
        world.setBlock(i + 8, j + 5, k + 16, 0);
        world.setBlock(i + 8, j + 5, k + 17, 0);
        world.setBlock(i + 8, j + 5, k + 18, 0);
        world.setBlock(i + 8, j + 5, k + 19, 0);
        world.setBlock(i + 8, j + 5, k + 20, 0);
        world.setBlock(i + 8, j + 5, k + 21, 0);
        world.setBlock(i + 8, j + 5, k + 22, 0);
        world.setBlock(i + 8, j + 5, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 5, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 5, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 5, k + 26, 0);
        world.setBlock(i + 8, j + 6, k + 0, 0);
        world.setBlock(i + 8, j + 6, k + 1, 0);
        world.setBlock(i + 8, j + 6, k + 2, 0);
        world.setBlock(i + 8, j + 6, k + 3, 0);
        world.setBlock(i + 8, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 6, k + 6, 0);
        world.setBlock(i + 8, j + 6, k + 7, 0);
        world.setBlock(i + 8, j + 6, k + 8, 0);
        world.setBlock(i + 8, j + 6, k + 9, 0);
        world.setBlock(i + 8, j + 6, k + 10, 0);
        world.setBlock(i + 8, j + 6, k + 11, 0);
        world.setBlock(i + 8, j + 6, k + 12, 0);
        world.setBlock(i + 8, j + 6, k + 13, 0);
        world.setBlock(i + 8, j + 6, k + 14, 0);
        world.setBlock(i + 8, j + 6, k + 15, 0);
        world.setBlock(i + 8, j + 6, k + 16, 0);
        world.setBlock(i + 8, j + 6, k + 17, 0);
        world.setBlock(i + 8, j + 6, k + 18, 0);
        world.setBlock(i + 8, j + 6, k + 19, 0);
        world.setBlock(i + 8, j + 6, k + 20, 0);
        world.setBlock(i + 8, j + 6, k + 21, 0);
        world.setBlock(i + 8, j + 6, k + 22, 0);
        world.setBlock(i + 8, j + 6, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 6, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 6, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 6, k + 26, 0);
        world.setBlock(i + 8, j + 7, k + 0, 0);
        world.setBlock(i + 8, j + 7, k + 1, 0);
        world.setBlock(i + 8, j + 7, k + 2, 0);
        world.setBlock(i + 8, j + 7, k + 3, 0);
        world.setBlock(i + 8, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 7, k + 6, 0);
        world.setBlock(i + 8, j + 7, k + 7, 0);
        world.setBlock(i + 8, j + 7, k + 8, 0);
        world.setBlock(i + 8, j + 7, k + 9, 0);
        world.setBlock(i + 8, j + 7, k + 10, 0);
        world.setBlock(i + 8, j + 7, k + 11, 0);
        world.setBlock(i + 8, j + 7, k + 12, 0);
        world.setBlock(i + 8, j + 7, k + 13, 0);
        world.setBlock(i + 8, j + 7, k + 14, 0);
        world.setBlock(i + 8, j + 7, k + 15, 0);
        world.setBlock(i + 8, j + 7, k + 16, 0);
        world.setBlock(i + 8, j + 7, k + 17, 0);
        world.setBlock(i + 8, j + 7, k + 18, 0);
        world.setBlock(i + 8, j + 7, k + 19, 0);
        world.setBlock(i + 8, j + 7, k + 20, 0);
        world.setBlock(i + 8, j + 7, k + 21, 0);
        world.setBlock(i + 8, j + 7, k + 22, 0);
        world.setBlock(i + 8, j + 7, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 7, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 7, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 7, k + 26, 0);
        world.setBlock(i + 8, j + 8, k + 0, 0);
        world.setBlock(i + 8, j + 8, k + 1, 0);
        world.setBlock(i + 8, j + 8, k + 2, 0);
        world.setBlock(i + 8, j + 8, k + 3, 0);
        world.setBlock(i + 8, j + 8, k + 4, 0);
        world.setBlock(i + 8, j + 8, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 8, k + 6, Block.web.blockID);
        world.setBlock(i + 8, j + 8, k + 7, 0);
        world.setBlock(i + 8, j + 8, k + 8, 0);
        world.setBlock(i + 8, j + 8, k + 9, 0);
        world.setBlock(i + 8, j + 8, k + 10, 0);
        world.setBlock(i + 8, j + 8, k + 11, 0);
        world.setBlock(i + 8, j + 8, k + 12, 0);
        world.setBlock(i + 8, j + 8, k + 13, 0);
        world.setBlock(i + 8, j + 8, k + 14, 0);
        world.setBlock(i + 8, j + 8, k + 15, 0);
        world.setBlock(i + 8, j + 8, k + 16, 0);
        world.setBlock(i + 8, j + 8, k + 17, 0);
        world.setBlock(i + 8, j + 8, k + 18, 0);
        world.setBlock(i + 8, j + 8, k + 19, 0);
        world.setBlock(i + 8, j + 8, k + 20, 0);
        world.setBlock(i + 8, j + 8, k + 21, 0);
        world.setBlock(i + 8, j + 8, k + 22, 0);
        world.setBlock(i + 8, j + 8, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 8, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 8, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 8, k + 26, 0);
        world.setBlock(i + 8, j + 9, k + 0, 0);
        world.setBlock(i + 8, j + 9, k + 1, 0);
        world.setBlock(i + 8, j + 9, k + 2, 0);
        world.setBlock(i + 8, j + 9, k + 3, 0);
        world.setBlock(i + 8, j + 9, k + 4, 0);
        world.setBlock(i + 8, j + 9, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 9, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 9, k + 17, 0);
        world.setBlock(i + 8, j + 9, k + 18, 0);
        world.setBlock(i + 8, j + 9, k + 19, 0);
        world.setBlock(i + 8, j + 9, k + 20, 0);
        world.setBlock(i + 8, j + 9, k + 21, 0);
        world.setBlock(i + 8, j + 9, k + 22, 0);
        world.setBlock(i + 8, j + 9, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 9, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 9, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 9, k + 26, 0);
        world.setBlock(i + 8, j + 10, k + 0, 0);
        world.setBlock(i + 8, j + 10, k + 1, 0);
        world.setBlock(i + 8, j + 10, k + 2, 0);
        world.setBlock(i + 8, j + 10, k + 3, 0);
        world.setBlock(i + 8, j + 10, k + 4, 0);
        world.setBlock(i + 8, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 10, k + 6, 0);
        world.setBlock(i + 8, j + 10, k + 7, 0);
        world.setBlock(i + 8, j + 10, k + 8, 0);
        world.setBlock(i + 8, j + 10, k + 9, 0);
        world.setBlock(i + 8, j + 10, k + 10, 0);
        world.setBlock(i + 8, j + 10, k + 11, 0);
        world.setBlock(i + 8, j + 10, k + 12, 0);
        world.setBlock(i + 8, j + 10, k + 13, 0);
        world.setBlock(i + 8, j + 10, k + 14, 0);
        world.setBlock(i + 8, j + 10, k + 15, Block.fence.blockID);
        world.setBlock(i + 8, j + 10, k + 16, Block.fence.blockID);
        world.setBlock(i + 8, j + 10, k + 17, 0);
        world.setBlock(i + 8, j + 10, k + 18, 0);
        world.setBlock(i + 8, j + 10, k + 19, 0);
        world.setBlock(i + 8, j + 10, k + 20, 0);
        world.setBlock(i + 8, j + 10, k + 21, 0);
        world.setBlock(i + 8, j + 10, k + 22, 0);
        world.setBlock(i + 8, j + 10, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 10, k + 26, 0);
        world.setBlock(i + 8, j + 11, k + 0, 0);
        world.setBlock(i + 8, j + 11, k + 1, 0);
        world.setBlock(i + 8, j + 11, k + 2, 0);
        world.setBlock(i + 8, j + 11, k + 3, 0);
        world.setBlock(i + 8, j + 11, k + 4, 0);
        world.setBlock(i + 8, j + 11, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 8, j + 11, k + 6, 0);
        world.setBlock(i + 8, j + 11, k + 7, 0);
        world.setBlock(i + 8, j + 11, k + 8, 0);
        world.setBlock(i + 8, j + 11, k + 9, 0);
        world.setBlock(i + 8, j + 11, k + 10, 0);
        world.setBlock(i + 8, j + 11, k + 11, 0);
        world.setBlock(i + 8, j + 11, k + 12, 0);
        world.setBlock(i + 8, j + 11, k + 13, 0);
        world.setBlock(i + 8, j + 11, k + 14, 0);
        world.setBlock(i + 8, j + 11, k + 15, 0);
        world.setBlock(i + 8, j + 11, k + 16, 0);
        world.setBlock(i + 8, j + 11, k + 17, 0);
        world.setBlock(i + 8, j + 11, k + 18, 0);
        world.setBlock(i + 8, j + 11, k + 19, 0);
        world.setBlock(i + 8, j + 11, k + 20, 0);
        world.setBlock(i + 8, j + 11, k + 21, 0);
        world.setBlock(i + 8, j + 11, k + 22, 0);
        world.setBlock(i + 8, j + 11, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 11, k + 26, 0);
        world.setBlock(i + 8, j + 12, k + 0, 0);
        world.setBlock(i + 8, j + 12, k + 1, 0);
        world.setBlock(i + 8, j + 12, k + 2, 0);
        world.setBlock(i + 8, j + 12, k + 3, 0);
        world.setBlock(i + 8, j + 12, k + 4, 0);
        world.setBlock(i + 8, j + 12, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 8, j + 12, k + 6, 0);
        world.setBlock(i + 8, j + 12, k + 7, 0);
        world.setBlock(i + 8, j + 12, k + 8, 0);
        world.setBlock(i + 8, j + 12, k + 9, 0);
        world.setBlock(i + 8, j + 12, k + 10, 0);
        world.setBlock(i + 8, j + 12, k + 11, 0);
        world.setBlock(i + 8, j + 12, k + 12, 0);
        world.setBlock(i + 8, j + 12, k + 13, 0);
        world.setBlock(i + 8, j + 12, k + 14, 0);
        world.setBlock(i + 8, j + 12, k + 15, 0);
        world.setBlock(i + 8, j + 12, k + 16, 0);
        world.setBlock(i + 8, j + 12, k + 17, 0);
        world.setBlock(i + 8, j + 12, k + 18, 0);
        world.setBlock(i + 8, j + 12, k + 19, 0);
        world.setBlock(i + 8, j + 12, k + 20, 0);
        world.setBlock(i + 8, j + 12, k + 21, 0);
        world.setBlock(i + 8, j + 12, k + 22, Block.web.blockID);
        world.setBlock(i + 8, j + 12, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 12, k + 26, 0);
        world.setBlock(i + 8, j + 13, k + 0, 0);
        world.setBlock(i + 8, j + 13, k + 1, 0);
        world.setBlock(i + 8, j + 13, k + 2, 0);
        world.setBlock(i + 8, j + 13, k + 3, 0);
        world.setBlock(i + 8, j + 13, k + 4, 0);
        world.setBlock(i + 8, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 13, k + 6, 0);
        world.setBlock(i + 8, j + 13, k + 7, 0);
        world.setBlock(i + 8, j + 13, k + 8, 0);
        world.setBlock(i + 8, j + 13, k + 9, 0);
        world.setBlock(i + 8, j + 13, k + 10, Block.glowStone.blockID);
        world.setBlock(i + 8, j + 13, k + 11, 0);
        world.setBlock(i + 8, j + 13, k + 12, 0);
        world.setBlock(i + 8, j + 13, k + 13, 0);
        world.setBlock(i + 8, j + 13, k + 14, 0);
        world.setBlock(i + 8, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 13, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 13, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 13, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 13, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 13, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 13, k + 26, 0);
        world.setBlock(i + 8, j + 14, k + 0, 0);
        world.setBlock(i + 8, j + 14, k + 1, 0);
        world.setBlock(i + 8, j + 14, k + 2, 0);
        world.setBlock(i + 8, j + 14, k + 3, 0);
        world.setBlock(i + 8, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 14, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 14, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 14, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 14, k + 26, 0);
        world.setBlock(i + 8, j + 15, k + 0, 0);
        world.setBlock(i + 8, j + 15, k + 1, 0);
        world.setBlock(i + 8, j + 15, k + 2, 0);
        world.setBlock(i + 8, j + 15, k + 3, 0);
        world.setBlock(i + 8, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 15, k + 5, 0);
        world.setBlock(i + 8, j + 15, k + 6, 0);
        world.setBlock(i + 8, j + 15, k + 7, 0);
        world.setBlock(i + 8, j + 15, k + 8, 0);
        world.setBlock(i + 8, j + 15, k + 9, 0);
        world.setBlock(i + 8, j + 15, k + 10, 0);
        world.setBlock(i + 8, j + 15, k + 11, 0);
        world.setBlock(i + 8, j + 15, k + 12, 0);
        world.setBlock(i + 8, j + 15, k + 13, 0);
        world.setBlock(i + 8, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 15, k + 22, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 8, j + 15, k + 23, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 8, j + 15, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 15, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 15, k + 26, 0);
        world.setBlock(i + 8, j + 16, k + 0, 0);
        world.setBlock(i + 8, j + 16, k + 1, 0);
        world.setBlock(i + 8, j + 16, k + 2, 0);
        world.setBlock(i + 8, j + 16, k + 3, 0);
        world.setBlock(i + 8, j + 16, k + 4, 0);
        world.setBlock(i + 8, j + 16, k + 5, 0);
        world.setBlock(i + 8, j + 16, k + 6, 0);
        world.setBlock(i + 8, j + 16, k + 7, 0);
        world.setBlock(i + 8, j + 16, k + 8, 0);
        world.setBlock(i + 8, j + 16, k + 9, 0);
        world.setBlock(i + 8, j + 16, k + 10, 0);
        world.setBlock(i + 8, j + 16, k + 11, 0);
        world.setBlock(i + 8, j + 16, k + 12, 0);
        world.setBlock(i + 8, j + 16, k + 13, 0);
        world.setBlock(i + 8, j + 16, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 16, k + 15, Block.workbench.blockID);
        world.setBlock(i + 8, j + 16, k + 16, 0);
        world.setBlock(i + 8, j + 16, k + 17, 0);
        world.setBlock(i + 8, j + 16, k + 18, 0);
        world.setBlock(i + 8, j + 16, k + 19, Block.bed.blockID);
        world.setBlock(i + 8, j + 16, k + 20, Block.bed.blockID, 8, 0);
        world.setBlock(i + 8, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 16, k + 22, 0);
        generate5(world, rand, i, j, k);
        return true;
    }

    public boolean generate5(World world, Random rand, int i, int j, int k)
    {
        world.setBlock(i + 8, j + 16, k + 23, 0);
        world.setBlock(i + 8, j + 16, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 16, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 16, k + 26, 0);
        world.setBlock(i + 8, j + 17, k + 0, 0);
        world.setBlock(i + 8, j + 17, k + 1, 0);
        world.setBlock(i + 8, j + 17, k + 2, 0);
        world.setBlock(i + 8, j + 17, k + 3, 0);
        world.setBlock(i + 8, j + 17, k + 4, 0);
        world.setBlock(i + 8, j + 17, k + 5, 0);
        world.setBlock(i + 8, j + 17, k + 6, 0);
        world.setBlock(i + 8, j + 17, k + 7, 0);
        world.setBlock(i + 8, j + 17, k + 8, 0);
        world.setBlock(i + 8, j + 17, k + 9, 0);
        world.setBlock(i + 8, j + 17, k + 10, 0);
        world.setBlock(i + 8, j + 17, k + 11, 0);
        world.setBlock(i + 8, j + 17, k + 12, 0);
        world.setBlock(i + 8, j + 17, k + 13, 0);
        world.setBlock(i + 8, j + 17, k + 14, Block.thinGlass.blockID);
        world.setBlock(i + 8, j + 17, k + 15, 0);
        world.setBlock(i + 8, j + 17, k + 16, 0);
        world.setBlock(i + 8, j + 17, k + 17, 0);
        world.setBlock(i + 8, j + 17, k + 18, 0);
        world.setBlock(i + 8, j + 17, k + 19, 0);
        world.setBlock(i + 8, j + 17, k + 20, 0);
        world.setBlock(i + 8, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 17, k + 22, 0);
        world.setBlock(i + 8, j + 17, k + 23, 0);
        world.setBlock(i + 8, j + 17, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 17, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 17, k + 26, 0);
        world.setBlock(i + 8, j + 18, k + 0, 0);
        world.setBlock(i + 8, j + 18, k + 1, 0);
        world.setBlock(i + 8, j + 18, k + 2, 0);
        world.setBlock(i + 8, j + 18, k + 3, 0);
        world.setBlock(i + 8, j + 18, k + 4, 0);
        world.setBlock(i + 8, j + 18, k + 5, 0);
        world.setBlock(i + 8, j + 18, k + 6, 0);
        world.setBlock(i + 8, j + 18, k + 7, 0);
        world.setBlock(i + 8, j + 18, k + 8, 0);
        world.setBlock(i + 8, j + 18, k + 9, 0);
        world.setBlock(i + 8, j + 18, k + 10, 0);
        world.setBlock(i + 8, j + 18, k + 11, 0);
        world.setBlock(i + 8, j + 18, k + 12, 0);
        world.setBlock(i + 8, j + 18, k + 13, 0);
        world.setBlock(i + 8, j + 18, k + 14, Block.thinGlass.blockID);
        world.setBlock(i + 8, j + 18, k + 15, 0);
        world.setBlock(i + 8, j + 18, k + 16, 0);
        world.setBlock(i + 8, j + 18, k + 17, 0);
        world.setBlock(i + 8, j + 18, k + 18, 0);
        world.setBlock(i + 8, j + 18, k + 19, 0);
        world.setBlock(i + 8, j + 18, k + 20, 0);
        world.setBlock(i + 8, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 18, k + 22, 0);
        world.setBlock(i + 8, j + 18, k + 23, 0);
        world.setBlock(i + 8, j + 18, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 18, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 8, j + 18, k + 26, 0);
        world.setBlock(i + 8, j + 19, k + 0, 0);
        world.setBlock(i + 8, j + 19, k + 1, 0);
        world.setBlock(i + 8, j + 19, k + 2, 0);
        world.setBlock(i + 8, j + 19, k + 3, 0);
        world.setBlock(i + 8, j + 19, k + 4, 0);
        world.setBlock(i + 8, j + 19, k + 5, 0);
        world.setBlock(i + 8, j + 19, k + 6, 0);
        world.setBlock(i + 8, j + 19, k + 7, 0);
        world.setBlock(i + 8, j + 19, k + 8, 0);
        world.setBlock(i + 8, j + 19, k + 9, 0);
        world.setBlock(i + 8, j + 19, k + 10, 0);
        world.setBlock(i + 8, j + 19, k + 11, 0);
        world.setBlock(i + 8, j + 19, k + 12, 0);
        world.setBlock(i + 8, j + 19, k + 13, 0);
        world.setBlock(i + 8, j + 19, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 19, k + 15, 0);
        world.setBlock(i + 8, j + 19, k + 16, 0);
        world.setBlock(i + 8, j + 19, k + 17, 0);
        world.setBlock(i + 8, j + 19, k + 18, 0);
        world.setBlock(i + 8, j + 19, k + 19, 0);
        world.setBlock(i + 8, j + 19, k + 20, 0);
        world.setBlock(i + 8, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 19, k + 22, 0);
        world.setBlock(i + 8, j + 19, k + 23, 0);
        world.setBlock(i + 8, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 19, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 19, k + 26, 0);
        world.setBlock(i + 8, j + 20, k + 0, 0);
        world.setBlock(i + 8, j + 20, k + 1, 0);
        world.setBlock(i + 8, j + 20, k + 2, 0);
        world.setBlock(i + 8, j + 20, k + 3, 0);
        world.setBlock(i + 8, j + 20, k + 4, 0);
        world.setBlock(i + 8, j + 20, k + 5, 0);
        world.setBlock(i + 8, j + 20, k + 6, 0);
        world.setBlock(i + 8, j + 20, k + 7, 0);
        world.setBlock(i + 8, j + 20, k + 8, 0);
        world.setBlock(i + 8, j + 20, k + 9, 0);
        world.setBlock(i + 8, j + 20, k + 10, 0);
        world.setBlock(i + 8, j + 20, k + 11, 0);
        world.setBlock(i + 8, j + 20, k + 12, 0);
        world.setBlock(i + 8, j + 20, k + 13, 0);
        world.setBlock(i + 8, j + 20, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 20, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 20, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 20, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 20, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 20, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 20, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 20, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 20, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 20, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 20, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 20, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 20, k + 26, 0);
        world.setBlock(i + 8, j + 21, k + 0, 0);
        world.setBlock(i + 8, j + 21, k + 1, 0);
        world.setBlock(i + 8, j + 21, k + 2, 0);
        world.setBlock(i + 8, j + 21, k + 3, 0);
        world.setBlock(i + 8, j + 21, k + 4, 0);
        world.setBlock(i + 8, j + 21, k + 5, 0);
        world.setBlock(i + 8, j + 21, k + 6, 0);
        world.setBlock(i + 8, j + 21, k + 7, 0);
        world.setBlock(i + 8, j + 21, k + 8, 0);
        world.setBlock(i + 8, j + 21, k + 9, 0);
        world.setBlock(i + 8, j + 21, k + 10, 0);
        world.setBlock(i + 8, j + 21, k + 11, 0);
        world.setBlock(i + 8, j + 21, k + 12, 0);
        world.setBlock(i + 8, j + 21, k + 13, 0);
        world.setBlock(i + 8, j + 21, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 21, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 21, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 21, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 21, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 21, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 21, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 21, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 21, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 21, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 21, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 21, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 21, k + 26, 0);
        world.setBlock(i + 8, j + 22, k + 0, 0);
        world.setBlock(i + 8, j + 22, k + 1, 0);
        world.setBlock(i + 8, j + 22, k + 2, 0);
        world.setBlock(i + 8, j + 22, k + 3, 0);
        world.setBlock(i + 8, j + 22, k + 4, 0);
        world.setBlock(i + 8, j + 22, k + 5, 0);
        world.setBlock(i + 8, j + 22, k + 6, 0);
        world.setBlock(i + 8, j + 22, k + 7, 0);
        world.setBlock(i + 8, j + 22, k + 8, 0);
        world.setBlock(i + 8, j + 22, k + 9, 0);
        world.setBlock(i + 8, j + 22, k + 10, 0);
        world.setBlock(i + 8, j + 22, k + 11, 0);
        world.setBlock(i + 8, j + 22, k + 12, 0);
        world.setBlock(i + 8, j + 22, k + 13, 0);
        world.setBlock(i + 8, j + 22, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 22, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 22, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 22, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 22, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 22, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 22, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 22, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 22, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 22, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 22, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 8, j + 22, k + 25, 0);
        world.setBlock(i + 8, j + 22, k + 26, 0);
        world.setBlock(i + 8, j + 23, k + 0, 0);
        world.setBlock(i + 8, j + 23, k + 1, 0);
        world.setBlock(i + 8, j + 23, k + 2, 0);
        world.setBlock(i + 8, j + 23, k + 3, 0);
        world.setBlock(i + 8, j + 23, k + 4, 0);
        world.setBlock(i + 8, j + 23, k + 5, 0);
        world.setBlock(i + 8, j + 23, k + 6, 0);
        world.setBlock(i + 8, j + 23, k + 7, 0);
        world.setBlock(i + 8, j + 23, k + 8, 0);
        world.setBlock(i + 8, j + 23, k + 9, 0);
        world.setBlock(i + 8, j + 23, k + 10, 0);
        world.setBlock(i + 8, j + 23, k + 11, 0);
        world.setBlock(i + 8, j + 23, k + 12, 0);
        world.setBlock(i + 8, j + 23, k + 13, 0);
        world.setBlock(i + 8, j + 23, k + 14, 0);
        world.setBlock(i + 8, j + 23, k + 15, 0);
        world.setBlock(i + 8, j + 23, k + 16, 0);
        world.setBlock(i + 8, j + 23, k + 17, 0);
        world.setBlock(i + 8, j + 23, k + 18, 0);
        world.setBlock(i + 8, j + 23, k + 19, 0);
        world.setBlock(i + 8, j + 23, k + 20, 0);
        world.setBlock(i + 8, j + 23, k + 21, 0);
        world.setBlock(i + 8, j + 23, k + 22, 0);
        world.setBlock(i + 8, j + 23, k + 23, 0);
        world.setBlock(i + 8, j + 23, k + 24, 0);
        world.setBlock(i + 8, j + 23, k + 25, 0);
        world.setBlock(i + 8, j + 23, k + 26, 0);
        world.setBlock(i + 8, j + 24, k + 0, 0);
        world.setBlock(i + 8, j + 24, k + 1, 0);
        world.setBlock(i + 8, j + 24, k + 2, 0);
        world.setBlock(i + 8, j + 24, k + 3, 0);
        world.setBlock(i + 8, j + 24, k + 4, 0);
        world.setBlock(i + 8, j + 24, k + 5, 0);
        world.setBlock(i + 8, j + 24, k + 6, 0);
        world.setBlock(i + 8, j + 24, k + 7, 0);
        world.setBlock(i + 8, j + 24, k + 8, 0);
        world.setBlock(i + 8, j + 24, k + 9, 0);
        world.setBlock(i + 8, j + 24, k + 10, 0);
        world.setBlock(i + 8, j + 24, k + 11, 0);
        world.setBlock(i + 8, j + 24, k + 12, 0);
        world.setBlock(i + 8, j + 24, k + 13, 0);
        world.setBlock(i + 8, j + 24, k + 14, 0);
        world.setBlock(i + 8, j + 24, k + 15, 0);
        world.setBlock(i + 8, j + 24, k + 16, 0);
        world.setBlock(i + 8, j + 24, k + 17, 0);
        world.setBlock(i + 8, j + 24, k + 18, 0);
        world.setBlock(i + 8, j + 24, k + 19, 0);
        world.setBlock(i + 8, j + 24, k + 20, 0);
        world.setBlock(i + 8, j + 24, k + 21, 0);
        world.setBlock(i + 8, j + 24, k + 22, 0);
        world.setBlock(i + 8, j + 24, k + 23, 0);
        world.setBlock(i + 8, j + 24, k + 24, 0);
        world.setBlock(i + 8, j + 24, k + 25, 0);
        world.setBlock(i + 8, j + 24, k + 26, 0);
        world.setBlock(i + 8, j + 25, k + 0, 0);
        world.setBlock(i + 8, j + 25, k + 1, 0);
        world.setBlock(i + 8, j + 25, k + 2, 0);
        world.setBlock(i + 8, j + 25, k + 3, 0);
        world.setBlock(i + 8, j + 25, k + 4, 0);
        world.setBlock(i + 8, j + 25, k + 5, 0);
        world.setBlock(i + 8, j + 25, k + 6, 0);
        world.setBlock(i + 8, j + 25, k + 7, 0);
        world.setBlock(i + 8, j + 25, k + 8, 0);
        world.setBlock(i + 8, j + 25, k + 9, 0);
        world.setBlock(i + 8, j + 25, k + 10, 0);
        world.setBlock(i + 8, j + 25, k + 11, 0);
        world.setBlock(i + 8, j + 25, k + 12, 0);
        world.setBlock(i + 8, j + 25, k + 13, 0);
        world.setBlock(i + 8, j + 25, k + 14, 0);
        world.setBlock(i + 8, j + 25, k + 15, 0);
        world.setBlock(i + 8, j + 25, k + 16, 0);
        world.setBlock(i + 8, j + 25, k + 17, 0);
        world.setBlock(i + 8, j + 25, k + 18, 0);
        world.setBlock(i + 8, j + 25, k + 19, 0);
        world.setBlock(i + 8, j + 25, k + 20, 0);
        world.setBlock(i + 8, j + 25, k + 21, 0);
        world.setBlock(i + 8, j + 25, k + 22, 0);
        world.setBlock(i + 8, j + 25, k + 23, 0);
        world.setBlock(i + 8, j + 25, k + 24, 0);
        world.setBlock(i + 8, j + 25, k + 25, 0);
        world.setBlock(i + 8, j + 25, k + 26, 0);
        world.setBlock(i + 9, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 9, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 1, k + 15, Block.glowStone.blockID);
        world.setBlock(i + 9, j + 1, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 1, k + 19, Block.glowStone.blockID);
        world.setBlock(i + 9, j + 1, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 9, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 9, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 9, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 9, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 9, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 9, j + 2, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 2, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 2, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 2, k + 8, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 9, j + 2, k + 9, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 9, j + 2, k + 10, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 9, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 9, j + 2, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 9, j + 2, k + 13, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 9, j + 2, k + 14, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 9, j + 2, k + 15, Block.glass.blockID);
        world.setBlock(i + 9, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 2, k + 17, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 9, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 2, k + 19, Block.glass.blockID);
        world.setBlock(i + 9, j + 2, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 2, k + 21, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 9, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 2, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 2, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 9, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 9, j + 3, k + 1, 0);
        world.setBlock(i + 9, j + 3, k + 2, 0);
        world.setBlock(i + 9, j + 3, k + 3, 0);
        world.setBlock(i + 9, j + 3, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 3, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 3, k + 7, 0);
        world.setBlock(i + 9, j + 3, k + 8, 0);
        world.setBlock(i + 9, j + 3, k + 9, 0);
        world.setBlock(i + 9, j + 3, k + 10, 0);
        world.setBlock(i + 9, j + 3, k + 11, Block.enchantmentTable.blockID);
        world.setBlock(i + 9, j + 3, k + 12, 0);
        world.setBlock(i + 9, j + 3, k + 13, 0);
        world.setBlock(i + 9, j + 3, k + 14, 0);
        world.setBlock(i + 9, j + 3, k + 15, 0);
        world.setBlock(i + 9, j + 3, k + 16, 0);
        world.setBlock(i + 9, j + 3, k + 17, 0);
        world.setBlock(i + 9, j + 3, k + 18, 0);
        world.setBlock(i + 9, j + 3, k + 19, 0);
        world.setBlock(i + 9, j + 3, k + 20, 0);
        world.setBlock(i + 9, j + 3, k + 21, 0);
        world.setBlock(i + 9, j + 3, k + 22, 0);
        world.setBlock(i + 9, j + 3, k + 23, 0);
        world.setBlock(i + 9, j + 3, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 3, k + 26, 0);
        world.setBlock(i + 9, j + 4, k + 0, 0);
        world.setBlock(i + 9, j + 4, k + 1, 0);
        world.setBlock(i + 9, j + 4, k + 2, 0);
        world.setBlock(i + 9, j + 4, k + 3, 0);
        world.setBlock(i + 9, j + 4, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 4, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 4, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 4, k + 7, 0);
        world.setBlock(i + 9, j + 4, k + 8, 0);
        world.setBlock(i + 9, j + 4, k + 9, 0);
        world.setBlock(i + 9, j + 4, k + 10, 0);
        world.setBlock(i + 9, j + 4, k + 11, 0);
        world.setBlock(i + 9, j + 4, k + 12, 0);
        world.setBlock(i + 9, j + 4, k + 13, 0);
        world.setBlock(i + 9, j + 4, k + 14, 0);
        world.setBlock(i + 9, j + 4, k + 15, 0);
        world.setBlock(i + 9, j + 4, k + 16, 0);
        world.setBlock(i + 9, j + 4, k + 17, 0);
        world.setBlock(i + 9, j + 4, k + 18, 0);
        world.setBlock(i + 9, j + 4, k + 19, 0);
        world.setBlock(i + 9, j + 4, k + 20, 0);
        world.setBlock(i + 9, j + 4, k + 21, 0);
        world.setBlock(i + 9, j + 4, k + 22, 0);
        world.setBlock(i + 9, j + 4, k + 23, 0);
        world.setBlock(i + 9, j + 4, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 4, k + 25, 0);
        world.setBlock(i + 9, j + 4, k + 26, 0);
        world.setBlock(i + 9, j + 5, k + 0, 0);
        world.setBlock(i + 9, j + 5, k + 1, 0);
        world.setBlock(i + 9, j + 5, k + 2, 0);
        world.setBlock(i + 9, j + 5, k + 3, 0);
        world.setBlock(i + 9, j + 5, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 5, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 5, k + 7, 0);
        world.setBlock(i + 9, j + 5, k + 8, 0);
        world.setBlock(i + 9, j + 5, k + 9, 0);
        world.setBlock(i + 9, j + 5, k + 10, 0);
        world.setBlock(i + 9, j + 5, k + 11, 0);
        world.setBlock(i + 9, j + 5, k + 12, 0);
        world.setBlock(i + 9, j + 5, k + 13, 0);
        world.setBlock(i + 9, j + 5, k + 14, 0);
        world.setBlock(i + 9, j + 5, k + 15, 0);
        world.setBlock(i + 9, j + 5, k + 16, 0);
        world.setBlock(i + 9, j + 5, k + 17, 0);
        world.setBlock(i + 9, j + 5, k + 18, 0);
        world.setBlock(i + 9, j + 5, k + 19, 0);
        world.setBlock(i + 9, j + 5, k + 20, 0);
        world.setBlock(i + 9, j + 5, k + 21, 0);
        world.setBlock(i + 9, j + 5, k + 22, 0);
        world.setBlock(i + 9, j + 5, k + 23, 0);
        world.setBlock(i + 9, j + 5, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 5, k + 25, 0);
        world.setBlock(i + 9, j + 5, k + 26, 0);
        world.setBlock(i + 9, j + 6, k + 0, 0);
        world.setBlock(i + 9, j + 6, k + 1, 0);
        world.setBlock(i + 9, j + 6, k + 2, 0);
        world.setBlock(i + 9, j + 6, k + 3, 0);
        world.setBlock(i + 9, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 6, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 6, k + 7, Block.glowStone.blockID);
        world.setBlock(i + 9, j + 6, k + 8, 0);
        world.setBlock(i + 9, j + 6, k + 9, 0);
        world.setBlock(i + 9, j + 6, k + 10, 0);
        world.setBlock(i + 9, j + 6, k + 11, 0);
        world.setBlock(i + 9, j + 6, k + 12, 0);
        world.setBlock(i + 9, j + 6, k + 13, 0);
        world.setBlock(i + 9, j + 6, k + 14, 0);
        world.setBlock(i + 9, j + 6, k + 15, 0);
        world.setBlock(i + 9, j + 6, k + 16, 0);
        world.setBlock(i + 9, j + 6, k + 17, 0);
        world.setBlock(i + 9, j + 6, k + 18, 0);
        world.setBlock(i + 9, j + 6, k + 19, 0);
        world.setBlock(i + 9, j + 6, k + 20, 0);
        world.setBlock(i + 9, j + 6, k + 21, 0);
        world.setBlock(i + 9, j + 6, k + 22, 0);
        world.setBlock(i + 9, j + 6, k + 23, Block.glowStone.blockID);
        world.setBlock(i + 9, j + 6, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 6, k + 25, 0);
        world.setBlock(i + 9, j + 6, k + 26, 0);
        world.setBlock(i + 9, j + 7, k + 0, 0);
        world.setBlock(i + 9, j + 7, k + 1, 0);
        world.setBlock(i + 9, j + 7, k + 2, 0);
        world.setBlock(i + 9, j + 7, k + 3, 0);
        world.setBlock(i + 9, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 7, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 7, k + 7, Block.fence.blockID);
        world.setBlock(i + 9, j + 7, k + 8, 0);
        world.setBlock(i + 9, j + 7, k + 9, 0);
        world.setBlock(i + 9, j + 7, k + 10, 0);
        world.setBlock(i + 9, j + 7, k + 11, 0);
        world.setBlock(i + 9, j + 7, k + 12, 0);
        world.setBlock(i + 9, j + 7, k + 13, 0);
        world.setBlock(i + 9, j + 7, k + 14, 0);
        world.setBlock(i + 9, j + 7, k + 15, 0);
        world.setBlock(i + 9, j + 7, k + 16, 0);
        world.setBlock(i + 9, j + 7, k + 17, 0);
        world.setBlock(i + 9, j + 7, k + 18, 0);
        world.setBlock(i + 9, j + 7, k + 19, 0);
        world.setBlock(i + 9, j + 7, k + 20, 0);
        world.setBlock(i + 9, j + 7, k + 21, 0);
        world.setBlock(i + 9, j + 7, k + 22, 0);
        world.setBlock(i + 9, j + 7, k + 23, Block.fence.blockID);
        world.setBlock(i + 9, j + 7, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 7, k + 25, 0);
        world.setBlock(i + 9, j + 7, k + 26, 0);
        world.setBlock(i + 9, j + 8, k + 0, 0);
        world.setBlock(i + 9, j + 8, k + 1, 0);
        world.setBlock(i + 9, j + 8, k + 2, 0);
        world.setBlock(i + 9, j + 8, k + 3, 0);
        world.setBlock(i + 9, j + 8, k + 4, 0);
        world.setBlock(i + 9, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 8, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 8, k + 7, 0);
        world.setBlock(i + 9, j + 8, k + 8, 0);
        world.setBlock(i + 9, j + 8, k + 9, 0);
        world.setBlock(i + 9, j + 8, k + 10, 0);
        world.setBlock(i + 9, j + 8, k + 11, 0);
        world.setBlock(i + 9, j + 8, k + 12, 0);
        world.setBlock(i + 9, j + 8, k + 13, 0);
        world.setBlock(i + 9, j + 8, k + 14, 0);
        world.setBlock(i + 9, j + 8, k + 15, 0);
        world.setBlock(i + 9, j + 8, k + 16, 0);
        world.setBlock(i + 9, j + 8, k + 17, 0);
        world.setBlock(i + 9, j + 8, k + 18, 0);
        world.setBlock(i + 9, j + 8, k + 19, 0);
        world.setBlock(i + 9, j + 8, k + 20, 0);
        world.setBlock(i + 9, j + 8, k + 21, 0);
        world.setBlock(i + 9, j + 8, k + 22, 0);
        world.setBlock(i + 9, j + 8, k + 23, 0);
        world.setBlock(i + 9, j + 8, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 8, k + 25, 0);
        world.setBlock(i + 9, j + 8, k + 26, 0);
        world.setBlock(i + 9, j + 9, k + 0, 0);
        world.setBlock(i + 9, j + 9, k + 1, 0);
        world.setBlock(i + 9, j + 9, k + 2, 0);
        world.setBlock(i + 9, j + 9, k + 3, 0);
        world.setBlock(i + 9, j + 9, k + 4, 0);
        world.setBlock(i + 9, j + 9, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 9, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 9, k + 13, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 9, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 9, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 9, k + 16, 0);
        world.setBlock(i + 9, j + 9, k + 17, 0);
        world.setBlock(i + 9, j + 9, k + 18, 0);
        world.setBlock(i + 9, j + 9, k + 19, 0);
        world.setBlock(i + 9, j + 9, k + 20, 0);
        world.setBlock(i + 9, j + 9, k + 21, 0);
        world.setBlock(i + 9, j + 9, k + 22, 0);
        world.setBlock(i + 9, j + 9, k + 23, 0);
        world.setBlock(i + 9, j + 9, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 9, k + 25, 0);
        world.setBlock(i + 9, j + 9, k + 26, 0);
        world.setBlock(i + 9, j + 10, k + 0, 0);
        world.setBlock(i + 9, j + 10, k + 1, 0);
        world.setBlock(i + 9, j + 10, k + 2, 0);
        world.setBlock(i + 9, j + 10, k + 3, 0);
        world.setBlock(i + 9, j + 10, k + 4, 0);
        world.setBlock(i + 9, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 10, k + 6, 0);
        world.setBlock(i + 9, j + 10, k + 7, 0);
        world.setBlock(i + 9, j + 10, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 10, k + 9, 0);
        world.setBlock(i + 9, j + 10, k + 10, 0);
        world.setBlock(i + 9, j + 10, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 10, k + 12, 0);
        world.setBlock(i + 9, j + 10, k + 13, 0);
        world.setBlock(i + 9, j + 10, k + 14, 0);
        world.setBlock(i + 9, j + 10, k + 15, Block.fence.blockID);
        world.setBlock(i + 9, j + 10, k + 16, 0);
        world.setBlock(i + 9, j + 10, k + 17, 0);
        world.setBlock(i + 9, j + 10, k + 18, 0);
        world.setBlock(i + 9, j + 10, k + 19, 0);
        world.setBlock(i + 9, j + 10, k + 20, 0);
        world.setBlock(i + 9, j + 10, k + 21, 0);
        world.setBlock(i + 9, j + 10, k + 22, 0);
        world.setBlock(i + 9, j + 10, k + 23, 0);
        world.setBlock(i + 9, j + 10, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 10, k + 25, 0);
        world.setBlock(i + 9, j + 10, k + 26, 0);
        world.setBlock(i + 9, j + 11, k + 0, 0);
        world.setBlock(i + 9, j + 11, k + 1, 0);
        world.setBlock(i + 9, j + 11, k + 2, 0);
        world.setBlock(i + 9, j + 11, k + 3, 0);
        world.setBlock(i + 9, j + 11, k + 4, 0);
        world.setBlock(i + 9, j + 11, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 11, k + 6, 0);
        world.setBlock(i + 9, j + 11, k + 7, 0);
        world.setBlock(i + 9, j + 11, k + 8, 0);
        world.setBlock(i + 9, j + 11, k + 9, 0);
        world.setBlock(i + 9, j + 11, k + 10, 0);
        world.setBlock(i + 9, j + 11, k + 11, 0);
        world.setBlock(i + 9, j + 11, k + 12, 0);
        world.setBlock(i + 9, j + 11, k + 13, 0);
        world.setBlock(i + 9, j + 11, k + 14, 0);
        world.setBlock(i + 9, j + 11, k + 15, 0);
        world.setBlock(i + 9, j + 11, k + 16, 0);
        world.setBlock(i + 9, j + 11, k + 17, 0);
        world.setBlock(i + 9, j + 11, k + 18, 0);
        world.setBlock(i + 9, j + 11, k + 19, 0);
        world.setBlock(i + 9, j + 11, k + 20, 0);
        world.setBlock(i + 9, j + 11, k + 21, 0);
        world.setBlock(i + 9, j + 11, k + 22, 0);
        world.setBlock(i + 9, j + 11, k + 23, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 9, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 11, k + 26, 0);
        world.setBlock(i + 9, j + 12, k + 0, 0);
        world.setBlock(i + 9, j + 12, k + 1, 0);
        world.setBlock(i + 9, j + 12, k + 2, 0);
        world.setBlock(i + 9, j + 12, k + 3, 0);
        world.setBlock(i + 9, j + 12, k + 4, 0);
        world.setBlock(i + 9, j + 12, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 12, k + 6, 0);
        world.setBlock(i + 9, j + 12, k + 7, 0);
        world.setBlock(i + 9, j + 12, k + 8, 0);
        world.setBlock(i + 9, j + 12, k + 9, 0);
        world.setBlock(i + 9, j + 12, k + 10, 0);
        world.setBlock(i + 9, j + 12, k + 11, 0);
        world.setBlock(i + 9, j + 12, k + 12, 0);
        world.setBlock(i + 9, j + 12, k + 13, 0);
        world.setBlock(i + 9, j + 12, k + 14, 0);
        world.setBlock(i + 9, j + 12, k + 15, 0);
        world.setBlock(i + 9, j + 12, k + 16, 0);
        world.setBlock(i + 9, j + 12, k + 17, 0);
        world.setBlock(i + 9, j + 12, k + 18, 0);
        world.setBlock(i + 9, j + 12, k + 19, 0);
        world.setBlock(i + 9, j + 12, k + 20, 0);
        world.setBlock(i + 9, j + 12, k + 21, 0);
        world.setBlock(i + 9, j + 12, k + 22, 0);
        world.setBlock(i + 9, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 9, j + 12, k + 26, 0);
        world.setBlock(i + 9, j + 13, k + 0, 0);
        world.setBlock(i + 9, j + 13, k + 1, 0);
        world.setBlock(i + 9, j + 13, k + 2, 0);
        world.setBlock(i + 9, j + 13, k + 3, 0);
        world.setBlock(i + 9, j + 13, k + 4, 0);
        world.setBlock(i + 9, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 13, k + 6, Block.glowStone.blockID);
        world.setBlock(i + 9, j + 13, k + 7, 0);
        world.setBlock(i + 9, j + 13, k + 8, 0);
        world.setBlock(i + 9, j + 13, k + 9, 0);
        world.setBlock(i + 9, j + 13, k + 10, 0);
        world.setBlock(i + 9, j + 13, k + 11, 0);
        world.setBlock(i + 9, j + 13, k + 12, 0);
        world.setBlock(i + 9, j + 13, k + 13, 0);
        world.setBlock(i + 9, j + 13, k + 14, Block.glowStone.blockID);
        world.setBlock(i + 9, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 13, k + 16, 0);
        world.setBlock(i + 9, j + 13, k + 17, 0);
        world.setBlock(i + 9, j + 13, k + 18, 0);
        world.setBlock(i + 9, j + 13, k + 19, 0);
        world.setBlock(i + 9, j + 13, k + 20, 0);
        world.setBlock(i + 9, j + 13, k + 21, 0);
        world.setBlock(i + 9, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 13, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 13, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 13, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 13, k + 26, 0);
        world.setBlock(i + 9, j + 14, k + 0, 0);
        world.setBlock(i + 9, j + 14, k + 1, 0);
        world.setBlock(i + 9, j + 14, k + 2, 0);
        world.setBlock(i + 9, j + 14, k + 3, 0);
        world.setBlock(i + 9, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 19, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 9, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 14, k + 26, 0);
        world.setBlock(i + 9, j + 15, k + 0, 0);
        world.setBlock(i + 9, j + 15, k + 1, 0);
        world.setBlock(i + 9, j + 15, k + 2, 0);
        world.setBlock(i + 9, j + 15, k + 3, 0);
        world.setBlock(i + 9, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 5, 0);
        world.setBlock(i + 9, j + 15, k + 6, 0);
        world.setBlock(i + 9, j + 15, k + 7, 0);
        world.setBlock(i + 9, j + 15, k + 8, 0);
        world.setBlock(i + 9, j + 15, k + 9, 0);
        world.setBlock(i + 9, j + 15, k + 10, 0);
        world.setBlock(i + 9, j + 15, k + 11, 0);
        world.setBlock(i + 9, j + 15, k + 12, 0);
        world.setBlock(i + 9, j + 15, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 15, k + 25, 0);
        world.setBlock(i + 9, j + 15, k + 26, 0);
        world.setBlock(i + 9, j + 16, k + 0, 0);
        world.setBlock(i + 9, j + 16, k + 1, 0);
        world.setBlock(i + 9, j + 16, k + 2, 0);
        world.setBlock(i + 9, j + 16, k + 3, 0);
        world.setBlock(i + 9, j + 16, k + 4, 0);
        world.setBlock(i + 9, j + 16, k + 5, 0);
        world.setBlock(i + 9, j + 16, k + 6, 0);
        world.setBlock(i + 9, j + 16, k + 7, 0);
        world.setBlock(i + 9, j + 16, k + 8, 0);
        world.setBlock(i + 9, j + 16, k + 9, 0);
        world.setBlock(i + 9, j + 16, k + 10, 0);
        world.setBlock(i + 9, j + 16, k + 11, 0);
        world.setBlock(i + 9, j + 16, k + 12, 0);
        world.setBlock(i + 9, j + 16, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 16, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 16, k + 15, Block.enchantmentTable.blockID);
        world.setBlock(i + 9, j + 16, k + 16, 0);
        world.setBlock(i + 9, j + 16, k + 17, 0);
        world.setBlock(i + 9, j + 16, k + 18, 0);
        world.setBlock(i + 9, j + 16, k + 19, 0);
        world.setBlock(i + 9, j + 16, k + 20, 0);
        world.setBlock(i + 9, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 16, k + 22, 0);
        world.setBlock(i + 9, j + 16, k + 23, 0);
        world.setBlock(i + 9, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 16, k + 25, 0);
        world.setBlock(i + 9, j + 16, k + 26, 0);
        world.setBlock(i + 9, j + 17, k + 0, 0);
        world.setBlock(i + 9, j + 17, k + 1, 0);
        world.setBlock(i + 9, j + 17, k + 2, 0);
        world.setBlock(i + 9, j + 17, k + 3, 0);
        world.setBlock(i + 9, j + 17, k + 4, 0);
        world.setBlock(i + 9, j + 17, k + 5, 0);
        world.setBlock(i + 9, j + 17, k + 6, 0);
        world.setBlock(i + 9, j + 17, k + 7, 0);
        world.setBlock(i + 9, j + 17, k + 8, 0);
        world.setBlock(i + 9, j + 17, k + 9, 0);
        world.setBlock(i + 9, j + 17, k + 10, 0);
        world.setBlock(i + 9, j + 17, k + 11, 0);
        world.setBlock(i + 9, j + 17, k + 12, 0);
        world.setBlock(i + 9, j + 17, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 17, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 17, k + 15, 0);
        world.setBlock(i + 9, j + 17, k + 16, 0);
        world.setBlock(i + 9, j + 17, k + 17, 0);
        world.setBlock(i + 9, j + 17, k + 18, 0);
        world.setBlock(i + 9, j + 17, k + 19, 0);
        world.setBlock(i + 9, j + 17, k + 20, 0);
        world.setBlock(i + 9, j + 17, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 9, j + 17, k + 22, 0);
        world.setBlock(i + 9, j + 17, k + 23, 0);
        world.setBlock(i + 9, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 17, k + 25, 0);
        world.setBlock(i + 9, j + 17, k + 26, 0);
        world.setBlock(i + 9, j + 18, k + 0, 0);
        world.setBlock(i + 9, j + 18, k + 1, 0);
        world.setBlock(i + 9, j + 18, k + 2, 0);
        world.setBlock(i + 9, j + 18, k + 3, 0);
        world.setBlock(i + 9, j + 18, k + 4, 0);
        world.setBlock(i + 9, j + 18, k + 5, 0);
        world.setBlock(i + 9, j + 18, k + 6, 0);
        world.setBlock(i + 9, j + 18, k + 7, 0);
        world.setBlock(i + 9, j + 18, k + 8, 0);
        world.setBlock(i + 9, j + 18, k + 9, 0);
        world.setBlock(i + 9, j + 18, k + 10, 0);
        world.setBlock(i + 9, j + 18, k + 11, 0);
        world.setBlock(i + 9, j + 18, k + 12, 0);
        world.setBlock(i + 9, j + 18, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 18, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 18, k + 15, 0);
        world.setBlock(i + 9, j + 18, k + 16, 0);
        world.setBlock(i + 9, j + 18, k + 17, 0);
        world.setBlock(i + 9, j + 18, k + 18, 0);
        world.setBlock(i + 9, j + 18, k + 19, 0);
        world.setBlock(i + 9, j + 18, k + 20, 0);
        world.setBlock(i + 9, j + 18, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 9, j + 18, k + 22, 0);
        world.setBlock(i + 9, j + 18, k + 23, 0);
        world.setBlock(i + 9, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 18, k + 25, 0);
        world.setBlock(i + 9, j + 18, k + 26, 0);
        world.setBlock(i + 9, j + 19, k + 0, 0);
        world.setBlock(i + 9, j + 19, k + 1, 0);
        world.setBlock(i + 9, j + 19, k + 2, 0);
        world.setBlock(i + 9, j + 19, k + 3, 0);
        world.setBlock(i + 9, j + 19, k + 4, 0);
        world.setBlock(i + 9, j + 19, k + 5, 0);
        world.setBlock(i + 9, j + 19, k + 6, 0);
        world.setBlock(i + 9, j + 19, k + 7, 0);
        world.setBlock(i + 9, j + 19, k + 8, 0);
        world.setBlock(i + 9, j + 19, k + 9, 0);
        world.setBlock(i + 9, j + 19, k + 10, 0);
        world.setBlock(i + 9, j + 19, k + 11, 0);
        world.setBlock(i + 9, j + 19, k + 12, 0);
        world.setBlock(i + 9, j + 19, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 19, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 19, k + 15, 0);
        world.setBlock(i + 9, j + 19, k + 16, 0);
        world.setBlock(i + 9, j + 19, k + 17, 0);
        world.setBlock(i + 9, j + 19, k + 18, 0);
        world.setBlock(i + 9, j + 19, k + 19, 0);
        world.setBlock(i + 9, j + 19, k + 20, 0);
        world.setBlock(i + 9, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 19, k + 22, 0);
        world.setBlock(i + 9, j + 19, k + 23, 0);
        world.setBlock(i + 9, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 19, k + 25, 0);
        world.setBlock(i + 9, j + 19, k + 26, 0);
        world.setBlock(i + 9, j + 20, k + 0, 0);
        world.setBlock(i + 9, j + 20, k + 1, 0);
        world.setBlock(i + 9, j + 20, k + 2, 0);
        world.setBlock(i + 9, j + 20, k + 3, 0);
        world.setBlock(i + 9, j + 20, k + 4, 0);
        world.setBlock(i + 9, j + 20, k + 5, 0);
        world.setBlock(i + 9, j + 20, k + 6, 0);
        world.setBlock(i + 9, j + 20, k + 7, 0);
        world.setBlock(i + 9, j + 20, k + 8, 0);
        world.setBlock(i + 9, j + 20, k + 9, 0);
        world.setBlock(i + 9, j + 20, k + 10, 0);
        world.setBlock(i + 9, j + 20, k + 11, 0);
        world.setBlock(i + 9, j + 20, k + 12, 0);
        world.setBlock(i + 9, j + 20, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 20, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 20, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 20, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 20, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 20, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 20, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 20, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 20, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 20, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 20, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 20, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 20, k + 25, 0);
        world.setBlock(i + 9, j + 20, k + 26, 0);
        world.setBlock(i + 9, j + 21, k + 0, 0);
        world.setBlock(i + 9, j + 21, k + 1, 0);
        world.setBlock(i + 9, j + 21, k + 2, 0);
        world.setBlock(i + 9, j + 21, k + 3, 0);
        world.setBlock(i + 9, j + 21, k + 4, 0);
        world.setBlock(i + 9, j + 21, k + 5, 0);
        world.setBlock(i + 9, j + 21, k + 6, 0);
        world.setBlock(i + 9, j + 21, k + 7, 0);
        world.setBlock(i + 9, j + 21, k + 8, 0);
        world.setBlock(i + 9, j + 21, k + 9, 0);
        world.setBlock(i + 9, j + 21, k + 10, 0);
        world.setBlock(i + 9, j + 21, k + 11, 0);
        world.setBlock(i + 9, j + 21, k + 12, 0);
        world.setBlock(i + 9, j + 21, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 21, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 21, k + 15, 0);
        world.setBlock(i + 9, j + 21, k + 16, 0);
        world.setBlock(i + 9, j + 21, k + 17, 0);
        world.setBlock(i + 9, j + 21, k + 18, 0);
        world.setBlock(i + 9, j + 21, k + 19, 0);
        world.setBlock(i + 9, j + 21, k + 20, 0);
        world.setBlock(i + 9, j + 21, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 21, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 21, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 21, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 21, k + 25, 0);
        world.setBlock(i + 9, j + 21, k + 26, 0);
        world.setBlock(i + 9, j + 22, k + 0, 0);
        world.setBlock(i + 9, j + 22, k + 1, 0);
        world.setBlock(i + 9, j + 22, k + 2, 0);
        world.setBlock(i + 9, j + 22, k + 3, 0);
        world.setBlock(i + 9, j + 22, k + 4, 0);
        world.setBlock(i + 9, j + 22, k + 5, 0);
        world.setBlock(i + 9, j + 22, k + 6, 0);
        world.setBlock(i + 9, j + 22, k + 7, 0);
        world.setBlock(i + 9, j + 22, k + 8, 0);
        world.setBlock(i + 9, j + 22, k + 9, 0);
        world.setBlock(i + 9, j + 22, k + 10, 0);
        world.setBlock(i + 9, j + 22, k + 11, 0);
        world.setBlock(i + 9, j + 22, k + 12, 0);
        world.setBlock(i + 9, j + 22, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 22, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 22, k + 15, 0);
        world.setBlock(i + 9, j + 22, k + 16, 0);
        world.setBlock(i + 9, j + 22, k + 17, 0);
        world.setBlock(i + 9, j + 22, k + 18, 0);
        world.setBlock(i + 9, j + 22, k + 19, 0);
        world.setBlock(i + 9, j + 22, k + 20, 0);
        world.setBlock(i + 9, j + 22, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 22, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 22, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 22, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 22, k + 25, 0);
        world.setBlock(i + 9, j + 22, k + 26, 0);
        world.setBlock(i + 9, j + 23, k + 0, 0);
        world.setBlock(i + 9, j + 23, k + 1, 0);
        world.setBlock(i + 9, j + 23, k + 2, 0);
        world.setBlock(i + 9, j + 23, k + 3, 0);
        world.setBlock(i + 9, j + 23, k + 4, 0);
        world.setBlock(i + 9, j + 23, k + 5, 0);
        world.setBlock(i + 9, j + 23, k + 6, 0);
        world.setBlock(i + 9, j + 23, k + 7, 0);
        world.setBlock(i + 9, j + 23, k + 8, 0);
        world.setBlock(i + 9, j + 23, k + 9, 0);
        world.setBlock(i + 9, j + 23, k + 10, 0);
        world.setBlock(i + 9, j + 23, k + 11, 0);
        world.setBlock(i + 9, j + 23, k + 12, 0);
        world.setBlock(i + 9, j + 23, k + 13, 0);
        world.setBlock(i + 9, j + 23, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 23, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 23, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 23, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 23, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 23, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 23, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 23, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 23, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 23, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 9, j + 23, k + 24, 0);
        world.setBlock(i + 9, j + 23, k + 25, 0);
        world.setBlock(i + 9, j + 23, k + 26, 0);
        world.setBlock(i + 9, j + 24, k + 0, 0);
        world.setBlock(i + 9, j + 24, k + 1, 0);
        world.setBlock(i + 9, j + 24, k + 2, 0);
        world.setBlock(i + 9, j + 24, k + 3, 0);
        world.setBlock(i + 9, j + 24, k + 4, 0);
        world.setBlock(i + 9, j + 24, k + 5, 0);
        world.setBlock(i + 9, j + 24, k + 6, 0);
        world.setBlock(i + 9, j + 24, k + 7, 0);
        world.setBlock(i + 9, j + 24, k + 8, 0);
        world.setBlock(i + 9, j + 24, k + 9, 0);
        world.setBlock(i + 9, j + 24, k + 10, 0);
        world.setBlock(i + 9, j + 24, k + 11, 0);
        world.setBlock(i + 9, j + 24, k + 12, 0);
        world.setBlock(i + 9, j + 24, k + 13, 0);
        world.setBlock(i + 9, j + 24, k + 14, 0);
        world.setBlock(i + 9, j + 24, k + 15, 0);
        world.setBlock(i + 9, j + 24, k + 16, 0);
        world.setBlock(i + 9, j + 24, k + 17, 0);
        world.setBlock(i + 9, j + 24, k + 18, 0);
        world.setBlock(i + 9, j + 24, k + 19, 0);
        world.setBlock(i + 9, j + 24, k + 20, 0);
        world.setBlock(i + 9, j + 24, k + 21, 0);
        world.setBlock(i + 9, j + 24, k + 22, 0);
        world.setBlock(i + 9, j + 24, k + 23, 0);
        world.setBlock(i + 9, j + 24, k + 24, 0);
        world.setBlock(i + 9, j + 24, k + 25, 0);
        world.setBlock(i + 9, j + 24, k + 26, 0);
        world.setBlock(i + 9, j + 25, k + 0, 0);
        world.setBlock(i + 9, j + 25, k + 1, 0);
        world.setBlock(i + 9, j + 25, k + 2, 0);
        world.setBlock(i + 9, j + 25, k + 3, 0);
        world.setBlock(i + 9, j + 25, k + 4, 0);
        world.setBlock(i + 9, j + 25, k + 5, 0);
        world.setBlock(i + 9, j + 25, k + 6, 0);
        world.setBlock(i + 9, j + 25, k + 7, 0);
        world.setBlock(i + 9, j + 25, k + 8, 0);
        world.setBlock(i + 9, j + 25, k + 9, 0);
        world.setBlock(i + 9, j + 25, k + 10, 0);
        world.setBlock(i + 9, j + 25, k + 11, 0);
        world.setBlock(i + 9, j + 25, k + 12, 0);
        world.setBlock(i + 9, j + 25, k + 13, 0);
        world.setBlock(i + 9, j + 25, k + 14, 0);
        world.setBlock(i + 9, j + 25, k + 15, 0);
        world.setBlock(i + 9, j + 25, k + 16, 0);
        world.setBlock(i + 9, j + 25, k + 17, 0);
        world.setBlock(i + 9, j + 25, k + 18, 0);
        world.setBlock(i + 9, j + 25, k + 19, 0);
        world.setBlock(i + 9, j + 25, k + 20, 0);
        world.setBlock(i + 9, j + 25, k + 21, 0);
        world.setBlock(i + 9, j + 25, k + 22, 0);
        world.setBlock(i + 9, j + 25, k + 23, 0);
        world.setBlock(i + 9, j + 25, k + 24, 0);
        world.setBlock(i + 9, j + 25, k + 25, 0);
        world.setBlock(i + 9, j + 25, k + 26, 0);
        world.setBlock(i + 10, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 10, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 10, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 10, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 10, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 10, j + 2, k + 2, Block.dirt.blockID);
        world.setBlock(i + 10, j + 2, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 2, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 2, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 2, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 2, k + 8, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 10, j + 2, k + 9, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 10, j + 2, k + 10, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 10, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 10, j + 2, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 10, j + 2, k + 13, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 10, j + 2, k + 14, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 10, j + 2, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 2, k + 17, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 10, j + 2, k + 18, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 10, j + 2, k + 19, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 10, j + 2, k + 20, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 10, j + 2, k + 21, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 10, j + 2, k + 22, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 10, j + 2, k + 23, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 10, j + 2, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 10, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 10, j + 3, k + 0, 0);
        world.setBlock(i + 10, j + 3, k + 1, 0);
        world.setBlock(i + 10, j + 3, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 3, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 3, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 3, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 3, k + 7, 0);
        world.setBlock(i + 10, j + 3, k + 8, 0);
        world.setBlock(i + 10, j + 3, k + 9, 0);
        world.setBlock(i + 10, j + 3, k + 10, 0);
        world.setBlock(i + 10, j + 3, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 10, j + 3, k + 12, 0);
        world.setBlock(i + 10, j + 3, k + 13, 0);
        world.setBlock(i + 10, j + 3, k + 14, 0);
        world.setBlock(i + 10, j + 3, k + 15, 0);
        world.setBlock(i + 10, j + 3, k + 16, 0);
        world.setBlock(i + 10, j + 3, k + 17, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 10, j + 3, k + 18, 0);
        world.setBlock(i + 10, j + 3, k + 19, 0);
        world.setBlock(i + 10, j + 3, k + 20, 0);
        world.setBlock(i + 10, j + 3, k + 21, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 10, j + 3, k + 22, 0);
        world.setBlock(i + 10, j + 3, k + 23, 0);
        world.setBlock(i + 10, j + 3, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 3, k + 25, 0);
        world.setBlock(i + 10, j + 4, k + 0, 0);
        world.setBlock(i + 10, j + 4, k + 1, 0);
        world.setBlock(i + 10, j + 4, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 4, k + 3, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 10, j + 4, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 4, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 4, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 4, k + 7, 0);
        world.setBlock(i + 10, j + 4, k + 8, 0);
        world.setBlock(i + 10, j + 4, k + 9, 0);
        world.setBlock(i + 10, j + 4, k + 10, 0);
        world.setBlock(i + 10, j + 4, k + 11, 0);
        world.setBlock(i + 10, j + 4, k + 12, 0);
        world.setBlock(i + 10, j + 4, k + 13, 0);
        world.setBlock(i + 10, j + 4, k + 14, 0);
        world.setBlock(i + 10, j + 4, k + 15, 0);
        world.setBlock(i + 10, j + 4, k + 16, 0);
        world.setBlock(i + 10, j + 4, k + 17, Fossil.blockcultivateIdle.blockID);
        world.setBlock(i + 10, j + 4, k + 18, 0);
        world.setBlock(i + 10, j + 4, k + 19, 0);
        world.setBlock(i + 10, j + 4, k + 20, 0);
        world.setBlock(i + 10, j + 4, k + 21, Fossil.blockcultivateIdle.blockID);
        world.setBlock(i + 10, j + 4, k + 22, 0);
        world.setBlock(i + 10, j + 4, k + 23, 0);
        world.setBlock(i + 10, j + 4, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 4, k + 25, 0);
        world.setBlock(i + 10, j + 4, k + 26, 0);
        world.setBlock(i + 10, j + 5, k + 0, 0);
        world.setBlock(i + 10, j + 5, k + 1, 0);
        world.setBlock(i + 10, j + 5, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 5, k + 3, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 10, j + 5, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 5, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 5, k + 7, 0);
        world.setBlock(i + 10, j + 5, k + 8, 0);
        world.setBlock(i + 10, j + 5, k + 9, 0);
        world.setBlock(i + 10, j + 5, k + 10, 0);
        world.setBlock(i + 10, j + 5, k + 11, 0);
        world.setBlock(i + 10, j + 5, k + 12, 0);
        world.setBlock(i + 10, j + 5, k + 13, 0);
        world.setBlock(i + 10, j + 5, k + 14, 0);
        world.setBlock(i + 10, j + 5, k + 15, 0);
        world.setBlock(i + 10, j + 5, k + 16, 0);
        world.setBlock(i + 10, j + 5, k + 17, 0);
        world.setBlock(i + 10, j + 5, k + 18, 0);
        world.setBlock(i + 10, j + 5, k + 19, 0);
        world.setBlock(i + 10, j + 5, k + 20, 0);
        world.setBlock(i + 10, j + 5, k + 21, 0);
        world.setBlock(i + 10, j + 5, k + 22, 0);
        world.setBlock(i + 10, j + 5, k + 23, 0);
        world.setBlock(i + 10, j + 5, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 5, k + 25, 0);
        world.setBlock(i + 10, j + 5, k + 26, 0);
        world.setBlock(i + 10, j + 6, k + 0, 0);
        world.setBlock(i + 10, j + 6, k + 1, 0);
        world.setBlock(i + 10, j + 6, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 6, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 6, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 6, k + 7, 0);
        world.setBlock(i + 10, j + 6, k + 8, 0);
        world.setBlock(i + 10, j + 6, k + 9, 0);
        world.setBlock(i + 10, j + 6, k + 10, 0);
        world.setBlock(i + 10, j + 6, k + 11, 0);
        world.setBlock(i + 10, j + 6, k + 12, 0);
        world.setBlock(i + 10, j + 6, k + 13, 0);
        world.setBlock(i + 10, j + 6, k + 14, 0);
        world.setBlock(i + 10, j + 6, k + 15, 0);
        world.setBlock(i + 10, j + 6, k + 16, 0);
        world.setBlock(i + 10, j + 6, k + 17, 0);
        world.setBlock(i + 10, j + 6, k + 18, 0);
        world.setBlock(i + 10, j + 6, k + 19, 0);
        world.setBlock(i + 10, j + 6, k + 20, 0);
        world.setBlock(i + 10, j + 6, k + 21, 0);
        world.setBlock(i + 10, j + 6, k + 22, 0);
        world.setBlock(i + 10, j + 6, k + 23, 0);
        world.setBlock(i + 10, j + 6, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 6, k + 25, 0);
        world.setBlock(i + 10, j + 6, k + 26, 0);
        world.setBlock(i + 10, j + 7, k + 0, 0);
        world.setBlock(i + 10, j + 7, k + 1, 0);
        world.setBlock(i + 10, j + 7, k + 2, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 10, j + 7, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 7, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 7, k + 7, 0);
        world.setBlock(i + 10, j + 7, k + 8, 0);
        world.setBlock(i + 10, j + 7, k + 9, 0);
        world.setBlock(i + 10, j + 7, k + 10, 0);
        world.setBlock(i + 10, j + 7, k + 11, 0);
        world.setBlock(i + 10, j + 7, k + 12, 0);
        world.setBlock(i + 10, j + 7, k + 13, 0);
        world.setBlock(i + 10, j + 7, k + 14, 0);
        world.setBlock(i + 10, j + 7, k + 15, 0);
        world.setBlock(i + 10, j + 7, k + 16, 0);
        world.setBlock(i + 10, j + 7, k + 17, 0);
        world.setBlock(i + 10, j + 7, k + 18, 0);
        world.setBlock(i + 10, j + 7, k + 19, 0);
        world.setBlock(i + 10, j + 7, k + 20, 0);
        world.setBlock(i + 10, j + 7, k + 21, 0);
        world.setBlock(i + 10, j + 7, k + 22, 0);
        world.setBlock(i + 10, j + 7, k + 23, 0);
        world.setBlock(i + 10, j + 7, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 7, k + 25, 0);
        world.setBlock(i + 10, j + 7, k + 26, 0);
        world.setBlock(i + 10, j + 8, k + 0, 0);
        world.setBlock(i + 10, j + 8, k + 1, 0);
        world.setBlock(i + 10, j + 8, k + 2, 0);
        world.setBlock(i + 10, j + 8, k + 3, 0);
        world.setBlock(i + 10, j + 8, k + 4, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 10, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 8, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 8, k + 7, 0);
        world.setBlock(i + 10, j + 8, k + 8, 0);
        world.setBlock(i + 10, j + 8, k + 9, 0);
        world.setBlock(i + 10, j + 8, k + 10, 0);
        world.setBlock(i + 10, j + 8, k + 11, 0);
        world.setBlock(i + 10, j + 8, k + 12, 0);
        world.setBlock(i + 10, j + 8, k + 13, 0);
        world.setBlock(i + 10, j + 8, k + 14, 0);
        world.setBlock(i + 10, j + 8, k + 15, 0);
        world.setBlock(i + 10, j + 8, k + 16, 0);
        world.setBlock(i + 10, j + 8, k + 17, 0);
        world.setBlock(i + 10, j + 8, k + 18, 0);
        world.setBlock(i + 10, j + 8, k + 19, 0);
        world.setBlock(i + 10, j + 8, k + 20, 0);
        world.setBlock(i + 10, j + 8, k + 21, 0);
        world.setBlock(i + 10, j + 8, k + 22, 0);
        world.setBlock(i + 10, j + 8, k + 23, 0);
        world.setBlock(i + 10, j + 8, k + 24, Block.thinGlass.blockID);
        world.setBlock(i + 10, j + 8, k + 25, 0);
        world.setBlock(i + 10, j + 8, k + 26, 0);
        world.setBlock(i + 10, j + 9, k + 0, 0);
        world.setBlock(i + 10, j + 9, k + 1, 0);
        world.setBlock(i + 10, j + 9, k + 2, 0);
        world.setBlock(i + 10, j + 9, k + 3, 0);
        world.setBlock(i + 10, j + 9, k + 4, 0);
        world.setBlock(i + 10, j + 9, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 9, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 9, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 9, k + 16, 0);
        world.setBlock(i + 10, j + 9, k + 17, 0);
        world.setBlock(i + 10, j + 9, k + 18, 0);
        world.setBlock(i + 10, j + 9, k + 19, Block.glowStone.blockID);
        world.setBlock(i + 10, j + 9, k + 20, 0);
        world.setBlock(i + 10, j + 9, k + 21, 0);
        world.setBlock(i + 10, j + 9, k + 22, 0);
        world.setBlock(i + 10, j + 9, k + 23, 0);
        world.setBlock(i + 10, j + 9, k + 24, Block.thinGlass.blockID);
        world.setBlock(i + 10, j + 9, k + 25, 0);
        world.setBlock(i + 10, j + 9, k + 26, 0);
        world.setBlock(i + 10, j + 10, k + 0, 0);
        world.setBlock(i + 10, j + 10, k + 1, 0);
        world.setBlock(i + 10, j + 10, k + 2, 0);
        world.setBlock(i + 10, j + 10, k + 3, 0);
        world.setBlock(i + 10, j + 10, k + 4, 0);
        world.setBlock(i + 10, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 10, k + 6, 0);
        world.setBlock(i + 10, j + 10, k + 7, 0);
        world.setBlock(i + 10, j + 10, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 10, k + 9, 0);
        world.setBlock(i + 10, j + 10, k + 10, 0);
        world.setBlock(i + 10, j + 10, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 10, k + 12, 0);
        world.setBlock(i + 10, j + 10, k + 13, 0);
        world.setBlock(i + 10, j + 10, k + 14, Block.fence.blockID);
        world.setBlock(i + 10, j + 10, k + 15, Block.fence.blockID);
        world.setBlock(i + 10, j + 10, k + 16, 0);
        world.setBlock(i + 10, j + 10, k + 17, 0);
        world.setBlock(i + 10, j + 10, k + 18, 0);
        world.setBlock(i + 10, j + 10, k + 19, Block.fence.blockID);
        world.setBlock(i + 10, j + 10, k + 20, 0);
        world.setBlock(i + 10, j + 10, k + 21, 0);
        world.setBlock(i + 10, j + 10, k + 22, 0);
        world.setBlock(i + 10, j + 10, k + 23, 0);
        world.setBlock(i + 10, j + 10, k + 24, Block.thinGlass.blockID);
        world.setBlock(i + 10, j + 10, k + 25, 0);
        world.setBlock(i + 10, j + 10, k + 26, 0);
        world.setBlock(i + 10, j + 11, k + 0, 0);
        world.setBlock(i + 10, j + 11, k + 1, 0);
        world.setBlock(i + 10, j + 11, k + 2, 0);
        world.setBlock(i + 10, j + 11, k + 3, 0);
        world.setBlock(i + 10, j + 11, k + 4, 0);
        world.setBlock(i + 10, j + 11, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 10, j + 11, k + 6, 0);
        world.setBlock(i + 10, j + 11, k + 7, 0);
        world.setBlock(i + 10, j + 11, k + 8, 0);
        world.setBlock(i + 10, j + 11, k + 9, 0);
        world.setBlock(i + 10, j + 11, k + 10, 0);
        world.setBlock(i + 10, j + 11, k + 11, 0);
        world.setBlock(i + 10, j + 11, k + 12, 0);
        world.setBlock(i + 10, j + 11, k + 13, 0);
        world.setBlock(i + 10, j + 11, k + 14, 0);
        world.setBlock(i + 10, j + 11, k + 15, 0);
        world.setBlock(i + 10, j + 11, k + 16, 0);
        world.setBlock(i + 10, j + 11, k + 17, 0);
        world.setBlock(i + 10, j + 11, k + 18, 0);
        world.setBlock(i + 10, j + 11, k + 19, 0);
        world.setBlock(i + 10, j + 11, k + 20, 0);
        world.setBlock(i + 10, j + 11, k + 21, 0);
        world.setBlock(i + 10, j + 11, k + 22, 0);
        world.setBlock(i + 10, j + 11, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 11, k + 26, 0);
        world.setBlock(i + 10, j + 12, k + 0, 0);
        world.setBlock(i + 10, j + 12, k + 1, 0);
        world.setBlock(i + 10, j + 12, k + 2, 0);
        world.setBlock(i + 10, j + 12, k + 3, 0);
        world.setBlock(i + 10, j + 12, k + 4, 0);
        world.setBlock(i + 10, j + 12, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 10, j + 12, k + 6, 0);
        world.setBlock(i + 10, j + 12, k + 7, 0);
        world.setBlock(i + 10, j + 12, k + 8, 0);
        world.setBlock(i + 10, j + 12, k + 9, 0);
        world.setBlock(i + 10, j + 12, k + 10, 0);
        world.setBlock(i + 10, j + 12, k + 11, 0);
        world.setBlock(i + 10, j + 12, k + 12, 0);
        world.setBlock(i + 10, j + 12, k + 13, 0);
        world.setBlock(i + 10, j + 12, k + 14, 0);
        world.setBlock(i + 10, j + 12, k + 15, 0);
        world.setBlock(i + 10, j + 12, k + 16, 0);
        world.setBlock(i + 10, j + 12, k + 17, 0);
        world.setBlock(i + 10, j + 12, k + 18, 0);
        world.setBlock(i + 10, j + 12, k + 19, 0);
        world.setBlock(i + 10, j + 12, k + 20, 0);
        world.setBlock(i + 10, j + 12, k + 21, 0);
        world.setBlock(i + 10, j + 12, k + 22, 0);
        world.setBlock(i + 10, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 10, j + 12, k + 26, 0);
        world.setBlock(i + 10, j + 13, k + 0, 0);
        world.setBlock(i + 10, j + 13, k + 1, 0);
        world.setBlock(i + 10, j + 13, k + 2, 0);
        world.setBlock(i + 10, j + 13, k + 3, 0);
        world.setBlock(i + 10, j + 13, k + 4, 0);
        world.setBlock(i + 10, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 13, k + 6, 0);
        world.setBlock(i + 10, j + 13, k + 7, 0);
        world.setBlock(i + 10, j + 13, k + 8, 0);
        world.setBlock(i + 10, j + 13, k + 9, 0);
        world.setBlock(i + 10, j + 13, k + 10, 0);
        world.setBlock(i + 10, j + 13, k + 11, 0);
        world.setBlock(i + 10, j + 13, k + 12, 0);
        world.setBlock(i + 10, j + 13, k + 13, 0);
        world.setBlock(i + 10, j + 13, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 13, k + 16, 0);
        world.setBlock(i + 10, j + 13, k + 17, 0);
        world.setBlock(i + 10, j + 13, k + 18, 0);
        world.setBlock(i + 10, j + 13, k + 19, Block.fence.blockID);
        world.setBlock(i + 10, j + 13, k + 20, 0);
        world.setBlock(i + 10, j + 13, k + 21, 0);
        world.setBlock(i + 10, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 13, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 13, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 13, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 13, k + 26, 0);
        world.setBlock(i + 10, j + 14, k + 0, 0);
        world.setBlock(i + 10, j + 14, k + 1, 0);
        world.setBlock(i + 10, j + 14, k + 2, 0);
        world.setBlock(i + 10, j + 14, k + 3, 0);
        world.setBlock(i + 10, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 14, k + 26, 0);
        world.setBlock(i + 10, j + 15, k + 0, 0);
        world.setBlock(i + 10, j + 15, k + 1, 0);
        world.setBlock(i + 10, j + 15, k + 2, 0);
        world.setBlock(i + 10, j + 15, k + 3, 0);
        world.setBlock(i + 10, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 5, 0);
        world.setBlock(i + 10, j + 15, k + 6, 0);
        world.setBlock(i + 10, j + 15, k + 7, 0);
        world.setBlock(i + 10, j + 15, k + 8, 0);
        world.setBlock(i + 10, j + 15, k + 9, 0);
        world.setBlock(i + 10, j + 15, k + 10, 0);
        world.setBlock(i + 10, j + 15, k + 11, 0);
        world.setBlock(i + 10, j + 15, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 15, k + 25, 0);
        world.setBlock(i + 10, j + 15, k + 26, 0);
        world.setBlock(i + 10, j + 16, k + 0, 0);
        world.setBlock(i + 10, j + 16, k + 1, 0);
        world.setBlock(i + 10, j + 16, k + 2, 0);
        world.setBlock(i + 10, j + 16, k + 3, 0);
        world.setBlock(i + 10, j + 16, k + 4, 0);
        world.setBlock(i + 10, j + 16, k + 5, 0);
        world.setBlock(i + 10, j + 16, k + 6, 0);
        world.setBlock(i + 10, j + 16, k + 7, 0);
        world.setBlock(i + 10, j + 16, k + 8, 0);
        world.setBlock(i + 10, j + 16, k + 9, 0);
        world.setBlock(i + 10, j + 16, k + 10, 0);
        world.setBlock(i + 10, j + 16, k + 11, 0);
        world.setBlock(i + 10, j + 16, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 16, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 16, k + 14, Block.furnaceIdle.blockID, 3, 0);
        world.setBlock(i + 10, j + 16, k + 15, 0);
        world.setBlock(i + 10, j + 16, k + 16, 0);
        world.setBlock(i + 10, j + 16, k + 17, 0);
        world.setBlock(i + 10, j + 16, k + 18, 0);
        world.setBlock(i + 10, j + 16, k + 19, 0);
        world.setBlock(i + 10, j + 16, k + 20, 0);
        world.setBlock(i + 10, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 16, k + 22, 0);
        world.setBlock(i + 10, j + 16, k + 23, 0);
        world.setBlock(i + 10, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 16, k + 25, 0);
        world.setBlock(i + 10, j + 16, k + 26, 0);
        world.setBlock(i + 10, j + 17, k + 0, 0);
        world.setBlock(i + 10, j + 17, k + 1, 0);
        world.setBlock(i + 10, j + 17, k + 2, 0);
        world.setBlock(i + 10, j + 17, k + 3, 0);
        world.setBlock(i + 10, j + 17, k + 4, 0);
        world.setBlock(i + 10, j + 17, k + 5, 0);
        world.setBlock(i + 10, j + 17, k + 6, 0);
        world.setBlock(i + 10, j + 17, k + 7, 0);
        world.setBlock(i + 10, j + 17, k + 8, 0);
        world.setBlock(i + 10, j + 17, k + 9, 0);
        world.setBlock(i + 10, j + 17, k + 10, 0);
        world.setBlock(i + 10, j + 17, k + 11, 0);
        world.setBlock(i + 10, j + 17, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 17, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 17, k + 14, 0);
        world.setBlock(i + 10, j + 17, k + 15, 0);
        world.setBlock(i + 10, j + 17, k + 16, 0);
        world.setBlock(i + 10, j + 17, k + 17, 0);
        world.setBlock(i + 10, j + 17, k + 18, 0);
        world.setBlock(i + 10, j + 17, k + 19, 0);
        world.setBlock(i + 10, j + 17, k + 20, 0);
        world.setBlock(i + 10, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 17, k + 22, 0);
        world.setBlock(i + 10, j + 17, k + 23, 0);
        world.setBlock(i + 10, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 17, k + 25, 0);
        world.setBlock(i + 10, j + 17, k + 26, 0);
        world.setBlock(i + 10, j + 18, k + 0, 0);
        world.setBlock(i + 10, j + 18, k + 1, 0);
        world.setBlock(i + 10, j + 18, k + 2, 0);
        world.setBlock(i + 10, j + 18, k + 3, 0);
        world.setBlock(i + 10, j + 18, k + 4, 0);
        world.setBlock(i + 10, j + 18, k + 5, 0);
        world.setBlock(i + 10, j + 18, k + 6, 0);
        world.setBlock(i + 10, j + 18, k + 7, 0);
        world.setBlock(i + 10, j + 18, k + 8, 0);
        world.setBlock(i + 10, j + 18, k + 9, 0);
        world.setBlock(i + 10, j + 18, k + 10, 0);
        world.setBlock(i + 10, j + 18, k + 11, 0);
        world.setBlock(i + 10, j + 18, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 18, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 18, k + 14, Block.glowStone.blockID);
        world.setBlock(i + 10, j + 18, k + 15, 0);
        world.setBlock(i + 10, j + 18, k + 16, 0);
        world.setBlock(i + 10, j + 18, k + 17, 0);
        world.setBlock(i + 10, j + 18, k + 18, 0);
        world.setBlock(i + 10, j + 18, k + 19, 0);
        world.setBlock(i + 10, j + 18, k + 20, Block.glowStone.blockID);
        world.setBlock(i + 10, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 18, k + 22, Block.glowStone.blockID);
        world.setBlock(i + 10, j + 18, k + 23, 0);
        world.setBlock(i + 10, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 18, k + 25, 0);
        world.setBlock(i + 10, j + 18, k + 26, 0);
        world.setBlock(i + 10, j + 19, k + 0, 0);
        world.setBlock(i + 10, j + 19, k + 1, 0);
        world.setBlock(i + 10, j + 19, k + 2, 0);
        world.setBlock(i + 10, j + 19, k + 3, 0);
        world.setBlock(i + 10, j + 19, k + 4, 0);
        world.setBlock(i + 10, j + 19, k + 5, 0);
        world.setBlock(i + 10, j + 19, k + 6, 0);
        world.setBlock(i + 10, j + 19, k + 7, 0);
        world.setBlock(i + 10, j + 19, k + 8, 0);
        world.setBlock(i + 10, j + 19, k + 9, 0);
        world.setBlock(i + 10, j + 19, k + 10, 0);
        world.setBlock(i + 10, j + 19, k + 11, 0);
        world.setBlock(i + 10, j + 19, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 19, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 19, k + 14, Block.fence.blockID);
        world.setBlock(i + 10, j + 19, k + 15, 0);
        world.setBlock(i + 10, j + 19, k + 16, 0);
        world.setBlock(i + 10, j + 19, k + 17, 0);
        world.setBlock(i + 10, j + 19, k + 18, 0);
        world.setBlock(i + 10, j + 19, k + 19, 0);
        world.setBlock(i + 10, j + 19, k + 20, Block.fence.blockID);
        world.setBlock(i + 10, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 19, k + 22, Block.fence.blockID);
        world.setBlock(i + 10, j + 19, k + 23, 0);
        world.setBlock(i + 10, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 19, k + 25, 0);
        world.setBlock(i + 10, j + 19, k + 26, 0);
        world.setBlock(i + 10, j + 20, k + 0, 0);
        world.setBlock(i + 10, j + 20, k + 1, 0);
        world.setBlock(i + 10, j + 20, k + 2, 0);
        world.setBlock(i + 10, j + 20, k + 3, 0);
        world.setBlock(i + 10, j + 20, k + 4, 0);
        world.setBlock(i + 10, j + 20, k + 5, 0);
        world.setBlock(i + 10, j + 20, k + 6, 0);
        world.setBlock(i + 10, j + 20, k + 7, 0);
        world.setBlock(i + 10, j + 20, k + 8, 0);
        world.setBlock(i + 10, j + 20, k + 9, 0);
        world.setBlock(i + 10, j + 20, k + 10, 0);
        world.setBlock(i + 10, j + 20, k + 11, 0);
        world.setBlock(i + 10, j + 20, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 20, k + 13, Block.stoneBrick.blockID);
        generate6(world, rand, i, j, k);
        return true;
    }

    public boolean generate6(World world, Random rand, int i, int j, int k)
    {
        world.setBlock(i + 10, j + 20, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 20, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 20, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 20, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 20, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 20, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 20, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 20, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 20, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 20, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 20, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 20, k + 25, 0);
        world.setBlock(i + 10, j + 20, k + 26, 0);
        world.setBlock(i + 10, j + 21, k + 0, 0);
        world.setBlock(i + 10, j + 21, k + 1, 0);
        world.setBlock(i + 10, j + 21, k + 2, 0);
        world.setBlock(i + 10, j + 21, k + 3, 0);
        world.setBlock(i + 10, j + 21, k + 4, 0);
        world.setBlock(i + 10, j + 21, k + 5, 0);
        world.setBlock(i + 10, j + 21, k + 6, 0);
        world.setBlock(i + 10, j + 21, k + 7, 0);
        world.setBlock(i + 10, j + 21, k + 8, 0);
        world.setBlock(i + 10, j + 21, k + 9, 0);
        world.setBlock(i + 10, j + 21, k + 10, 0);
        world.setBlock(i + 10, j + 21, k + 11, 0);
        world.setBlock(i + 10, j + 21, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 21, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 21, k + 14, 0);
        world.setBlock(i + 10, j + 21, k + 15, 0);
        world.setBlock(i + 10, j + 21, k + 16, 0);
        world.setBlock(i + 10, j + 21, k + 17, 0);
        world.setBlock(i + 10, j + 21, k + 18, 0);
        world.setBlock(i + 10, j + 21, k + 19, 0);
        world.setBlock(i + 10, j + 21, k + 20, 0);
        world.setBlock(i + 10, j + 21, k + 21, 0);
        world.setBlock(i + 10, j + 21, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 21, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 21, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 21, k + 25, 0);
        world.setBlock(i + 10, j + 21, k + 26, 0);
        world.setBlock(i + 10, j + 22, k + 0, 0);
        world.setBlock(i + 10, j + 22, k + 1, 0);
        world.setBlock(i + 10, j + 22, k + 2, 0);
        world.setBlock(i + 10, j + 22, k + 3, 0);
        world.setBlock(i + 10, j + 22, k + 4, 0);
        world.setBlock(i + 10, j + 22, k + 5, 0);
        world.setBlock(i + 10, j + 22, k + 6, 0);
        world.setBlock(i + 10, j + 22, k + 7, 0);
        world.setBlock(i + 10, j + 22, k + 8, 0);
        world.setBlock(i + 10, j + 22, k + 9, 0);
        world.setBlock(i + 10, j + 22, k + 10, 0);
        world.setBlock(i + 10, j + 22, k + 11, 0);
        world.setBlock(i + 10, j + 22, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 22, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 22, k + 14, 0);
        world.setBlock(i + 10, j + 22, k + 15, 0);
        world.setBlock(i + 10, j + 22, k + 16, 0);
        world.setBlock(i + 10, j + 22, k + 17, 0);
        world.setBlock(i + 10, j + 22, k + 18, 0);
        world.setBlock(i + 10, j + 22, k + 19, 0);
        world.setBlock(i + 10, j + 22, k + 20, 0);
        world.setBlock(i + 10, j + 22, k + 21, 0);
        world.setBlock(i + 10, j + 22, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 22, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 22, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 22, k + 25, 0);
        world.setBlock(i + 10, j + 22, k + 26, 0);
        world.setBlock(i + 10, j + 23, k + 0, 0);
        world.setBlock(i + 10, j + 23, k + 1, 0);
        world.setBlock(i + 10, j + 23, k + 2, 0);
        world.setBlock(i + 10, j + 23, k + 3, 0);
        world.setBlock(i + 10, j + 23, k + 4, 0);
        world.setBlock(i + 10, j + 23, k + 5, 0);
        world.setBlock(i + 10, j + 23, k + 6, 0);
        world.setBlock(i + 10, j + 23, k + 7, 0);
        world.setBlock(i + 10, j + 23, k + 8, 0);
        world.setBlock(i + 10, j + 23, k + 9, 0);
        world.setBlock(i + 10, j + 23, k + 10, 0);
        world.setBlock(i + 10, j + 23, k + 11, 0);
        world.setBlock(i + 10, j + 23, k + 12, 0);
        world.setBlock(i + 10, j + 23, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 23, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 23, k + 15, Block.glowStone.blockID);
        world.setBlock(i + 10, j + 23, k + 16, 0);
        world.setBlock(i + 10, j + 23, k + 17, 0);
        world.setBlock(i + 10, j + 23, k + 18, 0);
        world.setBlock(i + 10, j + 23, k + 19, 0);
        world.setBlock(i + 10, j + 23, k + 20, Block.glowStone.blockID);
        world.setBlock(i + 10, j + 23, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 23, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 23, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 23, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 23, k + 25, 0);
        world.setBlock(i + 10, j + 23, k + 26, 0);
        world.setBlock(i + 10, j + 24, k + 0, 0);
        world.setBlock(i + 10, j + 24, k + 1, 0);
        world.setBlock(i + 10, j + 24, k + 2, 0);
        world.setBlock(i + 10, j + 24, k + 3, 0);
        world.setBlock(i + 10, j + 24, k + 4, 0);
        world.setBlock(i + 10, j + 24, k + 5, 0);
        world.setBlock(i + 10, j + 24, k + 6, 0);
        world.setBlock(i + 10, j + 24, k + 7, 0);
        world.setBlock(i + 10, j + 24, k + 8, 0);
        world.setBlock(i + 10, j + 24, k + 9, 0);
        world.setBlock(i + 10, j + 24, k + 10, 0);
        world.setBlock(i + 10, j + 24, k + 11, 0);
        world.setBlock(i + 10, j + 24, k + 12, 0);
        world.setBlock(i + 10, j + 24, k + 13, 0);
        world.setBlock(i + 10, j + 24, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 24, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 24, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 24, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 24, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 24, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 24, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 24, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 24, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 24, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 10, j + 24, k + 24, 0);
        world.setBlock(i + 10, j + 24, k + 25, 0);
        world.setBlock(i + 10, j + 24, k + 26, 0);
        world.setBlock(i + 10, j + 25, k + 0, 0);
        world.setBlock(i + 10, j + 25, k + 1, 0);
        world.setBlock(i + 10, j + 25, k + 2, 0);
        world.setBlock(i + 10, j + 25, k + 3, 0);
        world.setBlock(i + 10, j + 25, k + 4, 0);
        world.setBlock(i + 10, j + 25, k + 5, 0);
        world.setBlock(i + 10, j + 25, k + 6, 0);
        world.setBlock(i + 10, j + 25, k + 7, 0);
        world.setBlock(i + 10, j + 25, k + 8, 0);
        world.setBlock(i + 10, j + 25, k + 9, 0);
        world.setBlock(i + 10, j + 25, k + 10, 0);
        world.setBlock(i + 10, j + 25, k + 11, 0);
        world.setBlock(i + 10, j + 25, k + 12, 0);
        world.setBlock(i + 10, j + 25, k + 13, 0);
        world.setBlock(i + 10, j + 25, k + 14, 0);
        world.setBlock(i + 10, j + 25, k + 15, 0);
        world.setBlock(i + 10, j + 25, k + 16, 0);
        world.setBlock(i + 10, j + 25, k + 17, 0);
        world.setBlock(i + 10, j + 25, k + 18, 0);
        world.setBlock(i + 10, j + 25, k + 19, 0);
        world.setBlock(i + 10, j + 25, k + 20, 0);
        world.setBlock(i + 10, j + 25, k + 21, 0);
        world.setBlock(i + 10, j + 25, k + 22, 0);
        world.setBlock(i + 10, j + 25, k + 23, 0);
        world.setBlock(i + 10, j + 25, k + 24, 0);
        world.setBlock(i + 10, j + 25, k + 25, 0);
        world.setBlock(i + 10, j + 25, k + 26, 0);
        world.setBlock(i + 11, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 2, Block.grass.blockID);
        world.setBlock(i + 11, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 11, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 11, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 11, j + 2, k + 0, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 1, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 9, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 11, j + 2, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 11, j + 2, k + 12, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 11, j + 2, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 16, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 11, j + 2, k + 17, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 11, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 21, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 11, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 11, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 11, j + 3, k + 0, 0);
        world.setBlock(i + 11, j + 3, k + 1, 0);
        world.setBlock(i + 11, j + 3, k + 2, 0);
        world.setBlock(i + 11, j + 3, k + 3, 0);
        world.setBlock(i + 11, j + 3, k + 4, 0);
        world.setBlock(i + 11, j + 3, k + 6, 0);
        world.setBlock(i + 11, j + 3, k + 7, 0);
        world.setBlock(i + 11, j + 3, k + 8, 0);
        world.setBlock(i + 11, j + 3, k + 9, 0);
        world.setBlock(i + 11, j + 3, k + 10, 0);
        world.setBlock(i + 11, j + 3, k + 11, 0);
        world.setBlock(i + 11, j + 3, k + 12, 0);
        world.setBlock(i + 11, j + 3, k + 13, 0);
        world.setBlock(i + 11, j + 3, k + 14, 0);
        world.setBlock(i + 11, j + 3, k + 15, 0);
        world.setBlock(i + 11, j + 3, k + 16, 0);
        world.setBlock(i + 11, j + 3, k + 17, 0);
        world.setBlock(i + 11, j + 3, k + 18, 0);
        world.setBlock(i + 11, j + 3, k + 19, 0);
        world.setBlock(i + 11, j + 3, k + 20, 0);
        world.setBlock(i + 11, j + 3, k + 21, 0);
        world.setBlock(i + 11, j + 3, k + 22, 0);
        world.setBlock(i + 11, j + 3, k + 23, 0);
        world.setBlock(i + 11, j + 3, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 4, k + 0, 0);
        world.setBlock(i + 11, j + 4, k + 1, 0);
        world.setBlock(i + 11, j + 4, k + 2, 0);
        world.setBlock(i + 11, j + 4, k + 3, 0);
        world.setBlock(i + 11, j + 4, k + 4, 0);
        world.setBlock(i + 11, j + 4, k + 6, 0);
        world.setBlock(i + 11, j + 4, k + 7, 0);
        world.setBlock(i + 11, j + 4, k + 8, 0);
        world.setBlock(i + 11, j + 4, k + 9, 0);
        world.setBlock(i + 11, j + 4, k + 10, 0);
        world.setBlock(i + 11, j + 4, k + 11, 0);
        world.setBlock(i + 11, j + 4, k + 12, 0);
        world.setBlock(i + 11, j + 4, k + 13, 0);
        world.setBlock(i + 11, j + 4, k + 14, 0);
        world.setBlock(i + 11, j + 4, k + 15, 0);
        world.setBlock(i + 11, j + 4, k + 16, 0);
        world.setBlock(i + 11, j + 4, k + 17, 0);
        world.setBlock(i + 11, j + 4, k + 18, 0);
        world.setBlock(i + 11, j + 4, k + 19, 0);
        world.setBlock(i + 11, j + 4, k + 20, 0);
        world.setBlock(i + 11, j + 4, k + 21, 0);
        world.setBlock(i + 11, j + 4, k + 22, 0);
        world.setBlock(i + 11, j + 4, k + 23, 0);
        world.setBlock(i + 11, j + 4, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 4, k + 25, 0);
        world.setBlock(i + 11, j + 4, k + 26, 0);
        world.setBlock(i + 11, j + 5, k + 0, 0);
        world.setBlock(i + 11, j + 5, k + 1, 0);
        world.setBlock(i + 11, j + 5, k + 2, 0);
        world.setBlock(i + 11, j + 5, k + 3, 0);
        world.setBlock(i + 11, j + 5, k + 4, 0);
        world.setBlock(i + 11, j + 5, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 5, k + 6, 0);
        world.setBlock(i + 11, j + 5, k + 7, 0);
        world.setBlock(i + 11, j + 5, k + 8, 0);
        world.setBlock(i + 11, j + 5, k + 9, 0);
        world.setBlock(i + 11, j + 5, k + 10, 0);
        world.setBlock(i + 11, j + 5, k + 11, 0);
        world.setBlock(i + 11, j + 5, k + 12, 0);
        world.setBlock(i + 11, j + 5, k + 13, 0);
        world.setBlock(i + 11, j + 5, k + 14, 0);
        world.setBlock(i + 11, j + 5, k + 15, 0);
        world.setBlock(i + 11, j + 5, k + 16, 0);
        world.setBlock(i + 11, j + 5, k + 17, 0);
        world.setBlock(i + 11, j + 5, k + 18, 0);
        world.setBlock(i + 11, j + 5, k + 19, 0);
        world.setBlock(i + 11, j + 5, k + 20, 0);
        world.setBlock(i + 11, j + 5, k + 21, 0);
        world.setBlock(i + 11, j + 5, k + 22, 0);
        world.setBlock(i + 11, j + 5, k + 23, 0);
        world.setBlock(i + 11, j + 5, k + 24, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 11, j + 5, k + 25, 0);
        world.setBlock(i + 11, j + 5, k + 26, 0);
        world.setBlock(i + 11, j + 6, k + 0, 0);
        world.setBlock(i + 11, j + 6, k + 1, 0);
        world.setBlock(i + 11, j + 6, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 6, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 11, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 11, j + 6, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 11, j + 6, k + 7, 0);
        world.setBlock(i + 11, j + 6, k + 8, 0);
        world.setBlock(i + 11, j + 6, k + 9, 0);
        world.setBlock(i + 11, j + 6, k + 10, 0);
        world.setBlock(i + 11, j + 6, k + 11, 0);
        world.setBlock(i + 11, j + 6, k + 12, 0);
        world.setBlock(i + 11, j + 6, k + 13, 0);
        world.setBlock(i + 11, j + 6, k + 14, 0);
        world.setBlock(i + 11, j + 6, k + 15, 0);
        world.setBlock(i + 11, j + 6, k + 16, 0);
        world.setBlock(i + 11, j + 6, k + 17, 0);
        world.setBlock(i + 11, j + 6, k + 18, 0);
        world.setBlock(i + 11, j + 6, k + 19, 0);
        world.setBlock(i + 11, j + 6, k + 20, 0);
        world.setBlock(i + 11, j + 6, k + 21, 0);
        world.setBlock(i + 11, j + 6, k + 22, 0);
        world.setBlock(i + 11, j + 6, k + 23, 0);
        world.setBlock(i + 11, j + 6, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 6, k + 25, 0);
        world.setBlock(i + 11, j + 6, k + 26, 0);
        world.setBlock(i + 11, j + 7, k + 0, 0);
        world.setBlock(i + 11, j + 7, k + 1, 0);
        world.setBlock(i + 11, j + 7, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 7, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 7, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 11, j + 7, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 7, k + 7, 0);
        world.setBlock(i + 11, j + 7, k + 8, 0);
        world.setBlock(i + 11, j + 7, k + 9, 0);
        world.setBlock(i + 11, j + 7, k + 10, 0);
        world.setBlock(i + 11, j + 7, k + 11, 0);
        world.setBlock(i + 11, j + 7, k + 12, 0);
        world.setBlock(i + 11, j + 7, k + 13, 0);
        world.setBlock(i + 11, j + 7, k + 14, 0);
        world.setBlock(i + 11, j + 7, k + 15, 0);
        world.setBlock(i + 11, j + 7, k + 16, 0);
        world.setBlock(i + 11, j + 7, k + 17, 0);
        world.setBlock(i + 11, j + 7, k + 18, 0);
        world.setBlock(i + 11, j + 7, k + 19, 0);
        world.setBlock(i + 11, j + 7, k + 20, 0);
        world.setBlock(i + 11, j + 7, k + 21, 0);
        world.setBlock(i + 11, j + 7, k + 22, 0);
        world.setBlock(i + 11, j + 7, k + 23, 0);
        world.setBlock(i + 11, j + 7, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 7, k + 25, 0);
        world.setBlock(i + 11, j + 7, k + 26, 0);
        world.setBlock(i + 11, j + 8, k + 0, 0);
        world.setBlock(i + 11, j + 8, k + 1, 0);
        world.setBlock(i + 11, j + 8, k + 2, 0);
        world.setBlock(i + 11, j + 8, k + 3, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 11, j + 8, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 11, j + 8, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 11, j + 8, k + 7, 0);
        world.setBlock(i + 11, j + 8, k + 8, 0);
        world.setBlock(i + 11, j + 8, k + 9, 0);
        world.setBlock(i + 11, j + 8, k + 10, 0);
        world.setBlock(i + 11, j + 8, k + 11, 0);
        world.setBlock(i + 11, j + 8, k + 12, 0);
        world.setBlock(i + 11, j + 8, k + 13, 0);
        world.setBlock(i + 11, j + 8, k + 14, 0);
        world.setBlock(i + 11, j + 8, k + 15, 0);
        world.setBlock(i + 11, j + 8, k + 16, 0);
        world.setBlock(i + 11, j + 8, k + 17, 0);
        world.setBlock(i + 11, j + 8, k + 18, 0);
        world.setBlock(i + 11, j + 8, k + 19, Block.glowStone.blockID);
        world.setBlock(i + 11, j + 8, k + 20, 0);
        world.setBlock(i + 11, j + 8, k + 21, 0);
        world.setBlock(i + 11, j + 8, k + 22, 0);
        world.setBlock(i + 11, j + 8, k + 23, 0);
        world.setBlock(i + 11, j + 8, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 8, k + 25, 0);
        world.setBlock(i + 11, j + 8, k + 26, 0);
        world.setBlock(i + 11, j + 9, k + 0, 0);
        world.setBlock(i + 11, j + 9, k + 1, 0);
        world.setBlock(i + 11, j + 9, k + 2, 0);
        world.setBlock(i + 11, j + 9, k + 3, 0);
        world.setBlock(i + 11, j + 9, k + 4, 0);
        world.setBlock(i + 11, j + 9, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 9, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 11, j + 9, k + 15, 0);
        world.setBlock(i + 11, j + 9, k + 16, 0);
        world.setBlock(i + 11, j + 9, k + 17, 0);
        world.setBlock(i + 11, j + 9, k + 18, Block.glowStone.blockID);
        world.setBlock(i + 11, j + 9, k + 19, Block.fence.blockID);
        world.setBlock(i + 11, j + 9, k + 20, Block.glowStone.blockID);
        world.setBlock(i + 11, j + 9, k + 21, 0);
        world.setBlock(i + 11, j + 9, k + 22, 0);
        world.setBlock(i + 11, j + 9, k + 23, 0);
        world.setBlock(i + 11, j + 9, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 9, k + 25, 0);
        world.setBlock(i + 11, j + 9, k + 26, 0);
        world.setBlock(i + 11, j + 10, k + 0, 0);
        world.setBlock(i + 11, j + 10, k + 1, 0);
        world.setBlock(i + 11, j + 10, k + 2, 0);
        world.setBlock(i + 11, j + 10, k + 3, 0);
        world.setBlock(i + 11, j + 10, k + 4, 0);
        world.setBlock(i + 11, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 10, k + 6, 0);
        world.setBlock(i + 11, j + 10, k + 7, 0);
        world.setBlock(i + 11, j + 10, k + 8, Block.workbench.blockID);
        world.setBlock(i + 11, j + 10, k + 9, 0);
        world.setBlock(i + 11, j + 10, k + 10, 0);
        world.setBlock(i + 11, j + 10, k + 11, Block.chest.blockID, 2, 0);
        world.setBlock(i + 11, j + 10, k + 12, 0);
        world.setBlock(i + 11, j + 10, k + 13, 0);
        world.setBlock(i + 11, j + 10, k + 14, Block.fence.blockID);
        world.setBlock(i + 11, j + 10, k + 15, 0);
        world.setBlock(i + 11, j + 10, k + 16, 0);
        world.setBlock(i + 11, j + 10, k + 17, 0);
        world.setBlock(i + 11, j + 10, k + 18, Block.fence.blockID);
        world.setBlock(i + 11, j + 10, k + 19, Block.fence.blockID);
        world.setBlock(i + 11, j + 10, k + 20, Block.fence.blockID);
        world.setBlock(i + 11, j + 10, k + 21, 0);
        world.setBlock(i + 11, j + 10, k + 22, 0);
        world.setBlock(i + 11, j + 10, k + 23, Block.web.blockID);
        world.setBlock(i + 11, j + 10, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 10, k + 25, 0);
        world.setBlock(i + 11, j + 10, k + 26, 0);
        world.setBlock(i + 11, j + 11, k + 0, 0);
        world.setBlock(i + 11, j + 11, k + 1, 0);
        world.setBlock(i + 11, j + 11, k + 2, 0);
        world.setBlock(i + 11, j + 11, k + 3, 0);
        world.setBlock(i + 11, j + 11, k + 4, 0);
        world.setBlock(i + 11, j + 11, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 11, k + 6, 0);
        world.setBlock(i + 11, j + 11, k + 7, 0);
        world.setBlock(i + 11, j + 11, k + 8, 0);
        world.setBlock(i + 11, j + 11, k + 9, 0);
        world.setBlock(i + 11, j + 11, k + 10, 0);
        world.setBlock(i + 11, j + 11, k + 11, 0);
        world.setBlock(i + 11, j + 11, k + 12, 0);
        world.setBlock(i + 11, j + 11, k + 13, 0);
        world.setBlock(i + 11, j + 11, k + 14, 0);
        world.setBlock(i + 11, j + 11, k + 15, 0);
        world.setBlock(i + 11, j + 11, k + 16, 0);
        world.setBlock(i + 11, j + 11, k + 17, 0);
        world.setBlock(i + 11, j + 11, k + 18, 0);
        world.setBlock(i + 11, j + 11, k + 19, Block.fence.blockID);
        world.setBlock(i + 11, j + 11, k + 20, 0);
        world.setBlock(i + 11, j + 11, k + 21, 0);
        world.setBlock(i + 11, j + 11, k + 22, 0);
        world.setBlock(i + 11, j + 11, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 11, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 11, j + 11, k + 26, 0);
        world.setBlock(i + 11, j + 12, k + 0, 0);
        world.setBlock(i + 11, j + 12, k + 1, 0);
        world.setBlock(i + 11, j + 12, k + 2, 0);
        world.setBlock(i + 11, j + 12, k + 3, 0);
        world.setBlock(i + 11, j + 12, k + 4, 0);
        world.setBlock(i + 11, j + 12, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 12, k + 6, 0);
        world.setBlock(i + 11, j + 12, k + 7, 0);
        world.setBlock(i + 11, j + 12, k + 8, 0);
        world.setBlock(i + 11, j + 12, k + 9, 0);
        world.setBlock(i + 11, j + 12, k + 10, 0);
        world.setBlock(i + 11, j + 12, k + 11, 0);
        world.setBlock(i + 11, j + 12, k + 12, 0);
        world.setBlock(i + 11, j + 12, k + 13, 0);
        world.setBlock(i + 11, j + 12, k + 14, 0);
        world.setBlock(i + 11, j + 12, k + 15, 0);
        world.setBlock(i + 11, j + 12, k + 16, 0);
        world.setBlock(i + 11, j + 12, k + 17, 0);
        world.setBlock(i + 11, j + 12, k + 18, 0);
        world.setBlock(i + 11, j + 12, k + 19, Block.fence.blockID);
        world.setBlock(i + 11, j + 12, k + 20, 0);
        world.setBlock(i + 11, j + 12, k + 21, 0);
        world.setBlock(i + 11, j + 12, k + 22, 0);
        world.setBlock(i + 11, j + 12, k + 23, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 11, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 11, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 11, j + 12, k + 26, 0);
        world.setBlock(i + 11, j + 13, k + 0, 0);
        world.setBlock(i + 11, j + 13, k + 1, 0);
        world.setBlock(i + 11, j + 13, k + 2, 0);
        world.setBlock(i + 11, j + 13, k + 3, 0);
        world.setBlock(i + 11, j + 13, k + 4, 0);
        world.setBlock(i + 11, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 13, k + 6, 0);
        world.setBlock(i + 11, j + 13, k + 7, 0);
        world.setBlock(i + 11, j + 13, k + 8, 0);
        world.setBlock(i + 11, j + 13, k + 9, 0);
        world.setBlock(i + 11, j + 13, k + 10, 0);
        world.setBlock(i + 11, j + 13, k + 11, 0);
        world.setBlock(i + 11, j + 13, k + 12, 0);
        world.setBlock(i + 11, j + 13, k + 13, 0);
        world.setBlock(i + 11, j + 13, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 13, k + 15, 0);
        world.setBlock(i + 11, j + 13, k + 16, 0);
        world.setBlock(i + 11, j + 13, k + 17, 0);
        world.setBlock(i + 11, j + 13, k + 18, Block.fence.blockID);
        world.setBlock(i + 11, j + 13, k + 19, Block.fence.blockID);
        world.setBlock(i + 11, j + 13, k + 20, Block.fence.blockID);
        world.setBlock(i + 11, j + 13, k + 21, 0);
        world.setBlock(i + 11, j + 13, k + 22, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 11, j + 13, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 13, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 13, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 13, k + 26, 0);
        world.setBlock(i + 11, j + 14, k + 0, 0);
        world.setBlock(i + 11, j + 14, k + 1, 0);
        world.setBlock(i + 11, j + 14, k + 2, 0);
        world.setBlock(i + 11, j + 14, k + 3, 0);
        world.setBlock(i + 11, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 14, k + 26, 0);
        world.setBlock(i + 11, j + 15, k + 0, 0);
        world.setBlock(i + 11, j + 15, k + 1, 0);
        world.setBlock(i + 11, j + 15, k + 2, 0);
        world.setBlock(i + 11, j + 15, k + 3, 0);
        world.setBlock(i + 11, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 5, 0);
        world.setBlock(i + 11, j + 15, k + 6, 0);
        world.setBlock(i + 11, j + 15, k + 7, 0);
        world.setBlock(i + 11, j + 15, k + 8, 0);
        world.setBlock(i + 11, j + 15, k + 9, 0);
        world.setBlock(i + 11, j + 15, k + 10, 0);
        world.setBlock(i + 11, j + 15, k + 11, 0);
        world.setBlock(i + 11, j + 15, k + 12, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 11, j + 15, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 15, k + 25, 0);
        world.setBlock(i + 11, j + 15, k + 26, 0);
        world.setBlock(i + 11, j + 16, k + 0, 0);
        world.setBlock(i + 11, j + 16, k + 1, 0);
        world.setBlock(i + 11, j + 16, k + 2, 0);
        world.setBlock(i + 11, j + 16, k + 3, 0);
        world.setBlock(i + 11, j + 16, k + 4, 0);
        world.setBlock(i + 11, j + 16, k + 5, 0);
        world.setBlock(i + 11, j + 16, k + 6, 0);
        world.setBlock(i + 11, j + 16, k + 7, 0);
        world.setBlock(i + 11, j + 16, k + 8, 0);
        world.setBlock(i + 11, j + 16, k + 9, 0);
        world.setBlock(i + 11, j + 16, k + 10, 0);
        world.setBlock(i + 11, j + 16, k + 11, 0);
        world.setBlock(i + 11, j + 16, k + 12, 0);
        world.setBlock(i + 11, j + 16, k + 14, 0);
        world.setBlock(i + 11, j + 16, k + 15, 0);
        world.setBlock(i + 11, j + 16, k + 16, 0);
        world.setBlock(i + 11, j + 16, k + 17, 0);
        world.setBlock(i + 11, j + 16, k + 18, 0);
        world.setBlock(i + 11, j + 16, k + 19, 0);
        world.setBlock(i + 11, j + 16, k + 20, 0);
        world.setBlock(i + 11, j + 16, k + 22, 0);
        world.setBlock(i + 11, j + 16, k + 23, 0);
        world.setBlock(i + 11, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 16, k + 25, 0);
        world.setBlock(i + 11, j + 16, k + 26, 0);
        world.setBlock(i + 11, j + 17, k + 0, 0);
        world.setBlock(i + 11, j + 17, k + 1, 0);
        world.setBlock(i + 11, j + 17, k + 2, 0);
        world.setBlock(i + 11, j + 17, k + 3, 0);
        world.setBlock(i + 11, j + 17, k + 4, 0);
        world.setBlock(i + 11, j + 17, k + 5, 0);
        world.setBlock(i + 11, j + 17, k + 6, 0);
        world.setBlock(i + 11, j + 17, k + 7, 0);
        world.setBlock(i + 11, j + 17, k + 8, 0);
        world.setBlock(i + 11, j + 17, k + 9, 0);
        world.setBlock(i + 11, j + 17, k + 10, 0);
        world.setBlock(i + 11, j + 17, k + 11, 0);
        world.setBlock(i + 11, j + 17, k + 12, 0);
        world.setBlock(i + 11, j + 17, k + 14, 0);
        world.setBlock(i + 11, j + 17, k + 15, 0);
        world.setBlock(i + 11, j + 17, k + 16, 0);
        world.setBlock(i + 11, j + 17, k + 17, 0);
        world.setBlock(i + 11, j + 17, k + 18, 0);
        world.setBlock(i + 11, j + 17, k + 19, 0);
        world.setBlock(i + 11, j + 17, k + 20, 0);
        world.setBlock(i + 11, j + 17, k + 22, 0);
        world.setBlock(i + 11, j + 17, k + 23, 0);
        world.setBlock(i + 11, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 17, k + 25, 0);
        world.setBlock(i + 11, j + 17, k + 26, 0);
        world.setBlock(i + 11, j + 18, k + 0, 0);
        world.setBlock(i + 11, j + 18, k + 1, 0);
        world.setBlock(i + 11, j + 18, k + 2, 0);
        world.setBlock(i + 11, j + 18, k + 3, 0);
        world.setBlock(i + 11, j + 18, k + 4, 0);
        world.setBlock(i + 11, j + 18, k + 5, 0);
        world.setBlock(i + 11, j + 18, k + 6, 0);
        world.setBlock(i + 11, j + 18, k + 7, 0);
        world.setBlock(i + 11, j + 18, k + 8, 0);
        world.setBlock(i + 11, j + 18, k + 9, 0);
        world.setBlock(i + 11, j + 18, k + 10, 0);
        world.setBlock(i + 11, j + 18, k + 11, 0);
        world.setBlock(i + 11, j + 18, k + 12, 0);
        world.setBlock(i + 11, j + 18, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 18, k + 14, 0);
        world.setBlock(i + 11, j + 18, k + 15, 0);
        world.setBlock(i + 11, j + 18, k + 16, 0);
        world.setBlock(i + 11, j + 18, k + 17, 0);
        world.setBlock(i + 11, j + 18, k + 18, 0);
        world.setBlock(i + 11, j + 18, k + 19, 0);
        world.setBlock(i + 11, j + 18, k + 20, 0);
        world.setBlock(i + 11, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 18, k + 22, 0);
        world.setBlock(i + 11, j + 18, k + 23, 0);
        world.setBlock(i + 11, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 18, k + 25, 0);
        world.setBlock(i + 11, j + 18, k + 26, 0);
        world.setBlock(i + 11, j + 19, k + 0, 0);
        world.setBlock(i + 11, j + 19, k + 1, 0);
        world.setBlock(i + 11, j + 19, k + 2, 0);
        world.setBlock(i + 11, j + 19, k + 3, 0);
        world.setBlock(i + 11, j + 19, k + 4, 0);
        world.setBlock(i + 11, j + 19, k + 5, 0);
        world.setBlock(i + 11, j + 19, k + 6, 0);
        world.setBlock(i + 11, j + 19, k + 7, 0);
        world.setBlock(i + 11, j + 19, k + 8, 0);
        world.setBlock(i + 11, j + 19, k + 9, 0);
        world.setBlock(i + 11, j + 19, k + 10, 0);
        world.setBlock(i + 11, j + 19, k + 11, 0);
        world.setBlock(i + 11, j + 19, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 19, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 19, k + 14, 0);
        world.setBlock(i + 11, j + 19, k + 15, 0);
        world.setBlock(i + 11, j + 19, k + 16, 0);
        world.setBlock(i + 11, j + 19, k + 17, 0);
        world.setBlock(i + 11, j + 19, k + 18, 0);
        world.setBlock(i + 11, j + 19, k + 19, 0);
        world.setBlock(i + 11, j + 19, k + 20, 0);
        world.setBlock(i + 11, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 19, k + 22, 0);
        world.setBlock(i + 11, j + 19, k + 23, 0);
        world.setBlock(i + 11, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 19, k + 25, 0);
        world.setBlock(i + 11, j + 19, k + 26, 0);
        world.setBlock(i + 11, j + 20, k + 0, 0);
        world.setBlock(i + 11, j + 20, k + 1, 0);
        world.setBlock(i + 11, j + 20, k + 2, 0);
        world.setBlock(i + 11, j + 20, k + 3, 0);
        world.setBlock(i + 11, j + 20, k + 4, 0);
        world.setBlock(i + 11, j + 20, k + 5, 0);
        world.setBlock(i + 11, j + 20, k + 6, 0);
        world.setBlock(i + 11, j + 20, k + 7, 0);
        world.setBlock(i + 11, j + 20, k + 8, 0);
        world.setBlock(i + 11, j + 20, k + 9, 0);
        world.setBlock(i + 11, j + 20, k + 10, 0);
        world.setBlock(i + 11, j + 20, k + 11, 0);
        world.setBlock(i + 11, j + 20, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 20, k + 25, 0);
        world.setBlock(i + 11, j + 20, k + 26, 0);
        world.setBlock(i + 11, j + 21, k + 0, 0);
        world.setBlock(i + 11, j + 21, k + 1, 0);
        world.setBlock(i + 11, j + 21, k + 2, 0);
        world.setBlock(i + 11, j + 21, k + 3, 0);
        world.setBlock(i + 11, j + 21, k + 4, 0);
        world.setBlock(i + 11, j + 21, k + 5, 0);
        world.setBlock(i + 11, j + 21, k + 6, 0);
        world.setBlock(i + 11, j + 21, k + 7, 0);
        world.setBlock(i + 11, j + 21, k + 8, 0);
        world.setBlock(i + 11, j + 21, k + 9, 0);
        world.setBlock(i + 11, j + 21, k + 10, 0);
        world.setBlock(i + 11, j + 21, k + 11, 0);
        world.setBlock(i + 11, j + 21, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 21, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 21, k + 14, 0);
        world.setBlock(i + 11, j + 21, k + 15, 0);
        world.setBlock(i + 11, j + 21, k + 16, 0);
        world.setBlock(i + 11, j + 21, k + 17, 0);
        world.setBlock(i + 11, j + 21, k + 18, 0);
        world.setBlock(i + 11, j + 21, k + 19, 0);
        world.setBlock(i + 11, j + 21, k + 20, 0);
        world.setBlock(i + 11, j + 21, k + 21, 0);
        world.setBlock(i + 11, j + 21, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 21, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 21, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 21, k + 25, 0);
        world.setBlock(i + 11, j + 21, k + 26, 0);
        world.setBlock(i + 11, j + 22, k + 0, 0);
        world.setBlock(i + 11, j + 22, k + 1, 0);
        world.setBlock(i + 11, j + 22, k + 2, 0);
        world.setBlock(i + 11, j + 22, k + 3, 0);
        world.setBlock(i + 11, j + 22, k + 4, 0);
        world.setBlock(i + 11, j + 22, k + 5, 0);
        world.setBlock(i + 11, j + 22, k + 6, 0);
        world.setBlock(i + 11, j + 22, k + 7, 0);
        world.setBlock(i + 11, j + 22, k + 8, 0);
        world.setBlock(i + 11, j + 22, k + 9, 0);
        world.setBlock(i + 11, j + 22, k + 10, 0);
        world.setBlock(i + 11, j + 22, k + 11, 0);
        world.setBlock(i + 11, j + 22, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 22, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 22, k + 14, 0);
        world.setBlock(i + 11, j + 22, k + 15, 0);
        world.setBlock(i + 11, j + 22, k + 16, 0);
        world.setBlock(i + 11, j + 22, k + 17, 0);
        world.setBlock(i + 11, j + 22, k + 18, 0);
        world.setBlock(i + 11, j + 22, k + 19, 0);
        world.setBlock(i + 11, j + 22, k + 20, 0);
        world.setBlock(i + 11, j + 22, k + 21, 0);
        world.setBlock(i + 11, j + 22, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 22, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 22, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 22, k + 25, 0);
        world.setBlock(i + 11, j + 22, k + 26, 0);
        world.setBlock(i + 11, j + 23, k + 0, 0);
        world.setBlock(i + 11, j + 23, k + 1, 0);
        world.setBlock(i + 11, j + 23, k + 2, 0);
        world.setBlock(i + 11, j + 23, k + 3, 0);
        world.setBlock(i + 11, j + 23, k + 4, 0);
        world.setBlock(i + 11, j + 23, k + 5, 0);
        world.setBlock(i + 11, j + 23, k + 6, 0);
        world.setBlock(i + 11, j + 23, k + 7, 0);
        world.setBlock(i + 11, j + 23, k + 8, 0);
        world.setBlock(i + 11, j + 23, k + 9, 0);
        world.setBlock(i + 11, j + 23, k + 10, 0);
        world.setBlock(i + 11, j + 23, k + 11, 0);
        world.setBlock(i + 11, j + 23, k + 12, 0);
        world.setBlock(i + 11, j + 23, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 23, k + 14, 0);
        world.setBlock(i + 11, j + 23, k + 15, 0);
        world.setBlock(i + 11, j + 23, k + 16, 0);
        world.setBlock(i + 11, j + 23, k + 17, 0);
        world.setBlock(i + 11, j + 23, k + 18, 0);
        world.setBlock(i + 11, j + 23, k + 19, 0);
        world.setBlock(i + 11, j + 23, k + 20, 0);
        world.setBlock(i + 11, j + 23, k + 21, 0);
        world.setBlock(i + 11, j + 23, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 23, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 23, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 23, k + 25, 0);
        world.setBlock(i + 11, j + 23, k + 26, 0);
        world.setBlock(i + 11, j + 24, k + 0, 0);
        world.setBlock(i + 11, j + 24, k + 1, 0);
        world.setBlock(i + 11, j + 24, k + 2, 0);
        world.setBlock(i + 11, j + 24, k + 3, 0);
        world.setBlock(i + 11, j + 24, k + 4, 0);
        world.setBlock(i + 11, j + 24, k + 5, 0);
        world.setBlock(i + 11, j + 24, k + 6, 0);
        world.setBlock(i + 11, j + 24, k + 7, 0);
        world.setBlock(i + 11, j + 24, k + 8, 0);
        world.setBlock(i + 11, j + 24, k + 9, 0);
        world.setBlock(i + 11, j + 24, k + 10, 0);
        world.setBlock(i + 11, j + 24, k + 11, 0);
        world.setBlock(i + 11, j + 24, k + 12, 0);
        world.setBlock(i + 11, j + 24, k + 13, 0);
        world.setBlock(i + 11, j + 24, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 24, k + 15, Block.web.blockID);
        world.setBlock(i + 11, j + 24, k + 16, 0);
        world.setBlock(i + 11, j + 24, k + 17, 0);
        world.setBlock(i + 11, j + 24, k + 18, 0);
        world.setBlock(i + 11, j + 24, k + 19, 0);
        world.setBlock(i + 11, j + 24, k + 20, 0);
        world.setBlock(i + 11, j + 24, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 24, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 24, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 24, k + 24, 0);
        world.setBlock(i + 11, j + 24, k + 25, 0);
        world.setBlock(i + 11, j + 24, k + 26, 0);
        world.setBlock(i + 11, j + 25, k + 0, 0);
        world.setBlock(i + 11, j + 25, k + 1, 0);
        world.setBlock(i + 11, j + 25, k + 2, 0);
        world.setBlock(i + 11, j + 25, k + 3, 0);
        world.setBlock(i + 11, j + 25, k + 4, 0);
        world.setBlock(i + 11, j + 25, k + 5, 0);
        world.setBlock(i + 11, j + 25, k + 6, 0);
        world.setBlock(i + 11, j + 25, k + 7, 0);
        world.setBlock(i + 11, j + 25, k + 8, 0);
        world.setBlock(i + 11, j + 25, k + 9, 0);
        world.setBlock(i + 11, j + 25, k + 10, 0);
        world.setBlock(i + 11, j + 25, k + 11, 0);
        world.setBlock(i + 11, j + 25, k + 12, 0);
        world.setBlock(i + 11, j + 25, k + 13, 0);
        world.setBlock(i + 11, j + 25, k + 14, 0);
        world.setBlock(i + 11, j + 25, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 25, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 25, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 25, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 25, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 25, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 25, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 25, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 11, j + 25, k + 23, 0);
        world.setBlock(i + 11, j + 25, k + 24, 0);
        world.setBlock(i + 11, j + 25, k + 25, 0);
        world.setBlock(i + 11, j + 25, k + 26, 0);
        world.setBlock(i + 12, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 2, Block.grass.blockID);
        world.setBlock(i + 12, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 12, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 12, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 12, j + 2, k + 0, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 1, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 12, j + 2, k + 12, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 12, j + 2, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 15, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 12, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 17, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 12, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 20, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 12, j + 2, k + 21, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 12, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 12, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 12, j + 3, k + 0, 0);
        world.setBlock(i + 12, j + 3, k + 1, 0);
        world.setBlock(i + 12, j + 3, k + 2, 0);
        world.setBlock(i + 12, j + 3, k + 3, 0);
        world.setBlock(i + 12, j + 3, k + 7, 0);
        world.setBlock(i + 12, j + 3, k + 8, 0);
        world.setBlock(i + 12, j + 3, k + 9, 0);
        world.setBlock(i + 12, j + 3, k + 10, 0);
        world.setBlock(i + 12, j + 3, k + 11, 0);
        world.setBlock(i + 12, j + 3, k + 12, 0);
        world.setBlock(i + 12, j + 3, k + 13, 0);
        world.setBlock(i + 12, j + 3, k + 14, 0);
        world.setBlock(i + 12, j + 3, k + 15, 0);
        world.setBlock(i + 12, j + 3, k + 16, 0);
        world.setBlock(i + 12, j + 3, k + 17, 0);
        world.setBlock(i + 12, j + 3, k + 18, 0);
        world.setBlock(i + 12, j + 3, k + 19, 0);
        world.setBlock(i + 12, j + 3, k + 20, 0);
        world.setBlock(i + 12, j + 3, k + 21, 0);
        world.setBlock(i + 12, j + 3, k + 22, 0);
        world.setBlock(i + 12, j + 3, k + 23, 0);
        world.setBlock(i + 12, j + 3, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 3, k + 26, 0);
        world.setBlock(i + 12, j + 4, k + 0, 0);
        world.setBlock(i + 12, j + 4, k + 1, 0);
        world.setBlock(i + 12, j + 4, k + 2, 0);
        world.setBlock(i + 12, j + 4, k + 3, 0);
        world.setBlock(i + 12, j + 4, k + 4, 0);
        world.setBlock(i + 12, j + 4, k + 6, 0);
        world.setBlock(i + 12, j + 4, k + 7, 0);
        world.setBlock(i + 12, j + 4, k + 8, 0);
        world.setBlock(i + 12, j + 4, k + 9, 0);
        world.setBlock(i + 12, j + 4, k + 10, 0);
        world.setBlock(i + 12, j + 4, k + 11, 0);
        world.setBlock(i + 12, j + 4, k + 12, 0);
        world.setBlock(i + 12, j + 4, k + 13, 0);
        world.setBlock(i + 12, j + 4, k + 14, 0);
        world.setBlock(i + 12, j + 4, k + 15, 0);
        world.setBlock(i + 12, j + 4, k + 16, 0);
        world.setBlock(i + 12, j + 4, k + 17, 0);
        world.setBlock(i + 12, j + 4, k + 18, 0);
        world.setBlock(i + 12, j + 4, k + 19, 0);
        world.setBlock(i + 12, j + 4, k + 20, 0);
        world.setBlock(i + 12, j + 4, k + 21, 0);
        world.setBlock(i + 12, j + 4, k + 22, 0);
        world.setBlock(i + 12, j + 4, k + 23, 0);
        world.setBlock(i + 12, j + 4, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 4, k + 25, 0);
        world.setBlock(i + 12, j + 4, k + 26, 0);
        world.setBlock(i + 12, j + 5, k + 0, 0);
        world.setBlock(i + 12, j + 5, k + 1, 0);
        world.setBlock(i + 12, j + 5, k + 2, 0);
        world.setBlock(i + 12, j + 5, k + 3, 0);
        world.setBlock(i + 12, j + 5, k + 4, Block.web.blockID);
        world.setBlock(i + 12, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 12, j + 5, k + 6, 0);
        world.setBlock(i + 12, j + 5, k + 7, 0);
        world.setBlock(i + 12, j + 5, k + 8, 0);
        world.setBlock(i + 12, j + 5, k + 9, 0);
        world.setBlock(i + 12, j + 5, k + 10, 0);
        world.setBlock(i + 12, j + 5, k + 11, 0);
        world.setBlock(i + 12, j + 5, k + 12, 0);
        world.setBlock(i + 12, j + 5, k + 13, 0);
        world.setBlock(i + 12, j + 5, k + 14, 0);
        world.setBlock(i + 12, j + 5, k + 15, 0);
        world.setBlock(i + 12, j + 5, k + 16, 0);
        world.setBlock(i + 12, j + 5, k + 17, 0);
        world.setBlock(i + 12, j + 5, k + 18, 0);
        world.setBlock(i + 12, j + 5, k + 19, 0);
        world.setBlock(i + 12, j + 5, k + 20, 0);
        world.setBlock(i + 12, j + 5, k + 21, 0);
        world.setBlock(i + 12, j + 5, k + 22, 0);
        world.setBlock(i + 12, j + 5, k + 23, 0);
        world.setBlock(i + 12, j + 5, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 5, k + 25, 0);
        world.setBlock(i + 12, j + 5, k + 26, 0);
        world.setBlock(i + 12, j + 6, k + 0, 0);
        world.setBlock(i + 12, j + 6, k + 1, 0);
        world.setBlock(i + 12, j + 6, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 6, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 12, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 12, j + 6, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 6, k + 7, 0);
        world.setBlock(i + 12, j + 6, k + 8, 0);
        world.setBlock(i + 12, j + 6, k + 9, 0);
        world.setBlock(i + 12, j + 6, k + 10, 0);
        world.setBlock(i + 12, j + 6, k + 11, 0);
        world.setBlock(i + 12, j + 6, k + 12, 0);
        world.setBlock(i + 12, j + 6, k + 13, 0);
        world.setBlock(i + 12, j + 6, k + 14, 0);
        world.setBlock(i + 12, j + 6, k + 15, 0);
        world.setBlock(i + 12, j + 6, k + 16, 0);
        world.setBlock(i + 12, j + 6, k + 17, 0);
        world.setBlock(i + 12, j + 6, k + 18, 0);
        world.setBlock(i + 12, j + 6, k + 19, 0);
        world.setBlock(i + 12, j + 6, k + 20, 0);
        world.setBlock(i + 12, j + 6, k + 21, 0);
        world.setBlock(i + 12, j + 6, k + 22, 0);
        world.setBlock(i + 12, j + 6, k + 23, 0);
        world.setBlock(i + 12, j + 6, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 6, k + 25, 0);
        world.setBlock(i + 12, j + 6, k + 26, 0);
        world.setBlock(i + 12, j + 7, k + 0, 0);
        world.setBlock(i + 12, j + 7, k + 1, 0);
        world.setBlock(i + 12, j + 7, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 7, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 7, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 12, j + 7, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 12, j + 7, k + 7, 0);
        world.setBlock(i + 12, j + 7, k + 8, 0);
        world.setBlock(i + 12, j + 7, k + 9, 0);
        world.setBlock(i + 12, j + 7, k + 10, 0);
        world.setBlock(i + 12, j + 7, k + 11, 0);
        world.setBlock(i + 12, j + 7, k + 12, 0);
        world.setBlock(i + 12, j + 7, k + 13, 0);
        world.setBlock(i + 12, j + 7, k + 14, 0);
        world.setBlock(i + 12, j + 7, k + 15, 0);
        world.setBlock(i + 12, j + 7, k + 16, 0);
        world.setBlock(i + 12, j + 7, k + 17, 0);
        world.setBlock(i + 12, j + 7, k + 18, 0);
        world.setBlock(i + 12, j + 7, k + 19, 0);
        world.setBlock(i + 12, j + 7, k + 20, 0);
        world.setBlock(i + 12, j + 7, k + 21, 0);
        world.setBlock(i + 12, j + 7, k + 22, 0);
        world.setBlock(i + 12, j + 7, k + 23, 0);
        world.setBlock(i + 12, j + 7, k + 24, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 12, j + 7, k + 25, 0);
        world.setBlock(i + 12, j + 7, k + 26, 0);
        world.setBlock(i + 12, j + 8, k + 0, 0);
        world.setBlock(i + 12, j + 8, k + 1, 0);
        world.setBlock(i + 12, j + 8, k + 2, 0);
        world.setBlock(i + 12, j + 8, k + 3, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 12, j + 8, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 12, j + 8, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 12, j + 8, k + 7, 0);
        world.setBlock(i + 12, j + 8, k + 8, 0);
        world.setBlock(i + 12, j + 8, k + 9, 0);
        world.setBlock(i + 12, j + 8, k + 10, 0);
        world.setBlock(i + 12, j + 8, k + 11, 0);
        world.setBlock(i + 12, j + 8, k + 12, 0);
        world.setBlock(i + 12, j + 8, k + 13, 0);
        world.setBlock(i + 12, j + 8, k + 14, 0);
        world.setBlock(i + 12, j + 8, k + 15, 0);
        world.setBlock(i + 12, j + 8, k + 16, 0);
        world.setBlock(i + 12, j + 8, k + 17, 0);
        world.setBlock(i + 12, j + 8, k + 18, 0);
        world.setBlock(i + 12, j + 8, k + 19, Block.glowStone.blockID);
        world.setBlock(i + 12, j + 8, k + 20, 0);
        world.setBlock(i + 12, j + 8, k + 21, 0);
        world.setBlock(i + 12, j + 8, k + 22, 0);
        world.setBlock(i + 12, j + 8, k + 23, 0);
        world.setBlock(i + 12, j + 8, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 8, k + 25, 0);
        world.setBlock(i + 12, j + 8, k + 26, 0);
        world.setBlock(i + 12, j + 9, k + 0, 0);
        world.setBlock(i + 12, j + 9, k + 1, 0);
        world.setBlock(i + 12, j + 9, k + 2, 0);
        world.setBlock(i + 12, j + 9, k + 3, 0);
        world.setBlock(i + 12, j + 9, k + 4, 0);
        world.setBlock(i + 12, j + 9, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 9, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 9, k + 9, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 12, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 12, j + 9, k + 15, 0);
        world.setBlock(i + 12, j + 9, k + 16, 0);
        world.setBlock(i + 12, j + 9, k + 17, 0);
        world.setBlock(i + 12, j + 9, k + 18, Block.glowStone.blockID);
        world.setBlock(i + 12, j + 9, k + 19, Block.fence.blockID);
        world.setBlock(i + 12, j + 9, k + 20, Block.glowStone.blockID);
        world.setBlock(i + 12, j + 9, k + 21, 0);
        world.setBlock(i + 12, j + 9, k + 22, 0);
        world.setBlock(i + 12, j + 9, k + 23, 0);
        world.setBlock(i + 12, j + 9, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 9, k + 25, 0);
        world.setBlock(i + 12, j + 9, k + 26, 0);
        world.setBlock(i + 12, j + 10, k + 0, 0);
        world.setBlock(i + 12, j + 10, k + 1, 0);
        world.setBlock(i + 12, j + 10, k + 2, 0);
        world.setBlock(i + 12, j + 10, k + 3, 0);
        world.setBlock(i + 12, j + 10, k + 4, 0);
        world.setBlock(i + 12, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 10, k + 6, 0);
        world.setBlock(i + 12, j + 10, k + 7, 0);
        world.setBlock(i + 12, j + 10, k + 8, 0);
        world.setBlock(i + 12, j + 10, k + 9, 0);
        world.setBlock(i + 12, j + 10, k + 10, 0);
        world.setBlock(i + 12, j + 10, k + 11, 0);
        world.setBlock(i + 12, j + 10, k + 12, 0);
        world.setBlock(i + 12, j + 10, k + 13, 0);
        world.setBlock(i + 12, j + 10, k + 14, Block.fence.blockID);
        world.setBlock(i + 12, j + 10, k + 15, 0);
        world.setBlock(i + 12, j + 10, k + 16, 0);
        world.setBlock(i + 12, j + 10, k + 17, 0);
        world.setBlock(i + 12, j + 10, k + 18, Block.fence.blockID);
        world.setBlock(i + 12, j + 10, k + 19, Block.fence.blockID);
        world.setBlock(i + 12, j + 10, k + 20, Block.fence.blockID);
        world.setBlock(i + 12, j + 10, k + 21, 0);
        world.setBlock(i + 12, j + 10, k + 22, 0);
        world.setBlock(i + 12, j + 10, k + 23, 0);
        world.setBlock(i + 12, j + 10, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 10, k + 25, 0);
        world.setBlock(i + 12, j + 10, k + 26, 0);
        world.setBlock(i + 12, j + 11, k + 0, 0);
        world.setBlock(i + 12, j + 11, k + 1, 0);
        world.setBlock(i + 12, j + 11, k + 2, 0);
        world.setBlock(i + 12, j + 11, k + 3, 0);
        world.setBlock(i + 12, j + 11, k + 4, 0);
        world.setBlock(i + 12, j + 11, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 11, k + 6, 0);
        world.setBlock(i + 12, j + 11, k + 7, 0);
        world.setBlock(i + 12, j + 11, k + 8, 0);
        world.setBlock(i + 12, j + 11, k + 9, 0);
        world.setBlock(i + 12, j + 11, k + 10, 0);
        world.setBlock(i + 12, j + 11, k + 11, 0);
        world.setBlock(i + 12, j + 11, k + 12, 0);
        world.setBlock(i + 12, j + 11, k + 13, 0);
        world.setBlock(i + 12, j + 11, k + 14, 0);
        world.setBlock(i + 12, j + 11, k + 15, 0);
        world.setBlock(i + 12, j + 11, k + 16, 0);
        world.setBlock(i + 12, j + 11, k + 17, 0);
        world.setBlock(i + 12, j + 11, k + 18, 0);
        world.setBlock(i + 12, j + 11, k + 19, Block.fence.blockID);
        world.setBlock(i + 12, j + 11, k + 20, 0);
        world.setBlock(i + 12, j + 11, k + 21, 0);
        world.setBlock(i + 12, j + 11, k + 22, 0);
        world.setBlock(i + 12, j + 11, k + 23, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 12, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 12, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 12, j + 11, k + 26, 0);
        world.setBlock(i + 12, j + 12, k + 0, 0);
        world.setBlock(i + 12, j + 12, k + 1, 0);
        world.setBlock(i + 12, j + 12, k + 2, 0);
        world.setBlock(i + 12, j + 12, k + 3, 0);
        world.setBlock(i + 12, j + 12, k + 4, 0);
        world.setBlock(i + 12, j + 12, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 12, k + 6, 0);
        world.setBlock(i + 12, j + 12, k + 7, 0);
        world.setBlock(i + 12, j + 12, k + 8, 0);
        world.setBlock(i + 12, j + 12, k + 9, 0);
        world.setBlock(i + 12, j + 12, k + 10, 0);
        world.setBlock(i + 12, j + 12, k + 11, 0);
        world.setBlock(i + 12, j + 12, k + 12, 0);
        world.setBlock(i + 12, j + 12, k + 13, 0);
        world.setBlock(i + 12, j + 12, k + 14, 0);
        world.setBlock(i + 12, j + 12, k + 15, 0);
        world.setBlock(i + 12, j + 12, k + 16, 0);
        world.setBlock(i + 12, j + 12, k + 17, 0);
        world.setBlock(i + 12, j + 12, k + 18, 0);
        world.setBlock(i + 12, j + 12, k + 19, Block.fence.blockID);
        world.setBlock(i + 12, j + 12, k + 20, 0);
        world.setBlock(i + 12, j + 12, k + 21, 0);
        world.setBlock(i + 12, j + 12, k + 22, 0);
        world.setBlock(i + 12, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 12, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 12, j + 12, k + 26, 0);
        world.setBlock(i + 12, j + 13, k + 0, 0);
        world.setBlock(i + 12, j + 13, k + 1, 0);
        world.setBlock(i + 12, j + 13, k + 2, 0);
        world.setBlock(i + 12, j + 13, k + 3, 0);
        world.setBlock(i + 12, j + 13, k + 4, 0);
        world.setBlock(i + 12, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 13, k + 6, 0);
        world.setBlock(i + 12, j + 13, k + 7, 0);
        world.setBlock(i + 12, j + 13, k + 8, 0);
        world.setBlock(i + 12, j + 13, k + 9, 0);
        world.setBlock(i + 12, j + 13, k + 10, Block.glowStone.blockID);
        world.setBlock(i + 12, j + 13, k + 11, 0);
        world.setBlock(i + 12, j + 13, k + 12, 0);
        world.setBlock(i + 12, j + 13, k + 13, 0);
        world.setBlock(i + 12, j + 13, k + 14, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 12, j + 13, k + 15, 0);
        world.setBlock(i + 12, j + 13, k + 16, 0);
        world.setBlock(i + 12, j + 13, k + 17, 0);
        world.setBlock(i + 12, j + 13, k + 18, Block.fence.blockID);
        world.setBlock(i + 12, j + 13, k + 19, Block.fence.blockID);
        world.setBlock(i + 12, j + 13, k + 20, Block.fence.blockID);
        world.setBlock(i + 12, j + 13, k + 21, 0);
        world.setBlock(i + 12, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 13, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 13, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 13, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 13, k + 26, 0);
        world.setBlock(i + 12, j + 14, k + 0, 0);
        world.setBlock(i + 12, j + 14, k + 1, 0);
        world.setBlock(i + 12, j + 14, k + 2, 0);
        world.setBlock(i + 12, j + 14, k + 3, 0);
        world.setBlock(i + 12, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 14, k + 26, 0);
        world.setBlock(i + 12, j + 15, k + 0, 0);
        world.setBlock(i + 12, j + 15, k + 1, 0);
        world.setBlock(i + 12, j + 15, k + 2, 0);
        world.setBlock(i + 12, j + 15, k + 3, 0);
        world.setBlock(i + 12, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 5, 0);
        world.setBlock(i + 12, j + 15, k + 6, 0);
        world.setBlock(i + 12, j + 15, k + 7, 0);
        world.setBlock(i + 12, j + 15, k + 8, 0);
        world.setBlock(i + 12, j + 15, k + 9, 0);
        world.setBlock(i + 12, j + 15, k + 10, 0);
        world.setBlock(i + 12, j + 15, k + 11, 0);
        world.setBlock(i + 12, j + 15, k + 12, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 12, j + 15, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 15, k + 25, 0);
        world.setBlock(i + 12, j + 15, k + 26, 0);
        world.setBlock(i + 12, j + 16, k + 0, 0);
        world.setBlock(i + 12, j + 16, k + 1, 0);
        world.setBlock(i + 12, j + 16, k + 2, 0);
        world.setBlock(i + 12, j + 16, k + 3, 0);
        world.setBlock(i + 12, j + 16, k + 4, 0);
        world.setBlock(i + 12, j + 16, k + 5, 0);
        world.setBlock(i + 12, j + 16, k + 6, 0);
        world.setBlock(i + 12, j + 16, k + 7, 0);
        world.setBlock(i + 12, j + 16, k + 8, 0);
        world.setBlock(i + 12, j + 16, k + 9, 0);
        world.setBlock(i + 12, j + 16, k + 10, 0);
        world.setBlock(i + 12, j + 16, k + 11, 0);
        world.setBlock(i + 12, j + 16, k + 12, 0);
        world.setBlock(i + 12, j + 16, k + 14, 0);
        world.setBlock(i + 12, j + 16, k + 15, 0);
        world.setBlock(i + 12, j + 16, k + 16, 0);
        world.setBlock(i + 12, j + 16, k + 17, 0);
        world.setBlock(i + 12, j + 16, k + 18, 0);
        world.setBlock(i + 12, j + 16, k + 19, 0);
        world.setBlock(i + 12, j + 16, k + 20, 0);
        world.setBlock(i + 12, j + 16, k + 22, 0);
        world.setBlock(i + 12, j + 16, k + 23, 0);
        world.setBlock(i + 12, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 16, k + 25, 0);
        world.setBlock(i + 12, j + 16, k + 26, 0);
        world.setBlock(i + 12, j + 17, k + 0, 0);
        world.setBlock(i + 12, j + 17, k + 1, 0);
        world.setBlock(i + 12, j + 17, k + 2, 0);
        world.setBlock(i + 12, j + 17, k + 3, 0);
        world.setBlock(i + 12, j + 17, k + 4, 0);
        world.setBlock(i + 12, j + 17, k + 5, 0);
        world.setBlock(i + 12, j + 17, k + 6, 0);
        world.setBlock(i + 12, j + 17, k + 7, 0);
        world.setBlock(i + 12, j + 17, k + 8, 0);
        world.setBlock(i + 12, j + 17, k + 9, 0);
        world.setBlock(i + 12, j + 17, k + 10, 0);
        world.setBlock(i + 12, j + 17, k + 11, 0);
        world.setBlock(i + 12, j + 17, k + 12, 0);
        world.setBlock(i + 12, j + 17, k + 14, 0);
        world.setBlock(i + 12, j + 17, k + 15, 0);
        world.setBlock(i + 12, j + 17, k + 16, 0);
        world.setBlock(i + 12, j + 17, k + 17, 0);
        world.setBlock(i + 12, j + 17, k + 18, 0);
        world.setBlock(i + 12, j + 17, k + 19, 0);
        world.setBlock(i + 12, j + 17, k + 20, 0);
        world.setBlock(i + 12, j + 17, k + 22, 0);
        world.setBlock(i + 12, j + 17, k + 23, 0);
        world.setBlock(i + 12, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 17, k + 25, 0);
        world.setBlock(i + 12, j + 17, k + 26, 0);
        world.setBlock(i + 12, j + 18, k + 0, 0);
        world.setBlock(i + 12, j + 18, k + 1, 0);
        world.setBlock(i + 12, j + 18, k + 2, 0);
        world.setBlock(i + 12, j + 18, k + 3, 0);
        world.setBlock(i + 12, j + 18, k + 4, 0);
        world.setBlock(i + 12, j + 18, k + 5, 0);
        world.setBlock(i + 12, j + 18, k + 6, 0);
        world.setBlock(i + 12, j + 18, k + 7, 0);
        world.setBlock(i + 12, j + 18, k + 8, 0);
        world.setBlock(i + 12, j + 18, k + 9, 0);
        world.setBlock(i + 12, j + 18, k + 10, 0);
        world.setBlock(i + 12, j + 18, k + 11, 0);
        world.setBlock(i + 12, j + 18, k + 12, 0);
        world.setBlock(i + 12, j + 18, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 18, k + 14, 0);
        world.setBlock(i + 12, j + 18, k + 15, 0);
        world.setBlock(i + 12, j + 18, k + 16, 0);
        world.setBlock(i + 12, j + 18, k + 17, 0);
        world.setBlock(i + 12, j + 18, k + 18, 0);
        world.setBlock(i + 12, j + 18, k + 19, 0);
        world.setBlock(i + 12, j + 18, k + 20, 0);
        world.setBlock(i + 12, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 18, k + 22, 0);
        world.setBlock(i + 12, j + 18, k + 23, 0);
        world.setBlock(i + 12, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 18, k + 25, 0);
        world.setBlock(i + 12, j + 18, k + 26, 0);
        world.setBlock(i + 12, j + 19, k + 0, 0);
        world.setBlock(i + 12, j + 19, k + 1, 0);
        world.setBlock(i + 12, j + 19, k + 2, 0);
        world.setBlock(i + 12, j + 19, k + 3, 0);
        world.setBlock(i + 12, j + 19, k + 4, 0);
        world.setBlock(i + 12, j + 19, k + 5, 0);
        world.setBlock(i + 12, j + 19, k + 6, 0);
        world.setBlock(i + 12, j + 19, k + 7, 0);
        world.setBlock(i + 12, j + 19, k + 8, 0);
        world.setBlock(i + 12, j + 19, k + 9, 0);
        world.setBlock(i + 12, j + 19, k + 10, 0);
        world.setBlock(i + 12, j + 19, k + 11, 0);
        world.setBlock(i + 12, j + 19, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 19, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 19, k + 14, 0);
        world.setBlock(i + 12, j + 19, k + 15, 0);
        world.setBlock(i + 12, j + 19, k + 16, 0);
        world.setBlock(i + 12, j + 19, k + 17, 0);
        world.setBlock(i + 12, j + 19, k + 18, 0);
        world.setBlock(i + 12, j + 19, k + 19, 0);
        world.setBlock(i + 12, j + 19, k + 20, 0);
        world.setBlock(i + 12, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 19, k + 22, 0);
        world.setBlock(i + 12, j + 19, k + 23, 0);
        world.setBlock(i + 12, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 19, k + 25, 0);
        world.setBlock(i + 12, j + 19, k + 26, 0);
        world.setBlock(i + 12, j + 20, k + 0, 0);
        world.setBlock(i + 12, j + 20, k + 1, 0);
        world.setBlock(i + 12, j + 20, k + 2, 0);
        world.setBlock(i + 12, j + 20, k + 3, 0);
        world.setBlock(i + 12, j + 20, k + 4, 0);
        world.setBlock(i + 12, j + 20, k + 5, 0);
        world.setBlock(i + 12, j + 20, k + 6, 0);
        world.setBlock(i + 12, j + 20, k + 7, 0);
        world.setBlock(i + 12, j + 20, k + 8, 0);
        world.setBlock(i + 12, j + 20, k + 9, 0);
        world.setBlock(i + 12, j + 20, k + 10, 0);
        world.setBlock(i + 12, j + 20, k + 11, 0);
        world.setBlock(i + 12, j + 20, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 20, k + 25, 0);
        world.setBlock(i + 12, j + 20, k + 26, 0);
        world.setBlock(i + 12, j + 21, k + 0, 0);
        world.setBlock(i + 12, j + 21, k + 1, 0);
        world.setBlock(i + 12, j + 21, k + 2, 0);
        world.setBlock(i + 12, j + 21, k + 3, 0);
        world.setBlock(i + 12, j + 21, k + 4, 0);
        world.setBlock(i + 12, j + 21, k + 5, 0);
        world.setBlock(i + 12, j + 21, k + 6, 0);
        world.setBlock(i + 12, j + 21, k + 7, 0);
        world.setBlock(i + 12, j + 21, k + 8, 0);
        world.setBlock(i + 12, j + 21, k + 9, 0);
        world.setBlock(i + 12, j + 21, k + 10, 0);
        world.setBlock(i + 12, j + 21, k + 11, 0);
        world.setBlock(i + 12, j + 21, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 21, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 21, k + 14, 0);
        world.setBlock(i + 12, j + 21, k + 15, 0);
        world.setBlock(i + 12, j + 21, k + 16, 0);
        world.setBlock(i + 12, j + 21, k + 17, 0);
        world.setBlock(i + 12, j + 21, k + 18, 0);
        world.setBlock(i + 12, j + 21, k + 19, 0);
        world.setBlock(i + 12, j + 21, k + 20, 0);
        world.setBlock(i + 12, j + 21, k + 21, 0);
        world.setBlock(i + 12, j + 21, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 21, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 21, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 21, k + 25, 0);
        world.setBlock(i + 12, j + 21, k + 26, 0);
        world.setBlock(i + 12, j + 22, k + 0, 0);
        world.setBlock(i + 12, j + 22, k + 1, 0);
        world.setBlock(i + 12, j + 22, k + 2, 0);
        world.setBlock(i + 12, j + 22, k + 3, 0);
        world.setBlock(i + 12, j + 22, k + 4, 0);
        world.setBlock(i + 12, j + 22, k + 5, 0);
        world.setBlock(i + 12, j + 22, k + 6, 0);
        world.setBlock(i + 12, j + 22, k + 7, 0);
        world.setBlock(i + 12, j + 22, k + 8, 0);
        world.setBlock(i + 12, j + 22, k + 9, 0);
        world.setBlock(i + 12, j + 22, k + 10, 0);
        world.setBlock(i + 12, j + 22, k + 11, 0);
        world.setBlock(i + 12, j + 22, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 22, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 22, k + 14, 0);
        world.setBlock(i + 12, j + 22, k + 15, 0);
        world.setBlock(i + 12, j + 22, k + 16, 0);
        world.setBlock(i + 12, j + 22, k + 17, 0);
        world.setBlock(i + 12, j + 22, k + 18, 0);
        world.setBlock(i + 12, j + 22, k + 19, 0);
        world.setBlock(i + 12, j + 22, k + 20, 0);
        world.setBlock(i + 12, j + 22, k + 21, 0);
        world.setBlock(i + 12, j + 22, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 22, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 22, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 22, k + 25, 0);
        world.setBlock(i + 12, j + 22, k + 26, 0);
        world.setBlock(i + 12, j + 23, k + 0, 0);
        world.setBlock(i + 12, j + 23, k + 1, 0);
        world.setBlock(i + 12, j + 23, k + 2, 0);
        world.setBlock(i + 12, j + 23, k + 3, 0);
        world.setBlock(i + 12, j + 23, k + 4, 0);
        world.setBlock(i + 12, j + 23, k + 5, 0);
        world.setBlock(i + 12, j + 23, k + 6, 0);
        world.setBlock(i + 12, j + 23, k + 7, 0);
        world.setBlock(i + 12, j + 23, k + 8, 0);
        world.setBlock(i + 12, j + 23, k + 9, 0);
        world.setBlock(i + 12, j + 23, k + 10, 0);
        world.setBlock(i + 12, j + 23, k + 11, 0);
        world.setBlock(i + 12, j + 23, k + 12, 0);
        world.setBlock(i + 12, j + 23, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 23, k + 14, 0);
        world.setBlock(i + 12, j + 23, k + 15, 0);
        world.setBlock(i + 12, j + 23, k + 16, 0);
        world.setBlock(i + 12, j + 23, k + 17, 0);
        world.setBlock(i + 12, j + 23, k + 18, 0);
        world.setBlock(i + 12, j + 23, k + 19, 0);
        world.setBlock(i + 12, j + 23, k + 20, 0);
        world.setBlock(i + 12, j + 23, k + 21, 0);
        world.setBlock(i + 12, j + 23, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 23, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 23, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 23, k + 25, 0);
        world.setBlock(i + 12, j + 23, k + 26, 0);
        world.setBlock(i + 12, j + 24, k + 0, 0);
        world.setBlock(i + 12, j + 24, k + 1, 0);
        world.setBlock(i + 12, j + 24, k + 2, 0);
        world.setBlock(i + 12, j + 24, k + 3, 0);
        world.setBlock(i + 12, j + 24, k + 4, 0);
        world.setBlock(i + 12, j + 24, k + 5, 0);
        world.setBlock(i + 12, j + 24, k + 6, 0);
        world.setBlock(i + 12, j + 24, k + 7, 0);
        world.setBlock(i + 12, j + 24, k + 8, 0);
        world.setBlock(i + 12, j + 24, k + 9, 0);
        world.setBlock(i + 12, j + 24, k + 10, 0);
        world.setBlock(i + 12, j + 24, k + 11, 0);
        world.setBlock(i + 12, j + 24, k + 12, 0);
        world.setBlock(i + 12, j + 24, k + 13, 0);
        world.setBlock(i + 12, j + 24, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 24, k + 15, 0);
        world.setBlock(i + 12, j + 24, k + 16, 0);
        world.setBlock(i + 12, j + 24, k + 17, Block.web.blockID);
        world.setBlock(i + 12, j + 24, k + 18, 0);
        world.setBlock(i + 12, j + 24, k + 19, 0);
        world.setBlock(i + 12, j + 24, k + 20, 0);
        world.setBlock(i + 12, j + 24, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 24, k + 22, Block.stoneBrick.blockID);
        generate7(world, rand, i, j, k);
        return true;
    }

    public boolean generate7(World world, Random rand, int i, int j, int k)
    {
        world.setBlock(i + 12, j + 24, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 24, k + 24, 0);
        world.setBlock(i + 12, j + 24, k + 25, 0);
        world.setBlock(i + 12, j + 24, k + 26, 0);
        world.setBlock(i + 12, j + 25, k + 0, 0);
        world.setBlock(i + 12, j + 25, k + 1, 0);
        world.setBlock(i + 12, j + 25, k + 2, 0);
        world.setBlock(i + 12, j + 25, k + 3, 0);
        world.setBlock(i + 12, j + 25, k + 4, 0);
        world.setBlock(i + 12, j + 25, k + 5, 0);
        world.setBlock(i + 12, j + 25, k + 6, 0);
        world.setBlock(i + 12, j + 25, k + 7, 0);
        world.setBlock(i + 12, j + 25, k + 8, 0);
        world.setBlock(i + 12, j + 25, k + 9, 0);
        world.setBlock(i + 12, j + 25, k + 10, 0);
        world.setBlock(i + 12, j + 25, k + 11, 0);
        world.setBlock(i + 12, j + 25, k + 12, 0);
        world.setBlock(i + 12, j + 25, k + 13, 0);
        world.setBlock(i + 12, j + 25, k + 14, 0);
        world.setBlock(i + 12, j + 25, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 25, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 25, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 25, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 25, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 25, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 25, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 25, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 12, j + 25, k + 23, 0);
        world.setBlock(i + 12, j + 25, k + 24, 0);
        world.setBlock(i + 12, j + 25, k + 25, 0);
        world.setBlock(i + 12, j + 25, k + 26, 0);
        world.setBlock(i + 13, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 3, Block.grass.blockID);
        world.setBlock(i + 13, j + 0, k + 4, Block.grass.blockID);
        world.setBlock(i + 13, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 13, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 13, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 13, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 13, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 13, j + 2, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 2, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 2, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 2, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 2, k + 8, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 13, j + 2, k + 9, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 13, j + 2, k + 10, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 13, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 13, j + 2, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 13, j + 2, k + 13, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 13, j + 2, k + 14, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 13, j + 2, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 2, k + 17, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 13, j + 2, k + 18, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 13, j + 2, k + 19, Block.cobblestone.blockID);
        world.setBlock(i + 13, j + 2, k + 20, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 13, j + 2, k + 21, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 13, j + 2, k + 22, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 13, j + 2, k + 23, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 13, j + 2, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 13, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 13, j + 3, k + 0, 0);
        world.setBlock(i + 13, j + 3, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 3, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 3, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 3, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 3, k + 7, 0);
        world.setBlock(i + 13, j + 3, k + 8, 0);
        world.setBlock(i + 13, j + 3, k + 9, 0);
        world.setBlock(i + 13, j + 3, k + 10, 0);
        world.setBlock(i + 13, j + 3, k + 11, Block.furnaceIdle.blockID, 2, 0);
        world.setBlock(i + 13, j + 3, k + 12, 0);
        world.setBlock(i + 13, j + 3, k + 13, 0);
        world.setBlock(i + 13, j + 3, k + 14, 0);
        world.setBlock(i + 13, j + 3, k + 15, 0);
        world.setBlock(i + 13, j + 3, k + 16, 0);
        world.setBlock(i + 13, j + 3, k + 17, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 13, j + 3, k + 18, 0);
        world.setBlock(i + 13, j + 3, k + 19, 0);
        world.setBlock(i + 13, j + 3, k + 20, 0);
        world.setBlock(i + 13, j + 3, k + 21, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 13, j + 3, k + 22, 0);
        world.setBlock(i + 13, j + 3, k + 23, 0);
        world.setBlock(i + 13, j + 3, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 3, k + 26, 0);
        world.setBlock(i + 13, j + 4, k + 0, 0);
        world.setBlock(i + 13, j + 4, k + 1, 0);
        world.setBlock(i + 13, j + 4, k + 2, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 13, j + 4, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 4, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 4, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 4, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 4, k + 7, 0);
        world.setBlock(i + 13, j + 4, k + 8, 0);
        world.setBlock(i + 13, j + 4, k + 9, 0);
        world.setBlock(i + 13, j + 4, k + 10, 0);
        world.setBlock(i + 13, j + 4, k + 11, 0);
        world.setBlock(i + 13, j + 4, k + 12, 0);
        world.setBlock(i + 13, j + 4, k + 13, 0);
        world.setBlock(i + 13, j + 4, k + 14, 0);
        world.setBlock(i + 13, j + 4, k + 15, 0);
        world.setBlock(i + 13, j + 4, k + 16, 0);
        world.setBlock(i + 13, j + 4, k + 17, Fossil.blockcultivateIdle.blockID);
        world.setBlock(i + 13, j + 4, k + 18, 0);
        world.setBlock(i + 13, j + 4, k + 19, 0);
        world.setBlock(i + 13, j + 4, k + 20, 0);
        world.setBlock(i + 13, j + 4, k + 21, Fossil.blockcultivateIdle.blockID);
        world.setBlock(i + 13, j + 4, k + 22, 0);
        world.setBlock(i + 13, j + 4, k + 23, 0);
        world.setBlock(i + 13, j + 4, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 4, k + 25, 0);
        world.setBlock(i + 13, j + 4, k + 26, 0);
        world.setBlock(i + 13, j + 5, k + 0, 0);
        world.setBlock(i + 13, j + 5, k + 1, 0);
        world.setBlock(i + 13, j + 5, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 5, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 5, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 5, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 5, k + 7, 0);
        world.setBlock(i + 13, j + 5, k + 8, 0);
        world.setBlock(i + 13, j + 5, k + 9, 0);
        world.setBlock(i + 13, j + 5, k + 10, 0);
        world.setBlock(i + 13, j + 5, k + 11, 0);
        world.setBlock(i + 13, j + 5, k + 12, 0);
        world.setBlock(i + 13, j + 5, k + 13, 0);
        world.setBlock(i + 13, j + 5, k + 14, 0);
        world.setBlock(i + 13, j + 5, k + 15, 0);
        world.setBlock(i + 13, j + 5, k + 16, 0);
        world.setBlock(i + 13, j + 5, k + 17, 0);
        world.setBlock(i + 13, j + 5, k + 18, 0);
        world.setBlock(i + 13, j + 5, k + 19, 0);
        world.setBlock(i + 13, j + 5, k + 20, 0);
        world.setBlock(i + 13, j + 5, k + 21, 0);
        world.setBlock(i + 13, j + 5, k + 22, 0);
        world.setBlock(i + 13, j + 5, k + 23, 0);
        world.setBlock(i + 13, j + 5, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 5, k + 25, 0);
        world.setBlock(i + 13, j + 5, k + 26, 0);
        world.setBlock(i + 13, j + 6, k + 0, 0);
        world.setBlock(i + 13, j + 6, k + 1, 0);
        world.setBlock(i + 13, j + 6, k + 2, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 6, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 6, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 6, k + 7, 0);
        world.setBlock(i + 13, j + 6, k + 8, 0);
        world.setBlock(i + 13, j + 6, k + 9, 0);
        world.setBlock(i + 13, j + 6, k + 10, 0);
        world.setBlock(i + 13, j + 6, k + 11, 0);
        world.setBlock(i + 13, j + 6, k + 12, 0);
        world.setBlock(i + 13, j + 6, k + 13, 0);
        world.setBlock(i + 13, j + 6, k + 14, 0);
        world.setBlock(i + 13, j + 6, k + 15, 0);
        world.setBlock(i + 13, j + 6, k + 16, 0);
        world.setBlock(i + 13, j + 6, k + 17, 0);
        world.setBlock(i + 13, j + 6, k + 18, 0);
        world.setBlock(i + 13, j + 6, k + 19, 0);
        world.setBlock(i + 13, j + 6, k + 20, 0);
        world.setBlock(i + 13, j + 6, k + 21, 0);
        world.setBlock(i + 13, j + 6, k + 22, 0);
        world.setBlock(i + 13, j + 6, k + 23, 0);
        world.setBlock(i + 13, j + 6, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 6, k + 25, 0);
        world.setBlock(i + 13, j + 6, k + 26, 0);
        world.setBlock(i + 13, j + 7, k + 0, 0);
        world.setBlock(i + 13, j + 7, k + 1, 0);
        world.setBlock(i + 13, j + 7, k + 2, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 13, j + 7, k + 3, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 7, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 7, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 7, k + 7, 0);
        world.setBlock(i + 13, j + 7, k + 8, 0);
        world.setBlock(i + 13, j + 7, k + 9, 0);
        world.setBlock(i + 13, j + 7, k + 10, 0);
        world.setBlock(i + 13, j + 7, k + 11, 0);
        world.setBlock(i + 13, j + 7, k + 12, 0);
        world.setBlock(i + 13, j + 7, k + 13, 0);
        world.setBlock(i + 13, j + 7, k + 14, 0);
        world.setBlock(i + 13, j + 7, k + 15, 0);
        world.setBlock(i + 13, j + 7, k + 16, 0);
        world.setBlock(i + 13, j + 7, k + 17, 0);
        world.setBlock(i + 13, j + 7, k + 18, 0);
        world.setBlock(i + 13, j + 7, k + 19, 0);
        world.setBlock(i + 13, j + 7, k + 20, 0);
        world.setBlock(i + 13, j + 7, k + 21, 0);
        world.setBlock(i + 13, j + 7, k + 22, 0);
        world.setBlock(i + 13, j + 7, k + 23, 0);
        world.setBlock(i + 13, j + 7, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 7, k + 25, 0);
        world.setBlock(i + 13, j + 7, k + 26, 0);
        world.setBlock(i + 13, j + 8, k + 0, 0);
        world.setBlock(i + 13, j + 8, k + 1, 0);
        world.setBlock(i + 13, j + 8, k + 2, 0);
        world.setBlock(i + 13, j + 8, k + 3, 0);
        world.setBlock(i + 13, j + 8, k + 4, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 13, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 8, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 8, k + 7, 0);
        world.setBlock(i + 13, j + 8, k + 8, 0);
        world.setBlock(i + 13, j + 8, k + 9, 0);
        world.setBlock(i + 13, j + 8, k + 10, 0);
        world.setBlock(i + 13, j + 8, k + 11, 0);
        world.setBlock(i + 13, j + 8, k + 12, 0);
        world.setBlock(i + 13, j + 8, k + 13, 0);
        world.setBlock(i + 13, j + 8, k + 14, 0);
        world.setBlock(i + 13, j + 8, k + 15, 0);
        world.setBlock(i + 13, j + 8, k + 16, 0);
        world.setBlock(i + 13, j + 8, k + 17, 0);
        world.setBlock(i + 13, j + 8, k + 18, 0);
        world.setBlock(i + 13, j + 8, k + 19, 0);
        world.setBlock(i + 13, j + 8, k + 20, 0);
        world.setBlock(i + 13, j + 8, k + 21, 0);
        world.setBlock(i + 13, j + 8, k + 22, 0);
        world.setBlock(i + 13, j + 8, k + 23, 0);
        world.setBlock(i + 13, j + 8, k + 24, Block.thinGlass.blockID);
        world.setBlock(i + 13, j + 8, k + 25, 0);
        world.setBlock(i + 13, j + 8, k + 26, 0);
        world.setBlock(i + 13, j + 9, k + 0, 0);
        world.setBlock(i + 13, j + 9, k + 1, 0);
        world.setBlock(i + 13, j + 9, k + 2, 0);
        world.setBlock(i + 13, j + 9, k + 3, 0);
        world.setBlock(i + 13, j + 9, k + 4, 0);
        world.setBlock(i + 13, j + 9, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 9, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 9, k + 12, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 13, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 9, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 9, k + 16, 0);
        world.setBlock(i + 13, j + 9, k + 17, 0);
        world.setBlock(i + 13, j + 9, k + 18, 0);
        world.setBlock(i + 13, j + 9, k + 19, Block.glowStone.blockID);
        world.setBlock(i + 13, j + 9, k + 20, 0);
        world.setBlock(i + 13, j + 9, k + 21, 0);
        world.setBlock(i + 13, j + 9, k + 22, 0);
        world.setBlock(i + 13, j + 9, k + 23, 0);
        world.setBlock(i + 13, j + 9, k + 24, Block.thinGlass.blockID);
        world.setBlock(i + 13, j + 9, k + 25, 0);
        world.setBlock(i + 13, j + 9, k + 26, 0);
        world.setBlock(i + 13, j + 10, k + 0, 0);
        world.setBlock(i + 13, j + 10, k + 1, 0);
        world.setBlock(i + 13, j + 10, k + 2, 0);
        world.setBlock(i + 13, j + 10, k + 3, 0);
        world.setBlock(i + 13, j + 10, k + 4, 0);
        world.setBlock(i + 13, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 10, k + 6, 0);
        world.setBlock(i + 13, j + 10, k + 7, 0);
        world.setBlock(i + 13, j + 10, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 10, k + 9, 0);
        world.setBlock(i + 13, j + 10, k + 10, 0);
        world.setBlock(i + 13, j + 10, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 10, k + 12, 0);
        world.setBlock(i + 13, j + 10, k + 13, 0);
        world.setBlock(i + 13, j + 10, k + 14, Block.fence.blockID);
        world.setBlock(i + 13, j + 10, k + 15, Block.fence.blockID);
        world.setBlock(i + 13, j + 10, k + 16, 0);
        world.setBlock(i + 13, j + 10, k + 17, 0);
        world.setBlock(i + 13, j + 10, k + 18, 0);
        world.setBlock(i + 13, j + 10, k + 19, Block.fence.blockID);
        world.setBlock(i + 13, j + 10, k + 20, 0);
        world.setBlock(i + 13, j + 10, k + 21, 0);
        world.setBlock(i + 13, j + 10, k + 22, 0);
        world.setBlock(i + 13, j + 10, k + 23, 0);
        world.setBlock(i + 13, j + 10, k + 24, Block.thinGlass.blockID);
        world.setBlock(i + 13, j + 10, k + 25, 0);
        world.setBlock(i + 13, j + 10, k + 26, 0);
        world.setBlock(i + 13, j + 11, k + 0, 0);
        world.setBlock(i + 13, j + 11, k + 1, 0);
        world.setBlock(i + 13, j + 11, k + 2, 0);
        world.setBlock(i + 13, j + 11, k + 3, 0);
        world.setBlock(i + 13, j + 11, k + 4, 0);
        world.setBlock(i + 13, j + 11, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 13, j + 11, k + 6, 0);
        world.setBlock(i + 13, j + 11, k + 7, 0);
        world.setBlock(i + 13, j + 11, k + 8, 0);
        world.setBlock(i + 13, j + 11, k + 9, 0);
        world.setBlock(i + 13, j + 11, k + 10, 0);
        world.setBlock(i + 13, j + 11, k + 11, 0);
        world.setBlock(i + 13, j + 11, k + 12, 0);
        world.setBlock(i + 13, j + 11, k + 13, 0);
        world.setBlock(i + 13, j + 11, k + 14, 0);
        world.setBlock(i + 13, j + 11, k + 15, 0);
        world.setBlock(i + 13, j + 11, k + 16, 0);
        world.setBlock(i + 13, j + 11, k + 17, 0);
        world.setBlock(i + 13, j + 11, k + 18, 0);
        world.setBlock(i + 13, j + 11, k + 19, 0);
        world.setBlock(i + 13, j + 11, k + 20, 0);
        world.setBlock(i + 13, j + 11, k + 21, 0);
        world.setBlock(i + 13, j + 11, k + 22, 0);
        world.setBlock(i + 13, j + 11, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 11, k + 26, 0);
        world.setBlock(i + 13, j + 12, k + 0, 0);
        world.setBlock(i + 13, j + 12, k + 1, 0);
        world.setBlock(i + 13, j + 12, k + 2, 0);
        world.setBlock(i + 13, j + 12, k + 3, 0);
        world.setBlock(i + 13, j + 12, k + 4, 0);
        world.setBlock(i + 13, j + 12, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 13, j + 12, k + 6, 0);
        world.setBlock(i + 13, j + 12, k + 7, 0);
        world.setBlock(i + 13, j + 12, k + 8, 0);
        world.setBlock(i + 13, j + 12, k + 9, 0);
        world.setBlock(i + 13, j + 12, k + 10, 0);
        world.setBlock(i + 13, j + 12, k + 11, 0);
        world.setBlock(i + 13, j + 12, k + 12, 0);
        world.setBlock(i + 13, j + 12, k + 13, 0);
        world.setBlock(i + 13, j + 12, k + 14, 0);
        world.setBlock(i + 13, j + 12, k + 15, 0);
        world.setBlock(i + 13, j + 12, k + 16, 0);
        world.setBlock(i + 13, j + 12, k + 17, 0);
        world.setBlock(i + 13, j + 12, k + 18, 0);
        world.setBlock(i + 13, j + 12, k + 19, 0);
        world.setBlock(i + 13, j + 12, k + 20, 0);
        world.setBlock(i + 13, j + 12, k + 21, 0);
        world.setBlock(i + 13, j + 12, k + 22, 0);
        world.setBlock(i + 13, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 13, j + 12, k + 26, 0);
        world.setBlock(i + 13, j + 13, k + 0, 0);
        world.setBlock(i + 13, j + 13, k + 1, 0);
        world.setBlock(i + 13, j + 13, k + 2, 0);
        world.setBlock(i + 13, j + 13, k + 3, 0);
        world.setBlock(i + 13, j + 13, k + 4, 0);
        world.setBlock(i + 13, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 13, k + 6, 0);
        world.setBlock(i + 13, j + 13, k + 7, 0);
        world.setBlock(i + 13, j + 13, k + 8, 0);
        world.setBlock(i + 13, j + 13, k + 9, 0);
        world.setBlock(i + 13, j + 13, k + 10, 0);
        world.setBlock(i + 13, j + 13, k + 11, 0);
        world.setBlock(i + 13, j + 13, k + 12, 0);
        world.setBlock(i + 13, j + 13, k + 13, 0);
        world.setBlock(i + 13, j + 13, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 13, k + 16, 0);
        world.setBlock(i + 13, j + 13, k + 17, 0);
        world.setBlock(i + 13, j + 13, k + 18, 0);
        world.setBlock(i + 13, j + 13, k + 19, Block.fence.blockID);
        world.setBlock(i + 13, j + 13, k + 20, Block.web.blockID);
        world.setBlock(i + 13, j + 13, k + 21, 0);
        world.setBlock(i + 13, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 13, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 13, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 13, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 13, k + 26, 0);
        world.setBlock(i + 13, j + 14, k + 0, 0);
        world.setBlock(i + 13, j + 14, k + 1, 0);
        world.setBlock(i + 13, j + 14, k + 2, 0);
        world.setBlock(i + 13, j + 14, k + 3, 0);
        world.setBlock(i + 13, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 14, k + 26, 0);
        world.setBlock(i + 13, j + 15, k + 0, 0);
        world.setBlock(i + 13, j + 15, k + 1, 0);
        world.setBlock(i + 13, j + 15, k + 2, 0);
        world.setBlock(i + 13, j + 15, k + 3, 0);
        world.setBlock(i + 13, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 5, 0);
        world.setBlock(i + 13, j + 15, k + 6, 0);
        world.setBlock(i + 13, j + 15, k + 7, 0);
        world.setBlock(i + 13, j + 15, k + 8, 0);
        world.setBlock(i + 13, j + 15, k + 9, 0);
        world.setBlock(i + 13, j + 15, k + 10, 0);
        world.setBlock(i + 13, j + 15, k + 11, 0);
        world.setBlock(i + 13, j + 15, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 15, k + 25, 0);
        world.setBlock(i + 13, j + 15, k + 26, 0);
        world.setBlock(i + 13, j + 16, k + 0, 0);
        world.setBlock(i + 13, j + 16, k + 1, 0);
        world.setBlock(i + 13, j + 16, k + 2, 0);
        world.setBlock(i + 13, j + 16, k + 3, 0);
        world.setBlock(i + 13, j + 16, k + 4, 0);
        world.setBlock(i + 13, j + 16, k + 5, 0);
        world.setBlock(i + 13, j + 16, k + 6, 0);
        world.setBlock(i + 13, j + 16, k + 7, 0);
        world.setBlock(i + 13, j + 16, k + 8, 0);
        world.setBlock(i + 13, j + 16, k + 9, 0);
        world.setBlock(i + 13, j + 16, k + 10, 0);
        world.setBlock(i + 13, j + 16, k + 11, 0);
        world.setBlock(i + 13, j + 16, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 16, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 16, k + 14, 0);
        world.setBlock(i + 13, j + 16, k + 15, 0);
        world.setBlock(i + 13, j + 16, k + 16, 0);
        world.setBlock(i + 13, j + 16, k + 17, 0);
        world.setBlock(i + 13, j + 16, k + 18, 0);
        world.setBlock(i + 13, j + 16, k + 19, 0);
        world.setBlock(i + 13, j + 16, k + 20, 0);
        world.setBlock(i + 13, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 16, k + 22, 0);
        world.setBlock(i + 13, j + 16, k + 23, 0);
        world.setBlock(i + 13, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 16, k + 25, 0);
        world.setBlock(i + 13, j + 16, k + 26, 0);
        world.setBlock(i + 13, j + 17, k + 0, 0);
        world.setBlock(i + 13, j + 17, k + 1, 0);
        world.setBlock(i + 13, j + 17, k + 2, 0);
        world.setBlock(i + 13, j + 17, k + 3, 0);
        world.setBlock(i + 13, j + 17, k + 4, 0);
        world.setBlock(i + 13, j + 17, k + 5, 0);
        world.setBlock(i + 13, j + 17, k + 6, 0);
        world.setBlock(i + 13, j + 17, k + 7, 0);
        world.setBlock(i + 13, j + 17, k + 8, 0);
        world.setBlock(i + 13, j + 17, k + 9, 0);
        world.setBlock(i + 13, j + 17, k + 10, 0);
        world.setBlock(i + 13, j + 17, k + 11, 0);
        world.setBlock(i + 13, j + 17, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 17, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 17, k + 14, 0);
        world.setBlock(i + 13, j + 17, k + 15, 0);
        world.setBlock(i + 13, j + 17, k + 16, 0);
        world.setBlock(i + 13, j + 17, k + 17, 0);
        world.setBlock(i + 13, j + 17, k + 18, 0);
        world.setBlock(i + 13, j + 17, k + 19, 0);
        world.setBlock(i + 13, j + 17, k + 20, 0);
        world.setBlock(i + 13, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 17, k + 22, 0);
        world.setBlock(i + 13, j + 17, k + 23, 0);
        world.setBlock(i + 13, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 17, k + 25, 0);
        world.setBlock(i + 13, j + 17, k + 26, 0);
        world.setBlock(i + 13, j + 18, k + 0, 0);
        world.setBlock(i + 13, j + 18, k + 1, 0);
        world.setBlock(i + 13, j + 18, k + 2, 0);
        world.setBlock(i + 13, j + 18, k + 3, 0);
        world.setBlock(i + 13, j + 18, k + 4, 0);
        world.setBlock(i + 13, j + 18, k + 5, 0);
        world.setBlock(i + 13, j + 18, k + 6, 0);
        world.setBlock(i + 13, j + 18, k + 7, 0);
        world.setBlock(i + 13, j + 18, k + 8, 0);
        world.setBlock(i + 13, j + 18, k + 9, 0);
        world.setBlock(i + 13, j + 18, k + 10, 0);
        world.setBlock(i + 13, j + 18, k + 11, 0);
        world.setBlock(i + 13, j + 18, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 18, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 18, k + 14, Block.glowStone.blockID);
        world.setBlock(i + 13, j + 18, k + 15, 0);
        world.setBlock(i + 13, j + 18, k + 16, 0);
        world.setBlock(i + 13, j + 18, k + 17, 0);
        world.setBlock(i + 13, j + 18, k + 18, 0);
        world.setBlock(i + 13, j + 18, k + 19, 0);
        world.setBlock(i + 13, j + 18, k + 20, Block.glowStone.blockID);
        world.setBlock(i + 13, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 18, k + 22, Block.glowStone.blockID);
        world.setBlock(i + 13, j + 18, k + 23, 0);
        world.setBlock(i + 13, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 18, k + 25, 0);
        world.setBlock(i + 13, j + 18, k + 26, 0);
        world.setBlock(i + 13, j + 19, k + 0, 0);
        world.setBlock(i + 13, j + 19, k + 1, 0);
        world.setBlock(i + 13, j + 19, k + 2, 0);
        world.setBlock(i + 13, j + 19, k + 3, 0);
        world.setBlock(i + 13, j + 19, k + 4, 0);
        world.setBlock(i + 13, j + 19, k + 5, 0);
        world.setBlock(i + 13, j + 19, k + 6, 0);
        world.setBlock(i + 13, j + 19, k + 7, 0);
        world.setBlock(i + 13, j + 19, k + 8, 0);
        world.setBlock(i + 13, j + 19, k + 9, 0);
        world.setBlock(i + 13, j + 19, k + 10, 0);
        world.setBlock(i + 13, j + 19, k + 11, 0);
        world.setBlock(i + 13, j + 19, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 19, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 19, k + 14, Block.fence.blockID);
        world.setBlock(i + 13, j + 19, k + 15, 0);
        world.setBlock(i + 13, j + 19, k + 16, 0);
        world.setBlock(i + 13, j + 19, k + 17, 0);
        world.setBlock(i + 13, j + 19, k + 18, 0);
        world.setBlock(i + 13, j + 19, k + 19, 0);
        world.setBlock(i + 13, j + 19, k + 20, Block.fence.blockID);
        world.setBlock(i + 13, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 19, k + 22, Block.fence.blockID);
        world.setBlock(i + 13, j + 19, k + 23, 0);
        world.setBlock(i + 13, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 19, k + 25, 0);
        world.setBlock(i + 13, j + 19, k + 26, 0);
        world.setBlock(i + 13, j + 20, k + 0, 0);
        world.setBlock(i + 13, j + 20, k + 1, 0);
        world.setBlock(i + 13, j + 20, k + 2, 0);
        world.setBlock(i + 13, j + 20, k + 3, 0);
        world.setBlock(i + 13, j + 20, k + 4, 0);
        world.setBlock(i + 13, j + 20, k + 5, 0);
        world.setBlock(i + 13, j + 20, k + 6, 0);
        world.setBlock(i + 13, j + 20, k + 7, 0);
        world.setBlock(i + 13, j + 20, k + 8, 0);
        world.setBlock(i + 13, j + 20, k + 9, 0);
        world.setBlock(i + 13, j + 20, k + 10, 0);
        world.setBlock(i + 13, j + 20, k + 11, 0);
        world.setBlock(i + 13, j + 20, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 20, k + 25, 0);
        world.setBlock(i + 13, j + 20, k + 26, 0);
        world.setBlock(i + 13, j + 21, k + 0, 0);
        world.setBlock(i + 13, j + 21, k + 1, 0);
        world.setBlock(i + 13, j + 21, k + 2, 0);
        world.setBlock(i + 13, j + 21, k + 3, 0);
        world.setBlock(i + 13, j + 21, k + 4, 0);
        world.setBlock(i + 13, j + 21, k + 5, 0);
        world.setBlock(i + 13, j + 21, k + 6, 0);
        world.setBlock(i + 13, j + 21, k + 7, 0);
        world.setBlock(i + 13, j + 21, k + 8, 0);
        world.setBlock(i + 13, j + 21, k + 9, 0);
        world.setBlock(i + 13, j + 21, k + 10, 0);
        world.setBlock(i + 13, j + 21, k + 11, 0);
        world.setBlock(i + 13, j + 21, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 21, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 21, k + 14, 0);
        world.setBlock(i + 13, j + 21, k + 15, 0);
        world.setBlock(i + 13, j + 21, k + 16, 0);
        world.setBlock(i + 13, j + 21, k + 17, 0);
        world.setBlock(i + 13, j + 21, k + 18, 0);
        world.setBlock(i + 13, j + 21, k + 19, 0);
        world.setBlock(i + 13, j + 21, k + 20, 0);
        world.setBlock(i + 13, j + 21, k + 21, 0);
        world.setBlock(i + 13, j + 21, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 21, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 21, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 21, k + 25, 0);
        world.setBlock(i + 13, j + 21, k + 26, 0);
        world.setBlock(i + 13, j + 22, k + 0, 0);
        world.setBlock(i + 13, j + 22, k + 1, 0);
        world.setBlock(i + 13, j + 22, k + 2, 0);
        world.setBlock(i + 13, j + 22, k + 3, 0);
        world.setBlock(i + 13, j + 22, k + 4, 0);
        world.setBlock(i + 13, j + 22, k + 5, 0);
        world.setBlock(i + 13, j + 22, k + 6, 0);
        world.setBlock(i + 13, j + 22, k + 7, 0);
        world.setBlock(i + 13, j + 22, k + 8, 0);
        world.setBlock(i + 13, j + 22, k + 9, 0);
        world.setBlock(i + 13, j + 22, k + 10, 0);
        world.setBlock(i + 13, j + 22, k + 11, 0);
        world.setBlock(i + 13, j + 22, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 22, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 22, k + 14, 0);
        world.setBlock(i + 13, j + 22, k + 15, 0);
        world.setBlock(i + 13, j + 22, k + 16, 0);
        world.setBlock(i + 13, j + 22, k + 17, 0);
        world.setBlock(i + 13, j + 22, k + 18, 0);
        world.setBlock(i + 13, j + 22, k + 19, 0);
        world.setBlock(i + 13, j + 22, k + 20, 0);
        world.setBlock(i + 13, j + 22, k + 21, 0);
        world.setBlock(i + 13, j + 22, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 22, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 22, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 22, k + 25, 0);
        world.setBlock(i + 13, j + 22, k + 26, 0);
        world.setBlock(i + 13, j + 23, k + 0, 0);
        world.setBlock(i + 13, j + 23, k + 1, 0);
        world.setBlock(i + 13, j + 23, k + 2, 0);
        world.setBlock(i + 13, j + 23, k + 3, 0);
        world.setBlock(i + 13, j + 23, k + 4, 0);
        world.setBlock(i + 13, j + 23, k + 5, 0);
        world.setBlock(i + 13, j + 23, k + 6, 0);
        world.setBlock(i + 13, j + 23, k + 7, 0);
        world.setBlock(i + 13, j + 23, k + 8, 0);
        world.setBlock(i + 13, j + 23, k + 9, 0);
        world.setBlock(i + 13, j + 23, k + 10, 0);
        world.setBlock(i + 13, j + 23, k + 11, 0);
        world.setBlock(i + 13, j + 23, k + 12, 0);
        world.setBlock(i + 13, j + 23, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 23, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 23, k + 15, Block.glowStone.blockID);
        world.setBlock(i + 13, j + 23, k + 16, 0);
        world.setBlock(i + 13, j + 23, k + 17, 0);
        world.setBlock(i + 13, j + 23, k + 18, 0);
        world.setBlock(i + 13, j + 23, k + 19, 0);
        world.setBlock(i + 13, j + 23, k + 20, Block.glowStone.blockID);
        world.setBlock(i + 13, j + 23, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 23, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 23, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 23, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 23, k + 25, 0);
        world.setBlock(i + 13, j + 23, k + 26, 0);
        world.setBlock(i + 13, j + 24, k + 0, 0);
        world.setBlock(i + 13, j + 24, k + 1, 0);
        world.setBlock(i + 13, j + 24, k + 2, 0);
        world.setBlock(i + 13, j + 24, k + 3, 0);
        world.setBlock(i + 13, j + 24, k + 4, 0);
        world.setBlock(i + 13, j + 24, k + 5, 0);
        world.setBlock(i + 13, j + 24, k + 6, 0);
        world.setBlock(i + 13, j + 24, k + 7, 0);
        world.setBlock(i + 13, j + 24, k + 8, 0);
        world.setBlock(i + 13, j + 24, k + 9, 0);
        world.setBlock(i + 13, j + 24, k + 10, 0);
        world.setBlock(i + 13, j + 24, k + 11, 0);
        world.setBlock(i + 13, j + 24, k + 12, 0);
        world.setBlock(i + 13, j + 24, k + 13, 0);
        world.setBlock(i + 13, j + 24, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 24, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 24, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 24, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 24, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 24, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 24, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 24, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 24, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 24, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 13, j + 24, k + 24, 0);
        world.setBlock(i + 13, j + 24, k + 25, 0);
        world.setBlock(i + 13, j + 24, k + 26, 0);
        world.setBlock(i + 13, j + 25, k + 0, 0);
        world.setBlock(i + 13, j + 25, k + 1, 0);
        world.setBlock(i + 13, j + 25, k + 2, 0);
        world.setBlock(i + 13, j + 25, k + 3, 0);
        world.setBlock(i + 13, j + 25, k + 4, 0);
        world.setBlock(i + 13, j + 25, k + 5, 0);
        world.setBlock(i + 13, j + 25, k + 6, 0);
        world.setBlock(i + 13, j + 25, k + 7, 0);
        world.setBlock(i + 13, j + 25, k + 8, 0);
        world.setBlock(i + 13, j + 25, k + 9, 0);
        world.setBlock(i + 13, j + 25, k + 10, 0);
        world.setBlock(i + 13, j + 25, k + 11, 0);
        world.setBlock(i + 13, j + 25, k + 12, 0);
        world.setBlock(i + 13, j + 25, k + 13, 0);
        world.setBlock(i + 13, j + 25, k + 14, 0);
        world.setBlock(i + 13, j + 25, k + 15, 0);
        world.setBlock(i + 13, j + 25, k + 16, 0);
        world.setBlock(i + 13, j + 25, k + 17, 0);
        world.setBlock(i + 13, j + 25, k + 18, 0);
        world.setBlock(i + 13, j + 25, k + 19, 0);
        world.setBlock(i + 13, j + 25, k + 20, 0);
        world.setBlock(i + 13, j + 25, k + 21, 0);
        world.setBlock(i + 13, j + 25, k + 22, 0);
        world.setBlock(i + 13, j + 25, k + 23, 0);
        world.setBlock(i + 13, j + 25, k + 24, 0);
        world.setBlock(i + 13, j + 25, k + 25, 0);
        world.setBlock(i + 13, j + 25, k + 26, 0);
        world.setBlock(i + 14, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 14, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 1, k + 15, Block.glowStone.blockID);
        world.setBlock(i + 14, j + 1, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 1, k + 19, Block.glowStone.blockID);
        world.setBlock(i + 14, j + 1, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 14, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 14, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 14, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 14, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 14, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 14, j + 2, k + 4, Block.dirt.blockID);
        world.setBlock(i + 14, j + 2, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 2, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 2, k + 8, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 14, j + 2, k + 9, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 14, j + 2, k + 10, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 14, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 14, j + 2, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 14, j + 2, k + 13, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 14, j + 2, k + 14, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 14, j + 2, k + 15, Block.glass.blockID);
        world.setBlock(i + 14, j + 2, k + 16, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 14, j + 2, k + 17, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 14, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 2, k + 19, Block.glass.blockID);
        world.setBlock(i + 14, j + 2, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 2, k + 21, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 14, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 2, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 2, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 14, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 14, j + 3, k + 3, 0);
        world.setBlock(i + 14, j + 3, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 3, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 3, k + 7, 0);
        world.setBlock(i + 14, j + 3, k + 8, 0);
        world.setBlock(i + 14, j + 3, k + 9, 0);
        world.setBlock(i + 14, j + 3, k + 10, 0);
        world.setBlock(i + 14, j + 3, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 14, j + 3, k + 12, 0);
        world.setBlock(i + 14, j + 3, k + 13, 0);
        world.setBlock(i + 14, j + 3, k + 14, 0);
        world.setBlock(i + 14, j + 3, k + 15, 0);
        world.setBlock(i + 14, j + 3, k + 16, 0);
        world.setBlock(i + 14, j + 3, k + 17, 0);
        world.setBlock(i + 14, j + 3, k + 18, 0);
        world.setBlock(i + 14, j + 3, k + 19, 0);
        world.setBlock(i + 14, j + 3, k + 20, 0);
        world.setBlock(i + 14, j + 3, k + 21, 0);
        world.setBlock(i + 14, j + 3, k + 22, 0);
        world.setBlock(i + 14, j + 3, k + 23, 0);
        world.setBlock(i + 14, j + 3, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 4, k + 0, 0);
        world.setBlock(i + 14, j + 4, k + 1, 0);
        world.setBlock(i + 14, j + 4, k + 2, 0);
        world.setBlock(i + 14, j + 4, k + 3, 0);
        world.setBlock(i + 14, j + 4, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 4, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 4, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 4, k + 7, 0);
        world.setBlock(i + 14, j + 4, k + 8, 0);
        world.setBlock(i + 14, j + 4, k + 9, 0);
        world.setBlock(i + 14, j + 4, k + 10, 0);
        world.setBlock(i + 14, j + 4, k + 11, 0);
        world.setBlock(i + 14, j + 4, k + 12, 0);
        world.setBlock(i + 14, j + 4, k + 13, 0);
        world.setBlock(i + 14, j + 4, k + 14, 0);
        world.setBlock(i + 14, j + 4, k + 15, 0);
        world.setBlock(i + 14, j + 4, k + 16, 0);
        world.setBlock(i + 14, j + 4, k + 17, 0);
        world.setBlock(i + 14, j + 4, k + 18, 0);
        world.setBlock(i + 14, j + 4, k + 19, 0);
        world.setBlock(i + 14, j + 4, k + 20, 0);
        world.setBlock(i + 14, j + 4, k + 21, 0);
        world.setBlock(i + 14, j + 4, k + 22, 0);
        world.setBlock(i + 14, j + 4, k + 23, 0);
        world.setBlock(i + 14, j + 4, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 4, k + 25, 0);
        world.setBlock(i + 14, j + 4, k + 26, 0);
        world.setBlock(i + 14, j + 5, k + 0, 0);
        world.setBlock(i + 14, j + 5, k + 1, 0);
        world.setBlock(i + 14, j + 5, k + 2, 0);
        world.setBlock(i + 14, j + 5, k + 3, 0);
        world.setBlock(i + 14, j + 5, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 5, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 5, k + 7, 0);
        world.setBlock(i + 14, j + 5, k + 8, 0);
        world.setBlock(i + 14, j + 5, k + 9, 0);
        world.setBlock(i + 14, j + 5, k + 10, 0);
        world.setBlock(i + 14, j + 5, k + 11, 0);
        world.setBlock(i + 14, j + 5, k + 12, 0);
        world.setBlock(i + 14, j + 5, k + 13, 0);
        world.setBlock(i + 14, j + 5, k + 14, 0);
        world.setBlock(i + 14, j + 5, k + 15, 0);
        world.setBlock(i + 14, j + 5, k + 16, 0);
        world.setBlock(i + 14, j + 5, k + 17, 0);
        world.setBlock(i + 14, j + 5, k + 18, 0);
        world.setBlock(i + 14, j + 5, k + 19, 0);
        world.setBlock(i + 14, j + 5, k + 20, 0);
        world.setBlock(i + 14, j + 5, k + 21, 0);
        world.setBlock(i + 14, j + 5, k + 22, 0);
        world.setBlock(i + 14, j + 5, k + 23, 0);
        world.setBlock(i + 14, j + 5, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 5, k + 25, 0);
        world.setBlock(i + 14, j + 5, k + 26, 0);
        world.setBlock(i + 14, j + 6, k + 0, 0);
        world.setBlock(i + 14, j + 6, k + 1, 0);
        world.setBlock(i + 14, j + 6, k + 2, 0);
        world.setBlock(i + 14, j + 6, k + 3, 0);
        world.setBlock(i + 14, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 6, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 6, k + 7, Block.glowStone.blockID);
        world.setBlock(i + 14, j + 6, k + 8, 0);
        world.setBlock(i + 14, j + 6, k + 9, 0);
        world.setBlock(i + 14, j + 6, k + 10, 0);
        world.setBlock(i + 14, j + 6, k + 11, 0);
        world.setBlock(i + 14, j + 6, k + 12, 0);
        world.setBlock(i + 14, j + 6, k + 13, 0);
        world.setBlock(i + 14, j + 6, k + 14, 0);
        world.setBlock(i + 14, j + 6, k + 15, 0);
        world.setBlock(i + 14, j + 6, k + 16, 0);
        world.setBlock(i + 14, j + 6, k + 17, 0);
        world.setBlock(i + 14, j + 6, k + 18, 0);
        world.setBlock(i + 14, j + 6, k + 19, 0);
        world.setBlock(i + 14, j + 6, k + 20, 0);
        world.setBlock(i + 14, j + 6, k + 21, 0);
        world.setBlock(i + 14, j + 6, k + 22, 0);
        world.setBlock(i + 14, j + 6, k + 23, Block.glowStone.blockID);
        world.setBlock(i + 14, j + 6, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 6, k + 25, 0);
        world.setBlock(i + 14, j + 6, k + 26, 0);
        world.setBlock(i + 14, j + 7, k + 0, 0);
        world.setBlock(i + 14, j + 7, k + 1, 0);
        world.setBlock(i + 14, j + 7, k + 2, 0);
        world.setBlock(i + 14, j + 7, k + 3, 0);
        world.setBlock(i + 14, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 7, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 7, k + 7, Block.fence.blockID);
        world.setBlock(i + 14, j + 7, k + 8, 0);
        world.setBlock(i + 14, j + 7, k + 9, 0);
        world.setBlock(i + 14, j + 7, k + 10, 0);
        world.setBlock(i + 14, j + 7, k + 11, 0);
        world.setBlock(i + 14, j + 7, k + 12, 0);
        world.setBlock(i + 14, j + 7, k + 13, 0);
        world.setBlock(i + 14, j + 7, k + 14, 0);
        world.setBlock(i + 14, j + 7, k + 15, 0);
        world.setBlock(i + 14, j + 7, k + 16, 0);
        world.setBlock(i + 14, j + 7, k + 17, 0);
        world.setBlock(i + 14, j + 7, k + 18, 0);
        world.setBlock(i + 14, j + 7, k + 19, 0);
        world.setBlock(i + 14, j + 7, k + 20, 0);
        world.setBlock(i + 14, j + 7, k + 21, 0);
        world.setBlock(i + 14, j + 7, k + 22, 0);
        world.setBlock(i + 14, j + 7, k + 23, Block.fence.blockID);
        world.setBlock(i + 14, j + 7, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 7, k + 25, 0);
        world.setBlock(i + 14, j + 7, k + 26, 0);
        world.setBlock(i + 14, j + 8, k + 0, 0);
        world.setBlock(i + 14, j + 8, k + 1, 0);
        world.setBlock(i + 14, j + 8, k + 2, 0);
        world.setBlock(i + 14, j + 8, k + 3, 0);
        world.setBlock(i + 14, j + 8, k + 4, 0);
        world.setBlock(i + 14, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 8, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 8, k + 7, 0);
        world.setBlock(i + 14, j + 8, k + 8, 0);
        world.setBlock(i + 14, j + 8, k + 9, 0);
        world.setBlock(i + 14, j + 8, k + 10, 0);
        world.setBlock(i + 14, j + 8, k + 11, 0);
        world.setBlock(i + 14, j + 8, k + 12, 0);
        world.setBlock(i + 14, j + 8, k + 13, 0);
        world.setBlock(i + 14, j + 8, k + 14, 0);
        world.setBlock(i + 14, j + 8, k + 15, 0);
        world.setBlock(i + 14, j + 8, k + 16, 0);
        world.setBlock(i + 14, j + 8, k + 17, 0);
        world.setBlock(i + 14, j + 8, k + 18, 0);
        world.setBlock(i + 14, j + 8, k + 19, 0);
        world.setBlock(i + 14, j + 8, k + 20, 0);
        world.setBlock(i + 14, j + 8, k + 21, 0);
        world.setBlock(i + 14, j + 8, k + 22, 0);
        world.setBlock(i + 14, j + 8, k + 23, 0);
        world.setBlock(i + 14, j + 8, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 8, k + 25, 0);
        world.setBlock(i + 14, j + 8, k + 26, 0);
        world.setBlock(i + 14, j + 9, k + 0, 0);
        world.setBlock(i + 14, j + 9, k + 1, 0);
        world.setBlock(i + 14, j + 9, k + 2, 0);
        world.setBlock(i + 14, j + 9, k + 3, 0);
        world.setBlock(i + 14, j + 9, k + 4, 0);
        world.setBlock(i + 14, j + 9, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 9, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 9, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 9, k + 16, 0);
        world.setBlock(i + 14, j + 9, k + 17, 0);
        world.setBlock(i + 14, j + 9, k + 18, 0);
        world.setBlock(i + 14, j + 9, k + 19, 0);
        world.setBlock(i + 14, j + 9, k + 20, 0);
        world.setBlock(i + 14, j + 9, k + 21, 0);
        world.setBlock(i + 14, j + 9, k + 22, 0);
        world.setBlock(i + 14, j + 9, k + 23, 0);
        world.setBlock(i + 14, j + 9, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 9, k + 25, 0);
        world.setBlock(i + 14, j + 9, k + 26, 0);
        world.setBlock(i + 14, j + 10, k + 0, 0);
        world.setBlock(i + 14, j + 10, k + 1, 0);
        world.setBlock(i + 14, j + 10, k + 2, 0);
        world.setBlock(i + 14, j + 10, k + 3, 0);
        world.setBlock(i + 14, j + 10, k + 4, 0);
        world.setBlock(i + 14, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 10, k + 6, 0);
        world.setBlock(i + 14, j + 10, k + 7, 0);
        world.setBlock(i + 14, j + 10, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 10, k + 9, 0);
        world.setBlock(i + 14, j + 10, k + 10, 0);
        world.setBlock(i + 14, j + 10, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 10, k + 12, 0);
        world.setBlock(i + 14, j + 10, k + 13, 0);
        world.setBlock(i + 14, j + 10, k + 14, 0);
        world.setBlock(i + 14, j + 10, k + 15, Block.fence.blockID);
        world.setBlock(i + 14, j + 10, k + 16, 0);
        world.setBlock(i + 14, j + 10, k + 17, 0);
        world.setBlock(i + 14, j + 10, k + 18, 0);
        world.setBlock(i + 14, j + 10, k + 19, 0);
        world.setBlock(i + 14, j + 10, k + 20, 0);
        world.setBlock(i + 14, j + 10, k + 21, 0);
        world.setBlock(i + 14, j + 10, k + 22, 0);
        world.setBlock(i + 14, j + 10, k + 23, 0);
        world.setBlock(i + 14, j + 10, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 10, k + 25, 0);
        world.setBlock(i + 14, j + 10, k + 26, 0);
        world.setBlock(i + 14, j + 11, k + 0, 0);
        world.setBlock(i + 14, j + 11, k + 1, 0);
        world.setBlock(i + 14, j + 11, k + 2, 0);
        world.setBlock(i + 14, j + 11, k + 3, 0);
        world.setBlock(i + 14, j + 11, k + 4, 0);
        world.setBlock(i + 14, j + 11, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 11, k + 6, 0);
        world.setBlock(i + 14, j + 11, k + 7, 0);
        world.setBlock(i + 14, j + 11, k + 8, 0);
        world.setBlock(i + 14, j + 11, k + 9, 0);
        world.setBlock(i + 14, j + 11, k + 10, 0);
        world.setBlock(i + 14, j + 11, k + 11, 0);
        world.setBlock(i + 14, j + 11, k + 12, 0);
        world.setBlock(i + 14, j + 11, k + 13, 0);
        world.setBlock(i + 14, j + 11, k + 14, 0);
        world.setBlock(i + 14, j + 11, k + 15, 0);
        world.setBlock(i + 14, j + 11, k + 16, 0);
        world.setBlock(i + 14, j + 11, k + 17, 0);
        world.setBlock(i + 14, j + 11, k + 18, 0);
        world.setBlock(i + 14, j + 11, k + 19, 0);
        world.setBlock(i + 14, j + 11, k + 20, 0);
        world.setBlock(i + 14, j + 11, k + 21, 0);
        world.setBlock(i + 14, j + 11, k + 22, 0);
        world.setBlock(i + 14, j + 11, k + 23, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 14, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 11, k + 26, 0);
        world.setBlock(i + 14, j + 12, k + 0, 0);
        world.setBlock(i + 14, j + 12, k + 1, 0);
        world.setBlock(i + 14, j + 12, k + 2, 0);
        world.setBlock(i + 14, j + 12, k + 3, 0);
        world.setBlock(i + 14, j + 12, k + 4, 0);
        world.setBlock(i + 14, j + 12, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 12, k + 6, 0);
        world.setBlock(i + 14, j + 12, k + 7, 0);
        world.setBlock(i + 14, j + 12, k + 8, 0);
        world.setBlock(i + 14, j + 12, k + 9, 0);
        world.setBlock(i + 14, j + 12, k + 10, 0);
        world.setBlock(i + 14, j + 12, k + 11, 0);
        world.setBlock(i + 14, j + 12, k + 12, 0);
        world.setBlock(i + 14, j + 12, k + 13, 0);
        world.setBlock(i + 14, j + 12, k + 14, 0);
        world.setBlock(i + 14, j + 12, k + 15, 0);
        world.setBlock(i + 14, j + 12, k + 16, 0);
        world.setBlock(i + 14, j + 12, k + 17, 0);
        world.setBlock(i + 14, j + 12, k + 18, 0);
        world.setBlock(i + 14, j + 12, k + 19, 0);
        world.setBlock(i + 14, j + 12, k + 20, 0);
        world.setBlock(i + 14, j + 12, k + 21, 0);
        world.setBlock(i + 14, j + 12, k + 22, 0);
        world.setBlock(i + 14, j + 12, k + 23, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 14, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 14, j + 12, k + 26, 0);
        world.setBlock(i + 14, j + 13, k + 0, 0);
        world.setBlock(i + 14, j + 13, k + 1, 0);
        world.setBlock(i + 14, j + 13, k + 2, 0);
        world.setBlock(i + 14, j + 13, k + 3, 0);
        world.setBlock(i + 14, j + 13, k + 4, 0);
        world.setBlock(i + 14, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 13, k + 6, Block.glowStone.blockID);
        world.setBlock(i + 14, j + 13, k + 7, 0);
        world.setBlock(i + 14, j + 13, k + 8, 0);
        world.setBlock(i + 14, j + 13, k + 9, 0);
        world.setBlock(i + 14, j + 13, k + 10, 0);
        world.setBlock(i + 14, j + 13, k + 11, 0);
        world.setBlock(i + 14, j + 13, k + 12, 0);
        world.setBlock(i + 14, j + 13, k + 13, 0);
        world.setBlock(i + 14, j + 13, k + 14, Block.glowStone.blockID);
        world.setBlock(i + 14, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 13, k + 16, Block.web.blockID);
        world.setBlock(i + 14, j + 13, k + 17, 0);
        world.setBlock(i + 14, j + 13, k + 18, 0);
        world.setBlock(i + 14, j + 13, k + 19, 0);
        world.setBlock(i + 14, j + 13, k + 20, 0);
        world.setBlock(i + 14, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 13, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 13, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 13, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 13, k + 26, 0);
        world.setBlock(i + 14, j + 14, k + 0, 0);
        world.setBlock(i + 14, j + 14, k + 1, 0);
        world.setBlock(i + 14, j + 14, k + 2, 0);
        world.setBlock(i + 14, j + 14, k + 3, 0);
        world.setBlock(i + 14, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 16, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 14, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 14, k + 26, 0);
        world.setBlock(i + 14, j + 15, k + 0, 0);
        world.setBlock(i + 14, j + 15, k + 1, 0);
        world.setBlock(i + 14, j + 15, k + 2, 0);
        world.setBlock(i + 14, j + 15, k + 3, 0);
        world.setBlock(i + 14, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 5, 0);
        world.setBlock(i + 14, j + 15, k + 6, 0);
        world.setBlock(i + 14, j + 15, k + 7, 0);
        world.setBlock(i + 14, j + 15, k + 8, 0);
        world.setBlock(i + 14, j + 15, k + 9, 0);
        world.setBlock(i + 14, j + 15, k + 10, 0);
        world.setBlock(i + 14, j + 15, k + 11, 0);
        world.setBlock(i + 14, j + 15, k + 12, 0);
        world.setBlock(i + 14, j + 15, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 15, k + 25, Block.web.blockID);
        world.setBlock(i + 14, j + 15, k + 26, 0);
        world.setBlock(i + 14, j + 16, k + 0, 0);
        world.setBlock(i + 14, j + 16, k + 1, 0);
        world.setBlock(i + 14, j + 16, k + 2, 0);
        world.setBlock(i + 14, j + 16, k + 3, 0);
        world.setBlock(i + 14, j + 16, k + 4, 0);
        world.setBlock(i + 14, j + 16, k + 5, 0);
        world.setBlock(i + 14, j + 16, k + 6, 0);
        world.setBlock(i + 14, j + 16, k + 7, 0);
        world.setBlock(i + 14, j + 16, k + 8, 0);
        world.setBlock(i + 14, j + 16, k + 9, 0);
        world.setBlock(i + 14, j + 16, k + 10, 0);
        world.setBlock(i + 14, j + 16, k + 11, 0);
        world.setBlock(i + 14, j + 16, k + 12, 0);
        world.setBlock(i + 14, j + 16, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 16, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 16, k + 16, 0);
        world.setBlock(i + 14, j + 16, k + 17, 0);
        world.setBlock(i + 14, j + 16, k + 18, 0);
        world.setBlock(i + 14, j + 16, k + 19, 0);
        world.setBlock(i + 14, j + 16, k + 20, 0);
        world.setBlock(i + 14, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 16, k + 22, 0);
        world.setBlock(i + 14, j + 16, k + 23, 0);
        world.setBlock(i + 14, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 16, k + 25, 0);
        world.setBlock(i + 14, j + 16, k + 26, 0);
        world.setBlock(i + 14, j + 17, k + 0, 0);
        world.setBlock(i + 14, j + 17, k + 1, 0);
        world.setBlock(i + 14, j + 17, k + 2, 0);
        world.setBlock(i + 14, j + 17, k + 3, 0);
        world.setBlock(i + 14, j + 17, k + 4, 0);
        world.setBlock(i + 14, j + 17, k + 5, 0);
        world.setBlock(i + 14, j + 17, k + 6, 0);
        world.setBlock(i + 14, j + 17, k + 7, 0);
        world.setBlock(i + 14, j + 17, k + 8, 0);
        world.setBlock(i + 14, j + 17, k + 9, 0);
        world.setBlock(i + 14, j + 17, k + 10, 0);
        world.setBlock(i + 14, j + 17, k + 11, 0);
        world.setBlock(i + 14, j + 17, k + 12, 0);
        world.setBlock(i + 14, j + 17, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 17, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 17, k + 16, 0);
        world.setBlock(i + 14, j + 17, k + 17, 0);
        world.setBlock(i + 14, j + 17, k + 18, 0);
        world.setBlock(i + 14, j + 17, k + 19, 0);
        world.setBlock(i + 14, j + 17, k + 20, 0);
        world.setBlock(i + 14, j + 17, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 14, j + 17, k + 22, 0);
        world.setBlock(i + 14, j + 17, k + 23, 0);
        world.setBlock(i + 14, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 17, k + 25, 0);
        world.setBlock(i + 14, j + 17, k + 26, 0);
        world.setBlock(i + 14, j + 18, k + 0, 0);
        world.setBlock(i + 14, j + 18, k + 1, 0);
        world.setBlock(i + 14, j + 18, k + 2, 0);
        world.setBlock(i + 14, j + 18, k + 3, 0);
        world.setBlock(i + 14, j + 18, k + 4, 0);
        world.setBlock(i + 14, j + 18, k + 5, 0);
        world.setBlock(i + 14, j + 18, k + 6, 0);
        world.setBlock(i + 14, j + 18, k + 7, 0);
        world.setBlock(i + 14, j + 18, k + 8, 0);
        world.setBlock(i + 14, j + 18, k + 9, 0);
        world.setBlock(i + 14, j + 18, k + 10, 0);
        world.setBlock(i + 14, j + 18, k + 11, 0);
        world.setBlock(i + 14, j + 18, k + 12, 0);
        world.setBlock(i + 14, j + 18, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 18, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 18, k + 16, 0);
        world.setBlock(i + 14, j + 18, k + 17, 0);
        world.setBlock(i + 14, j + 18, k + 18, 0);
        world.setBlock(i + 14, j + 18, k + 19, 0);
        world.setBlock(i + 14, j + 18, k + 20, 0);
        world.setBlock(i + 14, j + 18, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 14, j + 18, k + 22, 0);
        world.setBlock(i + 14, j + 18, k + 23, 0);
        world.setBlock(i + 14, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 18, k + 25, 0);
        world.setBlock(i + 14, j + 18, k + 26, 0);
        world.setBlock(i + 14, j + 19, k + 0, 0);
        world.setBlock(i + 14, j + 19, k + 1, 0);
        world.setBlock(i + 14, j + 19, k + 2, 0);
        world.setBlock(i + 14, j + 19, k + 3, 0);
        world.setBlock(i + 14, j + 19, k + 4, 0);
        world.setBlock(i + 14, j + 19, k + 5, 0);
        world.setBlock(i + 14, j + 19, k + 6, 0);
        world.setBlock(i + 14, j + 19, k + 7, 0);
        world.setBlock(i + 14, j + 19, k + 8, 0);
        world.setBlock(i + 14, j + 19, k + 9, 0);
        world.setBlock(i + 14, j + 19, k + 10, 0);
        world.setBlock(i + 14, j + 19, k + 11, 0);
        world.setBlock(i + 14, j + 19, k + 12, 0);
        world.setBlock(i + 14, j + 19, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 19, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 19, k + 16, 0);
        world.setBlock(i + 14, j + 19, k + 17, 0);
        world.setBlock(i + 14, j + 19, k + 18, 0);
        world.setBlock(i + 14, j + 19, k + 19, 0);
        world.setBlock(i + 14, j + 19, k + 20, 0);
        world.setBlock(i + 14, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 19, k + 22, 0);
        world.setBlock(i + 14, j + 19, k + 23, 0);
        world.setBlock(i + 14, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 19, k + 25, 0);
        world.setBlock(i + 14, j + 19, k + 26, 0);
        world.setBlock(i + 14, j + 20, k + 0, 0);
        world.setBlock(i + 14, j + 20, k + 1, 0);
        world.setBlock(i + 14, j + 20, k + 2, 0);
        world.setBlock(i + 14, j + 20, k + 3, 0);
        world.setBlock(i + 14, j + 20, k + 4, 0);
        world.setBlock(i + 14, j + 20, k + 5, 0);
        world.setBlock(i + 14, j + 20, k + 6, 0);
        world.setBlock(i + 14, j + 20, k + 7, 0);
        world.setBlock(i + 14, j + 20, k + 8, 0);
        world.setBlock(i + 14, j + 20, k + 9, 0);
        world.setBlock(i + 14, j + 20, k + 10, 0);
        world.setBlock(i + 14, j + 20, k + 11, 0);
        world.setBlock(i + 14, j + 20, k + 12, 0);
        world.setBlock(i + 14, j + 20, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 20, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 20, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 20, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 20, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 20, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 20, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 20, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 20, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 20, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 20, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 20, k + 25, 0);
        world.setBlock(i + 14, j + 20, k + 26, 0);
        world.setBlock(i + 14, j + 21, k + 0, 0);
        world.setBlock(i + 14, j + 21, k + 1, 0);
        world.setBlock(i + 14, j + 21, k + 2, 0);
        world.setBlock(i + 14, j + 21, k + 3, 0);
        world.setBlock(i + 14, j + 21, k + 4, 0);
        world.setBlock(i + 14, j + 21, k + 5, 0);
        world.setBlock(i + 14, j + 21, k + 6, 0);
        world.setBlock(i + 14, j + 21, k + 7, 0);
        world.setBlock(i + 14, j + 21, k + 8, 0);
        world.setBlock(i + 14, j + 21, k + 9, 0);
        world.setBlock(i + 14, j + 21, k + 10, 0);
        world.setBlock(i + 14, j + 21, k + 11, 0);
        world.setBlock(i + 14, j + 21, k + 12, 0);
        world.setBlock(i + 14, j + 21, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 21, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 21, k + 16, 0);
        world.setBlock(i + 14, j + 21, k + 17, 0);
        world.setBlock(i + 14, j + 21, k + 18, 0);
        world.setBlock(i + 14, j + 21, k + 19, 0);
        world.setBlock(i + 14, j + 21, k + 20, 0);
        world.setBlock(i + 14, j + 21, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 21, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 21, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 21, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 21, k + 25, 0);
        world.setBlock(i + 14, j + 21, k + 26, 0);
        world.setBlock(i + 14, j + 22, k + 0, 0);
        world.setBlock(i + 14, j + 22, k + 1, 0);
        world.setBlock(i + 14, j + 22, k + 2, 0);
        world.setBlock(i + 14, j + 22, k + 3, 0);
        world.setBlock(i + 14, j + 22, k + 4, 0);
        world.setBlock(i + 14, j + 22, k + 5, 0);
        world.setBlock(i + 14, j + 22, k + 6, 0);
        world.setBlock(i + 14, j + 22, k + 7, 0);
        world.setBlock(i + 14, j + 22, k + 8, 0);
        world.setBlock(i + 14, j + 22, k + 9, 0);
        world.setBlock(i + 14, j + 22, k + 10, 0);
        world.setBlock(i + 14, j + 22, k + 11, 0);
        world.setBlock(i + 14, j + 22, k + 12, 0);
        world.setBlock(i + 14, j + 22, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 22, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 22, k + 15, 0);
        world.setBlock(i + 14, j + 22, k + 16, 0);
        world.setBlock(i + 14, j + 22, k + 17, 0);
        world.setBlock(i + 14, j + 22, k + 18, 0);
        world.setBlock(i + 14, j + 22, k + 19, 0);
        world.setBlock(i + 14, j + 22, k + 20, 0);
        world.setBlock(i + 14, j + 22, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 22, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 22, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 22, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 22, k + 25, 0);
        world.setBlock(i + 14, j + 22, k + 26, 0);
        world.setBlock(i + 14, j + 23, k + 0, 0);
        world.setBlock(i + 14, j + 23, k + 1, 0);
        world.setBlock(i + 14, j + 23, k + 2, 0);
        world.setBlock(i + 14, j + 23, k + 3, 0);
        world.setBlock(i + 14, j + 23, k + 4, 0);
        world.setBlock(i + 14, j + 23, k + 5, 0);
        world.setBlock(i + 14, j + 23, k + 6, 0);
        world.setBlock(i + 14, j + 23, k + 7, 0);
        world.setBlock(i + 14, j + 23, k + 8, 0);
        world.setBlock(i + 14, j + 23, k + 9, 0);
        world.setBlock(i + 14, j + 23, k + 10, 0);
        world.setBlock(i + 14, j + 23, k + 11, 0);
        world.setBlock(i + 14, j + 23, k + 12, 0);
        world.setBlock(i + 14, j + 23, k + 13, 0);
        world.setBlock(i + 14, j + 23, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 23, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 23, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 23, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 23, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 23, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 23, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 23, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 23, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 23, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 14, j + 23, k + 24, 0);
        world.setBlock(i + 14, j + 23, k + 25, 0);
        world.setBlock(i + 14, j + 23, k + 26, 0);
        world.setBlock(i + 14, j + 24, k + 0, 0);
        world.setBlock(i + 14, j + 24, k + 1, 0);
        world.setBlock(i + 14, j + 24, k + 2, 0);
        world.setBlock(i + 14, j + 24, k + 3, 0);
        world.setBlock(i + 14, j + 24, k + 4, 0);
        world.setBlock(i + 14, j + 24, k + 5, 0);
        world.setBlock(i + 14, j + 24, k + 6, 0);
        world.setBlock(i + 14, j + 24, k + 7, 0);
        world.setBlock(i + 14, j + 24, k + 8, 0);
        world.setBlock(i + 14, j + 24, k + 9, 0);
        world.setBlock(i + 14, j + 24, k + 10, 0);
        world.setBlock(i + 14, j + 24, k + 11, 0);
        world.setBlock(i + 14, j + 24, k + 12, 0);
        world.setBlock(i + 14, j + 24, k + 13, 0);
        world.setBlock(i + 14, j + 24, k + 14, 0);
        world.setBlock(i + 14, j + 24, k + 15, 0);
        world.setBlock(i + 14, j + 24, k + 16, 0);
        world.setBlock(i + 14, j + 24, k + 17, 0);
        world.setBlock(i + 14, j + 24, k + 18, 0);
        world.setBlock(i + 14, j + 24, k + 19, 0);
        world.setBlock(i + 14, j + 24, k + 20, 0);
        world.setBlock(i + 14, j + 24, k + 21, 0);
        world.setBlock(i + 14, j + 24, k + 22, 0);
        world.setBlock(i + 14, j + 24, k + 23, 0);
        world.setBlock(i + 14, j + 24, k + 24, 0);
        world.setBlock(i + 14, j + 24, k + 25, 0);
        world.setBlock(i + 14, j + 24, k + 26, 0);
        world.setBlock(i + 14, j + 25, k + 0, 0);
        world.setBlock(i + 14, j + 25, k + 1, 0);
        world.setBlock(i + 14, j + 25, k + 2, 0);
        world.setBlock(i + 14, j + 25, k + 3, 0);
        world.setBlock(i + 14, j + 25, k + 4, 0);
        world.setBlock(i + 14, j + 25, k + 5, 0);
        world.setBlock(i + 14, j + 25, k + 6, 0);
        world.setBlock(i + 14, j + 25, k + 7, 0);
        world.setBlock(i + 14, j + 25, k + 8, 0);
        world.setBlock(i + 14, j + 25, k + 9, 0);
        world.setBlock(i + 14, j + 25, k + 10, 0);
        world.setBlock(i + 14, j + 25, k + 11, 0);
        world.setBlock(i + 14, j + 25, k + 12, 0);
        world.setBlock(i + 14, j + 25, k + 13, 0);
        world.setBlock(i + 14, j + 25, k + 14, 0);
        world.setBlock(i + 14, j + 25, k + 15, 0);
        world.setBlock(i + 14, j + 25, k + 16, 0);
        world.setBlock(i + 14, j + 25, k + 17, 0);
        world.setBlock(i + 14, j + 25, k + 18, 0);
        world.setBlock(i + 14, j + 25, k + 19, 0);
        world.setBlock(i + 14, j + 25, k + 20, 0);
        world.setBlock(i + 14, j + 25, k + 21, 0);
        world.setBlock(i + 14, j + 25, k + 22, 0);
        world.setBlock(i + 14, j + 25, k + 23, 0);
        world.setBlock(i + 14, j + 25, k + 24, 0);
        world.setBlock(i + 14, j + 25, k + 25, 0);
        world.setBlock(i + 14, j + 25, k + 26, 0);
        world.setBlock(i + 15, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 15, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 1, k + 10, Block.glowStone.blockID);
        world.setBlock(i + 15, j + 1, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 15, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 15, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 15, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 15, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 15, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 15, j + 2, k + 4, Block.grass.blockID);
        world.setBlock(i + 15, j + 2, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 2, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 2, k + 8, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 15, j + 2, k + 9, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 15, j + 2, k + 10, Block.glass.blockID);
        world.setBlock(i + 15, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 15, j + 2, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 15, j + 2, k + 13, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 15, j + 2, k + 14, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 15, j + 2, k + 15, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 15, j + 2, k + 16, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 15, j + 2, k + 17, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 15, j + 2, k + 18, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 15, j + 2, k + 19, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 15, j + 2, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 2, k + 21, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 15, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 2, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 2, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 2, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 2, k + 26, Block.grass.blockID);
        generate8(world, rand, i, j, k);
        return true;
    }

    public boolean generate8(World world, Random rand, int i, int j, int k)
    {
        world.setBlock(i + 15, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 3, k + 6, 0);
        world.setBlock(i + 15, j + 3, k + 7, 0);
        world.setBlock(i + 15, j + 3, k + 8, 0);
        world.setBlock(i + 15, j + 3, k + 9, 0);
        world.setBlock(i + 15, j + 3, k + 10, 0);
        world.setBlock(i + 15, j + 3, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 15, j + 3, k + 12, 0);
        world.setBlock(i + 15, j + 3, k + 13, 0);
        world.setBlock(i + 15, j + 3, k + 14, 0);
        world.setBlock(i + 15, j + 3, k + 15, 0);
        world.setBlock(i + 15, j + 3, k + 16, 0);
        world.setBlock(i + 15, j + 3, k + 17, 0);
        world.setBlock(i + 15, j + 3, k + 18, 0);
        world.setBlock(i + 15, j + 3, k + 19, Block.stoneDoubleSlab.blockID, 3, 0);
        world.setBlock(i + 15, j + 3, k + 20, 0);
        world.setBlock(i + 15, j + 3, k + 21, 0);
        world.setBlock(i + 15, j + 3, k + 22, 0);
        world.setBlock(i + 15, j + 3, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 3, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 3, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 4, k + 0, 0);
        world.setBlock(i + 15, j + 4, k + 1, 0);
        world.setBlock(i + 15, j + 4, k + 2, 0);
        world.setBlock(i + 15, j + 4, k + 3, 0);
        world.setBlock(i + 15, j + 4, k + 4, 0);
        world.setBlock(i + 15, j + 4, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 15, j + 4, k + 6, 0);
        world.setBlock(i + 15, j + 4, k + 7, 0);
        world.setBlock(i + 15, j + 4, k + 8, 0);
        world.setBlock(i + 15, j + 4, k + 9, 0);
        world.setBlock(i + 15, j + 4, k + 10, 0);
        world.setBlock(i + 15, j + 4, k + 11, 0);
        world.setBlock(i + 15, j + 4, k + 12, 0);
        world.setBlock(i + 15, j + 4, k + 13, 0);
        world.setBlock(i + 15, j + 4, k + 14, 0);
        world.setBlock(i + 15, j + 4, k + 15, 0);
        world.setBlock(i + 15, j + 4, k + 16, 0);
        world.setBlock(i + 15, j + 4, k + 17, 0);
        world.setBlock(i + 15, j + 4, k + 18, 0);
        world.setBlock(i + 15, j + 4, k + 19, Fossil.blockcultivateIdle.blockID);
        world.setBlock(i + 15, j + 4, k + 20, 0);
        world.setBlock(i + 15, j + 4, k + 21, 0);
        world.setBlock(i + 15, j + 4, k + 22, 0);
        world.setBlock(i + 15, j + 4, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 4, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 4, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 4, k + 26, 0);
        world.setBlock(i + 15, j + 5, k + 0, 0);
        world.setBlock(i + 15, j + 5, k + 1, 0);
        world.setBlock(i + 15, j + 5, k + 2, 0);
        world.setBlock(i + 15, j + 5, k + 3, 0);
        world.setBlock(i + 15, j + 5, k + 4, 0);
        world.setBlock(i + 15, j + 5, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 15, j + 5, k + 6, 0);
        world.setBlock(i + 15, j + 5, k + 7, 0);
        world.setBlock(i + 15, j + 5, k + 8, 0);
        world.setBlock(i + 15, j + 5, k + 9, 0);
        world.setBlock(i + 15, j + 5, k + 10, 0);
        world.setBlock(i + 15, j + 5, k + 11, 0);
        world.setBlock(i + 15, j + 5, k + 12, 0);
        world.setBlock(i + 15, j + 5, k + 13, 0);
        world.setBlock(i + 15, j + 5, k + 14, 0);
        world.setBlock(i + 15, j + 5, k + 15, 0);
        world.setBlock(i + 15, j + 5, k + 16, 0);
        world.setBlock(i + 15, j + 5, k + 17, 0);
        world.setBlock(i + 15, j + 5, k + 18, 0);
        world.setBlock(i + 15, j + 5, k + 19, 0);
        world.setBlock(i + 15, j + 5, k + 20, 0);
        world.setBlock(i + 15, j + 5, k + 21, 0);
        world.setBlock(i + 15, j + 5, k + 22, 0);
        world.setBlock(i + 15, j + 5, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 5, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 5, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 5, k + 26, 0);
        world.setBlock(i + 15, j + 6, k + 0, 0);
        world.setBlock(i + 15, j + 6, k + 1, 0);
        world.setBlock(i + 15, j + 6, k + 2, 0);
        world.setBlock(i + 15, j + 6, k + 3, 0);
        world.setBlock(i + 15, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 6, k + 6, 0);
        world.setBlock(i + 15, j + 6, k + 7, 0);
        world.setBlock(i + 15, j + 6, k + 8, 0);
        world.setBlock(i + 15, j + 6, k + 9, 0);
        world.setBlock(i + 15, j + 6, k + 10, 0);
        world.setBlock(i + 15, j + 6, k + 11, 0);
        world.setBlock(i + 15, j + 6, k + 12, 0);
        world.setBlock(i + 15, j + 6, k + 13, 0);
        world.setBlock(i + 15, j + 6, k + 14, 0);
        world.setBlock(i + 15, j + 6, k + 15, 0);
        world.setBlock(i + 15, j + 6, k + 16, 0);
        world.setBlock(i + 15, j + 6, k + 17, 0);
        world.setBlock(i + 15, j + 6, k + 18, 0);
        world.setBlock(i + 15, j + 6, k + 19, 0);
        world.setBlock(i + 15, j + 6, k + 20, 0);
        world.setBlock(i + 15, j + 6, k + 21, 0);
        world.setBlock(i + 15, j + 6, k + 22, 0);
        world.setBlock(i + 15, j + 6, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 6, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 6, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 6, k + 26, 0);
        world.setBlock(i + 15, j + 7, k + 0, 0);
        world.setBlock(i + 15, j + 7, k + 1, 0);
        world.setBlock(i + 15, j + 7, k + 2, 0);
        world.setBlock(i + 15, j + 7, k + 3, 0);
        world.setBlock(i + 15, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 7, k + 6, 0);
        world.setBlock(i + 15, j + 7, k + 7, 0);
        world.setBlock(i + 15, j + 7, k + 8, 0);
        world.setBlock(i + 15, j + 7, k + 9, 0);
        world.setBlock(i + 15, j + 7, k + 10, 0);
        world.setBlock(i + 15, j + 7, k + 11, 0);
        world.setBlock(i + 15, j + 7, k + 12, 0);
        world.setBlock(i + 15, j + 7, k + 13, 0);
        world.setBlock(i + 15, j + 7, k + 14, 0);
        world.setBlock(i + 15, j + 7, k + 15, 0);
        world.setBlock(i + 15, j + 7, k + 16, 0);
        world.setBlock(i + 15, j + 7, k + 17, 0);
        world.setBlock(i + 15, j + 7, k + 18, 0);
        world.setBlock(i + 15, j + 7, k + 19, 0);
        world.setBlock(i + 15, j + 7, k + 20, 0);
        world.setBlock(i + 15, j + 7, k + 21, 0);
        world.setBlock(i + 15, j + 7, k + 22, 0);
        world.setBlock(i + 15, j + 7, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 7, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 7, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 7, k + 26, 0);
        world.setBlock(i + 15, j + 8, k + 0, 0);
        world.setBlock(i + 15, j + 8, k + 1, 0);
        world.setBlock(i + 15, j + 8, k + 2, 0);
        world.setBlock(i + 15, j + 8, k + 3, 0);
        world.setBlock(i + 15, j + 8, k + 4, 0);
        world.setBlock(i + 15, j + 8, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 8, k + 6, 0);
        world.setBlock(i + 15, j + 8, k + 7, 0);
        world.setBlock(i + 15, j + 8, k + 8, 0);
        world.setBlock(i + 15, j + 8, k + 9, 0);
        world.setBlock(i + 15, j + 8, k + 10, 0);
        world.setBlock(i + 15, j + 8, k + 11, 0);
        world.setBlock(i + 15, j + 8, k + 12, 0);
        world.setBlock(i + 15, j + 8, k + 13, 0);
        world.setBlock(i + 15, j + 8, k + 14, 0);
        world.setBlock(i + 15, j + 8, k + 15, 0);
        world.setBlock(i + 15, j + 8, k + 16, 0);
        world.setBlock(i + 15, j + 8, k + 17, 0);
        world.setBlock(i + 15, j + 8, k + 18, 0);
        world.setBlock(i + 15, j + 8, k + 19, 0);
        world.setBlock(i + 15, j + 8, k + 20, 0);
        world.setBlock(i + 15, j + 8, k + 21, 0);
        world.setBlock(i + 15, j + 8, k + 22, 0);
        world.setBlock(i + 15, j + 8, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 8, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 8, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 8, k + 26, 0);
        world.setBlock(i + 15, j + 9, k + 0, 0);
        world.setBlock(i + 15, j + 9, k + 1, 0);
        world.setBlock(i + 15, j + 9, k + 2, 0);
        world.setBlock(i + 15, j + 9, k + 3, 0);
        world.setBlock(i + 15, j + 9, k + 4, 0);
        world.setBlock(i + 15, j + 9, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 9, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 9, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 9, k + 17, 0);
        world.setBlock(i + 15, j + 9, k + 18, 0);
        world.setBlock(i + 15, j + 9, k + 19, 0);
        world.setBlock(i + 15, j + 9, k + 20, 0);
        world.setBlock(i + 15, j + 9, k + 21, 0);
        world.setBlock(i + 15, j + 9, k + 22, 0);
        world.setBlock(i + 15, j + 9, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 9, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 9, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 9, k + 26, 0);
        world.setBlock(i + 15, j + 10, k + 0, 0);
        world.setBlock(i + 15, j + 10, k + 1, 0);
        world.setBlock(i + 15, j + 10, k + 2, 0);
        world.setBlock(i + 15, j + 10, k + 3, 0);
        world.setBlock(i + 15, j + 10, k + 4, 0);
        world.setBlock(i + 15, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 10, k + 6, 0);
        world.setBlock(i + 15, j + 10, k + 7, 0);
        world.setBlock(i + 15, j + 10, k + 8, Block.chest.blockID, 2, 0);
        world.setBlock(i + 15, j + 10, k + 9, 0);
        world.setBlock(i + 15, j + 10, k + 10, 0);
        world.setBlock(i + 15, j + 10, k + 11, Block.chest.blockID, 2, 0);
        world.setBlock(i + 15, j + 10, k + 12, 0);
        world.setBlock(i + 15, j + 10, k + 13, 0);
        world.setBlock(i + 15, j + 10, k + 14, 0);
        world.setBlock(i + 15, j + 10, k + 15, Block.fence.blockID);
        world.setBlock(i + 15, j + 10, k + 16, Block.fence.blockID);
        world.setBlock(i + 15, j + 10, k + 17, 0);
        world.setBlock(i + 15, j + 10, k + 18, 0);
        world.setBlock(i + 15, j + 10, k + 19, 0);
        world.setBlock(i + 15, j + 10, k + 20, 0);
        world.setBlock(i + 15, j + 10, k + 21, 0);
        world.setBlock(i + 15, j + 10, k + 22, 0);
        world.setBlock(i + 15, j + 10, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 10, k + 26, 0);
        world.setBlock(i + 15, j + 11, k + 0, 0);
        world.setBlock(i + 15, j + 11, k + 1, 0);
        world.setBlock(i + 15, j + 11, k + 2, 0);
        world.setBlock(i + 15, j + 11, k + 3, 0);
        world.setBlock(i + 15, j + 11, k + 4, 0);
        world.setBlock(i + 15, j + 11, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 15, j + 11, k + 6, 0);
        world.setBlock(i + 15, j + 11, k + 7, 0);
        world.setBlock(i + 15, j + 11, k + 8, 0);
        world.setBlock(i + 15, j + 11, k + 9, 0);
        world.setBlock(i + 15, j + 11, k + 10, 0);
        world.setBlock(i + 15, j + 11, k + 11, 0);
        world.setBlock(i + 15, j + 11, k + 12, 0);
        world.setBlock(i + 15, j + 11, k + 13, 0);
        world.setBlock(i + 15, j + 11, k + 14, 0);
        world.setBlock(i + 15, j + 11, k + 15, 0);
        world.setBlock(i + 15, j + 11, k + 16, 0);
        world.setBlock(i + 15, j + 11, k + 17, 0);
        world.setBlock(i + 15, j + 11, k + 18, 0);
        world.setBlock(i + 15, j + 11, k + 19, 0);
        world.setBlock(i + 15, j + 11, k + 20, 0);
        world.setBlock(i + 15, j + 11, k + 21, 0);
        world.setBlock(i + 15, j + 11, k + 22, 0);
        world.setBlock(i + 15, j + 11, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 11, k + 26, 0);
        world.setBlock(i + 15, j + 12, k + 0, 0);
        world.setBlock(i + 15, j + 12, k + 1, 0);
        world.setBlock(i + 15, j + 12, k + 2, 0);
        world.setBlock(i + 15, j + 12, k + 3, 0);
        world.setBlock(i + 15, j + 12, k + 4, 0);
        world.setBlock(i + 15, j + 12, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 15, j + 12, k + 6, 0);
        world.setBlock(i + 15, j + 12, k + 7, 0);
        world.setBlock(i + 15, j + 12, k + 8, 0);
        world.setBlock(i + 15, j + 12, k + 9, 0);
        world.setBlock(i + 15, j + 12, k + 10, 0);
        world.setBlock(i + 15, j + 12, k + 11, 0);
        world.setBlock(i + 15, j + 12, k + 12, 0);
        world.setBlock(i + 15, j + 12, k + 13, 0);
        world.setBlock(i + 15, j + 12, k + 14, 0);
        world.setBlock(i + 15, j + 12, k + 15, 0);
        world.setBlock(i + 15, j + 12, k + 16, 0);
        world.setBlock(i + 15, j + 12, k + 17, 0);
        world.setBlock(i + 15, j + 12, k + 18, 0);
        world.setBlock(i + 15, j + 12, k + 19, 0);
        world.setBlock(i + 15, j + 12, k + 20, 0);
        world.setBlock(i + 15, j + 12, k + 21, 0);
        world.setBlock(i + 15, j + 12, k + 22, 0);
        world.setBlock(i + 15, j + 12, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 12, k + 26, 0);
        world.setBlock(i + 15, j + 13, k + 0, 0);
        world.setBlock(i + 15, j + 13, k + 1, 0);
        world.setBlock(i + 15, j + 13, k + 2, 0);
        world.setBlock(i + 15, j + 13, k + 3, 0);
        world.setBlock(i + 15, j + 13, k + 4, 0);
        world.setBlock(i + 15, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 13, k + 6, 0);
        world.setBlock(i + 15, j + 13, k + 7, 0);
        world.setBlock(i + 15, j + 13, k + 8, 0);
        world.setBlock(i + 15, j + 13, k + 9, 0);
        world.setBlock(i + 15, j + 13, k + 10, 0);
        world.setBlock(i + 15, j + 13, k + 11, 0);
        world.setBlock(i + 15, j + 13, k + 12, 0);
        world.setBlock(i + 15, j + 13, k + 13, 0);
        world.setBlock(i + 15, j + 13, k + 14, 0);
        world.setBlock(i + 15, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 13, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 13, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 13, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 13, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 13, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 13, k + 26, 0);
        world.setBlock(i + 15, j + 14, k + 0, 0);
        world.setBlock(i + 15, j + 14, k + 1, 0);
        world.setBlock(i + 15, j + 14, k + 2, 0);
        world.setBlock(i + 15, j + 14, k + 3, 0);
        world.setBlock(i + 15, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 14, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 14, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 14, k + 26, 0);
        world.setBlock(i + 15, j + 15, k + 0, 0);
        world.setBlock(i + 15, j + 15, k + 1, 0);
        world.setBlock(i + 15, j + 15, k + 2, 0);
        world.setBlock(i + 15, j + 15, k + 3, 0);
        world.setBlock(i + 15, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 15, k + 5, 0);
        world.setBlock(i + 15, j + 15, k + 6, 0);
        world.setBlock(i + 15, j + 15, k + 7, 0);
        world.setBlock(i + 15, j + 15, k + 8, 0);
        world.setBlock(i + 15, j + 15, k + 9, 0);
        world.setBlock(i + 15, j + 15, k + 10, 0);
        world.setBlock(i + 15, j + 15, k + 11, 0);
        world.setBlock(i + 15, j + 15, k + 12, 0);
        world.setBlock(i + 15, j + 15, k + 13, 0);
        world.setBlock(i + 15, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 15, k + 22, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 15, j + 15, k + 23, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 15, j + 15, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 15, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 15, k + 26, 0);
        world.setBlock(i + 15, j + 16, k + 0, 0);
        world.setBlock(i + 15, j + 16, k + 1, 0);
        world.setBlock(i + 15, j + 16, k + 2, 0);
        world.setBlock(i + 15, j + 16, k + 3, 0);
        world.setBlock(i + 15, j + 16, k + 4, 0);
        world.setBlock(i + 15, j + 16, k + 5, 0);
        world.setBlock(i + 15, j + 16, k + 6, 0);
        world.setBlock(i + 15, j + 16, k + 7, 0);
        world.setBlock(i + 15, j + 16, k + 8, 0);
        world.setBlock(i + 15, j + 16, k + 9, 0);
        world.setBlock(i + 15, j + 16, k + 10, 0);
        world.setBlock(i + 15, j + 16, k + 11, 0);
        world.setBlock(i + 15, j + 16, k + 12, 0);
        world.setBlock(i + 15, j + 16, k + 13, 0);
        world.setBlock(i + 15, j + 16, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 16, k + 15, Block.chest.blockID, 3, 0);
        world.setBlock(i + 15, j + 16, k + 16, 0);
        world.setBlock(i + 15, j + 16, k + 17, 0);
        world.setBlock(i + 15, j + 16, k + 18, 0);
        world.setBlock(i + 15, j + 16, k + 19, Block.bed.blockID);
        world.setBlock(i + 15, j + 16, k + 20, Block.bed.blockID, 8, 0);
        world.setBlock(i + 15, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 16, k + 22, 0);
        world.setBlock(i + 15, j + 16, k + 23, 0);
        world.setBlock(i + 15, j + 16, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 16, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 16, k + 26, 0);
        world.setBlock(i + 15, j + 17, k + 0, 0);
        world.setBlock(i + 15, j + 17, k + 1, 0);
        world.setBlock(i + 15, j + 17, k + 2, 0);
        world.setBlock(i + 15, j + 17, k + 3, 0);
        world.setBlock(i + 15, j + 17, k + 4, 0);
        world.setBlock(i + 15, j + 17, k + 5, 0);
        world.setBlock(i + 15, j + 17, k + 6, 0);
        world.setBlock(i + 15, j + 17, k + 7, 0);
        world.setBlock(i + 15, j + 17, k + 8, 0);
        world.setBlock(i + 15, j + 17, k + 9, 0);
        world.setBlock(i + 15, j + 17, k + 10, 0);
        world.setBlock(i + 15, j + 17, k + 11, 0);
        world.setBlock(i + 15, j + 17, k + 12, 0);
        world.setBlock(i + 15, j + 17, k + 13, 0);
        world.setBlock(i + 15, j + 17, k + 14, Block.thinGlass.blockID);
        world.setBlock(i + 15, j + 17, k + 15, 0);
        world.setBlock(i + 15, j + 17, k + 16, 0);
        world.setBlock(i + 15, j + 17, k + 17, 0);
        world.setBlock(i + 15, j + 17, k + 18, 0);
        world.setBlock(i + 15, j + 17, k + 19, 0);
        world.setBlock(i + 15, j + 17, k + 20, 0);
        world.setBlock(i + 15, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 17, k + 22, 0);
        world.setBlock(i + 15, j + 17, k + 23, 0);
        world.setBlock(i + 15, j + 17, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 17, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 15, j + 17, k + 26, 0);
        world.setBlock(i + 15, j + 18, k + 0, 0);
        world.setBlock(i + 15, j + 18, k + 1, 0);
        world.setBlock(i + 15, j + 18, k + 2, 0);
        world.setBlock(i + 15, j + 18, k + 3, 0);
        world.setBlock(i + 15, j + 18, k + 4, 0);
        world.setBlock(i + 15, j + 18, k + 5, 0);
        world.setBlock(i + 15, j + 18, k + 6, 0);
        world.setBlock(i + 15, j + 18, k + 7, 0);
        world.setBlock(i + 15, j + 18, k + 8, 0);
        world.setBlock(i + 15, j + 18, k + 9, 0);
        world.setBlock(i + 15, j + 18, k + 10, 0);
        world.setBlock(i + 15, j + 18, k + 11, 0);
        world.setBlock(i + 15, j + 18, k + 12, 0);
        world.setBlock(i + 15, j + 18, k + 13, 0);
        world.setBlock(i + 15, j + 18, k + 14, Block.thinGlass.blockID);
        world.setBlock(i + 15, j + 18, k + 15, 0);
        world.setBlock(i + 15, j + 18, k + 16, 0);
        world.setBlock(i + 15, j + 18, k + 17, 0);
        world.setBlock(i + 15, j + 18, k + 18, 0);
        world.setBlock(i + 15, j + 18, k + 19, 0);
        world.setBlock(i + 15, j + 18, k + 20, 0);
        world.setBlock(i + 15, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 18, k + 22, 0);
        world.setBlock(i + 15, j + 18, k + 23, 0);
        world.setBlock(i + 15, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 18, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 18, k + 26, 0);
        world.setBlock(i + 15, j + 19, k + 0, 0);
        world.setBlock(i + 15, j + 19, k + 1, 0);
        world.setBlock(i + 15, j + 19, k + 2, 0);
        world.setBlock(i + 15, j + 19, k + 3, 0);
        world.setBlock(i + 15, j + 19, k + 4, 0);
        world.setBlock(i + 15, j + 19, k + 5, 0);
        world.setBlock(i + 15, j + 19, k + 6, 0);
        world.setBlock(i + 15, j + 19, k + 7, 0);
        world.setBlock(i + 15, j + 19, k + 8, 0);
        world.setBlock(i + 15, j + 19, k + 9, 0);
        world.setBlock(i + 15, j + 19, k + 10, 0);
        world.setBlock(i + 15, j + 19, k + 11, 0);
        world.setBlock(i + 15, j + 19, k + 12, 0);
        world.setBlock(i + 15, j + 19, k + 13, 0);
        world.setBlock(i + 15, j + 19, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 19, k + 15, 0);
        world.setBlock(i + 15, j + 19, k + 16, 0);
        world.setBlock(i + 15, j + 19, k + 17, 0);
        world.setBlock(i + 15, j + 19, k + 18, 0);
        world.setBlock(i + 15, j + 19, k + 19, 0);
        world.setBlock(i + 15, j + 19, k + 20, 0);
        world.setBlock(i + 15, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 19, k + 22, Block.web.blockID);
        world.setBlock(i + 15, j + 19, k + 23, 0);
        world.setBlock(i + 15, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 19, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 19, k + 26, 0);
        world.setBlock(i + 15, j + 20, k + 0, 0);
        world.setBlock(i + 15, j + 20, k + 1, 0);
        world.setBlock(i + 15, j + 20, k + 2, 0);
        world.setBlock(i + 15, j + 20, k + 3, 0);
        world.setBlock(i + 15, j + 20, k + 4, 0);
        world.setBlock(i + 15, j + 20, k + 5, 0);
        world.setBlock(i + 15, j + 20, k + 6, 0);
        world.setBlock(i + 15, j + 20, k + 7, 0);
        world.setBlock(i + 15, j + 20, k + 8, 0);
        world.setBlock(i + 15, j + 20, k + 9, 0);
        world.setBlock(i + 15, j + 20, k + 10, 0);
        world.setBlock(i + 15, j + 20, k + 11, 0);
        world.setBlock(i + 15, j + 20, k + 12, 0);
        world.setBlock(i + 15, j + 20, k + 13, 0);
        world.setBlock(i + 15, j + 20, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 20, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 20, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 20, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 20, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 20, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 20, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 20, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 20, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 20, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 20, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 20, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 20, k + 26, 0);
        world.setBlock(i + 15, j + 21, k + 0, 0);
        world.setBlock(i + 15, j + 21, k + 1, 0);
        world.setBlock(i + 15, j + 21, k + 2, 0);
        world.setBlock(i + 15, j + 21, k + 3, 0);
        world.setBlock(i + 15, j + 21, k + 4, 0);
        world.setBlock(i + 15, j + 21, k + 5, 0);
        world.setBlock(i + 15, j + 21, k + 6, 0);
        world.setBlock(i + 15, j + 21, k + 7, 0);
        world.setBlock(i + 15, j + 21, k + 8, 0);
        world.setBlock(i + 15, j + 21, k + 9, 0);
        world.setBlock(i + 15, j + 21, k + 10, 0);
        world.setBlock(i + 15, j + 21, k + 11, 0);
        world.setBlock(i + 15, j + 21, k + 12, 0);
        world.setBlock(i + 15, j + 21, k + 13, 0);
        world.setBlock(i + 15, j + 21, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 21, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 21, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 21, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 21, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 21, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 21, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 21, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 21, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 21, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 21, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 21, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 21, k + 26, 0);
        world.setBlock(i + 15, j + 22, k + 0, 0);
        world.setBlock(i + 15, j + 22, k + 1, 0);
        world.setBlock(i + 15, j + 22, k + 2, 0);
        world.setBlock(i + 15, j + 22, k + 3, 0);
        world.setBlock(i + 15, j + 22, k + 4, 0);
        world.setBlock(i + 15, j + 22, k + 5, 0);
        world.setBlock(i + 15, j + 22, k + 6, 0);
        world.setBlock(i + 15, j + 22, k + 7, 0);
        world.setBlock(i + 15, j + 22, k + 8, 0);
        world.setBlock(i + 15, j + 22, k + 9, 0);
        world.setBlock(i + 15, j + 22, k + 10, 0);
        world.setBlock(i + 15, j + 22, k + 11, 0);
        world.setBlock(i + 15, j + 22, k + 12, 0);
        world.setBlock(i + 15, j + 22, k + 13, 0);
        world.setBlock(i + 15, j + 22, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 22, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 22, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 22, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 22, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 22, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 22, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 22, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 22, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 22, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 22, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 15, j + 22, k + 25, 0);
        world.setBlock(i + 15, j + 22, k + 26, 0);
        world.setBlock(i + 15, j + 23, k + 0, 0);
        world.setBlock(i + 15, j + 23, k + 1, 0);
        world.setBlock(i + 15, j + 23, k + 2, 0);
        world.setBlock(i + 15, j + 23, k + 3, 0);
        world.setBlock(i + 15, j + 23, k + 4, 0);
        world.setBlock(i + 15, j + 23, k + 5, 0);
        world.setBlock(i + 15, j + 23, k + 6, 0);
        world.setBlock(i + 15, j + 23, k + 7, 0);
        world.setBlock(i + 15, j + 23, k + 8, 0);
        world.setBlock(i + 15, j + 23, k + 9, 0);
        world.setBlock(i + 15, j + 23, k + 10, 0);
        world.setBlock(i + 15, j + 23, k + 11, 0);
        world.setBlock(i + 15, j + 23, k + 12, 0);
        world.setBlock(i + 15, j + 23, k + 13, 0);
        world.setBlock(i + 15, j + 23, k + 14, 0);
        world.setBlock(i + 15, j + 23, k + 15, 0);
        world.setBlock(i + 15, j + 23, k + 16, 0);
        world.setBlock(i + 15, j + 23, k + 17, 0);
        world.setBlock(i + 15, j + 23, k + 18, 0);
        world.setBlock(i + 15, j + 23, k + 19, 0);
        world.setBlock(i + 15, j + 23, k + 20, 0);
        world.setBlock(i + 15, j + 23, k + 21, 0);
        world.setBlock(i + 15, j + 23, k + 22, 0);
        world.setBlock(i + 15, j + 23, k + 23, 0);
        world.setBlock(i + 15, j + 23, k + 24, 0);
        world.setBlock(i + 15, j + 23, k + 25, 0);
        world.setBlock(i + 15, j + 23, k + 26, 0);
        world.setBlock(i + 15, j + 24, k + 0, 0);
        world.setBlock(i + 15, j + 24, k + 1, 0);
        world.setBlock(i + 15, j + 24, k + 2, 0);
        world.setBlock(i + 15, j + 24, k + 3, 0);
        world.setBlock(i + 15, j + 24, k + 4, 0);
        world.setBlock(i + 15, j + 24, k + 5, 0);
        world.setBlock(i + 15, j + 24, k + 6, 0);
        world.setBlock(i + 15, j + 24, k + 7, 0);
        world.setBlock(i + 15, j + 24, k + 8, 0);
        world.setBlock(i + 15, j + 24, k + 9, 0);
        world.setBlock(i + 15, j + 24, k + 10, 0);
        world.setBlock(i + 15, j + 24, k + 11, 0);
        world.setBlock(i + 15, j + 24, k + 12, 0);
        world.setBlock(i + 15, j + 24, k + 13, 0);
        world.setBlock(i + 15, j + 24, k + 14, 0);
        world.setBlock(i + 15, j + 24, k + 15, 0);
        world.setBlock(i + 15, j + 24, k + 16, 0);
        world.setBlock(i + 15, j + 24, k + 17, 0);
        world.setBlock(i + 15, j + 24, k + 18, 0);
        world.setBlock(i + 15, j + 24, k + 19, 0);
        world.setBlock(i + 15, j + 24, k + 20, 0);
        world.setBlock(i + 15, j + 24, k + 21, 0);
        world.setBlock(i + 15, j + 24, k + 22, 0);
        world.setBlock(i + 15, j + 24, k + 23, 0);
        world.setBlock(i + 15, j + 24, k + 24, 0);
        world.setBlock(i + 15, j + 24, k + 25, 0);
        world.setBlock(i + 15, j + 24, k + 26, 0);
        world.setBlock(i + 15, j + 25, k + 0, 0);
        world.setBlock(i + 15, j + 25, k + 1, 0);
        world.setBlock(i + 15, j + 25, k + 2, 0);
        world.setBlock(i + 15, j + 25, k + 3, 0);
        world.setBlock(i + 15, j + 25, k + 4, 0);
        world.setBlock(i + 15, j + 25, k + 5, 0);
        world.setBlock(i + 15, j + 25, k + 6, 0);
        world.setBlock(i + 15, j + 25, k + 7, 0);
        world.setBlock(i + 15, j + 25, k + 8, 0);
        world.setBlock(i + 15, j + 25, k + 9, 0);
        world.setBlock(i + 15, j + 25, k + 10, 0);
        world.setBlock(i + 15, j + 25, k + 11, 0);
        world.setBlock(i + 15, j + 25, k + 12, 0);
        world.setBlock(i + 15, j + 25, k + 13, 0);
        world.setBlock(i + 15, j + 25, k + 14, 0);
        world.setBlock(i + 15, j + 25, k + 15, 0);
        world.setBlock(i + 15, j + 25, k + 16, 0);
        world.setBlock(i + 15, j + 25, k + 17, 0);
        world.setBlock(i + 15, j + 25, k + 18, 0);
        world.setBlock(i + 15, j + 25, k + 19, 0);
        world.setBlock(i + 15, j + 25, k + 20, 0);
        world.setBlock(i + 15, j + 25, k + 21, 0);
        world.setBlock(i + 15, j + 25, k + 22, 0);
        world.setBlock(i + 15, j + 25, k + 23, 0);
        world.setBlock(i + 15, j + 25, k + 24, 0);
        world.setBlock(i + 15, j + 25, k + 25, 0);
        world.setBlock(i + 15, j + 25, k + 26, 0);
        world.setBlock(i + 16, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 16, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 16, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 16, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 16, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 16, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 16, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 16, j + 2, k + 4, Block.grass.blockID);
        world.setBlock(i + 16, j + 2, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 2, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 2, k + 8, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 16, j + 2, k + 9, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 16, j + 2, k + 10, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 16, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 16, j + 2, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 16, j + 2, k + 13, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 16, j + 2, k + 14, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 16, j + 2, k + 15, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 16, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 2, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 2, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 2, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 2, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 2, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 2, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 2, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 16, j + 3, k + 4, 0);
        world.setBlock(i + 16, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 3, k + 6, 0);
        world.setBlock(i + 16, j + 3, k + 7, 0);
        world.setBlock(i + 16, j + 3, k + 8, 0);
        world.setBlock(i + 16, j + 3, k + 9, 0);
        world.setBlock(i + 16, j + 3, k + 10, 0);
        world.setBlock(i + 16, j + 3, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 16, j + 3, k + 12, 0);
        world.setBlock(i + 16, j + 3, k + 13, 0);
        world.setBlock(i + 16, j + 3, k + 14, Block.blockGold.blockID);
        world.setBlock(i + 16, j + 3, k + 15, Block.furnaceIdle.blockID, 4, 0);
        world.setBlock(i + 16, j + 3, k + 16, 0);
        world.setBlock(i + 16, j + 3, k + 17, 0);
        world.setBlock(i + 16, j + 3, k + 18, 0);
        world.setBlock(i + 16, j + 3, k + 19, 0);
        world.setBlock(i + 16, j + 3, k + 20, 0);
        world.setBlock(i + 16, j + 3, k + 21, 0);
        world.setBlock(i + 16, j + 3, k + 22, 0);
        world.setBlock(i + 16, j + 3, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 3, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 3, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 4, k + 0, 0);
        world.setBlock(i + 16, j + 4, k + 1, 0);
        world.setBlock(i + 16, j + 4, k + 2, 0);
        world.setBlock(i + 16, j + 4, k + 3, 0);
        world.setBlock(i + 16, j + 4, k + 4, 0);
        world.setBlock(i + 16, j + 4, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 4, k + 6, 0);
        world.setBlock(i + 16, j + 4, k + 7, 0);
        world.setBlock(i + 16, j + 4, k + 8, 0);
        world.setBlock(i + 16, j + 4, k + 9, 0);
        world.setBlock(i + 16, j + 4, k + 10, 0);
        world.setBlock(i + 16, j + 4, k + 11, 0);
        world.setBlock(i + 16, j + 4, k + 12, 0);
        world.setBlock(i + 16, j + 4, k + 13, 0);
        world.setBlock(i + 16, j + 4, k + 14, 0);
        world.setBlock(i + 16, j + 4, k + 15, Block.furnaceIdle.blockID, 4, 0);
        world.setBlock(i + 16, j + 4, k + 16, 0);
        world.setBlock(i + 16, j + 4, k + 17, 0);
        world.setBlock(i + 16, j + 4, k + 18, 0);
        world.setBlock(i + 16, j + 4, k + 19, 0);
        world.setBlock(i + 16, j + 4, k + 20, 0);
        world.setBlock(i + 16, j + 4, k + 21, 0);
        world.setBlock(i + 16, j + 4, k + 22, 0);
        world.setBlock(i + 16, j + 4, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 4, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 4, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 4, k + 26, 0);
        world.setBlock(i + 16, j + 5, k + 0, 0);
        world.setBlock(i + 16, j + 5, k + 1, 0);
        world.setBlock(i + 16, j + 5, k + 2, 0);
        world.setBlock(i + 16, j + 5, k + 3, 0);
        world.setBlock(i + 16, j + 5, k + 4, 0);
        world.setBlock(i + 16, j + 5, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 5, k + 6, 0);
        world.setBlock(i + 16, j + 5, k + 7, 0);
        world.setBlock(i + 16, j + 5, k + 8, 0);
        world.setBlock(i + 16, j + 5, k + 9, 0);
        world.setBlock(i + 16, j + 5, k + 10, 0);
        world.setBlock(i + 16, j + 5, k + 11, 0);
        world.setBlock(i + 16, j + 5, k + 12, 0);
        world.setBlock(i + 16, j + 5, k + 13, 0);
        world.setBlock(i + 16, j + 5, k + 14, 0);
        world.setBlock(i + 16, j + 5, k + 15, 0);
        world.setBlock(i + 16, j + 5, k + 16, 0);
        world.setBlock(i + 16, j + 5, k + 17, 0);
        world.setBlock(i + 16, j + 5, k + 18, 0);
        world.setBlock(i + 16, j + 5, k + 19, 0);
        world.setBlock(i + 16, j + 5, k + 20, 0);
        world.setBlock(i + 16, j + 5, k + 21, 0);
        world.setBlock(i + 16, j + 5, k + 22, 0);
        world.setBlock(i + 16, j + 5, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 5, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 5, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 5, k + 26, 0);
        world.setBlock(i + 16, j + 6, k + 0, 0);
        world.setBlock(i + 16, j + 6, k + 1, 0);
        world.setBlock(i + 16, j + 6, k + 2, 0);
        world.setBlock(i + 16, j + 6, k + 3, 0);
        world.setBlock(i + 16, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 6, k + 6, 0);
        world.setBlock(i + 16, j + 6, k + 7, 0);
        world.setBlock(i + 16, j + 6, k + 8, 0);
        world.setBlock(i + 16, j + 6, k + 9, 0);
        world.setBlock(i + 16, j + 6, k + 10, 0);
        world.setBlock(i + 16, j + 6, k + 11, 0);
        world.setBlock(i + 16, j + 6, k + 12, 0);
        world.setBlock(i + 16, j + 6, k + 13, 0);
        world.setBlock(i + 16, j + 6, k + 14, Block.glowStone.blockID);
        world.setBlock(i + 16, j + 6, k + 15, 0);
        world.setBlock(i + 16, j + 6, k + 16, 0);
        world.setBlock(i + 16, j + 6, k + 17, 0);
        world.setBlock(i + 16, j + 6, k + 18, 0);
        world.setBlock(i + 16, j + 6, k + 19, Block.glowStone.blockID);
        world.setBlock(i + 16, j + 6, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 6, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 6, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 6, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 6, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 6, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 6, k + 26, 0);
        world.setBlock(i + 16, j + 7, k + 0, 0);
        world.setBlock(i + 16, j + 7, k + 1, 0);
        world.setBlock(i + 16, j + 7, k + 2, 0);
        world.setBlock(i + 16, j + 7, k + 3, 0);
        world.setBlock(i + 16, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 7, k + 6, 0);
        world.setBlock(i + 16, j + 7, k + 7, 0);
        world.setBlock(i + 16, j + 7, k + 8, 0);
        world.setBlock(i + 16, j + 7, k + 9, 0);
        world.setBlock(i + 16, j + 7, k + 10, 0);
        world.setBlock(i + 16, j + 7, k + 11, 0);
        world.setBlock(i + 16, j + 7, k + 12, 0);
        world.setBlock(i + 16, j + 7, k + 13, 0);
        world.setBlock(i + 16, j + 7, k + 14, Block.fence.blockID);
        world.setBlock(i + 16, j + 7, k + 15, 0);
        world.setBlock(i + 16, j + 7, k + 16, 0);
        world.setBlock(i + 16, j + 7, k + 17, 0);
        world.setBlock(i + 16, j + 7, k + 18, 0);
        world.setBlock(i + 16, j + 7, k + 19, Block.fence.blockID);
        world.setBlock(i + 16, j + 7, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 7, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 7, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 7, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 7, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 7, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 7, k + 26, 0);
        world.setBlock(i + 16, j + 8, k + 0, 0);
        world.setBlock(i + 16, j + 8, k + 1, 0);
        world.setBlock(i + 16, j + 8, k + 2, 0);
        world.setBlock(i + 16, j + 8, k + 3, 0);
        world.setBlock(i + 16, j + 8, k + 4, 0);
        world.setBlock(i + 16, j + 8, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 8, k + 6, Block.web.blockID);
        world.setBlock(i + 16, j + 8, k + 7, 0);
        world.setBlock(i + 16, j + 8, k + 8, 0);
        world.setBlock(i + 16, j + 8, k + 9, 0);
        world.setBlock(i + 16, j + 8, k + 10, 0);
        world.setBlock(i + 16, j + 8, k + 11, 0);
        world.setBlock(i + 16, j + 8, k + 12, 0);
        world.setBlock(i + 16, j + 8, k + 13, 0);
        world.setBlock(i + 16, j + 8, k + 14, 0);
        world.setBlock(i + 16, j + 8, k + 15, 0);
        world.setBlock(i + 16, j + 8, k + 16, 0);
        world.setBlock(i + 16, j + 8, k + 17, 0);
        world.setBlock(i + 16, j + 8, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 8, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 8, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 8, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 8, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 8, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 8, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 8, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 8, k + 26, 0);
        world.setBlock(i + 16, j + 9, k + 0, 0);
        world.setBlock(i + 16, j + 9, k + 1, 0);
        world.setBlock(i + 16, j + 9, k + 2, 0);
        world.setBlock(i + 16, j + 9, k + 3, 0);
        world.setBlock(i + 16, j + 9, k + 4, 0);
        world.setBlock(i + 16, j + 9, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 9, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 16, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 11, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 16, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 9, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 9, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 9, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 9, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 9, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 9, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 9, k + 26, 0);
        world.setBlock(i + 16, j + 10, k + 0, 0);
        world.setBlock(i + 16, j + 10, k + 1, 0);
        world.setBlock(i + 16, j + 10, k + 2, 0);
        world.setBlock(i + 16, j + 10, k + 3, 0);
        world.setBlock(i + 16, j + 10, k + 4, 0);
        world.setBlock(i + 16, j + 10, k + 5, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 16, j + 10, k + 6, 0);
        world.setBlock(i + 16, j + 10, k + 7, 0);
        world.setBlock(i + 16, j + 10, k + 8, 0);
        world.setBlock(i + 16, j + 10, k + 9, 0);
        world.setBlock(i + 16, j + 10, k + 10, 0);
        world.setBlock(i + 16, j + 10, k + 11, 0);
        world.setBlock(i + 16, j + 10, k + 12, 0);
        world.setBlock(i + 16, j + 10, k + 13, 0);
        world.setBlock(i + 16, j + 10, k + 14, 0);
        world.setBlock(i + 16, j + 10, k + 15, 0);
        world.setBlock(i + 16, j + 10, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 10, k + 17, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 10, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 10, k + 19, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 10, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 10, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 10, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 10, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 10, k + 26, 0);
        world.setBlock(i + 16, j + 11, k + 0, 0);
        world.setBlock(i + 16, j + 11, k + 1, 0);
        world.setBlock(i + 16, j + 11, k + 2, 0);
        world.setBlock(i + 16, j + 11, k + 3, 0);
        world.setBlock(i + 16, j + 11, k + 4, 0);
        world.setBlock(i + 16, j + 11, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 11, k + 6, 0);
        world.setBlock(i + 16, j + 11, k + 7, 0);
        world.setBlock(i + 16, j + 11, k + 8, 0);
        world.setBlock(i + 16, j + 11, k + 9, 0);
        world.setBlock(i + 16, j + 11, k + 10, 0);
        world.setBlock(i + 16, j + 11, k + 11, 0);
        world.setBlock(i + 16, j + 11, k + 12, 0);
        world.setBlock(i + 16, j + 11, k + 13, 0);
        world.setBlock(i + 16, j + 11, k + 14, 0);
        world.setBlock(i + 16, j + 11, k + 15, 0);
        world.setBlock(i + 16, j + 11, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 11, k + 17, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 11, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 11, k + 19, Block.thinGlass.blockID);
        world.setBlock(i + 16, j + 11, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 11, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 11, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 11, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 11, k + 26, 0);
        world.setBlock(i + 16, j + 12, k + 0, 0);
        world.setBlock(i + 16, j + 12, k + 1, 0);
        world.setBlock(i + 16, j + 12, k + 2, 0);
        world.setBlock(i + 16, j + 12, k + 3, 0);
        world.setBlock(i + 16, j + 12, k + 4, 0);
        world.setBlock(i + 16, j + 12, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 12, k + 6, 0);
        world.setBlock(i + 16, j + 12, k + 7, 0);
        world.setBlock(i + 16, j + 12, k + 8, 0);
        world.setBlock(i + 16, j + 12, k + 9, 0);
        world.setBlock(i + 16, j + 12, k + 10, 0);
        world.setBlock(i + 16, j + 12, k + 11, 0);
        world.setBlock(i + 16, j + 12, k + 12, 0);
        world.setBlock(i + 16, j + 12, k + 13, 0);
        world.setBlock(i + 16, j + 12, k + 14, 0);
        world.setBlock(i + 16, j + 12, k + 15, 0);
        world.setBlock(i + 16, j + 12, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 12, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 12, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 12, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 12, k + 20, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 16, j + 12, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 12, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 12, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 12, k + 26, 0);
        world.setBlock(i + 16, j + 13, k + 0, 0);
        world.setBlock(i + 16, j + 13, k + 1, 0);
        world.setBlock(i + 16, j + 13, k + 2, 0);
        world.setBlock(i + 16, j + 13, k + 3, 0);
        world.setBlock(i + 16, j + 13, k + 4, 0);
        world.setBlock(i + 16, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 13, k + 6, 0);
        world.setBlock(i + 16, j + 13, k + 7, 0);
        world.setBlock(i + 16, j + 13, k + 8, 0);
        world.setBlock(i + 16, j + 13, k + 9, 0);
        world.setBlock(i + 16, j + 13, k + 10, Block.glowStone.blockID);
        world.setBlock(i + 16, j + 13, k + 11, 0);
        world.setBlock(i + 16, j + 13, k + 12, 0);
        world.setBlock(i + 16, j + 13, k + 13, 0);
        world.setBlock(i + 16, j + 13, k + 14, 0);
        world.setBlock(i + 16, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 13, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 13, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 13, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 13, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 13, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 13, k + 26, 0);
        world.setBlock(i + 16, j + 14, k + 0, 0);
        world.setBlock(i + 16, j + 14, k + 1, 0);
        world.setBlock(i + 16, j + 14, k + 2, 0);
        world.setBlock(i + 16, j + 14, k + 3, 0);
        world.setBlock(i + 16, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 14, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 14, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 14, k + 26, 0);
        world.setBlock(i + 16, j + 15, k + 0, 0);
        world.setBlock(i + 16, j + 15, k + 1, 0);
        world.setBlock(i + 16, j + 15, k + 2, 0);
        world.setBlock(i + 16, j + 15, k + 3, 0);
        world.setBlock(i + 16, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 15, k + 5, 0);
        world.setBlock(i + 16, j + 15, k + 6, 0);
        world.setBlock(i + 16, j + 15, k + 7, 0);
        world.setBlock(i + 16, j + 15, k + 8, 0);
        world.setBlock(i + 16, j + 15, k + 9, 0);
        world.setBlock(i + 16, j + 15, k + 10, 0);
        world.setBlock(i + 16, j + 15, k + 11, 0);
        world.setBlock(i + 16, j + 15, k + 12, 0);
        world.setBlock(i + 16, j + 15, k + 13, 0);
        world.setBlock(i + 16, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 15, k + 22, 0);
        world.setBlock(i + 16, j + 15, k + 23, 0);
        world.setBlock(i + 16, j + 15, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 15, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 15, k + 26, 0);
        world.setBlock(i + 16, j + 16, k + 0, 0);
        world.setBlock(i + 16, j + 16, k + 1, 0);
        world.setBlock(i + 16, j + 16, k + 2, 0);
        world.setBlock(i + 16, j + 16, k + 3, 0);
        world.setBlock(i + 16, j + 16, k + 4, 0);
        world.setBlock(i + 16, j + 16, k + 5, 0);
        world.setBlock(i + 16, j + 16, k + 6, 0);
        world.setBlock(i + 16, j + 16, k + 7, 0);
        world.setBlock(i + 16, j + 16, k + 8, 0);
        world.setBlock(i + 16, j + 16, k + 9, 0);
        world.setBlock(i + 16, j + 16, k + 10, 0);
        world.setBlock(i + 16, j + 16, k + 11, 0);
        world.setBlock(i + 16, j + 16, k + 12, 0);
        world.setBlock(i + 16, j + 16, k + 13, 0);
        world.setBlock(i + 16, j + 16, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 16, k + 15, Block.jukebox.blockID, 1, 0);
        world.setBlock(i + 16, j + 16, k + 16, 0);
        world.setBlock(i + 16, j + 16, k + 17, 0);
        world.setBlock(i + 16, j + 16, k + 18, 0);
        world.setBlock(i + 16, j + 16, k + 19, 0);
        world.setBlock(i + 16, j + 16, k + 20, 0);
        world.setBlock(i + 16, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 16, k + 22, 0);
        world.setBlock(i + 16, j + 16, k + 23, 0);
        world.setBlock(i + 16, j + 16, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 16, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 16, k + 26, 0);
        world.setBlock(i + 16, j + 17, k + 0, 0);
        world.setBlock(i + 16, j + 17, k + 1, 0);
        world.setBlock(i + 16, j + 17, k + 2, 0);
        world.setBlock(i + 16, j + 17, k + 3, 0);
        world.setBlock(i + 16, j + 17, k + 4, 0);
        world.setBlock(i + 16, j + 17, k + 5, 0);
        world.setBlock(i + 16, j + 17, k + 6, 0);
        world.setBlock(i + 16, j + 17, k + 7, 0);
        world.setBlock(i + 16, j + 17, k + 8, 0);
        world.setBlock(i + 16, j + 17, k + 9, 0);
        world.setBlock(i + 16, j + 17, k + 10, 0);
        world.setBlock(i + 16, j + 17, k + 11, 0);
        world.setBlock(i + 16, j + 17, k + 12, 0);
        world.setBlock(i + 16, j + 17, k + 13, 0);
        world.setBlock(i + 16, j + 17, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 17, k + 15, 0);
        world.setBlock(i + 16, j + 17, k + 16, 0);
        world.setBlock(i + 16, j + 17, k + 17, 0);
        world.setBlock(i + 16, j + 17, k + 18, 0);
        world.setBlock(i + 16, j + 17, k + 19, 0);
        world.setBlock(i + 16, j + 17, k + 20, 0);
        world.setBlock(i + 16, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 17, k + 22, 0);
        world.setBlock(i + 16, j + 17, k + 23, 0);
        world.setBlock(i + 16, j + 17, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 17, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 16, j + 17, k + 26, 0);
        world.setBlock(i + 16, j + 18, k + 0, 0);
        world.setBlock(i + 16, j + 18, k + 1, 0);
        world.setBlock(i + 16, j + 18, k + 2, 0);
        world.setBlock(i + 16, j + 18, k + 3, 0);
        world.setBlock(i + 16, j + 18, k + 4, 0);
        world.setBlock(i + 16, j + 18, k + 5, 0);
        world.setBlock(i + 16, j + 18, k + 6, 0);
        world.setBlock(i + 16, j + 18, k + 7, 0);
        world.setBlock(i + 16, j + 18, k + 8, 0);
        world.setBlock(i + 16, j + 18, k + 9, 0);
        world.setBlock(i + 16, j + 18, k + 10, 0);
        world.setBlock(i + 16, j + 18, k + 11, 0);
        world.setBlock(i + 16, j + 18, k + 12, 0);
        world.setBlock(i + 16, j + 18, k + 13, 0);
        world.setBlock(i + 16, j + 18, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 18, k + 15, 0);
        world.setBlock(i + 16, j + 18, k + 16, 0);
        world.setBlock(i + 16, j + 18, k + 17, 0);
        world.setBlock(i + 16, j + 18, k + 18, 0);
        world.setBlock(i + 16, j + 18, k + 19, 0);
        world.setBlock(i + 16, j + 18, k + 20, 0);
        world.setBlock(i + 16, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 18, k + 22, 0);
        world.setBlock(i + 16, j + 18, k + 23, 0);
        world.setBlock(i + 16, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 18, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 18, k + 26, 0);
        world.setBlock(i + 16, j + 19, k + 0, 0);
        world.setBlock(i + 16, j + 19, k + 1, 0);
        world.setBlock(i + 16, j + 19, k + 2, 0);
        world.setBlock(i + 16, j + 19, k + 3, 0);
        world.setBlock(i + 16, j + 19, k + 4, 0);
        world.setBlock(i + 16, j + 19, k + 5, 0);
        world.setBlock(i + 16, j + 19, k + 6, 0);
        world.setBlock(i + 16, j + 19, k + 7, 0);
        world.setBlock(i + 16, j + 19, k + 8, 0);
        world.setBlock(i + 16, j + 19, k + 9, 0);
        world.setBlock(i + 16, j + 19, k + 10, 0);
        world.setBlock(i + 16, j + 19, k + 11, 0);
        world.setBlock(i + 16, j + 19, k + 12, 0);
        world.setBlock(i + 16, j + 19, k + 13, 0);
        world.setBlock(i + 16, j + 19, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 19, k + 15, 0);
        world.setBlock(i + 16, j + 19, k + 16, 0);
        world.setBlock(i + 16, j + 19, k + 17, 0);
        world.setBlock(i + 16, j + 19, k + 18, 0);
        world.setBlock(i + 16, j + 19, k + 19, 0);
        world.setBlock(i + 16, j + 19, k + 20, 0);
        world.setBlock(i + 16, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 19, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 19, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 19, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 19, k + 26, 0);
        world.setBlock(i + 16, j + 20, k + 0, 0);
        world.setBlock(i + 16, j + 20, k + 1, 0);
        world.setBlock(i + 16, j + 20, k + 2, 0);
        world.setBlock(i + 16, j + 20, k + 3, 0);
        world.setBlock(i + 16, j + 20, k + 4, 0);
        world.setBlock(i + 16, j + 20, k + 5, 0);
        world.setBlock(i + 16, j + 20, k + 6, 0);
        world.setBlock(i + 16, j + 20, k + 7, 0);
        world.setBlock(i + 16, j + 20, k + 8, 0);
        world.setBlock(i + 16, j + 20, k + 9, 0);
        world.setBlock(i + 16, j + 20, k + 10, 0);
        world.setBlock(i + 16, j + 20, k + 11, 0);
        world.setBlock(i + 16, j + 20, k + 12, 0);
        world.setBlock(i + 16, j + 20, k + 13, 0);
        world.setBlock(i + 16, j + 20, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 20, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 20, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 20, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 20, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 20, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 20, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 20, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 20, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 20, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 20, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 20, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 20, k + 26, 0);
        world.setBlock(i + 16, j + 21, k + 0, 0);
        world.setBlock(i + 16, j + 21, k + 1, 0);
        world.setBlock(i + 16, j + 21, k + 2, 0);
        world.setBlock(i + 16, j + 21, k + 3, 0);
        world.setBlock(i + 16, j + 21, k + 4, 0);
        world.setBlock(i + 16, j + 21, k + 5, 0);
        world.setBlock(i + 16, j + 21, k + 6, 0);
        world.setBlock(i + 16, j + 21, k + 7, 0);
        world.setBlock(i + 16, j + 21, k + 8, 0);
        world.setBlock(i + 16, j + 21, k + 9, 0);
        world.setBlock(i + 16, j + 21, k + 10, 0);
        world.setBlock(i + 16, j + 21, k + 11, 0);
        world.setBlock(i + 16, j + 21, k + 12, 0);
        world.setBlock(i + 16, j + 21, k + 13, 0);
        world.setBlock(i + 16, j + 21, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 21, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 21, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 21, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 21, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 21, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 21, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 21, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 21, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 21, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 21, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 21, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 16, j + 21, k + 26, 0);
        world.setBlock(i + 16, j + 22, k + 0, 0);
        world.setBlock(i + 16, j + 22, k + 1, 0);
        world.setBlock(i + 16, j + 22, k + 2, 0);
        world.setBlock(i + 16, j + 22, k + 3, 0);
        world.setBlock(i + 16, j + 22, k + 4, 0);
        world.setBlock(i + 16, j + 22, k + 5, 0);
        world.setBlock(i + 16, j + 22, k + 6, 0);
        world.setBlock(i + 16, j + 22, k + 7, 0);
        world.setBlock(i + 16, j + 22, k + 8, 0);
        world.setBlock(i + 16, j + 22, k + 9, 0);
        world.setBlock(i + 16, j + 22, k + 10, 0);
        world.setBlock(i + 16, j + 22, k + 11, 0);
        world.setBlock(i + 16, j + 22, k + 12, 0);
        world.setBlock(i + 16, j + 22, k + 13, 0);
        world.setBlock(i + 16, j + 22, k + 14, 0);
        world.setBlock(i + 16, j + 22, k + 15, 0);
        world.setBlock(i + 16, j + 22, k + 16, 0);
        world.setBlock(i + 16, j + 22, k + 17, 0);
        world.setBlock(i + 16, j + 22, k + 18, 0);
        world.setBlock(i + 16, j + 22, k + 19, 0);
        world.setBlock(i + 16, j + 22, k + 20, 0);
        world.setBlock(i + 16, j + 22, k + 21, 0);
        world.setBlock(i + 16, j + 22, k + 22, 0);
        world.setBlock(i + 16, j + 22, k + 23, 0);
        world.setBlock(i + 16, j + 22, k + 24, 0);
        world.setBlock(i + 16, j + 22, k + 25, 0);
        world.setBlock(i + 16, j + 22, k + 26, 0);
        world.setBlock(i + 16, j + 23, k + 0, 0);
        world.setBlock(i + 16, j + 23, k + 1, 0);
        world.setBlock(i + 16, j + 23, k + 2, 0);
        world.setBlock(i + 16, j + 23, k + 3, 0);
        world.setBlock(i + 16, j + 23, k + 4, 0);
        world.setBlock(i + 16, j + 23, k + 5, 0);
        world.setBlock(i + 16, j + 23, k + 6, 0);
        world.setBlock(i + 16, j + 23, k + 7, 0);
        world.setBlock(i + 16, j + 23, k + 8, 0);
        world.setBlock(i + 16, j + 23, k + 9, 0);
        world.setBlock(i + 16, j + 23, k + 10, 0);
        world.setBlock(i + 16, j + 23, k + 11, 0);
        world.setBlock(i + 16, j + 23, k + 12, 0);
        world.setBlock(i + 16, j + 23, k + 13, 0);
        world.setBlock(i + 16, j + 23, k + 14, 0);
        world.setBlock(i + 16, j + 23, k + 15, 0);
        world.setBlock(i + 16, j + 23, k + 16, 0);
        world.setBlock(i + 16, j + 23, k + 17, 0);
        world.setBlock(i + 16, j + 23, k + 18, 0);
        world.setBlock(i + 16, j + 23, k + 19, 0);
        world.setBlock(i + 16, j + 23, k + 20, 0);
        world.setBlock(i + 16, j + 23, k + 21, 0);
        world.setBlock(i + 16, j + 23, k + 22, 0);
        world.setBlock(i + 16, j + 23, k + 23, 0);
        world.setBlock(i + 16, j + 23, k + 24, 0);
        world.setBlock(i + 16, j + 23, k + 25, 0);
        world.setBlock(i + 16, j + 23, k + 26, 0);
        world.setBlock(i + 16, j + 24, k + 0, 0);
        world.setBlock(i + 16, j + 24, k + 1, 0);
        world.setBlock(i + 16, j + 24, k + 2, 0);
        world.setBlock(i + 16, j + 24, k + 3, 0);
        world.setBlock(i + 16, j + 24, k + 4, 0);
        world.setBlock(i + 16, j + 24, k + 5, 0);
        world.setBlock(i + 16, j + 24, k + 6, 0);
        world.setBlock(i + 16, j + 24, k + 7, 0);
        world.setBlock(i + 16, j + 24, k + 8, 0);
        world.setBlock(i + 16, j + 24, k + 9, 0);
        world.setBlock(i + 16, j + 24, k + 10, 0);
        world.setBlock(i + 16, j + 24, k + 11, 0);
        world.setBlock(i + 16, j + 24, k + 12, 0);
        world.setBlock(i + 16, j + 24, k + 13, 0);
        world.setBlock(i + 16, j + 24, k + 14, 0);
        world.setBlock(i + 16, j + 24, k + 15, 0);
        world.setBlock(i + 16, j + 24, k + 16, 0);
        world.setBlock(i + 16, j + 24, k + 17, 0);
        world.setBlock(i + 16, j + 24, k + 18, 0);
        world.setBlock(i + 16, j + 24, k + 19, 0);
        world.setBlock(i + 16, j + 24, k + 20, 0);
        world.setBlock(i + 16, j + 24, k + 21, 0);
        world.setBlock(i + 16, j + 24, k + 22, 0);
        world.setBlock(i + 16, j + 24, k + 23, 0);
        world.setBlock(i + 16, j + 24, k + 24, 0);
        world.setBlock(i + 16, j + 24, k + 25, 0);
        world.setBlock(i + 16, j + 24, k + 26, 0);
        world.setBlock(i + 16, j + 25, k + 0, 0);
        world.setBlock(i + 16, j + 25, k + 1, 0);
        world.setBlock(i + 16, j + 25, k + 2, 0);
        world.setBlock(i + 16, j + 25, k + 3, 0);
        world.setBlock(i + 16, j + 25, k + 4, 0);
        world.setBlock(i + 16, j + 25, k + 5, 0);
        world.setBlock(i + 16, j + 25, k + 6, 0);
        world.setBlock(i + 16, j + 25, k + 7, 0);
        world.setBlock(i + 16, j + 25, k + 8, 0);
        world.setBlock(i + 16, j + 25, k + 9, 0);
        world.setBlock(i + 16, j + 25, k + 10, 0);
        world.setBlock(i + 16, j + 25, k + 11, 0);
        world.setBlock(i + 16, j + 25, k + 12, 0);
        world.setBlock(i + 16, j + 25, k + 13, 0);
        world.setBlock(i + 16, j + 25, k + 14, 0);
        world.setBlock(i + 16, j + 25, k + 15, 0);
        world.setBlock(i + 16, j + 25, k + 16, 0);
        world.setBlock(i + 16, j + 25, k + 17, 0);
        world.setBlock(i + 16, j + 25, k + 18, 0);
        world.setBlock(i + 16, j + 25, k + 19, 0);
        world.setBlock(i + 16, j + 25, k + 20, 0);
        world.setBlock(i + 16, j + 25, k + 21, 0);
        world.setBlock(i + 16, j + 25, k + 22, 0);
        world.setBlock(i + 16, j + 25, k + 23, 0);
        world.setBlock(i + 16, j + 25, k + 24, 0);
        world.setBlock(i + 16, j + 25, k + 25, 0);
        world.setBlock(i + 16, j + 25, k + 26, 0);
        world.setBlock(i + 17, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 17, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 17, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 17, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 17, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 17, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 17, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 17, j + 2, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 2, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 2, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 2, k + 8, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 17, j + 2, k + 9, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 17, j + 2, k + 10, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 17, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 17, j + 2, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 17, j + 2, k + 13, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 17, j + 2, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 2, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 2, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 2, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 2, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 2, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 2, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 2, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 17, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 17, j + 3, k + 0, 0);
        world.setBlock(i + 17, j + 3, k + 3, 0);
        world.setBlock(i + 17, j + 3, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 3, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 3, k + 7, 0);
        world.setBlock(i + 17, j + 3, k + 8, 0);
        world.setBlock(i + 17, j + 3, k + 9, 0);
        world.setBlock(i + 17, j + 3, k + 10, 0);
        world.setBlock(i + 17, j + 3, k + 11, 0);
        world.setBlock(i + 17, j + 3, k + 12, 0);
        world.setBlock(i + 17, j + 3, k + 13, 0);
        world.setBlock(i + 17, j + 3, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 3, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 3, k + 16, 0);
        world.setBlock(i + 17, j + 3, k + 17, 0);
        world.setBlock(i + 17, j + 3, k + 18, 0);
        world.setBlock(i + 17, j + 3, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 3, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 3, k + 21, 0);
        world.setBlock(i + 17, j + 3, k + 22, 0);
        world.setBlock(i + 17, j + 3, k + 23, Block.chest.blockID, 2, 0);
        world.setBlock(i + 17, j + 3, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 3, k + 26, 0);
        world.setBlock(i + 17, j + 4, k + 0, 0);
        world.setBlock(i + 17, j + 4, k + 1, 0);
        world.setBlock(i + 17, j + 4, k + 2, 0);
        world.setBlock(i + 17, j + 4, k + 3, 0);
        world.setBlock(i + 17, j + 4, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 4, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 4, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 4, k + 7, 0);
        world.setBlock(i + 17, j + 4, k + 8, 0);
        world.setBlock(i + 17, j + 4, k + 9, 0);
        world.setBlock(i + 17, j + 4, k + 10, 0);
        world.setBlock(i + 17, j + 4, k + 11, 0);
        world.setBlock(i + 17, j + 4, k + 12, 0);
        world.setBlock(i + 17, j + 4, k + 13, 0);
        world.setBlock(i + 17, j + 4, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 4, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 4, k + 16, 0);
        world.setBlock(i + 17, j + 4, k + 17, 0);
        world.setBlock(i + 17, j + 4, k + 18, 0);
        world.setBlock(i + 17, j + 4, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 4, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 4, k + 21, 0);
        world.setBlock(i + 17, j + 4, k + 22, 0);
        world.setBlock(i + 17, j + 4, k + 23, Block.chest.blockID, 2, 0);
        world.setBlock(i + 17, j + 4, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 4, k + 25, 0);
        world.setBlock(i + 17, j + 4, k + 26, 0);
        world.setBlock(i + 17, j + 5, k + 0, 0);
        world.setBlock(i + 17, j + 5, k + 1, 0);
        world.setBlock(i + 17, j + 5, k + 2, 0);
        world.setBlock(i + 17, j + 5, k + 3, 0);
        world.setBlock(i + 17, j + 5, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 5, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 5, k + 7, 0);
        world.setBlock(i + 17, j + 5, k + 8, 0);
        world.setBlock(i + 17, j + 5, k + 9, 0);
        world.setBlock(i + 17, j + 5, k + 10, 0);
        world.setBlock(i + 17, j + 5, k + 11, 0);
        world.setBlock(i + 17, j + 5, k + 12, 0);
        world.setBlock(i + 17, j + 5, k + 13, 0);
        world.setBlock(i + 17, j + 5, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 5, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 5, k + 16, 0);
        world.setBlock(i + 17, j + 5, k + 17, 0);
        world.setBlock(i + 17, j + 5, k + 18, 0);
        world.setBlock(i + 17, j + 5, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 5, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 5, k + 21, 0);
        world.setBlock(i + 17, j + 5, k + 22, 0);
        world.setBlock(i + 17, j + 5, k + 23, 0);
        world.setBlock(i + 17, j + 5, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 5, k + 25, 0);
        world.setBlock(i + 17, j + 5, k + 26, 0);
        world.setBlock(i + 17, j + 6, k + 0, 0);
        world.setBlock(i + 17, j + 6, k + 1, 0);
        world.setBlock(i + 17, j + 6, k + 2, 0);
        world.setBlock(i + 17, j + 6, k + 3, 0);
        world.setBlock(i + 17, j + 6, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 6, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 6, k + 7, Block.glowStone.blockID);
        world.setBlock(i + 17, j + 6, k + 8, 0);
        world.setBlock(i + 17, j + 6, k + 9, 0);
        world.setBlock(i + 17, j + 6, k + 10, 0);
        world.setBlock(i + 17, j + 6, k + 11, 0);
        world.setBlock(i + 17, j + 6, k + 12, 0);
        world.setBlock(i + 17, j + 6, k + 13, 0);
        world.setBlock(i + 17, j + 6, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 6, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 6, k + 16, 0);
        world.setBlock(i + 17, j + 6, k + 17, 0);
        world.setBlock(i + 17, j + 6, k + 18, 0);
        world.setBlock(i + 17, j + 6, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 6, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 6, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 6, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 6, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 6, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 6, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 6, k + 26, 0);
        world.setBlock(i + 17, j + 7, k + 0, 0);
        world.setBlock(i + 17, j + 7, k + 1, 0);
        generate9(world, rand, i, j, k);
        return true;
    }

    public boolean generate9(World world, Random rand, int i, int j, int k)
    {
        world.setBlock(i + 17, j + 7, k + 2, 0);
        world.setBlock(i + 17, j + 7, k + 3, 0);
        world.setBlock(i + 17, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 7, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 7, k + 7, Block.fence.blockID);
        world.setBlock(i + 17, j + 7, k + 8, 0);
        world.setBlock(i + 17, j + 7, k + 9, 0);
        world.setBlock(i + 17, j + 7, k + 10, 0);
        world.setBlock(i + 17, j + 7, k + 11, 0);
        world.setBlock(i + 17, j + 7, k + 12, 0);
        world.setBlock(i + 17, j + 7, k + 13, 0);
        world.setBlock(i + 17, j + 7, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 7, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 7, k + 16, Block.web.blockID);
        world.setBlock(i + 17, j + 7, k + 17, 0);
        world.setBlock(i + 17, j + 7, k + 18, 0);
        world.setBlock(i + 17, j + 7, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 7, k + 20, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 17, j + 7, k + 21, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 17, j + 7, k + 22, 0);
        world.setBlock(i + 17, j + 7, k + 23, 0);
        world.setBlock(i + 17, j + 7, k + 24, 0);
        world.setBlock(i + 17, j + 7, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 7, k + 26, 0);
        world.setBlock(i + 17, j + 8, k + 0, 0);
        world.setBlock(i + 17, j + 8, k + 1, 0);
        world.setBlock(i + 17, j + 8, k + 2, 0);
        world.setBlock(i + 17, j + 8, k + 3, 0);
        world.setBlock(i + 17, j + 8, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 8, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 8, k + 7, 0);
        world.setBlock(i + 17, j + 8, k + 8, 0);
        world.setBlock(i + 17, j + 8, k + 9, 0);
        world.setBlock(i + 17, j + 8, k + 10, 0);
        world.setBlock(i + 17, j + 8, k + 11, 0);
        world.setBlock(i + 17, j + 8, k + 12, 0);
        world.setBlock(i + 17, j + 8, k + 13, 0);
        world.setBlock(i + 17, j + 8, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 8, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 8, k + 16, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 8, k + 17, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 8, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 8, k + 19, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 17, j + 8, k + 20, 0);
        world.setBlock(i + 17, j + 8, k + 21, 0);
        world.setBlock(i + 17, j + 8, k + 22, 0);
        world.setBlock(i + 17, j + 8, k + 23, 0);
        world.setBlock(i + 17, j + 8, k + 24, 0);
        world.setBlock(i + 17, j + 8, k + 25, Block.thinGlass.blockID);
        world.setBlock(i + 17, j + 8, k + 26, 0);
        world.setBlock(i + 17, j + 9, k + 0, 0);
        world.setBlock(i + 17, j + 9, k + 1, 0);
        world.setBlock(i + 17, j + 9, k + 2, 0);
        world.setBlock(i + 17, j + 9, k + 3, 0);
        world.setBlock(i + 17, j + 9, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 9, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 9, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 9, k + 7, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 9, k + 8, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 9, k + 9, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 9, k + 10, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 9, k + 11, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 9, k + 12, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 9, k + 13, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 9, k + 17, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 17, j + 9, k + 18, 0);
        world.setBlock(i + 17, j + 9, k + 19, 0);
        world.setBlock(i + 17, j + 9, k + 20, 0);
        world.setBlock(i + 17, j + 9, k + 21, 0);
        world.setBlock(i + 17, j + 9, k + 22, 0);
        world.setBlock(i + 17, j + 9, k + 23, 0);
        world.setBlock(i + 17, j + 9, k + 24, 0);
        world.setBlock(i + 17, j + 9, k + 25, Block.thinGlass.blockID);
        world.setBlock(i + 17, j + 9, k + 26, 0);
        world.setBlock(i + 17, j + 10, k + 0, 0);
        world.setBlock(i + 17, j + 10, k + 1, 0);
        world.setBlock(i + 17, j + 10, k + 2, 0);
        world.setBlock(i + 17, j + 10, k + 3, 0);
        world.setBlock(i + 17, j + 10, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 10, k + 6, 0);
        world.setBlock(i + 17, j + 10, k + 7, 0);
        world.setBlock(i + 17, j + 10, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 10, k + 9, 0);
        world.setBlock(i + 17, j + 10, k + 10, 0);
        world.setBlock(i + 17, j + 10, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 10, k + 12, 0);
        world.setBlock(i + 17, j + 10, k + 13, 0);
        world.setBlock(i + 17, j + 10, k + 14, 0);
        world.setBlock(i + 17, j + 10, k + 15, 0);
        world.setBlock(i + 17, j + 10, k + 16, 0);
        world.setBlock(i + 17, j + 10, k + 17, 0);
        world.setBlock(i + 17, j + 10, k + 18, 0);
        world.setBlock(i + 17, j + 10, k + 19, 0);
        world.setBlock(i + 17, j + 10, k + 20, 0);
        world.setBlock(i + 17, j + 10, k + 21, 0);
        world.setBlock(i + 17, j + 10, k + 22, 0);
        world.setBlock(i + 17, j + 10, k + 23, 0);
        world.setBlock(i + 17, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 10, k + 26, 0);
        world.setBlock(i + 17, j + 11, k + 0, 0);
        world.setBlock(i + 17, j + 11, k + 1, 0);
        world.setBlock(i + 17, j + 11, k + 2, 0);
        world.setBlock(i + 17, j + 11, k + 3, 0);
        world.setBlock(i + 17, j + 11, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 11, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 11, k + 6, 0);
        world.setBlock(i + 17, j + 11, k + 7, 0);
        world.setBlock(i + 17, j + 11, k + 8, 0);
        world.setBlock(i + 17, j + 11, k + 9, 0);
        world.setBlock(i + 17, j + 11, k + 10, 0);
        world.setBlock(i + 17, j + 11, k + 11, 0);
        world.setBlock(i + 17, j + 11, k + 12, 0);
        world.setBlock(i + 17, j + 11, k + 13, 0);
        world.setBlock(i + 17, j + 11, k + 14, 0);
        world.setBlock(i + 17, j + 11, k + 15, 0);
        world.setBlock(i + 17, j + 11, k + 16, 0);
        world.setBlock(i + 17, j + 11, k + 17, 0);
        world.setBlock(i + 17, j + 11, k + 18, 0);
        world.setBlock(i + 17, j + 11, k + 19, 0);
        world.setBlock(i + 17, j + 11, k + 20, 0);
        world.setBlock(i + 17, j + 11, k + 21, 0);
        world.setBlock(i + 17, j + 11, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 11, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 11, k + 26, 0);
        world.setBlock(i + 17, j + 12, k + 0, 0);
        world.setBlock(i + 17, j + 12, k + 1, 0);
        world.setBlock(i + 17, j + 12, k + 2, 0);
        world.setBlock(i + 17, j + 12, k + 3, 0);
        world.setBlock(i + 17, j + 12, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 12, k + 5, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 17, j + 12, k + 6, 0);
        world.setBlock(i + 17, j + 12, k + 7, 0);
        world.setBlock(i + 17, j + 12, k + 8, 0);
        world.setBlock(i + 17, j + 12, k + 9, 0);
        world.setBlock(i + 17, j + 12, k + 10, 0);
        world.setBlock(i + 17, j + 12, k + 11, 0);
        world.setBlock(i + 17, j + 12, k + 12, 0);
        world.setBlock(i + 17, j + 12, k + 13, 0);
        world.setBlock(i + 17, j + 12, k + 14, 0);
        world.setBlock(i + 17, j + 12, k + 15, 0);
        world.setBlock(i + 17, j + 12, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 12, k + 17, 0);
        world.setBlock(i + 17, j + 12, k + 18, 0);
        world.setBlock(i + 17, j + 12, k + 19, 0);
        world.setBlock(i + 17, j + 12, k + 20, 0);
        world.setBlock(i + 17, j + 12, k + 21, 0);
        world.setBlock(i + 17, j + 12, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 17, j + 12, k + 26, 0);
        world.setBlock(i + 17, j + 13, k + 0, 0);
        world.setBlock(i + 17, j + 13, k + 1, 0);
        world.setBlock(i + 17, j + 13, k + 2, 0);
        world.setBlock(i + 17, j + 13, k + 3, 0);
        world.setBlock(i + 17, j + 13, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 6, 0);
        world.setBlock(i + 17, j + 13, k + 7, 0);
        world.setBlock(i + 17, j + 13, k + 8, 0);
        world.setBlock(i + 17, j + 13, k + 9, 0);
        world.setBlock(i + 17, j + 13, k + 10, 0);
        world.setBlock(i + 17, j + 13, k + 11, 0);
        world.setBlock(i + 17, j + 13, k + 12, 0);
        world.setBlock(i + 17, j + 13, k + 13, 0);
        world.setBlock(i + 17, j + 13, k + 14, 0);
        world.setBlock(i + 17, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 13, k + 26, 0);
        world.setBlock(i + 17, j + 14, k + 0, 0);
        world.setBlock(i + 17, j + 14, k + 1, 0);
        world.setBlock(i + 17, j + 14, k + 2, 0);
        world.setBlock(i + 17, j + 14, k + 3, 0);
        world.setBlock(i + 17, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 22, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 17, j + 14, k + 23, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 17, j + 14, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 14, k + 26, 0);
        world.setBlock(i + 17, j + 15, k + 0, 0);
        world.setBlock(i + 17, j + 15, k + 1, 0);
        world.setBlock(i + 17, j + 15, k + 2, 0);
        world.setBlock(i + 17, j + 15, k + 3, 0);
        world.setBlock(i + 17, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 15, k + 5, 0);
        world.setBlock(i + 17, j + 15, k + 6, 0);
        world.setBlock(i + 17, j + 15, k + 7, 0);
        world.setBlock(i + 17, j + 15, k + 8, 0);
        world.setBlock(i + 17, j + 15, k + 9, 0);
        world.setBlock(i + 17, j + 15, k + 10, 0);
        world.setBlock(i + 17, j + 15, k + 11, 0);
        world.setBlock(i + 17, j + 15, k + 12, 0);
        world.setBlock(i + 17, j + 15, k + 13, 0);
        world.setBlock(i + 17, j + 15, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 15, k + 22, 0);
        world.setBlock(i + 17, j + 15, k + 23, 0);
        world.setBlock(i + 17, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 15, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 15, k + 26, 0);
        world.setBlock(i + 17, j + 16, k + 0, 0);
        world.setBlock(i + 17, j + 16, k + 1, 0);
        world.setBlock(i + 17, j + 16, k + 2, 0);
        world.setBlock(i + 17, j + 16, k + 3, 0);
        world.setBlock(i + 17, j + 16, k + 4, 0);
        world.setBlock(i + 17, j + 16, k + 5, 0);
        world.setBlock(i + 17, j + 16, k + 6, 0);
        world.setBlock(i + 17, j + 16, k + 7, 0);
        world.setBlock(i + 17, j + 16, k + 8, 0);
        world.setBlock(i + 17, j + 16, k + 9, 0);
        world.setBlock(i + 17, j + 16, k + 10, 0);
        world.setBlock(i + 17, j + 16, k + 11, 0);
        world.setBlock(i + 17, j + 16, k + 12, 0);
        world.setBlock(i + 17, j + 16, k + 13, 0);
        world.setBlock(i + 17, j + 16, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 16, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 16, k + 16, 0);
        world.setBlock(i + 17, j + 16, k + 17, 0);
        world.setBlock(i + 17, j + 16, k + 18, 0);
        world.setBlock(i + 17, j + 16, k + 19, Block.bed.blockID);
        world.setBlock(i + 17, j + 16, k + 20, Block.bed.blockID, 8, 0);
        world.setBlock(i + 17, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 16, k + 22, 0);
        world.setBlock(i + 17, j + 16, k + 23, 0);
        world.setBlock(i + 17, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 16, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 16, k + 26, 0);
        world.setBlock(i + 17, j + 17, k + 0, 0);
        world.setBlock(i + 17, j + 17, k + 1, 0);
        world.setBlock(i + 17, j + 17, k + 2, 0);
        world.setBlock(i + 17, j + 17, k + 3, 0);
        world.setBlock(i + 17, j + 17, k + 4, 0);
        world.setBlock(i + 17, j + 17, k + 5, 0);
        world.setBlock(i + 17, j + 17, k + 6, 0);
        world.setBlock(i + 17, j + 17, k + 7, 0);
        world.setBlock(i + 17, j + 17, k + 8, 0);
        world.setBlock(i + 17, j + 17, k + 9, 0);
        world.setBlock(i + 17, j + 17, k + 10, 0);
        world.setBlock(i + 17, j + 17, k + 11, 0);
        world.setBlock(i + 17, j + 17, k + 12, 0);
        world.setBlock(i + 17, j + 17, k + 13, 0);
        world.setBlock(i + 17, j + 17, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 17, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 17, k + 16, 0);
        world.setBlock(i + 17, j + 17, k + 17, 0);
        world.setBlock(i + 17, j + 17, k + 18, 0);
        world.setBlock(i + 17, j + 17, k + 19, 0);
        world.setBlock(i + 17, j + 17, k + 20, 0);
        world.setBlock(i + 17, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 17, k + 22, 0);
        world.setBlock(i + 17, j + 17, k + 23, 0);
        world.setBlock(i + 17, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 17, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 17, k + 26, 0);
        world.setBlock(i + 17, j + 18, k + 0, 0);
        world.setBlock(i + 17, j + 18, k + 1, 0);
        world.setBlock(i + 17, j + 18, k + 2, 0);
        world.setBlock(i + 17, j + 18, k + 3, 0);
        world.setBlock(i + 17, j + 18, k + 4, 0);
        world.setBlock(i + 17, j + 18, k + 5, 0);
        world.setBlock(i + 17, j + 18, k + 6, 0);
        world.setBlock(i + 17, j + 18, k + 7, 0);
        world.setBlock(i + 17, j + 18, k + 8, 0);
        world.setBlock(i + 17, j + 18, k + 9, 0);
        world.setBlock(i + 17, j + 18, k + 10, 0);
        world.setBlock(i + 17, j + 18, k + 11, 0);
        world.setBlock(i + 17, j + 18, k + 12, 0);
        world.setBlock(i + 17, j + 18, k + 13, 0);
        world.setBlock(i + 17, j + 18, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 18, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 18, k + 16, 0);
        world.setBlock(i + 17, j + 18, k + 17, 0);
        world.setBlock(i + 17, j + 18, k + 18, 0);
        world.setBlock(i + 17, j + 18, k + 19, 0);
        world.setBlock(i + 17, j + 18, k + 20, 0);
        world.setBlock(i + 17, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 18, k + 22, 0);
        world.setBlock(i + 17, j + 18, k + 23, 0);
        world.setBlock(i + 17, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 18, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 18, k + 26, 0);
        world.setBlock(i + 17, j + 19, k + 0, 0);
        world.setBlock(i + 17, j + 19, k + 1, 0);
        world.setBlock(i + 17, j + 19, k + 2, 0);
        world.setBlock(i + 17, j + 19, k + 3, 0);
        world.setBlock(i + 17, j + 19, k + 4, 0);
        world.setBlock(i + 17, j + 19, k + 5, 0);
        world.setBlock(i + 17, j + 19, k + 6, 0);
        world.setBlock(i + 17, j + 19, k + 7, 0);
        world.setBlock(i + 17, j + 19, k + 8, 0);
        world.setBlock(i + 17, j + 19, k + 9, 0);
        world.setBlock(i + 17, j + 19, k + 10, 0);
        world.setBlock(i + 17, j + 19, k + 11, 0);
        world.setBlock(i + 17, j + 19, k + 12, 0);
        world.setBlock(i + 17, j + 19, k + 13, 0);
        world.setBlock(i + 17, j + 19, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 19, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 19, k + 16, Block.glowStone.blockID);
        world.setBlock(i + 17, j + 19, k + 17, 0);
        world.setBlock(i + 17, j + 19, k + 18, 0);
        world.setBlock(i + 17, j + 19, k + 19, 0);
        world.setBlock(i + 17, j + 19, k + 20, 0);
        world.setBlock(i + 17, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 19, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 19, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 19, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 19, k + 26, 0);
        world.setBlock(i + 17, j + 20, k + 0, 0);
        world.setBlock(i + 17, j + 20, k + 1, 0);
        world.setBlock(i + 17, j + 20, k + 2, 0);
        world.setBlock(i + 17, j + 20, k + 3, 0);
        world.setBlock(i + 17, j + 20, k + 4, 0);
        world.setBlock(i + 17, j + 20, k + 5, 0);
        world.setBlock(i + 17, j + 20, k + 6, 0);
        world.setBlock(i + 17, j + 20, k + 7, 0);
        world.setBlock(i + 17, j + 20, k + 8, 0);
        world.setBlock(i + 17, j + 20, k + 9, 0);
        world.setBlock(i + 17, j + 20, k + 10, 0);
        world.setBlock(i + 17, j + 20, k + 11, 0);
        world.setBlock(i + 17, j + 20, k + 12, 0);
        world.setBlock(i + 17, j + 20, k + 13, 0);
        world.setBlock(i + 17, j + 20, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 20, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 20, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 20, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 20, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 20, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 20, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 20, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 20, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 20, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 20, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 20, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 17, j + 20, k + 26, 0);
        world.setBlock(i + 17, j + 21, k + 0, 0);
        world.setBlock(i + 17, j + 21, k + 1, 0);
        world.setBlock(i + 17, j + 21, k + 2, 0);
        world.setBlock(i + 17, j + 21, k + 3, 0);
        world.setBlock(i + 17, j + 21, k + 4, 0);
        world.setBlock(i + 17, j + 21, k + 5, 0);
        world.setBlock(i + 17, j + 21, k + 6, 0);
        world.setBlock(i + 17, j + 21, k + 7, 0);
        world.setBlock(i + 17, j + 21, k + 8, 0);
        world.setBlock(i + 17, j + 21, k + 9, 0);
        world.setBlock(i + 17, j + 21, k + 10, 0);
        world.setBlock(i + 17, j + 21, k + 11, 0);
        world.setBlock(i + 17, j + 21, k + 12, 0);
        world.setBlock(i + 17, j + 21, k + 13, 0);
        world.setBlock(i + 17, j + 21, k + 14, 0);
        world.setBlock(i + 17, j + 21, k + 15, 0);
        world.setBlock(i + 17, j + 21, k + 16, 0);
        world.setBlock(i + 17, j + 21, k + 17, 0);
        world.setBlock(i + 17, j + 21, k + 18, 0);
        world.setBlock(i + 17, j + 21, k + 19, 0);
        world.setBlock(i + 17, j + 21, k + 20, 0);
        world.setBlock(i + 17, j + 21, k + 21, 0);
        world.setBlock(i + 17, j + 21, k + 22, 0);
        world.setBlock(i + 17, j + 21, k + 23, 0);
        world.setBlock(i + 17, j + 21, k + 24, 0);
        world.setBlock(i + 17, j + 21, k + 25, 0);
        world.setBlock(i + 17, j + 21, k + 26, 0);
        world.setBlock(i + 17, j + 22, k + 0, 0);
        world.setBlock(i + 17, j + 22, k + 1, 0);
        world.setBlock(i + 17, j + 22, k + 2, 0);
        world.setBlock(i + 17, j + 22, k + 3, 0);
        world.setBlock(i + 17, j + 22, k + 4, 0);
        world.setBlock(i + 17, j + 22, k + 5, 0);
        world.setBlock(i + 17, j + 22, k + 6, 0);
        world.setBlock(i + 17, j + 22, k + 7, 0);
        world.setBlock(i + 17, j + 22, k + 8, 0);
        world.setBlock(i + 17, j + 22, k + 9, 0);
        world.setBlock(i + 17, j + 22, k + 10, 0);
        world.setBlock(i + 17, j + 22, k + 11, 0);
        world.setBlock(i + 17, j + 22, k + 12, 0);
        world.setBlock(i + 17, j + 22, k + 13, 0);
        world.setBlock(i + 17, j + 22, k + 14, 0);
        world.setBlock(i + 17, j + 22, k + 15, 0);
        world.setBlock(i + 17, j + 22, k + 16, 0);
        world.setBlock(i + 17, j + 22, k + 17, 0);
        world.setBlock(i + 17, j + 22, k + 18, 0);
        world.setBlock(i + 17, j + 22, k + 19, 0);
        world.setBlock(i + 17, j + 22, k + 20, 0);
        world.setBlock(i + 17, j + 22, k + 21, 0);
        world.setBlock(i + 17, j + 22, k + 22, 0);
        world.setBlock(i + 17, j + 22, k + 23, 0);
        world.setBlock(i + 17, j + 22, k + 24, 0);
        world.setBlock(i + 17, j + 22, k + 25, 0);
        world.setBlock(i + 17, j + 22, k + 26, 0);
        world.setBlock(i + 17, j + 23, k + 0, 0);
        world.setBlock(i + 17, j + 23, k + 1, 0);
        world.setBlock(i + 17, j + 23, k + 2, 0);
        world.setBlock(i + 17, j + 23, k + 3, 0);
        world.setBlock(i + 17, j + 23, k + 4, 0);
        world.setBlock(i + 17, j + 23, k + 5, 0);
        world.setBlock(i + 17, j + 23, k + 6, 0);
        world.setBlock(i + 17, j + 23, k + 7, 0);
        world.setBlock(i + 17, j + 23, k + 8, 0);
        world.setBlock(i + 17, j + 23, k + 9, 0);
        world.setBlock(i + 17, j + 23, k + 10, 0);
        world.setBlock(i + 17, j + 23, k + 11, 0);
        world.setBlock(i + 17, j + 23, k + 12, 0);
        world.setBlock(i + 17, j + 23, k + 13, 0);
        world.setBlock(i + 17, j + 23, k + 14, 0);
        world.setBlock(i + 17, j + 23, k + 15, 0);
        world.setBlock(i + 17, j + 23, k + 16, 0);
        world.setBlock(i + 17, j + 23, k + 17, 0);
        world.setBlock(i + 17, j + 23, k + 18, 0);
        world.setBlock(i + 17, j + 23, k + 19, 0);
        world.setBlock(i + 17, j + 23, k + 20, 0);
        world.setBlock(i + 17, j + 23, k + 21, 0);
        world.setBlock(i + 17, j + 23, k + 22, 0);
        world.setBlock(i + 17, j + 23, k + 23, 0);
        world.setBlock(i + 17, j + 23, k + 24, 0);
        world.setBlock(i + 17, j + 23, k + 25, 0);
        world.setBlock(i + 17, j + 23, k + 26, 0);
        world.setBlock(i + 17, j + 24, k + 0, 0);
        world.setBlock(i + 17, j + 24, k + 1, 0);
        world.setBlock(i + 17, j + 24, k + 2, 0);
        world.setBlock(i + 17, j + 24, k + 3, 0);
        world.setBlock(i + 17, j + 24, k + 4, 0);
        world.setBlock(i + 17, j + 24, k + 5, 0);
        world.setBlock(i + 17, j + 24, k + 6, 0);
        world.setBlock(i + 17, j + 24, k + 7, 0);
        world.setBlock(i + 17, j + 24, k + 8, 0);
        world.setBlock(i + 17, j + 24, k + 9, 0);
        world.setBlock(i + 17, j + 24, k + 10, 0);
        world.setBlock(i + 17, j + 24, k + 11, 0);
        world.setBlock(i + 17, j + 24, k + 12, 0);
        world.setBlock(i + 17, j + 24, k + 13, 0);
        world.setBlock(i + 17, j + 24, k + 14, 0);
        world.setBlock(i + 17, j + 24, k + 15, 0);
        world.setBlock(i + 17, j + 24, k + 16, 0);
        world.setBlock(i + 17, j + 24, k + 17, 0);
        world.setBlock(i + 17, j + 24, k + 18, 0);
        world.setBlock(i + 17, j + 24, k + 19, 0);
        world.setBlock(i + 17, j + 24, k + 20, 0);
        world.setBlock(i + 17, j + 24, k + 21, 0);
        world.setBlock(i + 17, j + 24, k + 22, 0);
        world.setBlock(i + 17, j + 24, k + 23, 0);
        world.setBlock(i + 17, j + 24, k + 24, 0);
        world.setBlock(i + 17, j + 24, k + 25, 0);
        world.setBlock(i + 17, j + 24, k + 26, 0);
        world.setBlock(i + 17, j + 25, k + 0, 0);
        world.setBlock(i + 17, j + 25, k + 1, 0);
        world.setBlock(i + 17, j + 25, k + 2, 0);
        world.setBlock(i + 17, j + 25, k + 3, 0);
        world.setBlock(i + 17, j + 25, k + 4, 0);
        world.setBlock(i + 17, j + 25, k + 5, 0);
        world.setBlock(i + 17, j + 25, k + 6, 0);
        world.setBlock(i + 17, j + 25, k + 7, 0);
        world.setBlock(i + 17, j + 25, k + 8, 0);
        world.setBlock(i + 17, j + 25, k + 9, 0);
        world.setBlock(i + 17, j + 25, k + 10, 0);
        world.setBlock(i + 17, j + 25, k + 11, 0);
        world.setBlock(i + 17, j + 25, k + 12, 0);
        world.setBlock(i + 17, j + 25, k + 13, 0);
        world.setBlock(i + 17, j + 25, k + 14, 0);
        world.setBlock(i + 17, j + 25, k + 15, 0);
        world.setBlock(i + 17, j + 25, k + 16, 0);
        world.setBlock(i + 17, j + 25, k + 17, 0);
        world.setBlock(i + 17, j + 25, k + 18, 0);
        world.setBlock(i + 17, j + 25, k + 19, 0);
        world.setBlock(i + 17, j + 25, k + 20, 0);
        world.setBlock(i + 17, j + 25, k + 21, 0);
        world.setBlock(i + 17, j + 25, k + 22, 0);
        world.setBlock(i + 17, j + 25, k + 23, 0);
        world.setBlock(i + 17, j + 25, k + 24, 0);
        world.setBlock(i + 17, j + 25, k + 25, 0);
        world.setBlock(i + 17, j + 25, k + 26, 0);
        world.setBlock(i + 18, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 18, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 18, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 18, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 18, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 18, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 18, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 18, j + 2, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 2, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 2, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 2, k + 8, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 18, j + 2, k + 9, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 18, j + 2, k + 10, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 18, j + 2, k + 11, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 18, j + 2, k + 12, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 18, j + 2, k + 13, Block.stoneDoubleSlab.blockID);
        world.setBlock(i + 18, j + 2, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 2, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 2, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 2, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 2, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 2, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 2, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 2, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 18, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 18, j + 3, k + 1, 0);
        world.setBlock(i + 18, j + 3, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 3, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 3, k + 7, 0);
        world.setBlock(i + 18, j + 3, k + 8, 0);
        world.setBlock(i + 18, j + 3, k + 9, 0);
        world.setBlock(i + 18, j + 3, k + 10, 0);
        world.setBlock(i + 18, j + 3, k + 11, 0);
        world.setBlock(i + 18, j + 3, k + 12, 0);
        world.setBlock(i + 18, j + 3, k + 13, 0);
        world.setBlock(i + 18, j + 3, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 3, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 3, k + 16, Block.stoneBrick.blockID, 1, 0);
        world.setBlock(i + 18, j + 3, k + 17, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 18, j + 3, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 3, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 3, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 3, k + 21, 0);
        world.setBlock(i + 18, j + 3, k + 22, 0);
        world.setBlock(i + 18, j + 3, k + 23, Block.chest.blockID, 2, 0);
        world.setBlock(i + 18, j + 3, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 3, k + 26, 0);
        world.setBlock(i + 18, j + 4, k + 0, 0);
        world.setBlock(i + 18, j + 4, k + 1, 0);
        world.setBlock(i + 18, j + 4, k + 2, 0);
        world.setBlock(i + 18, j + 4, k + 3, 0);
        world.setBlock(i + 18, j + 4, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 4, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 4, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 4, k + 7, 0);
        world.setBlock(i + 18, j + 4, k + 8, 0);
        world.setBlock(i + 18, j + 4, k + 9, 0);
        world.setBlock(i + 18, j + 4, k + 10, 0);
        world.setBlock(i + 18, j + 4, k + 11, 0);
        world.setBlock(i + 18, j + 4, k + 12, 0);
        world.setBlock(i + 18, j + 4, k + 13, 0);
        world.setBlock(i + 18, j + 4, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 4, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 4, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 4, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 4, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 4, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 4, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 4, k + 21, 0);
        world.setBlock(i + 18, j + 4, k + 22, 0);
        world.setBlock(i + 18, j + 4, k + 23, Block.chest.blockID, 2, 0);
        world.setBlock(i + 18, j + 4, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 4, k + 25, 0);
        world.setBlock(i + 18, j + 4, k + 26, 0);
        world.setBlock(i + 18, j + 5, k + 0, 0);
        world.setBlock(i + 18, j + 5, k + 1, 0);
        world.setBlock(i + 18, j + 5, k + 2, 0);
        world.setBlock(i + 18, j + 5, k + 3, 0);
        world.setBlock(i + 18, j + 5, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 5, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 5, k + 7, 0);
        world.setBlock(i + 18, j + 5, k + 8, 0);
        world.setBlock(i + 18, j + 5, k + 9, 0);
        world.setBlock(i + 18, j + 5, k + 10, 0);
        world.setBlock(i + 18, j + 5, k + 11, 0);
        world.setBlock(i + 18, j + 5, k + 12, 0);
        world.setBlock(i + 18, j + 5, k + 13, 0);
        world.setBlock(i + 18, j + 5, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 5, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 5, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 5, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 5, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 5, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 5, k + 20, Block.glowStone.blockID);
        world.setBlock(i + 18, j + 5, k + 21, 0);
        world.setBlock(i + 18, j + 5, k + 22, 0);
        world.setBlock(i + 18, j + 5, k + 23, 0);
        world.setBlock(i + 18, j + 5, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 5, k + 25, 0);
        world.setBlock(i + 18, j + 5, k + 26, 0);
        world.setBlock(i + 18, j + 6, k + 0, 0);
        world.setBlock(i + 18, j + 6, k + 1, 0);
        world.setBlock(i + 18, j + 6, k + 2, 0);
        world.setBlock(i + 18, j + 6, k + 3, 0);
        world.setBlock(i + 18, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 6, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 6, k + 7, 0);
        world.setBlock(i + 18, j + 6, k + 8, 0);
        world.setBlock(i + 18, j + 6, k + 9, 0);
        world.setBlock(i + 18, j + 6, k + 10, 0);
        world.setBlock(i + 18, j + 6, k + 11, 0);
        world.setBlock(i + 18, j + 6, k + 12, 0);
        world.setBlock(i + 18, j + 6, k + 13, 0);
        world.setBlock(i + 18, j + 6, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 6, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 6, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 6, k + 17, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 18, j + 6, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 6, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 6, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 6, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 6, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 6, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 6, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 6, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 6, k + 26, 0);
        world.setBlock(i + 18, j + 7, k + 0, 0);
        world.setBlock(i + 18, j + 7, k + 1, 0);
        world.setBlock(i + 18, j + 7, k + 2, 0);
        world.setBlock(i + 18, j + 7, k + 3, 0);
        world.setBlock(i + 18, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 7, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 7, k + 7, 0);
        world.setBlock(i + 18, j + 7, k + 8, 0);
        world.setBlock(i + 18, j + 7, k + 9, 0);
        world.setBlock(i + 18, j + 7, k + 10, 0);
        world.setBlock(i + 18, j + 7, k + 11, 0);
        world.setBlock(i + 18, j + 7, k + 12, 0);
        world.setBlock(i + 18, j + 7, k + 13, 0);
        world.setBlock(i + 18, j + 7, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 7, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 7, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 7, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 7, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 7, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 7, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 7, k + 21, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 18, j + 7, k + 22, 0);
        world.setBlock(i + 18, j + 7, k + 23, 0);
        world.setBlock(i + 18, j + 7, k + 24, 0);
        world.setBlock(i + 18, j + 7, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 7, k + 26, 0);
        world.setBlock(i + 18, j + 8, k + 0, 0);
        world.setBlock(i + 18, j + 8, k + 1, 0);
        world.setBlock(i + 18, j + 8, k + 2, 0);
        world.setBlock(i + 18, j + 8, k + 3, 0);
        world.setBlock(i + 18, j + 8, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 8, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 8, k + 7, 0);
        world.setBlock(i + 18, j + 8, k + 8, 0);
        world.setBlock(i + 18, j + 8, k + 9, 0);
        world.setBlock(i + 18, j + 8, k + 10, 0);
        world.setBlock(i + 18, j + 8, k + 11, 0);
        world.setBlock(i + 18, j + 8, k + 12, 0);
        world.setBlock(i + 18, j + 8, k + 13, 0);
        world.setBlock(i + 18, j + 8, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 8, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 8, k + 16, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 8, k + 17, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 8, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 8, k + 19, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 18, j + 8, k + 20, 0);
        world.setBlock(i + 18, j + 8, k + 21, 0);
        world.setBlock(i + 18, j + 8, k + 22, 0);
        world.setBlock(i + 18, j + 8, k + 23, 0);
        world.setBlock(i + 18, j + 8, k + 24, 0);
        world.setBlock(i + 18, j + 8, k + 25, Block.thinGlass.blockID);
        world.setBlock(i + 18, j + 8, k + 26, 0);
        world.setBlock(i + 18, j + 9, k + 0, 0);
        world.setBlock(i + 18, j + 9, k + 1, 0);
        world.setBlock(i + 18, j + 9, k + 2, 0);
        world.setBlock(i + 18, j + 9, k + 3, 0);
        world.setBlock(i + 18, j + 9, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 9, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 9, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 9, k + 7, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 9, k + 8, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 9, k + 10, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 9, k + 11, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 9, k + 12, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 9, k + 13, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 9, k + 17, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 18, j + 9, k + 18, 0);
        world.setBlock(i + 18, j + 9, k + 19, 0);
        world.setBlock(i + 18, j + 9, k + 20, 0);
        world.setBlock(i + 18, j + 9, k + 21, 0);
        world.setBlock(i + 18, j + 9, k + 22, 0);
        world.setBlock(i + 18, j + 9, k + 23, 0);
        world.setBlock(i + 18, j + 9, k + 24, 0);
        world.setBlock(i + 18, j + 9, k + 25, Block.thinGlass.blockID);
        world.setBlock(i + 18, j + 9, k + 26, 0);
        world.setBlock(i + 18, j + 10, k + 0, 0);
        world.setBlock(i + 18, j + 10, k + 1, 0);
        world.setBlock(i + 18, j + 10, k + 2, 0);
        world.setBlock(i + 18, j + 10, k + 3, 0);
        world.setBlock(i + 18, j + 10, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 10, k + 6, 0);
        world.setBlock(i + 18, j + 10, k + 7, 0);
        world.setBlock(i + 18, j + 10, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 10, k + 9, 0);
        world.setBlock(i + 18, j + 10, k + 10, 0);
        world.setBlock(i + 18, j + 10, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 10, k + 12, 0);
        world.setBlock(i + 18, j + 10, k + 13, 0);
        world.setBlock(i + 18, j + 10, k + 14, 0);
        world.setBlock(i + 18, j + 10, k + 15, 0);
        world.setBlock(i + 18, j + 10, k + 16, 0);
        world.setBlock(i + 18, j + 10, k + 17, 0);
        world.setBlock(i + 18, j + 10, k + 18, 0);
        world.setBlock(i + 18, j + 10, k + 19, 0);
        world.setBlock(i + 18, j + 10, k + 20, 0);
        world.setBlock(i + 18, j + 10, k + 21, 0);
        world.setBlock(i + 18, j + 10, k + 22, 0);
        world.setBlock(i + 18, j + 10, k + 23, 0);
        world.setBlock(i + 18, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 10, k + 26, 0);
        world.setBlock(i + 18, j + 11, k + 0, 0);
        world.setBlock(i + 18, j + 11, k + 1, 0);
        world.setBlock(i + 18, j + 11, k + 2, 0);
        world.setBlock(i + 18, j + 11, k + 3, 0);
        world.setBlock(i + 18, j + 11, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 11, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 11, k + 6, 0);
        world.setBlock(i + 18, j + 11, k + 7, 0);
        world.setBlock(i + 18, j + 11, k + 8, 0);
        world.setBlock(i + 18, j + 11, k + 9, 0);
        world.setBlock(i + 18, j + 11, k + 10, 0);
        world.setBlock(i + 18, j + 11, k + 11, 0);
        world.setBlock(i + 18, j + 11, k + 12, 0);
        world.setBlock(i + 18, j + 11, k + 13, 0);
        world.setBlock(i + 18, j + 11, k + 14, 0);
        world.setBlock(i + 18, j + 11, k + 15, 0);
        world.setBlock(i + 18, j + 11, k + 16, 0);
        world.setBlock(i + 18, j + 11, k + 17, 0);
        world.setBlock(i + 18, j + 11, k + 18, 0);
        world.setBlock(i + 18, j + 11, k + 19, 0);
        world.setBlock(i + 18, j + 11, k + 20, 0);
        world.setBlock(i + 18, j + 11, k + 21, Block.glowStone.blockID);
        world.setBlock(i + 18, j + 11, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 11, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 11, k + 26, 0);
        world.setBlock(i + 18, j + 12, k + 0, 0);
        world.setBlock(i + 18, j + 12, k + 1, 0);
        world.setBlock(i + 18, j + 12, k + 2, 0);
        world.setBlock(i + 18, j + 12, k + 3, 0);
        world.setBlock(i + 18, j + 12, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 12, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 12, k + 6, 0);
        world.setBlock(i + 18, j + 12, k + 7, 0);
        world.setBlock(i + 18, j + 12, k + 8, 0);
        world.setBlock(i + 18, j + 12, k + 9, 0);
        world.setBlock(i + 18, j + 12, k + 10, 0);
        world.setBlock(i + 18, j + 12, k + 11, 0);
        world.setBlock(i + 18, j + 12, k + 12, 0);
        world.setBlock(i + 18, j + 12, k + 13, 0);
        world.setBlock(i + 18, j + 12, k + 14, 0);
        world.setBlock(i + 18, j + 12, k + 15, 0);
        world.setBlock(i + 18, j + 12, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 12, k + 17, Block.web.blockID);
        world.setBlock(i + 18, j + 12, k + 18, 0);
        world.setBlock(i + 18, j + 12, k + 19, 0);
        world.setBlock(i + 18, j + 12, k + 20, 0);
        world.setBlock(i + 18, j + 12, k + 21, Block.fence.blockID);
        world.setBlock(i + 18, j + 12, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 18, j + 12, k + 26, 0);
        world.setBlock(i + 18, j + 13, k + 0, 0);
        world.setBlock(i + 18, j + 13, k + 1, 0);
        world.setBlock(i + 18, j + 13, k + 2, 0);
        world.setBlock(i + 18, j + 13, k + 3, 0);
        world.setBlock(i + 18, j + 13, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 13, k + 5, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 18, j + 13, k + 6, 0);
        world.setBlock(i + 18, j + 13, k + 7, 0);
        world.setBlock(i + 18, j + 13, k + 8, 0);
        world.setBlock(i + 18, j + 13, k + 9, 0);
        world.setBlock(i + 18, j + 13, k + 10, 0);
        world.setBlock(i + 18, j + 13, k + 11, 0);
        world.setBlock(i + 18, j + 13, k + 12, 0);
        world.setBlock(i + 18, j + 13, k + 13, 0);
        world.setBlock(i + 18, j + 13, k + 14, 0);
        world.setBlock(i + 18, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 13, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 13, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 13, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 13, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 13, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 13, k + 26, 0);
        world.setBlock(i + 18, j + 14, k + 0, 0);
        world.setBlock(i + 18, j + 14, k + 1, 0);
        world.setBlock(i + 18, j + 14, k + 2, 0);
        world.setBlock(i + 18, j + 14, k + 3, 0);
        world.setBlock(i + 18, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 22, 0);
        world.setBlock(i + 18, j + 14, k + 23, 0);
        world.setBlock(i + 18, j + 14, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 14, k + 26, 0);
        world.setBlock(i + 18, j + 15, k + 0, 0);
        world.setBlock(i + 18, j + 15, k + 1, 0);
        world.setBlock(i + 18, j + 15, k + 2, 0);
        world.setBlock(i + 18, j + 15, k + 3, 0);
        world.setBlock(i + 18, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 15, k + 5, 0);
        world.setBlock(i + 18, j + 15, k + 6, 0);
        world.setBlock(i + 18, j + 15, k + 7, 0);
        world.setBlock(i + 18, j + 15, k + 8, 0);
        world.setBlock(i + 18, j + 15, k + 9, 0);
        world.setBlock(i + 18, j + 15, k + 10, 0);
        world.setBlock(i + 18, j + 15, k + 11, 0);
        world.setBlock(i + 18, j + 15, k + 12, 0);
        world.setBlock(i + 18, j + 15, k + 13, 0);
        world.setBlock(i + 18, j + 15, k + 14, 0);
        world.setBlock(i + 18, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 15, k + 22, 0);
        world.setBlock(i + 18, j + 15, k + 23, 0);
        world.setBlock(i + 18, j + 15, k + 24, 0);
        world.setBlock(i + 18, j + 15, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 15, k + 26, 0);
        world.setBlock(i + 18, j + 16, k + 0, 0);
        world.setBlock(i + 18, j + 16, k + 1, 0);
        world.setBlock(i + 18, j + 16, k + 2, 0);
        world.setBlock(i + 18, j + 16, k + 3, 0);
        world.setBlock(i + 18, j + 16, k + 4, 0);
        world.setBlock(i + 18, j + 16, k + 5, 0);
        world.setBlock(i + 18, j + 16, k + 6, 0);
        world.setBlock(i + 18, j + 16, k + 7, 0);
        world.setBlock(i + 18, j + 16, k + 8, 0);
        world.setBlock(i + 18, j + 16, k + 9, 0);
        world.setBlock(i + 18, j + 16, k + 10, 0);
        world.setBlock(i + 18, j + 16, k + 11, 0);
        world.setBlock(i + 18, j + 16, k + 12, 0);
        world.setBlock(i + 18, j + 16, k + 13, 0);
        world.setBlock(i + 18, j + 16, k + 14, 0);
        world.setBlock(i + 18, j + 16, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 16, k + 16, 0);
        world.setBlock(i + 18, j + 16, k + 17, 0);
        world.setBlock(i + 18, j + 16, k + 18, 0);
        world.setBlock(i + 18, j + 16, k + 19, 0);
        world.setBlock(i + 18, j + 16, k + 20, 0);
        world.setBlock(i + 18, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 16, k + 22, 0);
        world.setBlock(i + 18, j + 16, k + 23, 0);
        world.setBlock(i + 18, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 16, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 16, k + 26, 0);
        world.setBlock(i + 18, j + 17, k + 0, 0);
        world.setBlock(i + 18, j + 17, k + 1, 0);
        world.setBlock(i + 18, j + 17, k + 2, 0);
        world.setBlock(i + 18, j + 17, k + 3, 0);
        world.setBlock(i + 18, j + 17, k + 4, 0);
        world.setBlock(i + 18, j + 17, k + 5, 0);
        world.setBlock(i + 18, j + 17, k + 6, 0);
        world.setBlock(i + 18, j + 17, k + 7, 0);
        world.setBlock(i + 18, j + 17, k + 8, 0);
        world.setBlock(i + 18, j + 17, k + 9, 0);
        world.setBlock(i + 18, j + 17, k + 10, 0);
        world.setBlock(i + 18, j + 17, k + 11, 0);
        world.setBlock(i + 18, j + 17, k + 12, 0);
        world.setBlock(i + 18, j + 17, k + 13, 0);
        world.setBlock(i + 18, j + 17, k + 14, 0);
        world.setBlock(i + 18, j + 17, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 17, k + 16, 0);
        world.setBlock(i + 18, j + 17, k + 17, 0);
        world.setBlock(i + 18, j + 17, k + 18, 0);
        world.setBlock(i + 18, j + 17, k + 19, 0);
        world.setBlock(i + 18, j + 17, k + 20, 0);
        world.setBlock(i + 18, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 17, k + 22, 0);
        world.setBlock(i + 18, j + 17, k + 23, 0);
        world.setBlock(i + 18, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 17, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 17, k + 26, 0);
        world.setBlock(i + 18, j + 18, k + 0, 0);
        world.setBlock(i + 18, j + 18, k + 1, 0);
        world.setBlock(i + 18, j + 18, k + 2, 0);
        world.setBlock(i + 18, j + 18, k + 3, 0);
        world.setBlock(i + 18, j + 18, k + 4, 0);
        world.setBlock(i + 18, j + 18, k + 5, 0);
        world.setBlock(i + 18, j + 18, k + 6, 0);
        world.setBlock(i + 18, j + 18, k + 7, 0);
        world.setBlock(i + 18, j + 18, k + 8, 0);
        world.setBlock(i + 18, j + 18, k + 9, 0);
        world.setBlock(i + 18, j + 18, k + 10, 0);
        world.setBlock(i + 18, j + 18, k + 11, 0);
        world.setBlock(i + 18, j + 18, k + 12, 0);
        world.setBlock(i + 18, j + 18, k + 13, 0);
        world.setBlock(i + 18, j + 18, k + 14, 0);
        world.setBlock(i + 18, j + 18, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 18, k + 16, 0);
        world.setBlock(i + 18, j + 18, k + 17, 0);
        world.setBlock(i + 18, j + 18, k + 18, 0);
        world.setBlock(i + 18, j + 18, k + 19, 0);
        world.setBlock(i + 18, j + 18, k + 20, 0);
        world.setBlock(i + 18, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 18, k + 22, 0);
        world.setBlock(i + 18, j + 18, k + 23, 0);
        world.setBlock(i + 18, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 18, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 18, k + 26, 0);
        world.setBlock(i + 18, j + 19, k + 0, 0);
        world.setBlock(i + 18, j + 19, k + 1, 0);
        world.setBlock(i + 18, j + 19, k + 2, 0);
        world.setBlock(i + 18, j + 19, k + 3, 0);
        world.setBlock(i + 18, j + 19, k + 4, 0);
        world.setBlock(i + 18, j + 19, k + 5, 0);
        world.setBlock(i + 18, j + 19, k + 6, 0);
        world.setBlock(i + 18, j + 19, k + 7, 0);
        world.setBlock(i + 18, j + 19, k + 8, 0);
        world.setBlock(i + 18, j + 19, k + 9, 0);
        world.setBlock(i + 18, j + 19, k + 10, 0);
        world.setBlock(i + 18, j + 19, k + 11, 0);
        world.setBlock(i + 18, j + 19, k + 12, 0);
        world.setBlock(i + 18, j + 19, k + 13, 0);
        world.setBlock(i + 18, j + 19, k + 14, 0);
        world.setBlock(i + 18, j + 19, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 19, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 19, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 19, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 19, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 19, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 19, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 19, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 19, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 18, j + 19, k + 26, 0);
        world.setBlock(i + 18, j + 20, k + 0, 0);
        world.setBlock(i + 18, j + 20, k + 1, 0);
        world.setBlock(i + 18, j + 20, k + 2, 0);
        world.setBlock(i + 18, j + 20, k + 3, 0);
        world.setBlock(i + 18, j + 20, k + 4, 0);
        world.setBlock(i + 18, j + 20, k + 5, 0);
        world.setBlock(i + 18, j + 20, k + 6, 0);
        world.setBlock(i + 18, j + 20, k + 7, 0);
        world.setBlock(i + 18, j + 20, k + 8, 0);
        world.setBlock(i + 18, j + 20, k + 9, 0);
        world.setBlock(i + 18, j + 20, k + 10, 0);
        world.setBlock(i + 18, j + 20, k + 11, 0);
        world.setBlock(i + 18, j + 20, k + 12, 0);
        world.setBlock(i + 18, j + 20, k + 13, 0);
        world.setBlock(i + 18, j + 20, k + 14, 0);
        world.setBlock(i + 18, j + 20, k + 15, 0);
        world.setBlock(i + 18, j + 20, k + 16, 0);
        world.setBlock(i + 18, j + 20, k + 17, 0);
        world.setBlock(i + 18, j + 20, k + 18, 0);
        world.setBlock(i + 18, j + 20, k + 19, 0);
        world.setBlock(i + 18, j + 20, k + 20, 0);
        world.setBlock(i + 18, j + 20, k + 21, 0);
        world.setBlock(i + 18, j + 20, k + 22, 0);
        world.setBlock(i + 18, j + 20, k + 23, 0);
        world.setBlock(i + 18, j + 20, k + 24, 0);
        world.setBlock(i + 18, j + 20, k + 25, 0);
        world.setBlock(i + 18, j + 20, k + 26, 0);
        world.setBlock(i + 18, j + 21, k + 0, 0);
        world.setBlock(i + 18, j + 21, k + 1, 0);
        world.setBlock(i + 18, j + 21, k + 2, 0);
        world.setBlock(i + 18, j + 21, k + 3, 0);
        world.setBlock(i + 18, j + 21, k + 4, 0);
        world.setBlock(i + 18, j + 21, k + 5, 0);
        world.setBlock(i + 18, j + 21, k + 6, 0);
        world.setBlock(i + 18, j + 21, k + 7, 0);
        world.setBlock(i + 18, j + 21, k + 8, 0);
        world.setBlock(i + 18, j + 21, k + 9, 0);
        world.setBlock(i + 18, j + 21, k + 10, 0);
        world.setBlock(i + 18, j + 21, k + 11, 0);
        world.setBlock(i + 18, j + 21, k + 12, 0);
        world.setBlock(i + 18, j + 21, k + 13, 0);
        world.setBlock(i + 18, j + 21, k + 14, 0);
        world.setBlock(i + 18, j + 21, k + 15, 0);
        world.setBlock(i + 18, j + 21, k + 16, 0);
        world.setBlock(i + 18, j + 21, k + 17, 0);
        world.setBlock(i + 18, j + 21, k + 18, 0);
        world.setBlock(i + 18, j + 21, k + 19, 0);
        world.setBlock(i + 18, j + 21, k + 20, 0);
        world.setBlock(i + 18, j + 21, k + 21, 0);
        world.setBlock(i + 18, j + 21, k + 22, 0);
        world.setBlock(i + 18, j + 21, k + 23, 0);
        world.setBlock(i + 18, j + 21, k + 24, 0);
        world.setBlock(i + 18, j + 21, k + 25, 0);
        world.setBlock(i + 18, j + 21, k + 26, 0);
        world.setBlock(i + 18, j + 22, k + 0, 0);
        world.setBlock(i + 18, j + 22, k + 1, 0);
        world.setBlock(i + 18, j + 22, k + 2, 0);
        world.setBlock(i + 18, j + 22, k + 3, 0);
        world.setBlock(i + 18, j + 22, k + 4, 0);
        world.setBlock(i + 18, j + 22, k + 5, 0);
        world.setBlock(i + 18, j + 22, k + 6, 0);
        world.setBlock(i + 18, j + 22, k + 7, 0);
        world.setBlock(i + 18, j + 22, k + 8, 0);
        world.setBlock(i + 18, j + 22, k + 9, 0);
        world.setBlock(i + 18, j + 22, k + 10, 0);
        world.setBlock(i + 18, j + 22, k + 11, 0);
        world.setBlock(i + 18, j + 22, k + 12, 0);
        world.setBlock(i + 18, j + 22, k + 13, 0);
        world.setBlock(i + 18, j + 22, k + 14, 0);
        world.setBlock(i + 18, j + 22, k + 15, 0);
        world.setBlock(i + 18, j + 22, k + 16, 0);
        world.setBlock(i + 18, j + 22, k + 17, 0);
        world.setBlock(i + 18, j + 22, k + 18, 0);
        world.setBlock(i + 18, j + 22, k + 19, 0);
        world.setBlock(i + 18, j + 22, k + 20, 0);
        world.setBlock(i + 18, j + 22, k + 21, 0);
        world.setBlock(i + 18, j + 22, k + 22, 0);
        world.setBlock(i + 18, j + 22, k + 23, 0);
        world.setBlock(i + 18, j + 22, k + 24, 0);
        world.setBlock(i + 18, j + 22, k + 25, 0);
        world.setBlock(i + 18, j + 22, k + 26, 0);
        world.setBlock(i + 18, j + 23, k + 0, 0);
        world.setBlock(i + 18, j + 23, k + 1, 0);
        world.setBlock(i + 18, j + 23, k + 2, 0);
        world.setBlock(i + 18, j + 23, k + 3, 0);
        world.setBlock(i + 18, j + 23, k + 4, 0);
        world.setBlock(i + 18, j + 23, k + 5, 0);
        world.setBlock(i + 18, j + 23, k + 6, 0);
        world.setBlock(i + 18, j + 23, k + 7, 0);
        world.setBlock(i + 18, j + 23, k + 8, 0);
        world.setBlock(i + 18, j + 23, k + 9, 0);
        world.setBlock(i + 18, j + 23, k + 10, 0);
        world.setBlock(i + 18, j + 23, k + 11, 0);
        world.setBlock(i + 18, j + 23, k + 12, 0);
        world.setBlock(i + 18, j + 23, k + 13, 0);
        world.setBlock(i + 18, j + 23, k + 14, 0);
        world.setBlock(i + 18, j + 23, k + 15, 0);
        world.setBlock(i + 18, j + 23, k + 16, 0);
        world.setBlock(i + 18, j + 23, k + 17, 0);
        world.setBlock(i + 18, j + 23, k + 18, 0);
        world.setBlock(i + 18, j + 23, k + 19, 0);
        world.setBlock(i + 18, j + 23, k + 20, 0);
        world.setBlock(i + 18, j + 23, k + 21, 0);
        world.setBlock(i + 18, j + 23, k + 22, 0);
        world.setBlock(i + 18, j + 23, k + 23, 0);
        world.setBlock(i + 18, j + 23, k + 24, 0);
        world.setBlock(i + 18, j + 23, k + 25, 0);
        world.setBlock(i + 18, j + 23, k + 26, 0);
        world.setBlock(i + 18, j + 24, k + 0, 0);
        world.setBlock(i + 18, j + 24, k + 1, 0);
        world.setBlock(i + 18, j + 24, k + 2, 0);
        world.setBlock(i + 18, j + 24, k + 3, 0);
        world.setBlock(i + 18, j + 24, k + 4, 0);
        world.setBlock(i + 18, j + 24, k + 5, 0);
        world.setBlock(i + 18, j + 24, k + 6, 0);
        world.setBlock(i + 18, j + 24, k + 7, 0);
        world.setBlock(i + 18, j + 24, k + 8, 0);
        world.setBlock(i + 18, j + 24, k + 9, 0);
        world.setBlock(i + 18, j + 24, k + 10, 0);
        world.setBlock(i + 18, j + 24, k + 11, 0);
        world.setBlock(i + 18, j + 24, k + 12, 0);
        world.setBlock(i + 18, j + 24, k + 13, 0);
        world.setBlock(i + 18, j + 24, k + 14, 0);
        world.setBlock(i + 18, j + 24, k + 15, 0);
        world.setBlock(i + 18, j + 24, k + 16, 0);
        world.setBlock(i + 18, j + 24, k + 17, 0);
        world.setBlock(i + 18, j + 24, k + 18, 0);
        world.setBlock(i + 18, j + 24, k + 19, 0);
        world.setBlock(i + 18, j + 24, k + 20, 0);
        world.setBlock(i + 18, j + 24, k + 21, 0);
        world.setBlock(i + 18, j + 24, k + 22, 0);
        world.setBlock(i + 18, j + 24, k + 23, 0);
        world.setBlock(i + 18, j + 24, k + 24, 0);
        world.setBlock(i + 18, j + 24, k + 25, 0);
        world.setBlock(i + 18, j + 24, k + 26, 0);
        world.setBlock(i + 18, j + 25, k + 0, 0);
        world.setBlock(i + 18, j + 25, k + 1, 0);
        world.setBlock(i + 18, j + 25, k + 2, 0);
        world.setBlock(i + 18, j + 25, k + 3, 0);
        world.setBlock(i + 18, j + 25, k + 4, 0);
        world.setBlock(i + 18, j + 25, k + 5, 0);
        world.setBlock(i + 18, j + 25, k + 6, 0);
        world.setBlock(i + 18, j + 25, k + 7, 0);
        world.setBlock(i + 18, j + 25, k + 8, 0);
        world.setBlock(i + 18, j + 25, k + 9, 0);
        world.setBlock(i + 18, j + 25, k + 10, 0);
        world.setBlock(i + 18, j + 25, k + 11, 0);
        world.setBlock(i + 18, j + 25, k + 12, 0);
        world.setBlock(i + 18, j + 25, k + 13, 0);
        world.setBlock(i + 18, j + 25, k + 14, 0);
        world.setBlock(i + 18, j + 25, k + 15, 0);
        world.setBlock(i + 18, j + 25, k + 16, 0);
        world.setBlock(i + 18, j + 25, k + 17, 0);
        world.setBlock(i + 18, j + 25, k + 18, 0);
        world.setBlock(i + 18, j + 25, k + 19, 0);
        world.setBlock(i + 18, j + 25, k + 20, 0);
        world.setBlock(i + 18, j + 25, k + 21, 0);
        world.setBlock(i + 18, j + 25, k + 22, 0);
        world.setBlock(i + 18, j + 25, k + 23, 0);
        world.setBlock(i + 18, j + 25, k + 24, 0);
        world.setBlock(i + 18, j + 25, k + 25, 0);
        world.setBlock(i + 18, j + 25, k + 26, 0);
        world.setBlock(i + 19, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 19, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 19, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 19, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 19, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 19, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 19, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 19, j + 2, k + 4, Block.grass.blockID);
        world.setBlock(i + 19, j + 2, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 23, Block.stoneBrick.blockID, 1, 0);
        world.setBlock(i + 19, j + 2, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 19, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 19, j + 3, k + 0, 0);
        world.setBlock(i + 19, j + 3, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 3, k + 6, 0);
        world.setBlock(i + 19, j + 3, k + 7, 0);
        world.setBlock(i + 19, j + 3, k + 8, 0);
        world.setBlock(i + 19, j + 3, k + 9, 0);
        world.setBlock(i + 19, j + 3, k + 10, 0);
        world.setBlock(i + 19, j + 3, k + 11, 0);
        world.setBlock(i + 19, j + 3, k + 12, 0);
        world.setBlock(i + 19, j + 3, k + 13, 0);
        world.setBlock(i + 19, j + 3, k + 14, 0);
        world.setBlock(i + 19, j + 3, k + 15, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 19, j + 3, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 3, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 3, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 3, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 3, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 3, k + 21, 0);
        world.setBlock(i + 19, j + 3, k + 22, 0);
        world.setBlock(i + 19, j + 3, k + 23, 0);
        world.setBlock(i + 19, j + 3, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 4, k + 0, 0);
        world.setBlock(i + 19, j + 4, k + 1, 0);
        world.setBlock(i + 19, j + 4, k + 2, 0);
        world.setBlock(i + 19, j + 4, k + 3, 0);
        world.setBlock(i + 19, j + 4, k + 4, 0);
        world.setBlock(i + 19, j + 4, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 19, j + 4, k + 6, 0);
        world.setBlock(i + 19, j + 4, k + 7, 0);
        world.setBlock(i + 19, j + 4, k + 8, 0);
        world.setBlock(i + 19, j + 4, k + 9, 0);
        world.setBlock(i + 19, j + 4, k + 10, 0);
        world.setBlock(i + 19, j + 4, k + 11, 0);
        world.setBlock(i + 19, j + 4, k + 12, 0);
        world.setBlock(i + 19, j + 4, k + 13, 0);
        world.setBlock(i + 19, j + 4, k + 14, 0);
        world.setBlock(i + 19, j + 4, k + 15, 0);
        world.setBlock(i + 19, j + 4, k + 16, 0);
        world.setBlock(i + 19, j + 4, k + 17, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 19, j + 4, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 4, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 4, k + 20, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 19, j + 4, k + 21, 0);
        world.setBlock(i + 19, j + 4, k + 22, 0);
        world.setBlock(i + 19, j + 4, k + 23, 0);
        world.setBlock(i + 19, j + 4, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 4, k + 25, 0);
        world.setBlock(i + 19, j + 4, k + 26, 0);
        world.setBlock(i + 19, j + 5, k + 0, 0);
        world.setBlock(i + 19, j + 5, k + 1, 0);
        world.setBlock(i + 19, j + 5, k + 2, 0);
        world.setBlock(i + 19, j + 5, k + 3, 0);
        world.setBlock(i + 19, j + 5, k + 4, 0);
        world.setBlock(i + 19, j + 5, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 19, j + 5, k + 6, 0);
        world.setBlock(i + 19, j + 5, k + 7, 0);
        world.setBlock(i + 19, j + 5, k + 8, 0);
        world.setBlock(i + 19, j + 5, k + 9, 0);
        world.setBlock(i + 19, j + 5, k + 10, 0);
        world.setBlock(i + 19, j + 5, k + 11, 0);
        world.setBlock(i + 19, j + 5, k + 12, 0);
        world.setBlock(i + 19, j + 5, k + 13, 0);
        world.setBlock(i + 19, j + 5, k + 14, 0);
        world.setBlock(i + 19, j + 5, k + 15, 0);
        world.setBlock(i + 19, j + 5, k + 16, 0);
        world.setBlock(i + 19, j + 5, k + 17, 0);
        world.setBlock(i + 19, j + 5, k + 18, 0);
        world.setBlock(i + 19, j + 5, k + 19, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 19, j + 5, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 5, k + 21, 0);
        world.setBlock(i + 19, j + 5, k + 22, 0);
        world.setBlock(i + 19, j + 5, k + 23, 0);
        world.setBlock(i + 19, j + 5, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 5, k + 25, Block.web.blockID);
        world.setBlock(i + 19, j + 5, k + 26, 0);
        world.setBlock(i + 19, j + 6, k + 0, 0);
        world.setBlock(i + 19, j + 6, k + 1, 0);
        world.setBlock(i + 19, j + 6, k + 2, 0);
        world.setBlock(i + 19, j + 6, k + 3, 0);
        world.setBlock(i + 19, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 19, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 19, j + 6, k + 6, 0);
        world.setBlock(i + 19, j + 6, k + 7, 0);
        world.setBlock(i + 19, j + 6, k + 8, 0);
        world.setBlock(i + 19, j + 6, k + 9, 0);
        world.setBlock(i + 19, j + 6, k + 10, 0);
        world.setBlock(i + 19, j + 6, k + 11, 0);
        world.setBlock(i + 19, j + 6, k + 12, 0);
        world.setBlock(i + 19, j + 6, k + 13, 0);
        world.setBlock(i + 19, j + 6, k + 14, 0);
        world.setBlock(i + 19, j + 6, k + 15, 0);
        world.setBlock(i + 19, j + 6, k + 16, 0);
        world.setBlock(i + 19, j + 6, k + 17, 0);
        world.setBlock(i + 19, j + 6, k + 18, 0);
        world.setBlock(i + 19, j + 6, k + 19, 0);
        world.setBlock(i + 19, j + 6, k + 20, 0);
        world.setBlock(i + 19, j + 6, k + 21, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 19, j + 6, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 6, k + 23, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 19, j + 6, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 6, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 6, k + 26, 0);
        world.setBlock(i + 19, j + 7, k + 0, 0);
        world.setBlock(i + 19, j + 7, k + 1, 0);
        world.setBlock(i + 19, j + 7, k + 2, 0);
        world.setBlock(i + 19, j + 7, k + 3, 0);
        world.setBlock(i + 19, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 19, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 19, j + 7, k + 6, 0);
        world.setBlock(i + 19, j + 7, k + 7, 0);
        world.setBlock(i + 19, j + 7, k + 8, 0);
        world.setBlock(i + 19, j + 7, k + 9, 0);
        world.setBlock(i + 19, j + 7, k + 10, 0);
        world.setBlock(i + 19, j + 7, k + 11, 0);
        world.setBlock(i + 19, j + 7, k + 12, 0);
        world.setBlock(i + 19, j + 7, k + 13, 0);
        world.setBlock(i + 19, j + 7, k + 14, 0);
        world.setBlock(i + 19, j + 7, k + 15, 0);
        world.setBlock(i + 19, j + 7, k + 16, 0);
        world.setBlock(i + 19, j + 7, k + 17, 0);
        world.setBlock(i + 19, j + 7, k + 18, 0);
        world.setBlock(i + 19, j + 7, k + 19, 0);
        world.setBlock(i + 19, j + 7, k + 20, 0);
        world.setBlock(i + 19, j + 7, k + 21, 0);
        world.setBlock(i + 19, j + 7, k + 22, 0);
        world.setBlock(i + 19, j + 7, k + 23, 0);
        world.setBlock(i + 19, j + 7, k + 24, 0);
        world.setBlock(i + 19, j + 7, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 7, k + 26, 0);
        world.setBlock(i + 19, j + 8, k + 0, 0);
        world.setBlock(i + 19, j + 8, k + 1, 0);
        world.setBlock(i + 19, j + 8, k + 2, 0);
        world.setBlock(i + 19, j + 8, k + 3, 0);
        world.setBlock(i + 19, j + 8, k + 4, 0);
        world.setBlock(i + 19, j + 8, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 8, k + 6, 0);
        world.setBlock(i + 19, j + 8, k + 7, 0);
        world.setBlock(i + 19, j + 8, k + 8, 0);
        world.setBlock(i + 19, j + 8, k + 9, 0);
        world.setBlock(i + 19, j + 8, k + 10, 0);
        world.setBlock(i + 19, j + 8, k + 11, 0);
        world.setBlock(i + 19, j + 8, k + 12, 0);
        world.setBlock(i + 19, j + 8, k + 13, 0);
        world.setBlock(i + 19, j + 8, k + 14, 0);
        world.setBlock(i + 19, j + 8, k + 15, 0);
        world.setBlock(i + 19, j + 8, k + 16, 0);
        world.setBlock(i + 19, j + 8, k + 17, 0);
        world.setBlock(i + 19, j + 8, k + 18, 0);
        world.setBlock(i + 19, j + 8, k + 19, 0);
        world.setBlock(i + 19, j + 8, k + 20, 0);
        world.setBlock(i + 19, j + 8, k + 21, 0);
        world.setBlock(i + 19, j + 8, k + 22, 0);
        world.setBlock(i + 19, j + 8, k + 23, 0);
        world.setBlock(i + 19, j + 8, k + 24, 0);
        world.setBlock(i + 19, j + 8, k + 25, Block.thinGlass.blockID);
        world.setBlock(i + 19, j + 8, k + 26, 0);
        world.setBlock(i + 19, j + 9, k + 0, 0);
        world.setBlock(i + 19, j + 9, k + 1, 0);
        world.setBlock(i + 19, j + 9, k + 2, 0);
        world.setBlock(i + 19, j + 9, k + 3, 0);
        world.setBlock(i + 19, j + 9, k + 4, 0);
        world.setBlock(i + 19, j + 9, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 19, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 19, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 9, k + 21, 0);
        world.setBlock(i + 19, j + 9, k + 22, 0);
        world.setBlock(i + 19, j + 9, k + 23, 0);
        world.setBlock(i + 19, j + 9, k + 24, 0);
        world.setBlock(i + 19, j + 9, k + 25, Block.thinGlass.blockID);
        world.setBlock(i + 19, j + 9, k + 26, 0);
        world.setBlock(i + 19, j + 10, k + 0, 0);
        world.setBlock(i + 19, j + 10, k + 1, 0);
        world.setBlock(i + 19, j + 10, k + 2, 0);
        world.setBlock(i + 19, j + 10, k + 3, 0);
        world.setBlock(i + 19, j + 10, k + 4, 0);
        world.setBlock(i + 19, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 10, k + 6, 0);
        world.setBlock(i + 19, j + 10, k + 7, 0);
        world.setBlock(i + 19, j + 10, k + 8, Block.workbench.blockID);
        world.setBlock(i + 19, j + 10, k + 9, 0);
        world.setBlock(i + 19, j + 10, k + 10, 0);
        world.setBlock(i + 19, j + 10, k + 11, Block.enchantmentTable.blockID);
        world.setBlock(i + 19, j + 10, k + 12, 0);
        world.setBlock(i + 19, j + 10, k + 13, 0);
        world.setBlock(i + 19, j + 10, k + 14, 0);
        world.setBlock(i + 19, j + 10, k + 15, 0);
        world.setBlock(i + 19, j + 10, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 10, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 10, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 10, k + 19, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 19, j + 10, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 10, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 10, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 10, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 19, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 19, j + 10, k + 26, 0);
        generate10(world, rand, i, j, k);
        return true;
    }

    public boolean generate10(World world, Random rand, int i, int j, int k)
    {
        world.setBlock(i + 19, j + 11, k + 0, 0);
        world.setBlock(i + 19, j + 11, k + 1, 0);
        world.setBlock(i + 19, j + 11, k + 2, 0);
        world.setBlock(i + 19, j + 11, k + 3, 0);
        world.setBlock(i + 19, j + 11, k + 4, 0);
        world.setBlock(i + 19, j + 11, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 19, j + 11, k + 6, 0);
        world.setBlock(i + 19, j + 11, k + 7, 0);
        world.setBlock(i + 19, j + 11, k + 8, 0);
        world.setBlock(i + 19, j + 11, k + 9, 0);
        world.setBlock(i + 19, j + 11, k + 10, 0);
        world.setBlock(i + 19, j + 11, k + 11, 0);
        world.setBlock(i + 19, j + 11, k + 12, 0);
        world.setBlock(i + 19, j + 11, k + 13, 0);
        world.setBlock(i + 19, j + 11, k + 14, 0);
        world.setBlock(i + 19, j + 11, k + 15, 0);
        world.setBlock(i + 19, j + 11, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 11, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 11, k + 18, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 19, j + 11, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 11, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 11, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 11, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 11, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 19, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 19, j + 11, k + 26, 0);
        world.setBlock(i + 19, j + 12, k + 0, 0);
        world.setBlock(i + 19, j + 12, k + 1, 0);
        world.setBlock(i + 19, j + 12, k + 2, 0);
        world.setBlock(i + 19, j + 12, k + 3, 0);
        world.setBlock(i + 19, j + 12, k + 4, 0);
        world.setBlock(i + 19, j + 12, k + 5, Block.thinGlass.blockID);
        world.setBlock(i + 19, j + 12, k + 6, 0);
        world.setBlock(i + 19, j + 12, k + 7, 0);
        world.setBlock(i + 19, j + 12, k + 8, 0);
        world.setBlock(i + 19, j + 12, k + 9, 0);
        world.setBlock(i + 19, j + 12, k + 10, 0);
        world.setBlock(i + 19, j + 12, k + 11, 0);
        world.setBlock(i + 19, j + 12, k + 12, 0);
        world.setBlock(i + 19, j + 12, k + 13, 0);
        world.setBlock(i + 19, j + 12, k + 14, 0);
        world.setBlock(i + 19, j + 12, k + 15, Block.glowStone.blockID);
        world.setBlock(i + 19, j + 12, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 12, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 12, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 12, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 12, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 12, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 12, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 19, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 19, j + 12, k + 26, 0);
        world.setBlock(i + 19, j + 13, k + 0, 0);
        world.setBlock(i + 19, j + 13, k + 1, 0);
        world.setBlock(i + 19, j + 13, k + 2, 0);
        world.setBlock(i + 19, j + 13, k + 3, 0);
        world.setBlock(i + 19, j + 13, k + 4, 0);
        world.setBlock(i + 19, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 13, k + 6, 0);
        world.setBlock(i + 19, j + 13, k + 7, 0);
        world.setBlock(i + 19, j + 13, k + 8, 0);
        world.setBlock(i + 19, j + 13, k + 9, 0);
        world.setBlock(i + 19, j + 13, k + 10, 0);
        world.setBlock(i + 19, j + 13, k + 11, 0);
        world.setBlock(i + 19, j + 13, k + 12, 0);
        world.setBlock(i + 19, j + 13, k + 13, 0);
        world.setBlock(i + 19, j + 13, k + 14, 0);
        world.setBlock(i + 19, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 13, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 13, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 13, k + 22, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 19, j + 13, k + 23, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 19, j + 13, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 13, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 13, k + 26, 0);
        world.setBlock(i + 19, j + 14, k + 0, 0);
        world.setBlock(i + 19, j + 14, k + 1, 0);
        world.setBlock(i + 19, j + 14, k + 2, 0);
        world.setBlock(i + 19, j + 14, k + 3, 0);
        world.setBlock(i + 19, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 22, 0);
        world.setBlock(i + 19, j + 14, k + 23, 0);
        world.setBlock(i + 19, j + 14, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 14, k + 26, 0);
        world.setBlock(i + 19, j + 15, k + 0, 0);
        world.setBlock(i + 19, j + 15, k + 1, 0);
        world.setBlock(i + 19, j + 15, k + 2, 0);
        world.setBlock(i + 19, j + 15, k + 3, 0);
        world.setBlock(i + 19, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 15, k + 5, 0);
        world.setBlock(i + 19, j + 15, k + 6, 0);
        world.setBlock(i + 19, j + 15, k + 7, 0);
        world.setBlock(i + 19, j + 15, k + 8, 0);
        world.setBlock(i + 19, j + 15, k + 9, 0);
        world.setBlock(i + 19, j + 15, k + 10, 0);
        world.setBlock(i + 19, j + 15, k + 11, 0);
        world.setBlock(i + 19, j + 15, k + 12, 0);
        world.setBlock(i + 19, j + 15, k + 13, 0);
        world.setBlock(i + 19, j + 15, k + 14, 0);
        world.setBlock(i + 19, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 15, k + 22, 0);
        world.setBlock(i + 19, j + 15, k + 23, 0);
        world.setBlock(i + 19, j + 15, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 15, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 15, k + 26, 0);
        world.setBlock(i + 19, j + 16, k + 0, 0);
        world.setBlock(i + 19, j + 16, k + 1, 0);
        world.setBlock(i + 19, j + 16, k + 2, 0);
        world.setBlock(i + 19, j + 16, k + 3, 0);
        world.setBlock(i + 19, j + 16, k + 4, 0);
        world.setBlock(i + 19, j + 16, k + 5, 0);
        world.setBlock(i + 19, j + 16, k + 6, 0);
        world.setBlock(i + 19, j + 16, k + 7, 0);
        world.setBlock(i + 19, j + 16, k + 8, 0);
        world.setBlock(i + 19, j + 16, k + 9, 0);
        world.setBlock(i + 19, j + 16, k + 10, 0);
        world.setBlock(i + 19, j + 16, k + 11, 0);
        world.setBlock(i + 19, j + 16, k + 12, 0);
        world.setBlock(i + 19, j + 16, k + 13, 0);
        world.setBlock(i + 19, j + 16, k + 14, 0);
        world.setBlock(i + 19, j + 16, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 16, k + 16, Block.bed.blockID, 3, 0);
        world.setBlock(i + 19, j + 16, k + 17, 0);
        world.setBlock(i + 19, j + 16, k + 18, 0);
        world.setBlock(i + 19, j + 16, k + 19, Block.bed.blockID);
        world.setBlock(i + 19, j + 16, k + 20, Block.bed.blockID, 8, 0);
        world.setBlock(i + 19, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 16, k + 22, 0);
        world.setBlock(i + 19, j + 16, k + 23, 0);
        world.setBlock(i + 19, j + 16, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 16, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 16, k + 26, 0);
        world.setBlock(i + 19, j + 17, k + 0, 0);
        world.setBlock(i + 19, j + 17, k + 1, 0);
        world.setBlock(i + 19, j + 17, k + 2, 0);
        world.setBlock(i + 19, j + 17, k + 3, 0);
        world.setBlock(i + 19, j + 17, k + 4, 0);
        world.setBlock(i + 19, j + 17, k + 5, 0);
        world.setBlock(i + 19, j + 17, k + 6, 0);
        world.setBlock(i + 19, j + 17, k + 7, 0);
        world.setBlock(i + 19, j + 17, k + 8, 0);
        world.setBlock(i + 19, j + 17, k + 9, 0);
        world.setBlock(i + 19, j + 17, k + 10, 0);
        world.setBlock(i + 19, j + 17, k + 11, 0);
        world.setBlock(i + 19, j + 17, k + 12, 0);
        world.setBlock(i + 19, j + 17, k + 13, 0);
        world.setBlock(i + 19, j + 17, k + 14, 0);
        world.setBlock(i + 19, j + 17, k + 15, Block.thinGlass.blockID);
        world.setBlock(i + 19, j + 17, k + 16, 0);
        world.setBlock(i + 19, j + 17, k + 17, 0);
        world.setBlock(i + 19, j + 17, k + 18, 0);
        world.setBlock(i + 19, j + 17, k + 19, 0);
        world.setBlock(i + 19, j + 17, k + 20, 0);
        world.setBlock(i + 19, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 17, k + 22, 0);
        world.setBlock(i + 19, j + 17, k + 23, 0);
        world.setBlock(i + 19, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 17, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 17, k + 26, 0);
        world.setBlock(i + 19, j + 18, k + 0, 0);
        world.setBlock(i + 19, j + 18, k + 1, 0);
        world.setBlock(i + 19, j + 18, k + 2, 0);
        world.setBlock(i + 19, j + 18, k + 3, 0);
        world.setBlock(i + 19, j + 18, k + 4, 0);
        world.setBlock(i + 19, j + 18, k + 5, 0);
        world.setBlock(i + 19, j + 18, k + 6, 0);
        world.setBlock(i + 19, j + 18, k + 7, 0);
        world.setBlock(i + 19, j + 18, k + 8, 0);
        world.setBlock(i + 19, j + 18, k + 9, 0);
        world.setBlock(i + 19, j + 18, k + 10, 0);
        world.setBlock(i + 19, j + 18, k + 11, 0);
        world.setBlock(i + 19, j + 18, k + 12, 0);
        world.setBlock(i + 19, j + 18, k + 13, 0);
        world.setBlock(i + 19, j + 18, k + 14, 0);
        world.setBlock(i + 19, j + 18, k + 15, Block.thinGlass.blockID);
        world.setBlock(i + 19, j + 18, k + 16, 0);
        world.setBlock(i + 19, j + 18, k + 17, 0);
        world.setBlock(i + 19, j + 18, k + 18, 0);
        world.setBlock(i + 19, j + 18, k + 19, 0);
        world.setBlock(i + 19, j + 18, k + 20, 0);
        world.setBlock(i + 19, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 18, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 18, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 18, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 18, k + 26, 0);
        world.setBlock(i + 19, j + 19, k + 0, 0);
        world.setBlock(i + 19, j + 19, k + 1, 0);
        world.setBlock(i + 19, j + 19, k + 2, 0);
        world.setBlock(i + 19, j + 19, k + 3, 0);
        world.setBlock(i + 19, j + 19, k + 4, 0);
        world.setBlock(i + 19, j + 19, k + 5, 0);
        world.setBlock(i + 19, j + 19, k + 6, 0);
        world.setBlock(i + 19, j + 19, k + 7, 0);
        world.setBlock(i + 19, j + 19, k + 8, 0);
        world.setBlock(i + 19, j + 19, k + 9, 0);
        world.setBlock(i + 19, j + 19, k + 10, 0);
        world.setBlock(i + 19, j + 19, k + 11, 0);
        world.setBlock(i + 19, j + 19, k + 12, 0);
        world.setBlock(i + 19, j + 19, k + 13, 0);
        world.setBlock(i + 19, j + 19, k + 14, 0);
        world.setBlock(i + 19, j + 19, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 19, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 19, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 19, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 19, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 19, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 19, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 19, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 19, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 19, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 19, j + 19, k + 26, 0);
        world.setBlock(i + 19, j + 20, k + 0, 0);
        world.setBlock(i + 19, j + 20, k + 1, 0);
        world.setBlock(i + 19, j + 20, k + 2, 0);
        world.setBlock(i + 19, j + 20, k + 3, 0);
        world.setBlock(i + 19, j + 20, k + 4, 0);
        world.setBlock(i + 19, j + 20, k + 5, 0);
        world.setBlock(i + 19, j + 20, k + 6, 0);
        world.setBlock(i + 19, j + 20, k + 7, 0);
        world.setBlock(i + 19, j + 20, k + 8, 0);
        world.setBlock(i + 19, j + 20, k + 9, 0);
        world.setBlock(i + 19, j + 20, k + 10, 0);
        world.setBlock(i + 19, j + 20, k + 11, 0);
        world.setBlock(i + 19, j + 20, k + 12, 0);
        world.setBlock(i + 19, j + 20, k + 13, 0);
        world.setBlock(i + 19, j + 20, k + 14, 0);
        world.setBlock(i + 19, j + 20, k + 15, 0);
        world.setBlock(i + 19, j + 20, k + 16, 0);
        world.setBlock(i + 19, j + 20, k + 17, 0);
        world.setBlock(i + 19, j + 20, k + 18, 0);
        world.setBlock(i + 19, j + 20, k + 19, 0);
        world.setBlock(i + 19, j + 20, k + 20, 0);
        world.setBlock(i + 19, j + 20, k + 21, 0);
        world.setBlock(i + 19, j + 20, k + 22, 0);
        world.setBlock(i + 19, j + 20, k + 23, 0);
        world.setBlock(i + 19, j + 20, k + 24, 0);
        world.setBlock(i + 19, j + 20, k + 25, 0);
        world.setBlock(i + 19, j + 20, k + 26, 0);
        world.setBlock(i + 19, j + 21, k + 0, 0);
        world.setBlock(i + 19, j + 21, k + 1, 0);
        world.setBlock(i + 19, j + 21, k + 2, 0);
        world.setBlock(i + 19, j + 21, k + 3, 0);
        world.setBlock(i + 19, j + 21, k + 4, 0);
        world.setBlock(i + 19, j + 21, k + 5, 0);
        world.setBlock(i + 19, j + 21, k + 6, 0);
        world.setBlock(i + 19, j + 21, k + 7, 0);
        world.setBlock(i + 19, j + 21, k + 8, 0);
        world.setBlock(i + 19, j + 21, k + 9, 0);
        world.setBlock(i + 19, j + 21, k + 10, 0);
        world.setBlock(i + 19, j + 21, k + 11, 0);
        world.setBlock(i + 19, j + 21, k + 12, 0);
        world.setBlock(i + 19, j + 21, k + 13, 0);
        world.setBlock(i + 19, j + 21, k + 14, 0);
        world.setBlock(i + 19, j + 21, k + 15, 0);
        world.setBlock(i + 19, j + 21, k + 16, 0);
        world.setBlock(i + 19, j + 21, k + 17, 0);
        world.setBlock(i + 19, j + 21, k + 18, 0);
        world.setBlock(i + 19, j + 21, k + 19, 0);
        world.setBlock(i + 19, j + 21, k + 20, 0);
        world.setBlock(i + 19, j + 21, k + 21, 0);
        world.setBlock(i + 19, j + 21, k + 22, 0);
        world.setBlock(i + 19, j + 21, k + 23, 0);
        world.setBlock(i + 19, j + 21, k + 24, 0);
        world.setBlock(i + 19, j + 21, k + 25, 0);
        world.setBlock(i + 19, j + 21, k + 26, 0);
        world.setBlock(i + 19, j + 22, k + 0, 0);
        world.setBlock(i + 19, j + 22, k + 1, 0);
        world.setBlock(i + 19, j + 22, k + 2, 0);
        world.setBlock(i + 19, j + 22, k + 3, 0);
        world.setBlock(i + 19, j + 22, k + 4, 0);
        world.setBlock(i + 19, j + 22, k + 5, 0);
        world.setBlock(i + 19, j + 22, k + 6, 0);
        world.setBlock(i + 19, j + 22, k + 7, 0);
        world.setBlock(i + 19, j + 22, k + 8, 0);
        world.setBlock(i + 19, j + 22, k + 9, 0);
        world.setBlock(i + 19, j + 22, k + 10, 0);
        world.setBlock(i + 19, j + 22, k + 11, 0);
        world.setBlock(i + 19, j + 22, k + 12, 0);
        world.setBlock(i + 19, j + 22, k + 13, 0);
        world.setBlock(i + 19, j + 22, k + 14, 0);
        world.setBlock(i + 19, j + 22, k + 15, 0);
        world.setBlock(i + 19, j + 22, k + 16, 0);
        world.setBlock(i + 19, j + 22, k + 17, 0);
        world.setBlock(i + 19, j + 22, k + 18, 0);
        world.setBlock(i + 19, j + 22, k + 19, 0);
        world.setBlock(i + 19, j + 22, k + 20, 0);
        world.setBlock(i + 19, j + 22, k + 21, 0);
        world.setBlock(i + 19, j + 22, k + 22, 0);
        world.setBlock(i + 19, j + 22, k + 23, 0);
        world.setBlock(i + 19, j + 22, k + 24, 0);
        world.setBlock(i + 19, j + 22, k + 25, 0);
        world.setBlock(i + 19, j + 22, k + 26, 0);
        world.setBlock(i + 19, j + 23, k + 0, 0);
        world.setBlock(i + 19, j + 23, k + 1, 0);
        world.setBlock(i + 19, j + 23, k + 2, 0);
        world.setBlock(i + 19, j + 23, k + 3, 0);
        world.setBlock(i + 19, j + 23, k + 4, 0);
        world.setBlock(i + 19, j + 23, k + 5, 0);
        world.setBlock(i + 19, j + 23, k + 6, 0);
        world.setBlock(i + 19, j + 23, k + 7, 0);
        world.setBlock(i + 19, j + 23, k + 8, 0);
        world.setBlock(i + 19, j + 23, k + 9, 0);
        world.setBlock(i + 19, j + 23, k + 10, 0);
        world.setBlock(i + 19, j + 23, k + 11, 0);
        world.setBlock(i + 19, j + 23, k + 12, 0);
        world.setBlock(i + 19, j + 23, k + 13, 0);
        world.setBlock(i + 19, j + 23, k + 14, 0);
        world.setBlock(i + 19, j + 23, k + 15, 0);
        world.setBlock(i + 19, j + 23, k + 16, 0);
        world.setBlock(i + 19, j + 23, k + 17, 0);
        world.setBlock(i + 19, j + 23, k + 18, 0);
        world.setBlock(i + 19, j + 23, k + 19, 0);
        world.setBlock(i + 19, j + 23, k + 20, 0);
        world.setBlock(i + 19, j + 23, k + 21, 0);
        world.setBlock(i + 19, j + 23, k + 22, 0);
        world.setBlock(i + 19, j + 23, k + 23, 0);
        world.setBlock(i + 19, j + 23, k + 24, 0);
        world.setBlock(i + 19, j + 23, k + 25, 0);
        world.setBlock(i + 19, j + 23, k + 26, 0);
        world.setBlock(i + 19, j + 24, k + 0, 0);
        world.setBlock(i + 19, j + 24, k + 1, 0);
        world.setBlock(i + 19, j + 24, k + 2, 0);
        world.setBlock(i + 19, j + 24, k + 3, 0);
        world.setBlock(i + 19, j + 24, k + 4, 0);
        world.setBlock(i + 19, j + 24, k + 5, 0);
        world.setBlock(i + 19, j + 24, k + 6, 0);
        world.setBlock(i + 19, j + 24, k + 7, 0);
        world.setBlock(i + 19, j + 24, k + 8, 0);
        world.setBlock(i + 19, j + 24, k + 9, 0);
        world.setBlock(i + 19, j + 24, k + 10, 0);
        world.setBlock(i + 19, j + 24, k + 11, 0);
        world.setBlock(i + 19, j + 24, k + 12, 0);
        world.setBlock(i + 19, j + 24, k + 13, 0);
        world.setBlock(i + 19, j + 24, k + 14, 0);
        world.setBlock(i + 19, j + 24, k + 15, 0);
        world.setBlock(i + 19, j + 24, k + 16, 0);
        world.setBlock(i + 19, j + 24, k + 17, 0);
        world.setBlock(i + 19, j + 24, k + 18, 0);
        world.setBlock(i + 19, j + 24, k + 19, 0);
        world.setBlock(i + 19, j + 24, k + 20, 0);
        world.setBlock(i + 19, j + 24, k + 21, 0);
        world.setBlock(i + 19, j + 24, k + 22, 0);
        world.setBlock(i + 19, j + 24, k + 23, 0);
        world.setBlock(i + 19, j + 24, k + 24, 0);
        world.setBlock(i + 19, j + 24, k + 25, 0);
        world.setBlock(i + 19, j + 24, k + 26, 0);
        world.setBlock(i + 19, j + 25, k + 0, 0);
        world.setBlock(i + 19, j + 25, k + 1, 0);
        world.setBlock(i + 19, j + 25, k + 2, 0);
        world.setBlock(i + 19, j + 25, k + 3, 0);
        world.setBlock(i + 19, j + 25, k + 4, 0);
        world.setBlock(i + 19, j + 25, k + 5, 0);
        world.setBlock(i + 19, j + 25, k + 6, 0);
        world.setBlock(i + 19, j + 25, k + 7, 0);
        world.setBlock(i + 19, j + 25, k + 8, 0);
        world.setBlock(i + 19, j + 25, k + 9, 0);
        world.setBlock(i + 19, j + 25, k + 10, 0);
        world.setBlock(i + 19, j + 25, k + 11, 0);
        world.setBlock(i + 19, j + 25, k + 12, 0);
        world.setBlock(i + 19, j + 25, k + 13, 0);
        world.setBlock(i + 19, j + 25, k + 14, 0);
        world.setBlock(i + 19, j + 25, k + 15, 0);
        world.setBlock(i + 19, j + 25, k + 16, 0);
        world.setBlock(i + 19, j + 25, k + 17, 0);
        world.setBlock(i + 19, j + 25, k + 18, 0);
        world.setBlock(i + 19, j + 25, k + 19, 0);
        world.setBlock(i + 19, j + 25, k + 20, 0);
        world.setBlock(i + 19, j + 25, k + 21, 0);
        world.setBlock(i + 19, j + 25, k + 22, 0);
        world.setBlock(i + 19, j + 25, k + 23, 0);
        world.setBlock(i + 19, j + 25, k + 24, 0);
        world.setBlock(i + 19, j + 25, k + 25, 0);
        world.setBlock(i + 19, j + 25, k + 26, 0);
        world.setBlock(i + 20, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 20, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 20, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 20, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 20, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 20, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 20, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 20, j + 2, k + 4, Block.grass.blockID);
        world.setBlock(i + 20, j + 2, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 2, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 2, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 22, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 20, j + 2, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 2, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 2, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 20, j + 3, k + 4, 0);
        world.setBlock(i + 20, j + 3, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 3, k + 6, 0);
        world.setBlock(i + 20, j + 3, k + 7, 0);
        world.setBlock(i + 20, j + 3, k + 8, 0);
        world.setBlock(i + 20, j + 3, k + 9, 0);
        world.setBlock(i + 20, j + 3, k + 10, 0);
        world.setBlock(i + 20, j + 3, k + 11, 0);
        world.setBlock(i + 20, j + 3, k + 12, 0);
        world.setBlock(i + 20, j + 3, k + 13, 0);
        world.setBlock(i + 20, j + 3, k + 14, 0);
        world.setBlock(i + 20, j + 3, k + 15, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 20, j + 3, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 3, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 3, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 3, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 3, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 3, k + 21, Block.chest.blockID, 4, 0);
        world.setBlock(i + 20, j + 3, k + 22, 0);
        world.setBlock(i + 20, j + 3, k + 23, Block.chest.blockID, 4, 0);
        world.setBlock(i + 20, j + 3, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 3, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 4, k + 0, 0);
        world.setBlock(i + 20, j + 4, k + 1, 0);
        world.setBlock(i + 20, j + 4, k + 2, 0);
        world.setBlock(i + 20, j + 4, k + 3, 0);
        world.setBlock(i + 20, j + 4, k + 4, 0);
        world.setBlock(i + 20, j + 4, k + 5, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 20, j + 4, k + 6, 0);
        world.setBlock(i + 20, j + 4, k + 7, 0);
        world.setBlock(i + 20, j + 4, k + 8, 0);
        world.setBlock(i + 20, j + 4, k + 9, 0);
        world.setBlock(i + 20, j + 4, k + 10, 0);
        world.setBlock(i + 20, j + 4, k + 11, 0);
        world.setBlock(i + 20, j + 4, k + 12, 0);
        world.setBlock(i + 20, j + 4, k + 13, 0);
        world.setBlock(i + 20, j + 4, k + 14, 0);
        world.setBlock(i + 20, j + 4, k + 15, 0);
        world.setBlock(i + 20, j + 4, k + 16, 0);
        world.setBlock(i + 20, j + 4, k + 17, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 20, j + 4, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 4, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 4, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 4, k + 21, Block.chest.blockID, 4, 0);
        world.setBlock(i + 20, j + 4, k + 22, 0);
        world.setBlock(i + 20, j + 4, k + 23, Block.chest.blockID, 4, 0);
        world.setBlock(i + 20, j + 4, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 4, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 4, k + 26, 0);
        world.setBlock(i + 20, j + 5, k + 0, 0);
        world.setBlock(i + 20, j + 5, k + 1, 0);
        world.setBlock(i + 20, j + 5, k + 2, 0);
        world.setBlock(i + 20, j + 5, k + 3, 0);
        world.setBlock(i + 20, j + 5, k + 4, 0);
        world.setBlock(i + 20, j + 5, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 5, k + 6, 0);
        world.setBlock(i + 20, j + 5, k + 7, 0);
        world.setBlock(i + 20, j + 5, k + 8, 0);
        world.setBlock(i + 20, j + 5, k + 9, 0);
        world.setBlock(i + 20, j + 5, k + 10, 0);
        world.setBlock(i + 20, j + 5, k + 11, 0);
        world.setBlock(i + 20, j + 5, k + 12, 0);
        world.setBlock(i + 20, j + 5, k + 13, 0);
        world.setBlock(i + 20, j + 5, k + 14, 0);
        world.setBlock(i + 20, j + 5, k + 15, 0);
        world.setBlock(i + 20, j + 5, k + 16, 0);
        world.setBlock(i + 20, j + 5, k + 17, 0);
        world.setBlock(i + 20, j + 5, k + 18, 0);
        world.setBlock(i + 20, j + 5, k + 19, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 20, j + 5, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 5, k + 21, 0);
        world.setBlock(i + 20, j + 5, k + 22, 0);
        world.setBlock(i + 20, j + 5, k + 23, 0);
        world.setBlock(i + 20, j + 5, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 5, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 5, k + 26, 0);
        world.setBlock(i + 20, j + 6, k + 0, 0);
        world.setBlock(i + 20, j + 6, k + 1, 0);
        world.setBlock(i + 20, j + 6, k + 2, 0);
        world.setBlock(i + 20, j + 6, k + 3, 0);
        world.setBlock(i + 20, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 6, k + 6, 0);
        world.setBlock(i + 20, j + 6, k + 7, 0);
        world.setBlock(i + 20, j + 6, k + 8, 0);
        world.setBlock(i + 20, j + 6, k + 9, Block.glowStone.blockID);
        world.setBlock(i + 20, j + 6, k + 10, 0);
        world.setBlock(i + 20, j + 6, k + 11, Block.glowStone.blockID);
        world.setBlock(i + 20, j + 6, k + 12, 0);
        world.setBlock(i + 20, j + 6, k + 13, 0);
        world.setBlock(i + 20, j + 6, k + 14, 0);
        world.setBlock(i + 20, j + 6, k + 15, 0);
        world.setBlock(i + 20, j + 6, k + 16, 0);
        world.setBlock(i + 20, j + 6, k + 17, 0);
        world.setBlock(i + 20, j + 6, k + 18, 0);
        world.setBlock(i + 20, j + 6, k + 19, 0);
        world.setBlock(i + 20, j + 6, k + 20, 0);
        world.setBlock(i + 20, j + 6, k + 21, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 20, j + 6, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 6, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 6, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 6, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 6, k + 26, 0);
        world.setBlock(i + 20, j + 7, k + 0, 0);
        world.setBlock(i + 20, j + 7, k + 1, 0);
        world.setBlock(i + 20, j + 7, k + 2, 0);
        world.setBlock(i + 20, j + 7, k + 3, 0);
        world.setBlock(i + 20, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 7, k + 6, Block.web.blockID);
        world.setBlock(i + 20, j + 7, k + 7, 0);
        world.setBlock(i + 20, j + 7, k + 8, 0);
        world.setBlock(i + 20, j + 7, k + 9, Block.fence.blockID);
        world.setBlock(i + 20, j + 7, k + 10, 0);
        world.setBlock(i + 20, j + 7, k + 11, Block.fence.blockID);
        world.setBlock(i + 20, j + 7, k + 12, 0);
        world.setBlock(i + 20, j + 7, k + 13, 0);
        world.setBlock(i + 20, j + 7, k + 14, 0);
        world.setBlock(i + 20, j + 7, k + 15, 0);
        world.setBlock(i + 20, j + 7, k + 16, 0);
        world.setBlock(i + 20, j + 7, k + 17, 0);
        world.setBlock(i + 20, j + 7, k + 18, 0);
        world.setBlock(i + 20, j + 7, k + 19, 0);
        world.setBlock(i + 20, j + 7, k + 20, 0);
        world.setBlock(i + 20, j + 7, k + 21, 0);
        world.setBlock(i + 20, j + 7, k + 22, 0);
        world.setBlock(i + 20, j + 7, k + 23, 0);
        world.setBlock(i + 20, j + 7, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 7, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 7, k + 26, 0);
        world.setBlock(i + 20, j + 8, k + 0, 0);
        world.setBlock(i + 20, j + 8, k + 1, 0);
        world.setBlock(i + 20, j + 8, k + 2, 0);
        world.setBlock(i + 20, j + 8, k + 3, 0);
        world.setBlock(i + 20, j + 8, k + 4, 0);
        world.setBlock(i + 20, j + 8, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 8, k + 6, 0);
        world.setBlock(i + 20, j + 8, k + 7, 0);
        world.setBlock(i + 20, j + 8, k + 8, 0);
        world.setBlock(i + 20, j + 8, k + 9, 0);
        world.setBlock(i + 20, j + 8, k + 10, 0);
        world.setBlock(i + 20, j + 8, k + 11, 0);
        world.setBlock(i + 20, j + 8, k + 12, 0);
        world.setBlock(i + 20, j + 8, k + 13, 0);
        world.setBlock(i + 20, j + 8, k + 14, 0);
        world.setBlock(i + 20, j + 8, k + 15, 0);
        world.setBlock(i + 20, j + 8, k + 16, 0);
        world.setBlock(i + 20, j + 8, k + 17, Block.glowStone.blockID);
        world.setBlock(i + 20, j + 8, k + 18, 0);
        world.setBlock(i + 20, j + 8, k + 19, 0);
        world.setBlock(i + 20, j + 8, k + 20, 0);
        world.setBlock(i + 20, j + 8, k + 21, 0);
        world.setBlock(i + 20, j + 8, k + 22, 0);
        world.setBlock(i + 20, j + 8, k + 23, 0);
        world.setBlock(i + 20, j + 8, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 8, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 8, k + 26, 0);
        world.setBlock(i + 20, j + 9, k + 0, 0);
        world.setBlock(i + 20, j + 9, k + 1, 0);
        world.setBlock(i + 20, j + 9, k + 2, 0);
        world.setBlock(i + 20, j + 9, k + 3, 0);
        world.setBlock(i + 20, j + 9, k + 4, 0);
        world.setBlock(i + 20, j + 9, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 9, k + 21, 0);
        world.setBlock(i + 20, j + 9, k + 22, 0);
        world.setBlock(i + 20, j + 9, k + 23, 0);
        world.setBlock(i + 20, j + 9, k + 24, Block.glowStone.blockID);
        world.setBlock(i + 20, j + 9, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 9, k + 26, 0);
        world.setBlock(i + 20, j + 10, k + 0, 0);
        world.setBlock(i + 20, j + 10, k + 1, 0);
        world.setBlock(i + 20, j + 10, k + 2, 0);
        world.setBlock(i + 20, j + 10, k + 3, 0);
        world.setBlock(i + 20, j + 10, k + 4, 0);
        world.setBlock(i + 20, j + 10, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 10, k + 6, Block.bookShelf.blockID);
        world.setBlock(i + 20, j + 10, k + 7, Block.bookShelf.blockID);
        world.setBlock(i + 20, j + 10, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 10, k + 9, Block.bookShelf.blockID);
        world.setBlock(i + 20, j + 10, k + 10, Block.bookShelf.blockID);
        world.setBlock(i + 20, j + 10, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 10, k + 12, Block.furnaceIdle.blockID, 4, 0);
        world.setBlock(i + 20, j + 10, k + 13, 0);
        world.setBlock(i + 20, j + 10, k + 14, 0);
        world.setBlock(i + 20, j + 10, k + 16, 0);
        world.setBlock(i + 20, j + 10, k + 17, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 20, j + 10, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 10, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 10, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 10, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 10, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 10, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 10, k + 26, 0);
        world.setBlock(i + 20, j + 11, k + 0, 0);
        world.setBlock(i + 20, j + 11, k + 1, 0);
        world.setBlock(i + 20, j + 11, k + 2, 0);
        world.setBlock(i + 20, j + 11, k + 3, 0);
        world.setBlock(i + 20, j + 11, k + 4, 0);
        world.setBlock(i + 20, j + 11, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 11, k + 6, Block.bookShelf.blockID);
        world.setBlock(i + 20, j + 11, k + 7, Block.bookShelf.blockID);
        world.setBlock(i + 20, j + 11, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 11, k + 9, Block.bookShelf.blockID);
        world.setBlock(i + 20, j + 11, k + 10, Block.bookShelf.blockID);
        world.setBlock(i + 20, j + 11, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 11, k + 12, 0);
        world.setBlock(i + 20, j + 11, k + 13, 0);
        world.setBlock(i + 20, j + 11, k + 14, 0);
        world.setBlock(i + 20, j + 11, k + 16, 0);
        world.setBlock(i + 20, j + 11, k + 17, 0);
        world.setBlock(i + 20, j + 11, k + 18, 0);
        world.setBlock(i + 20, j + 11, k + 19, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 20, j + 11, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 11, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 11, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 11, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 11, k + 26, 0);
        world.setBlock(i + 20, j + 12, k + 0, 0);
        world.setBlock(i + 20, j + 12, k + 1, 0);
        world.setBlock(i + 20, j + 12, k + 2, 0);
        world.setBlock(i + 20, j + 12, k + 3, 0);
        world.setBlock(i + 20, j + 12, k + 4, 0);
        world.setBlock(i + 20, j + 12, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 12, k + 6, Block.bookShelf.blockID);
        world.setBlock(i + 20, j + 12, k + 7, Block.bookShelf.blockID);
        world.setBlock(i + 20, j + 12, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 12, k + 9, Block.bookShelf.blockID);
        world.setBlock(i + 20, j + 12, k + 10, Block.bookShelf.blockID);
        world.setBlock(i + 20, j + 12, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 12, k + 12, 0);
        world.setBlock(i + 20, j + 12, k + 13, 0);
        world.setBlock(i + 20, j + 12, k + 14, 0);
        world.setBlock(i + 20, j + 12, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 12, k + 16, 0);
        world.setBlock(i + 20, j + 12, k + 17, 0);
        world.setBlock(i + 20, j + 12, k + 18, 0);
        world.setBlock(i + 20, j + 12, k + 19, 0);
        world.setBlock(i + 20, j + 12, k + 20, 0);
        world.setBlock(i + 20, j + 12, k + 21, Fossil.ancientStoneSingleSlab.blockID, 5, 0);
        world.setBlock(i + 20, j + 12, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 12, k + 26, 0);
        world.setBlock(i + 20, j + 13, k + 0, 0);
        world.setBlock(i + 20, j + 13, k + 1, 0);
        world.setBlock(i + 20, j + 13, k + 2, 0);
        world.setBlock(i + 20, j + 13, k + 3, 0);
        world.setBlock(i + 20, j + 13, k + 4, 0);
        world.setBlock(i + 20, j + 13, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 13, k + 6, 0);
        world.setBlock(i + 20, j + 13, k + 7, Block.web.blockID);
        world.setBlock(i + 20, j + 13, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 13, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 13, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 13, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 13, k + 12, Block.glowStone.blockID);
        world.setBlock(i + 20, j + 13, k + 13, 0);
        world.setBlock(i + 20, j + 13, k + 14, 0);
        world.setBlock(i + 20, j + 13, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 13, k + 17, Block.glowStone.blockID);
        world.setBlock(i + 20, j + 13, k + 18, 0);
        world.setBlock(i + 20, j + 13, k + 19, 0);
        world.setBlock(i + 20, j + 13, k + 20, 0);
        world.setBlock(i + 20, j + 13, k + 21, 0);
        world.setBlock(i + 20, j + 13, k + 22, 0);
        world.setBlock(i + 20, j + 13, k + 23, 0);
        world.setBlock(i + 20, j + 13, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 13, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 13, k + 26, 0);
        world.setBlock(i + 20, j + 14, k + 0, 0);
        world.setBlock(i + 20, j + 14, k + 1, 0);
        world.setBlock(i + 20, j + 14, k + 2, 0);
        world.setBlock(i + 20, j + 14, k + 3, 0);
        world.setBlock(i + 20, j + 14, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 14, k + 20, 0);
        world.setBlock(i + 20, j + 14, k + 21, 0);
        world.setBlock(i + 20, j + 14, k + 22, 0);
        world.setBlock(i + 20, j + 14, k + 23, 0);
        world.setBlock(i + 20, j + 14, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 14, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 14, k + 26, 0);
        world.setBlock(i + 20, j + 15, k + 0, 0);
        world.setBlock(i + 20, j + 15, k + 1, 0);
        world.setBlock(i + 20, j + 15, k + 2, 0);
        world.setBlock(i + 20, j + 15, k + 3, 0);
        world.setBlock(i + 20, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 15, k + 5, 0);
        world.setBlock(i + 20, j + 15, k + 6, 0);
        world.setBlock(i + 20, j + 15, k + 7, 0);
        world.setBlock(i + 20, j + 15, k + 8, 0);
        world.setBlock(i + 20, j + 15, k + 9, 0);
        world.setBlock(i + 20, j + 15, k + 10, 0);
        world.setBlock(i + 20, j + 15, k + 11, 0);
        world.setBlock(i + 20, j + 15, k + 12, 0);
        world.setBlock(i + 20, j + 15, k + 13, 0);
        world.setBlock(i + 20, j + 15, k + 14, 0);
        world.setBlock(i + 20, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 15, k + 22, 0);
        world.setBlock(i + 20, j + 15, k + 23, 0);
        world.setBlock(i + 20, j + 15, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 15, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 15, k + 26, 0);
        world.setBlock(i + 20, j + 16, k + 0, 0);
        world.setBlock(i + 20, j + 16, k + 1, 0);
        world.setBlock(i + 20, j + 16, k + 2, 0);
        world.setBlock(i + 20, j + 16, k + 3, 0);
        world.setBlock(i + 20, j + 16, k + 4, 0);
        world.setBlock(i + 20, j + 16, k + 5, 0);
        world.setBlock(i + 20, j + 16, k + 6, 0);
        world.setBlock(i + 20, j + 16, k + 7, 0);
        world.setBlock(i + 20, j + 16, k + 8, 0);
        world.setBlock(i + 20, j + 16, k + 9, 0);
        world.setBlock(i + 20, j + 16, k + 10, 0);
        world.setBlock(i + 20, j + 16, k + 11, 0);
        world.setBlock(i + 20, j + 16, k + 12, 0);
        world.setBlock(i + 20, j + 16, k + 13, 0);
        world.setBlock(i + 20, j + 16, k + 14, 0);
        world.setBlock(i + 20, j + 16, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 16, k + 16, Block.bed.blockID, 11, 0);
        world.setBlock(i + 20, j + 16, k + 17, 0);
        world.setBlock(i + 20, j + 16, k + 18, 0);
        world.setBlock(i + 20, j + 16, k + 19, 0);
        world.setBlock(i + 20, j + 16, k + 20, 0);
        world.setBlock(i + 20, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 16, k + 22, 0);
        world.setBlock(i + 20, j + 16, k + 23, 0);
        world.setBlock(i + 20, j + 16, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 16, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 20, j + 16, k + 26, 0);
        world.setBlock(i + 20, j + 17, k + 0, 0);
        world.setBlock(i + 20, j + 17, k + 1, 0);
        world.setBlock(i + 20, j + 17, k + 2, 0);
        world.setBlock(i + 20, j + 17, k + 3, 0);
        world.setBlock(i + 20, j + 17, k + 4, 0);
        world.setBlock(i + 20, j + 17, k + 5, 0);
        world.setBlock(i + 20, j + 17, k + 6, 0);
        world.setBlock(i + 20, j + 17, k + 7, 0);
        world.setBlock(i + 20, j + 17, k + 8, 0);
        world.setBlock(i + 20, j + 17, k + 9, 0);
        world.setBlock(i + 20, j + 17, k + 10, 0);
        world.setBlock(i + 20, j + 17, k + 11, 0);
        world.setBlock(i + 20, j + 17, k + 12, 0);
        world.setBlock(i + 20, j + 17, k + 13, 0);
        world.setBlock(i + 20, j + 17, k + 14, 0);
        world.setBlock(i + 20, j + 17, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 17, k + 16, 0);
        world.setBlock(i + 20, j + 17, k + 17, 0);
        world.setBlock(i + 20, j + 17, k + 18, 0);
        world.setBlock(i + 20, j + 17, k + 19, 0);
        world.setBlock(i + 20, j + 17, k + 20, 0);
        world.setBlock(i + 20, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 17, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 17, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 17, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 17, k + 26, 0);
        world.setBlock(i + 20, j + 18, k + 0, 0);
        world.setBlock(i + 20, j + 18, k + 1, 0);
        world.setBlock(i + 20, j + 18, k + 2, 0);
        world.setBlock(i + 20, j + 18, k + 3, 0);
        world.setBlock(i + 20, j + 18, k + 4, 0);
        world.setBlock(i + 20, j + 18, k + 5, 0);
        world.setBlock(i + 20, j + 18, k + 6, 0);
        world.setBlock(i + 20, j + 18, k + 7, 0);
        world.setBlock(i + 20, j + 18, k + 8, 0);
        world.setBlock(i + 20, j + 18, k + 9, 0);
        world.setBlock(i + 20, j + 18, k + 10, 0);
        world.setBlock(i + 20, j + 18, k + 11, 0);
        world.setBlock(i + 20, j + 18, k + 12, 0);
        world.setBlock(i + 20, j + 18, k + 13, 0);
        world.setBlock(i + 20, j + 18, k + 14, 0);
        world.setBlock(i + 20, j + 18, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 18, k + 16, 0);
        world.setBlock(i + 20, j + 18, k + 17, 0);
        world.setBlock(i + 20, j + 18, k + 18, Block.glowStone.blockID);
        world.setBlock(i + 20, j + 18, k + 19, 0);
        world.setBlock(i + 20, j + 18, k + 20, 0);
        world.setBlock(i + 20, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 18, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 18, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 18, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 18, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 18, k + 26, 0);
        world.setBlock(i + 20, j + 19, k + 0, 0);
        world.setBlock(i + 20, j + 19, k + 1, 0);
        world.setBlock(i + 20, j + 19, k + 2, 0);
        world.setBlock(i + 20, j + 19, k + 3, 0);
        world.setBlock(i + 20, j + 19, k + 4, 0);
        world.setBlock(i + 20, j + 19, k + 5, 0);
        world.setBlock(i + 20, j + 19, k + 6, 0);
        world.setBlock(i + 20, j + 19, k + 7, 0);
        world.setBlock(i + 20, j + 19, k + 8, 0);
        world.setBlock(i + 20, j + 19, k + 9, 0);
        world.setBlock(i + 20, j + 19, k + 10, 0);
        world.setBlock(i + 20, j + 19, k + 11, 0);
        world.setBlock(i + 20, j + 19, k + 12, 0);
        world.setBlock(i + 20, j + 19, k + 13, 0);
        world.setBlock(i + 20, j + 19, k + 14, 0);
        world.setBlock(i + 20, j + 19, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 19, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 19, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 19, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 19, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 19, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 20, j + 19, k + 22, 0);
        world.setBlock(i + 20, j + 19, k + 23, 0);
        world.setBlock(i + 20, j + 19, k + 24, 0);
        world.setBlock(i + 20, j + 19, k + 25, 0);
        world.setBlock(i + 20, j + 19, k + 26, 0);
        world.setBlock(i + 20, j + 20, k + 0, 0);
        world.setBlock(i + 20, j + 20, k + 1, 0);
        world.setBlock(i + 20, j + 20, k + 2, 0);
        world.setBlock(i + 20, j + 20, k + 3, 0);
        world.setBlock(i + 20, j + 20, k + 4, 0);
        world.setBlock(i + 20, j + 20, k + 5, 0);
        world.setBlock(i + 20, j + 20, k + 6, 0);
        world.setBlock(i + 20, j + 20, k + 7, 0);
        world.setBlock(i + 20, j + 20, k + 8, 0);
        world.setBlock(i + 20, j + 20, k + 9, 0);
        world.setBlock(i + 20, j + 20, k + 10, 0);
        world.setBlock(i + 20, j + 20, k + 11, 0);
        world.setBlock(i + 20, j + 20, k + 12, 0);
        world.setBlock(i + 20, j + 20, k + 13, 0);
        world.setBlock(i + 20, j + 20, k + 14, 0);
        world.setBlock(i + 20, j + 20, k + 15, 0);
        world.setBlock(i + 20, j + 20, k + 16, 0);
        world.setBlock(i + 20, j + 20, k + 17, 0);
        world.setBlock(i + 20, j + 20, k + 18, 0);
        world.setBlock(i + 20, j + 20, k + 19, 0);
        world.setBlock(i + 20, j + 20, k + 20, 0);
        world.setBlock(i + 20, j + 20, k + 21, 0);
        world.setBlock(i + 20, j + 20, k + 22, 0);
        world.setBlock(i + 20, j + 20, k + 23, 0);
        world.setBlock(i + 20, j + 20, k + 24, 0);
        world.setBlock(i + 20, j + 20, k + 25, 0);
        world.setBlock(i + 20, j + 20, k + 26, 0);
        world.setBlock(i + 20, j + 21, k + 0, 0);
        world.setBlock(i + 20, j + 21, k + 1, 0);
        world.setBlock(i + 20, j + 21, k + 2, 0);
        world.setBlock(i + 20, j + 21, k + 3, 0);
        world.setBlock(i + 20, j + 21, k + 4, 0);
        world.setBlock(i + 20, j + 21, k + 5, 0);
        world.setBlock(i + 20, j + 21, k + 6, 0);
        world.setBlock(i + 20, j + 21, k + 7, 0);
        world.setBlock(i + 20, j + 21, k + 8, 0);
        world.setBlock(i + 20, j + 21, k + 9, 0);
        world.setBlock(i + 20, j + 21, k + 10, 0);
        world.setBlock(i + 20, j + 21, k + 11, 0);
        world.setBlock(i + 20, j + 21, k + 12, 0);
        world.setBlock(i + 20, j + 21, k + 13, 0);
        world.setBlock(i + 20, j + 21, k + 14, 0);
        world.setBlock(i + 20, j + 21, k + 15, 0);
        world.setBlock(i + 20, j + 21, k + 16, 0);
        world.setBlock(i + 20, j + 21, k + 17, 0);
        world.setBlock(i + 20, j + 21, k + 18, 0);
        world.setBlock(i + 20, j + 21, k + 19, 0);
        world.setBlock(i + 20, j + 21, k + 20, 0);
        world.setBlock(i + 20, j + 21, k + 21, 0);
        world.setBlock(i + 20, j + 21, k + 22, 0);
        world.setBlock(i + 20, j + 21, k + 23, 0);
        world.setBlock(i + 20, j + 21, k + 24, 0);
        world.setBlock(i + 20, j + 21, k + 25, 0);
        world.setBlock(i + 20, j + 21, k + 26, 0);
        world.setBlock(i + 20, j + 22, k + 0, 0);
        world.setBlock(i + 20, j + 22, k + 1, 0);
        world.setBlock(i + 20, j + 22, k + 2, 0);
        world.setBlock(i + 20, j + 22, k + 3, 0);
        world.setBlock(i + 20, j + 22, k + 4, 0);
        world.setBlock(i + 20, j + 22, k + 5, 0);
        world.setBlock(i + 20, j + 22, k + 6, 0);
        world.setBlock(i + 20, j + 22, k + 7, 0);
        world.setBlock(i + 20, j + 22, k + 8, 0);
        world.setBlock(i + 20, j + 22, k + 9, 0);
        world.setBlock(i + 20, j + 22, k + 10, 0);
        world.setBlock(i + 20, j + 22, k + 11, 0);
        world.setBlock(i + 20, j + 22, k + 12, 0);
        world.setBlock(i + 20, j + 22, k + 13, 0);
        world.setBlock(i + 20, j + 22, k + 14, 0);
        world.setBlock(i + 20, j + 22, k + 15, 0);
        world.setBlock(i + 20, j + 22, k + 16, 0);
        world.setBlock(i + 20, j + 22, k + 17, 0);
        world.setBlock(i + 20, j + 22, k + 18, 0);
        world.setBlock(i + 20, j + 22, k + 19, 0);
        world.setBlock(i + 20, j + 22, k + 20, 0);
        world.setBlock(i + 20, j + 22, k + 21, 0);
        world.setBlock(i + 20, j + 22, k + 22, 0);
        world.setBlock(i + 20, j + 22, k + 23, 0);
        world.setBlock(i + 20, j + 22, k + 24, 0);
        world.setBlock(i + 20, j + 22, k + 25, 0);
        world.setBlock(i + 20, j + 22, k + 26, 0);
        world.setBlock(i + 20, j + 23, k + 0, 0);
        world.setBlock(i + 20, j + 23, k + 1, 0);
        world.setBlock(i + 20, j + 23, k + 2, 0);
        world.setBlock(i + 20, j + 23, k + 3, 0);
        world.setBlock(i + 20, j + 23, k + 4, 0);
        world.setBlock(i + 20, j + 23, k + 5, 0);
        world.setBlock(i + 20, j + 23, k + 6, 0);
        world.setBlock(i + 20, j + 23, k + 7, 0);
        world.setBlock(i + 20, j + 23, k + 8, 0);
        world.setBlock(i + 20, j + 23, k + 9, 0);
        world.setBlock(i + 20, j + 23, k + 10, 0);
        world.setBlock(i + 20, j + 23, k + 11, 0);
        world.setBlock(i + 20, j + 23, k + 12, 0);
        world.setBlock(i + 20, j + 23, k + 13, 0);
        world.setBlock(i + 20, j + 23, k + 14, 0);
        world.setBlock(i + 20, j + 23, k + 15, 0);
        world.setBlock(i + 20, j + 23, k + 16, 0);
        world.setBlock(i + 20, j + 23, k + 17, 0);
        world.setBlock(i + 20, j + 23, k + 18, 0);
        world.setBlock(i + 20, j + 23, k + 19, 0);
        world.setBlock(i + 20, j + 23, k + 20, 0);
        world.setBlock(i + 20, j + 23, k + 21, 0);
        world.setBlock(i + 20, j + 23, k + 22, 0);
        world.setBlock(i + 20, j + 23, k + 23, 0);
        world.setBlock(i + 20, j + 23, k + 24, 0);
        world.setBlock(i + 20, j + 23, k + 25, 0);
        world.setBlock(i + 20, j + 23, k + 26, 0);
        world.setBlock(i + 20, j + 24, k + 0, 0);
        world.setBlock(i + 20, j + 24, k + 1, 0);
        world.setBlock(i + 20, j + 24, k + 2, 0);
        world.setBlock(i + 20, j + 24, k + 3, 0);
        world.setBlock(i + 20, j + 24, k + 4, 0);
        world.setBlock(i + 20, j + 24, k + 5, 0);
        world.setBlock(i + 20, j + 24, k + 6, 0);
        world.setBlock(i + 20, j + 24, k + 7, 0);
        world.setBlock(i + 20, j + 24, k + 8, 0);
        world.setBlock(i + 20, j + 24, k + 9, 0);
        world.setBlock(i + 20, j + 24, k + 10, 0);
        world.setBlock(i + 20, j + 24, k + 11, 0);
        world.setBlock(i + 20, j + 24, k + 12, 0);
        world.setBlock(i + 20, j + 24, k + 13, 0);
        world.setBlock(i + 20, j + 24, k + 14, 0);
        world.setBlock(i + 20, j + 24, k + 15, 0);
        world.setBlock(i + 20, j + 24, k + 16, 0);
        world.setBlock(i + 20, j + 24, k + 17, 0);
        world.setBlock(i + 20, j + 24, k + 18, 0);
        world.setBlock(i + 20, j + 24, k + 19, 0);
        world.setBlock(i + 20, j + 24, k + 20, 0);
        world.setBlock(i + 20, j + 24, k + 21, 0);
        world.setBlock(i + 20, j + 24, k + 22, 0);
        world.setBlock(i + 20, j + 24, k + 23, 0);
        world.setBlock(i + 20, j + 24, k + 24, 0);
        world.setBlock(i + 20, j + 24, k + 25, 0);
        world.setBlock(i + 20, j + 24, k + 26, 0);
        world.setBlock(i + 20, j + 25, k + 0, 0);
        world.setBlock(i + 20, j + 25, k + 1, 0);
        world.setBlock(i + 20, j + 25, k + 2, 0);
        world.setBlock(i + 20, j + 25, k + 3, 0);
        world.setBlock(i + 20, j + 25, k + 4, 0);
        world.setBlock(i + 20, j + 25, k + 5, 0);
        world.setBlock(i + 20, j + 25, k + 6, 0);
        world.setBlock(i + 20, j + 25, k + 7, 0);
        world.setBlock(i + 20, j + 25, k + 8, 0);
        world.setBlock(i + 20, j + 25, k + 9, 0);
        world.setBlock(i + 20, j + 25, k + 10, 0);
        world.setBlock(i + 20, j + 25, k + 11, 0);
        world.setBlock(i + 20, j + 25, k + 12, 0);
        world.setBlock(i + 20, j + 25, k + 13, 0);
        world.setBlock(i + 20, j + 25, k + 14, 0);
        world.setBlock(i + 20, j + 25, k + 15, 0);
        world.setBlock(i + 20, j + 25, k + 16, 0);
        world.setBlock(i + 20, j + 25, k + 17, 0);
        world.setBlock(i + 20, j + 25, k + 18, 0);
        world.setBlock(i + 20, j + 25, k + 19, 0);
        world.setBlock(i + 20, j + 25, k + 20, 0);
        world.setBlock(i + 20, j + 25, k + 21, 0);
        world.setBlock(i + 20, j + 25, k + 22, 0);
        world.setBlock(i + 20, j + 25, k + 23, 0);
        world.setBlock(i + 20, j + 25, k + 24, 0);
        world.setBlock(i + 20, j + 25, k + 25, 0);
        world.setBlock(i + 20, j + 25, k + 26, 0);
        world.setBlock(i + 21, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 21, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 21, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 21, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 21, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 21, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 21, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 21, j + 2, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 2, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 2, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 2, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 2, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 2, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 2, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 2, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 2, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 21, j + 3, k + 0, 0);
        world.setBlock(i + 21, j + 3, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 3, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 9, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 21, j + 3, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 3, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 3, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 3, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 3, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 3, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 3, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 3, k + 26, 0);
        world.setBlock(i + 21, j + 4, k + 0, 0);
        world.setBlock(i + 21, j + 4, k + 1, 0);
        world.setBlock(i + 21, j + 4, k + 2, 0);
        world.setBlock(i + 21, j + 4, k + 3, 0);
        world.setBlock(i + 21, j + 4, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 4, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 4, k + 6, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 21, j + 4, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 4, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 4, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 4, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 4, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 4, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 4, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 4, k + 26, 0);
        world.setBlock(i + 21, j + 5, k + 0, 0);
        world.setBlock(i + 21, j + 5, k + 1, 0);
        world.setBlock(i + 21, j + 5, k + 2, 0);
        world.setBlock(i + 21, j + 5, k + 3, 0);
        world.setBlock(i + 21, j + 5, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 5, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 5, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 5, k + 8, Fossil.ancientGlass.blockID);
        world.setBlock(i + 21, j + 5, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 5, k + 10, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 5, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 5, k + 12, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 5, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 5, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 5, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 5, k + 16, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 5, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 5, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 5, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 5, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 5, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 5, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 5, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 5, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 5, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 5, k + 26, 0);
        world.setBlock(i + 21, j + 6, k + 0, 0);
        world.setBlock(i + 21, j + 6, k + 1, 0);
        world.setBlock(i + 21, j + 6, k + 2, 0);
        world.setBlock(i + 21, j + 6, k + 3, 0);
        world.setBlock(i + 21, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 6, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 6, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 6, k + 8, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 6, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 6, k + 10, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 6, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 6, k + 12, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 6, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 6, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 6, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 6, k + 16, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 6, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 6, k + 18, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 6, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 6, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 6, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 6, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 6, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 6, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 6, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 6, k + 26, 0);
        world.setBlock(i + 21, j + 7, k + 0, 0);
        world.setBlock(i + 21, j + 7, k + 1, 0);
        world.setBlock(i + 21, j + 7, k + 2, 0);
        world.setBlock(i + 21, j + 7, k + 3, 0);
        world.setBlock(i + 21, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 7, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 7, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 7, k + 8, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 7, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 7, k + 10, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 7, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 7, k + 12, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 7, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 7, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 7, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 7, k + 16, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 7, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 7, k + 18, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 7, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 7, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 7, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 7, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 7, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 7, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 7, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 7, k + 26, 0);
        world.setBlock(i + 21, j + 8, k + 0, 0);
        world.setBlock(i + 21, j + 8, k + 1, 0);
        world.setBlock(i + 21, j + 8, k + 2, 0);
        world.setBlock(i + 21, j + 8, k + 3, 0);
        world.setBlock(i + 21, j + 8, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 8, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 8, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 8, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 8, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 8, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 8, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 8, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 8, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 8, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 8, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 8, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 8, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 8, k + 18, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 8, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 8, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 8, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 8, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 8, k + 23, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 8, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 8, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 8, k + 26, 0);
        world.setBlock(i + 21, j + 9, k + 0, 0);
        world.setBlock(i + 21, j + 9, k + 1, 0);
        world.setBlock(i + 21, j + 9, k + 2, 0);
        world.setBlock(i + 21, j + 9, k + 3, 0);
        world.setBlock(i + 21, j + 9, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 7, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 8, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 9, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 10, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 11, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 12, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 13, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 9, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 9, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 9, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 21, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 9, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 9, k + 23, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 9, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 9, k + 26, 0);
        world.setBlock(i + 21, j + 10, k + 0, 0);
        world.setBlock(i + 21, j + 10, k + 1, 0);
        world.setBlock(i + 21, j + 10, k + 2, 0);
        world.setBlock(i + 21, j + 10, k + 3, 0);
        world.setBlock(i + 21, j + 10, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 7, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 8, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 9, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 10, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 11, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 12, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 13, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 16, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 17, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 18, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 21, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 22, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 10, k + 26, 0);
        world.setBlock(i + 21, j + 11, k + 0, 0);
        world.setBlock(i + 21, j + 11, k + 1, 0);
        world.setBlock(i + 21, j + 11, k + 2, 0);
        world.setBlock(i + 21, j + 11, k + 3, 0);
        world.setBlock(i + 21, j + 11, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 11, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 11, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 11, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 11, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 11, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 11, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 11, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 11, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 16, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 17, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 18, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 21, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 22, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 11, k + 26, 0);
        world.setBlock(i + 21, j + 12, k + 0, 0);
        world.setBlock(i + 21, j + 12, k + 1, 0);
        world.setBlock(i + 21, j + 12, k + 2, 0);
        world.setBlock(i + 21, j + 12, k + 3, 0);
        world.setBlock(i + 21, j + 12, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 12, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 12, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 12, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 12, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 12, k + 26, 0);
        world.setBlock(i + 21, j + 13, k + 0, 0);
        world.setBlock(i + 21, j + 13, k + 1, 0);
        world.setBlock(i + 21, j + 13, k + 2, 0);
        world.setBlock(i + 21, j + 13, k + 3, 0);
        world.setBlock(i + 21, j + 13, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 13, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 13, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 13, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 13, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 13, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 13, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 13, k + 26, 0);
        world.setBlock(i + 21, j + 14, k + 0, 0);
        world.setBlock(i + 21, j + 14, k + 1, 0);
        world.setBlock(i + 21, j + 14, k + 2, 0);
        world.setBlock(i + 21, j + 14, k + 3, 0);
        world.setBlock(i + 21, j + 14, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 14, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 14, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 14, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 14, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 14, k + 24, Fossil.ancientStonebrick.blockID);
        generate11(world, rand, i, j, k);
        return true;
    }

    public boolean generate11(World world, Random rand, int i, int j, int k)
    {
        world.setBlock(i + 21, j + 14, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 14, k + 26, 0);
        world.setBlock(i + 21, j + 15, k + 0, 0);
        world.setBlock(i + 21, j + 15, k + 1, 0);
        world.setBlock(i + 21, j + 15, k + 2, 0);
        world.setBlock(i + 21, j + 15, k + 3, 0);
        world.setBlock(i + 21, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 15, k + 5, 0);
        world.setBlock(i + 21, j + 15, k + 6, 0);
        world.setBlock(i + 21, j + 15, k + 7, 0);
        world.setBlock(i + 21, j + 15, k + 8, 0);
        world.setBlock(i + 21, j + 15, k + 9, 0);
        world.setBlock(i + 21, j + 15, k + 10, 0);
        world.setBlock(i + 21, j + 15, k + 11, 0);
        world.setBlock(i + 21, j + 15, k + 12, 0);
        world.setBlock(i + 21, j + 15, k + 13, 0);
        world.setBlock(i + 21, j + 15, k + 14, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 21, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 15, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 15, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 15, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 15, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 15, k + 22, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 15, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 15, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 15, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 15, k + 26, 0);
        world.setBlock(i + 21, j + 16, k + 0, 0);
        world.setBlock(i + 21, j + 16, k + 1, 0);
        world.setBlock(i + 21, j + 16, k + 2, 0);
        world.setBlock(i + 21, j + 16, k + 3, 0);
        world.setBlock(i + 21, j + 16, k + 4, 0);
        world.setBlock(i + 21, j + 16, k + 5, 0);
        world.setBlock(i + 21, j + 16, k + 6, 0);
        world.setBlock(i + 21, j + 16, k + 7, 0);
        world.setBlock(i + 21, j + 16, k + 8, 0);
        world.setBlock(i + 21, j + 16, k + 9, 0);
        world.setBlock(i + 21, j + 16, k + 10, 0);
        world.setBlock(i + 21, j + 16, k + 11, 0);
        world.setBlock(i + 21, j + 16, k + 12, 0);
        world.setBlock(i + 21, j + 16, k + 13, 0);
        world.setBlock(i + 21, j + 16, k + 14, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 21, j + 16, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 16, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 16, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 16, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 16, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 16, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 16, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 16, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 16, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 16, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 21, j + 16, k + 26, 0);
        world.setBlock(i + 21, j + 17, k + 0, 0);
        world.setBlock(i + 21, j + 17, k + 1, 0);
        world.setBlock(i + 21, j + 17, k + 2, 0);
        world.setBlock(i + 21, j + 17, k + 3, 0);
        world.setBlock(i + 21, j + 17, k + 4, 0);
        world.setBlock(i + 21, j + 17, k + 5, 0);
        world.setBlock(i + 21, j + 17, k + 6, 0);
        world.setBlock(i + 21, j + 17, k + 7, 0);
        world.setBlock(i + 21, j + 17, k + 8, 0);
        world.setBlock(i + 21, j + 17, k + 9, 0);
        world.setBlock(i + 21, j + 17, k + 10, 0);
        world.setBlock(i + 21, j + 17, k + 11, 0);
        world.setBlock(i + 21, j + 17, k + 12, 0);
        world.setBlock(i + 21, j + 17, k + 13, 0);
        world.setBlock(i + 21, j + 17, k + 14, 0);
        world.setBlock(i + 21, j + 17, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 17, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 17, k + 17, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 17, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 17, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 17, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 17, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 17, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 17, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 17, k + 24, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 17, k + 25, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 17, k + 26, 0);
        world.setBlock(i + 21, j + 18, k + 0, 0);
        world.setBlock(i + 21, j + 18, k + 1, 0);
        world.setBlock(i + 21, j + 18, k + 2, 0);
        world.setBlock(i + 21, j + 18, k + 3, 0);
        world.setBlock(i + 21, j + 18, k + 4, 0);
        world.setBlock(i + 21, j + 18, k + 5, 0);
        world.setBlock(i + 21, j + 18, k + 6, 0);
        world.setBlock(i + 21, j + 18, k + 7, 0);
        world.setBlock(i + 21, j + 18, k + 8, 0);
        world.setBlock(i + 21, j + 18, k + 9, 0);
        world.setBlock(i + 21, j + 18, k + 10, 0);
        world.setBlock(i + 21, j + 18, k + 11, 0);
        world.setBlock(i + 21, j + 18, k + 12, 0);
        world.setBlock(i + 21, j + 18, k + 13, 0);
        world.setBlock(i + 21, j + 18, k + 14, 0);
        world.setBlock(i + 21, j + 18, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 18, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 18, k + 17, Block.thinGlass.blockID);
        world.setBlock(i + 21, j + 18, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 18, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 18, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 18, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 18, k + 22, 0);
        world.setBlock(i + 21, j + 18, k + 23, 0);
        world.setBlock(i + 21, j + 18, k + 24, 0);
        world.setBlock(i + 21, j + 18, k + 25, 0);
        world.setBlock(i + 21, j + 18, k + 26, 0);
        world.setBlock(i + 21, j + 19, k + 0, 0);
        world.setBlock(i + 21, j + 19, k + 1, 0);
        world.setBlock(i + 21, j + 19, k + 2, 0);
        world.setBlock(i + 21, j + 19, k + 3, 0);
        world.setBlock(i + 21, j + 19, k + 4, 0);
        world.setBlock(i + 21, j + 19, k + 5, 0);
        world.setBlock(i + 21, j + 19, k + 6, 0);
        world.setBlock(i + 21, j + 19, k + 7, 0);
        world.setBlock(i + 21, j + 19, k + 8, 0);
        world.setBlock(i + 21, j + 19, k + 9, 0);
        world.setBlock(i + 21, j + 19, k + 10, 0);
        world.setBlock(i + 21, j + 19, k + 11, 0);
        world.setBlock(i + 21, j + 19, k + 12, 0);
        world.setBlock(i + 21, j + 19, k + 13, 0);
        world.setBlock(i + 21, j + 19, k + 14, 0);
        world.setBlock(i + 21, j + 19, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 19, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 19, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 19, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 19, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 19, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 19, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 21, j + 19, k + 22, 0);
        world.setBlock(i + 21, j + 19, k + 23, 0);
        world.setBlock(i + 21, j + 19, k + 24, 0);
        world.setBlock(i + 21, j + 19, k + 25, 0);
        world.setBlock(i + 21, j + 19, k + 26, 0);
        world.setBlock(i + 21, j + 20, k + 0, 0);
        world.setBlock(i + 21, j + 20, k + 1, 0);
        world.setBlock(i + 21, j + 20, k + 2, 0);
        world.setBlock(i + 21, j + 20, k + 3, 0);
        world.setBlock(i + 21, j + 20, k + 4, 0);
        world.setBlock(i + 21, j + 20, k + 5, 0);
        world.setBlock(i + 21, j + 20, k + 6, 0);
        world.setBlock(i + 21, j + 20, k + 7, 0);
        world.setBlock(i + 21, j + 20, k + 8, 0);
        world.setBlock(i + 21, j + 20, k + 9, 0);
        world.setBlock(i + 21, j + 20, k + 10, 0);
        world.setBlock(i + 21, j + 20, k + 11, 0);
        world.setBlock(i + 21, j + 20, k + 12, 0);
        world.setBlock(i + 21, j + 20, k + 13, 0);
        world.setBlock(i + 21, j + 20, k + 14, 0);
        world.setBlock(i + 21, j + 20, k + 15, 0);
        world.setBlock(i + 21, j + 20, k + 16, 0);
        world.setBlock(i + 21, j + 20, k + 17, 0);
        world.setBlock(i + 21, j + 20, k + 18, 0);
        world.setBlock(i + 21, j + 20, k + 19, 0);
        world.setBlock(i + 21, j + 20, k + 20, 0);
        world.setBlock(i + 21, j + 20, k + 21, 0);
        world.setBlock(i + 21, j + 20, k + 22, 0);
        world.setBlock(i + 21, j + 20, k + 23, 0);
        world.setBlock(i + 21, j + 20, k + 24, 0);
        world.setBlock(i + 21, j + 20, k + 25, 0);
        world.setBlock(i + 21, j + 20, k + 26, 0);
        world.setBlock(i + 21, j + 21, k + 0, 0);
        world.setBlock(i + 21, j + 21, k + 1, 0);
        world.setBlock(i + 21, j + 21, k + 2, 0);
        world.setBlock(i + 21, j + 21, k + 3, 0);
        world.setBlock(i + 21, j + 21, k + 4, 0);
        world.setBlock(i + 21, j + 21, k + 5, 0);
        world.setBlock(i + 21, j + 21, k + 6, 0);
        world.setBlock(i + 21, j + 21, k + 7, 0);
        world.setBlock(i + 21, j + 21, k + 8, 0);
        world.setBlock(i + 21, j + 21, k + 9, 0);
        world.setBlock(i + 21, j + 21, k + 10, 0);
        world.setBlock(i + 21, j + 21, k + 11, 0);
        world.setBlock(i + 21, j + 21, k + 12, 0);
        world.setBlock(i + 21, j + 21, k + 13, 0);
        world.setBlock(i + 21, j + 21, k + 14, 0);
        world.setBlock(i + 21, j + 21, k + 15, 0);
        world.setBlock(i + 21, j + 21, k + 16, 0);
        world.setBlock(i + 21, j + 21, k + 17, 0);
        world.setBlock(i + 21, j + 21, k + 18, 0);
        world.setBlock(i + 21, j + 21, k + 19, 0);
        world.setBlock(i + 21, j + 21, k + 20, 0);
        world.setBlock(i + 21, j + 21, k + 21, 0);
        world.setBlock(i + 21, j + 21, k + 22, 0);
        world.setBlock(i + 21, j + 21, k + 23, 0);
        world.setBlock(i + 21, j + 21, k + 24, 0);
        world.setBlock(i + 21, j + 21, k + 25, 0);
        world.setBlock(i + 21, j + 21, k + 26, 0);
        world.setBlock(i + 21, j + 22, k + 0, 0);
        world.setBlock(i + 21, j + 22, k + 1, 0);
        world.setBlock(i + 21, j + 22, k + 2, 0);
        world.setBlock(i + 21, j + 22, k + 3, 0);
        world.setBlock(i + 21, j + 22, k + 4, 0);
        world.setBlock(i + 21, j + 22, k + 5, 0);
        world.setBlock(i + 21, j + 22, k + 6, 0);
        world.setBlock(i + 21, j + 22, k + 7, 0);
        world.setBlock(i + 21, j + 22, k + 8, 0);
        world.setBlock(i + 21, j + 22, k + 9, 0);
        world.setBlock(i + 21, j + 22, k + 10, 0);
        world.setBlock(i + 21, j + 22, k + 11, 0);
        world.setBlock(i + 21, j + 22, k + 12, 0);
        world.setBlock(i + 21, j + 22, k + 13, 0);
        world.setBlock(i + 21, j + 22, k + 14, 0);
        world.setBlock(i + 21, j + 22, k + 15, 0);
        world.setBlock(i + 21, j + 22, k + 16, 0);
        world.setBlock(i + 21, j + 22, k + 17, 0);
        world.setBlock(i + 21, j + 22, k + 18, 0);
        world.setBlock(i + 21, j + 22, k + 19, 0);
        world.setBlock(i + 21, j + 22, k + 20, 0);
        world.setBlock(i + 21, j + 22, k + 21, 0);
        world.setBlock(i + 21, j + 22, k + 22, 0);
        world.setBlock(i + 21, j + 22, k + 23, 0);
        world.setBlock(i + 21, j + 22, k + 24, 0);
        world.setBlock(i + 21, j + 22, k + 25, 0);
        world.setBlock(i + 21, j + 22, k + 26, 0);
        world.setBlock(i + 21, j + 23, k + 0, 0);
        world.setBlock(i + 21, j + 23, k + 1, 0);
        world.setBlock(i + 21, j + 23, k + 2, 0);
        world.setBlock(i + 21, j + 23, k + 3, 0);
        world.setBlock(i + 21, j + 23, k + 4, 0);
        world.setBlock(i + 21, j + 23, k + 5, 0);
        world.setBlock(i + 21, j + 23, k + 6, 0);
        world.setBlock(i + 21, j + 23, k + 7, 0);
        world.setBlock(i + 21, j + 23, k + 8, 0);
        world.setBlock(i + 21, j + 23, k + 9, 0);
        world.setBlock(i + 21, j + 23, k + 10, 0);
        world.setBlock(i + 21, j + 23, k + 11, 0);
        world.setBlock(i + 21, j + 23, k + 12, 0);
        world.setBlock(i + 21, j + 23, k + 13, 0);
        world.setBlock(i + 21, j + 23, k + 14, 0);
        world.setBlock(i + 21, j + 23, k + 15, 0);
        world.setBlock(i + 21, j + 23, k + 16, 0);
        world.setBlock(i + 21, j + 23, k + 17, 0);
        world.setBlock(i + 21, j + 23, k + 18, 0);
        world.setBlock(i + 21, j + 23, k + 19, 0);
        world.setBlock(i + 21, j + 23, k + 20, 0);
        world.setBlock(i + 21, j + 23, k + 21, 0);
        world.setBlock(i + 21, j + 23, k + 22, 0);
        world.setBlock(i + 21, j + 23, k + 23, 0);
        world.setBlock(i + 21, j + 23, k + 24, 0);
        world.setBlock(i + 21, j + 23, k + 25, 0);
        world.setBlock(i + 21, j + 23, k + 26, 0);
        world.setBlock(i + 21, j + 24, k + 0, 0);
        world.setBlock(i + 21, j + 24, k + 1, 0);
        world.setBlock(i + 21, j + 24, k + 2, 0);
        world.setBlock(i + 21, j + 24, k + 3, 0);
        world.setBlock(i + 21, j + 24, k + 4, 0);
        world.setBlock(i + 21, j + 24, k + 5, 0);
        world.setBlock(i + 21, j + 24, k + 6, 0);
        world.setBlock(i + 21, j + 24, k + 7, 0);
        world.setBlock(i + 21, j + 24, k + 8, 0);
        world.setBlock(i + 21, j + 24, k + 9, 0);
        world.setBlock(i + 21, j + 24, k + 10, 0);
        world.setBlock(i + 21, j + 24, k + 11, 0);
        world.setBlock(i + 21, j + 24, k + 12, 0);
        world.setBlock(i + 21, j + 24, k + 13, 0);
        world.setBlock(i + 21, j + 24, k + 14, 0);
        world.setBlock(i + 21, j + 24, k + 15, 0);
        world.setBlock(i + 21, j + 24, k + 16, 0);
        world.setBlock(i + 21, j + 24, k + 17, 0);
        world.setBlock(i + 21, j + 24, k + 18, 0);
        world.setBlock(i + 21, j + 24, k + 19, 0);
        world.setBlock(i + 21, j + 24, k + 20, 0);
        world.setBlock(i + 21, j + 24, k + 21, 0);
        world.setBlock(i + 21, j + 24, k + 22, 0);
        world.setBlock(i + 21, j + 24, k + 23, 0);
        world.setBlock(i + 21, j + 24, k + 24, 0);
        world.setBlock(i + 21, j + 24, k + 25, 0);
        world.setBlock(i + 21, j + 24, k + 26, 0);
        world.setBlock(i + 21, j + 25, k + 0, 0);
        world.setBlock(i + 21, j + 25, k + 1, 0);
        world.setBlock(i + 21, j + 25, k + 2, 0);
        world.setBlock(i + 21, j + 25, k + 3, 0);
        world.setBlock(i + 21, j + 25, k + 4, 0);
        world.setBlock(i + 21, j + 25, k + 5, 0);
        world.setBlock(i + 21, j + 25, k + 6, 0);
        world.setBlock(i + 21, j + 25, k + 7, 0);
        world.setBlock(i + 21, j + 25, k + 8, 0);
        world.setBlock(i + 21, j + 25, k + 9, 0);
        world.setBlock(i + 21, j + 25, k + 10, 0);
        world.setBlock(i + 21, j + 25, k + 11, 0);
        world.setBlock(i + 21, j + 25, k + 12, 0);
        world.setBlock(i + 21, j + 25, k + 13, 0);
        world.setBlock(i + 21, j + 25, k + 14, 0);
        world.setBlock(i + 21, j + 25, k + 15, 0);
        world.setBlock(i + 21, j + 25, k + 16, 0);
        world.setBlock(i + 21, j + 25, k + 17, 0);
        world.setBlock(i + 21, j + 25, k + 18, 0);
        world.setBlock(i + 21, j + 25, k + 19, 0);
        world.setBlock(i + 21, j + 25, k + 20, 0);
        world.setBlock(i + 21, j + 25, k + 21, 0);
        world.setBlock(i + 21, j + 25, k + 22, 0);
        world.setBlock(i + 21, j + 25, k + 23, 0);
        world.setBlock(i + 21, j + 25, k + 24, 0);
        world.setBlock(i + 21, j + 25, k + 25, 0);
        world.setBlock(i + 21, j + 25, k + 26, 0);
        world.setBlock(i + 22, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 22, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 22, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 22, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 2, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 2, k + 6, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 7, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 8, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 9, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 10, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 11, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 12, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 13, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 2, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 2, k + 16, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 17, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 18, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 2, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 2, k + 21, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 22, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 23, Block.grass.blockID);
        world.setBlock(i + 22, j + 2, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 2, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 22, j + 3, k + 2, 0);
        world.setBlock(i + 22, j + 3, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 3, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 3, k + 10, 0);
        world.setBlock(i + 22, j + 3, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 3, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 3, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 3, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 3, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 3, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 4, k + 0, 0);
        world.setBlock(i + 22, j + 4, k + 1, 0);
        world.setBlock(i + 22, j + 4, k + 2, 0);
        world.setBlock(i + 22, j + 4, k + 3, 0);
        world.setBlock(i + 22, j + 4, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 4, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 4, k + 6, 0);
        world.setBlock(i + 22, j + 4, k + 7, 0);
        world.setBlock(i + 22, j + 4, k + 8, 0);
        world.setBlock(i + 22, j + 4, k + 9, 0);
        world.setBlock(i + 22, j + 4, k + 10, 0);
        world.setBlock(i + 22, j + 4, k + 11, 0);
        world.setBlock(i + 22, j + 4, k + 12, 0);
        world.setBlock(i + 22, j + 4, k + 13, 0);
        world.setBlock(i + 22, j + 4, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 4, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 4, k + 16, 0);
        world.setBlock(i + 22, j + 4, k + 17, 0);
        world.setBlock(i + 22, j + 4, k + 18, 0);
        world.setBlock(i + 22, j + 4, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 4, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 4, k + 21, 0);
        world.setBlock(i + 22, j + 4, k + 22, 0);
        world.setBlock(i + 22, j + 4, k + 23, 0);
        world.setBlock(i + 22, j + 4, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 4, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 4, k + 26, 0);
        world.setBlock(i + 22, j + 5, k + 0, 0);
        world.setBlock(i + 22, j + 5, k + 1, 0);
        world.setBlock(i + 22, j + 5, k + 2, 0);
        world.setBlock(i + 22, j + 5, k + 3, 0);
        world.setBlock(i + 22, j + 5, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 5, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 5, k + 6, 0);
        world.setBlock(i + 22, j + 5, k + 7, 0);
        world.setBlock(i + 22, j + 5, k + 8, 0);
        world.setBlock(i + 22, j + 5, k + 9, 0);
        world.setBlock(i + 22, j + 5, k + 10, 0);
        world.setBlock(i + 22, j + 5, k + 11, 0);
        world.setBlock(i + 22, j + 5, k + 12, 0);
        world.setBlock(i + 22, j + 5, k + 13, 0);
        world.setBlock(i + 22, j + 5, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 5, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 5, k + 16, 0);
        world.setBlock(i + 22, j + 5, k + 17, 0);
        world.setBlock(i + 22, j + 5, k + 18, 0);
        world.setBlock(i + 22, j + 5, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 5, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 5, k + 21, 0);
        world.setBlock(i + 22, j + 5, k + 22, 0);
        world.setBlock(i + 22, j + 5, k + 23, 0);
        world.setBlock(i + 22, j + 5, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 5, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 5, k + 26, 0);
        world.setBlock(i + 22, j + 6, k + 0, 0);
        world.setBlock(i + 22, j + 6, k + 1, 0);
        world.setBlock(i + 22, j + 6, k + 2, 0);
        world.setBlock(i + 22, j + 6, k + 3, 0);
        world.setBlock(i + 22, j + 6, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 6, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 6, k + 6, 0);
        world.setBlock(i + 22, j + 6, k + 7, 0);
        world.setBlock(i + 22, j + 6, k + 8, 0);
        world.setBlock(i + 22, j + 6, k + 9, 0);
        world.setBlock(i + 22, j + 6, k + 10, 0);
        world.setBlock(i + 22, j + 6, k + 11, 0);
        world.setBlock(i + 22, j + 6, k + 12, 0);
        world.setBlock(i + 22, j + 6, k + 13, 0);
        world.setBlock(i + 22, j + 6, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 6, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 6, k + 16, 0);
        world.setBlock(i + 22, j + 6, k + 17, 0);
        world.setBlock(i + 22, j + 6, k + 18, 0);
        world.setBlock(i + 22, j + 6, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 6, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 6, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 6, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 6, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 6, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 6, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 6, k + 26, 0);
        world.setBlock(i + 22, j + 7, k + 0, 0);
        world.setBlock(i + 22, j + 7, k + 1, 0);
        world.setBlock(i + 22, j + 7, k + 2, 0);
        world.setBlock(i + 22, j + 7, k + 3, 0);
        world.setBlock(i + 22, j + 7, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 7, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 7, k + 6, 0);
        world.setBlock(i + 22, j + 7, k + 7, 0);
        world.setBlock(i + 22, j + 7, k + 8, 0);
        world.setBlock(i + 22, j + 7, k + 9, 0);
        world.setBlock(i + 22, j + 7, k + 10, 0);
        world.setBlock(i + 22, j + 7, k + 11, 0);
        world.setBlock(i + 22, j + 7, k + 12, 0);
        world.setBlock(i + 22, j + 7, k + 13, 0);
        world.setBlock(i + 22, j + 7, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 7, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 7, k + 16, 0);
        world.setBlock(i + 22, j + 7, k + 17, 0);
        world.setBlock(i + 22, j + 7, k + 18, 0);
        world.setBlock(i + 22, j + 7, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 7, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 7, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 7, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 7, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 7, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 7, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 7, k + 26, 0);
        world.setBlock(i + 22, j + 8, k + 0, 0);
        world.setBlock(i + 22, j + 8, k + 1, 0);
        world.setBlock(i + 22, j + 8, k + 2, 0);
        world.setBlock(i + 22, j + 8, k + 3, 0);
        world.setBlock(i + 22, j + 8, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 8, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 8, k + 6, Block.web.blockID);
        world.setBlock(i + 22, j + 8, k + 7, 0);
        world.setBlock(i + 22, j + 8, k + 8, 0);
        world.setBlock(i + 22, j + 8, k + 9, 0);
        world.setBlock(i + 22, j + 8, k + 10, 0);
        world.setBlock(i + 22, j + 8, k + 11, 0);
        world.setBlock(i + 22, j + 8, k + 12, 0);
        world.setBlock(i + 22, j + 8, k + 13, 0);
        world.setBlock(i + 22, j + 8, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 8, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 8, k + 16, 0);
        world.setBlock(i + 22, j + 8, k + 17, 0);
        world.setBlock(i + 22, j + 8, k + 18, 0);
        world.setBlock(i + 22, j + 8, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 8, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 8, k + 21, 0);
        world.setBlock(i + 22, j + 8, k + 22, 0);
        world.setBlock(i + 22, j + 8, k + 23, 0);
        world.setBlock(i + 22, j + 8, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 8, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 8, k + 26, 0);
        world.setBlock(i + 22, j + 9, k + 0, 0);
        world.setBlock(i + 22, j + 9, k + 1, 0);
        world.setBlock(i + 22, j + 9, k + 2, 0);
        world.setBlock(i + 22, j + 9, k + 3, 0);
        world.setBlock(i + 22, j + 9, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 7, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 8, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 9, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 10, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 11, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 12, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 13, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 16, Block.web.blockID);
        world.setBlock(i + 22, j + 9, k + 17, 0);
        world.setBlock(i + 22, j + 9, k + 18, 0);
        world.setBlock(i + 22, j + 9, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 21, 0);
        world.setBlock(i + 22, j + 9, k + 22, 0);
        world.setBlock(i + 22, j + 9, k + 23, 0);
        world.setBlock(i + 22, j + 9, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 9, k + 26, 0);
        world.setBlock(i + 22, j + 10, k + 0, 0);
        world.setBlock(i + 22, j + 10, k + 1, 0);
        world.setBlock(i + 22, j + 10, k + 2, 0);
        world.setBlock(i + 22, j + 10, k + 3, 0);
        world.setBlock(i + 22, j + 10, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 6, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 7, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 8, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 9, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 10, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 11, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 12, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 13, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 16, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 17, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 18, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 21, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 22, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 10, k + 26, 0);
        world.setBlock(i + 22, j + 11, k + 0, 0);
        world.setBlock(i + 22, j + 11, k + 1, 0);
        world.setBlock(i + 22, j + 11, k + 2, 0);
        world.setBlock(i + 22, j + 11, k + 3, 0);
        world.setBlock(i + 22, j + 11, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 6, 0);
        world.setBlock(i + 22, j + 11, k + 7, 0);
        world.setBlock(i + 22, j + 11, k + 8, 0);
        world.setBlock(i + 22, j + 11, k + 9, 0);
        world.setBlock(i + 22, j + 11, k + 10, 0);
        world.setBlock(i + 22, j + 11, k + 11, 0);
        world.setBlock(i + 22, j + 11, k + 12, 0);
        world.setBlock(i + 22, j + 11, k + 13, 0);
        world.setBlock(i + 22, j + 11, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 16, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 17, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 18, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 19, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 20, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 21, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 22, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 23, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 11, k + 26, 0);
        world.setBlock(i + 22, j + 12, k + 0, 0);
        world.setBlock(i + 22, j + 12, k + 1, 0);
        world.setBlock(i + 22, j + 12, k + 2, 0);
        world.setBlock(i + 22, j + 12, k + 3, 0);
        world.setBlock(i + 22, j + 12, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 12, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 12, k + 6, 0);
        world.setBlock(i + 22, j + 12, k + 7, 0);
        world.setBlock(i + 22, j + 12, k + 8, 0);
        world.setBlock(i + 22, j + 12, k + 9, 0);
        world.setBlock(i + 22, j + 12, k + 10, 0);
        world.setBlock(i + 22, j + 12, k + 11, 0);
        world.setBlock(i + 22, j + 12, k + 12, 0);
        world.setBlock(i + 22, j + 12, k + 13, 0);
        world.setBlock(i + 22, j + 12, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 12, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 12, k + 16, 0);
        world.setBlock(i + 22, j + 12, k + 17, 0);
        world.setBlock(i + 22, j + 12, k + 18, 0);
        world.setBlock(i + 22, j + 12, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 12, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 12, k + 21, 0);
        world.setBlock(i + 22, j + 12, k + 22, 0);
        world.setBlock(i + 22, j + 12, k + 23, 0);
        world.setBlock(i + 22, j + 12, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 12, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 12, k + 26, 0);
        world.setBlock(i + 22, j + 13, k + 0, 0);
        world.setBlock(i + 22, j + 13, k + 1, 0);
        world.setBlock(i + 22, j + 13, k + 2, 0);
        world.setBlock(i + 22, j + 13, k + 3, 0);
        world.setBlock(i + 22, j + 13, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 13, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 13, k + 6, 0);
        world.setBlock(i + 22, j + 13, k + 7, 0);
        world.setBlock(i + 22, j + 13, k + 8, Block.web.blockID);
        world.setBlock(i + 22, j + 13, k + 9, 0);
        world.setBlock(i + 22, j + 13, k + 10, 0);
        world.setBlock(i + 22, j + 13, k + 11, 0);
        world.setBlock(i + 22, j + 13, k + 12, 0);
        world.setBlock(i + 22, j + 13, k + 13, Block.web.blockID);
        world.setBlock(i + 22, j + 13, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 13, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 13, k + 16, 0);
        world.setBlock(i + 22, j + 13, k + 17, 0);
        world.setBlock(i + 22, j + 13, k + 18, 0);
        world.setBlock(i + 22, j + 13, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 13, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 13, k + 21, 0);
        world.setBlock(i + 22, j + 13, k + 22, 0);
        world.setBlock(i + 22, j + 13, k + 23, 0);
        world.setBlock(i + 22, j + 13, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 13, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 13, k + 26, 0);
        world.setBlock(i + 22, j + 14, k + 0, 0);
        world.setBlock(i + 22, j + 14, k + 1, 0);
        world.setBlock(i + 22, j + 14, k + 2, 0);
        world.setBlock(i + 22, j + 14, k + 3, 0);
        world.setBlock(i + 22, j + 14, k + 4, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 14, k + 5, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 14, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 14, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 14, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 14, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 14, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 14, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 14, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 14, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 14, k + 14, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 14, k + 15, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 14, k + 16, 0);
        world.setBlock(i + 22, j + 14, k + 17, 0);
        world.setBlock(i + 22, j + 14, k + 18, 0);
        world.setBlock(i + 22, j + 14, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 14, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 14, k + 21, 0);
        world.setBlock(i + 22, j + 14, k + 22, 0);
        world.setBlock(i + 22, j + 14, k + 23, 0);
        world.setBlock(i + 22, j + 14, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 14, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 14, k + 26, 0);
        world.setBlock(i + 22, j + 15, k + 0, 0);
        world.setBlock(i + 22, j + 15, k + 1, 0);
        world.setBlock(i + 22, j + 15, k + 2, 0);
        world.setBlock(i + 22, j + 15, k + 3, 0);
        world.setBlock(i + 22, j + 15, k + 4, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 5, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 6, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 7, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 8, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 9, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 10, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 11, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 12, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 13, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 14, Block.stoneBrick.blockID, 2, 0);
        world.setBlock(i + 22, j + 15, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 16, 0);
        world.setBlock(i + 22, j + 15, k + 17, 0);
        world.setBlock(i + 22, j + 15, k + 18, 0);
        world.setBlock(i + 22, j + 15, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 15, k + 21, 0);
        world.setBlock(i + 22, j + 15, k + 22, 0);
        world.setBlock(i + 22, j + 15, k + 23, 0);
        world.setBlock(i + 22, j + 15, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 15, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 15, k + 26, 0);
        world.setBlock(i + 22, j + 16, k + 0, 0);
        world.setBlock(i + 22, j + 16, k + 1, 0);
        world.setBlock(i + 22, j + 16, k + 2, 0);
        world.setBlock(i + 22, j + 16, k + 3, 0);
        world.setBlock(i + 22, j + 16, k + 4, 0);
        world.setBlock(i + 22, j + 16, k + 5, 0);
        world.setBlock(i + 22, j + 16, k + 6, 0);
        world.setBlock(i + 22, j + 16, k + 7, 0);
        world.setBlock(i + 22, j + 16, k + 8, 0);
        world.setBlock(i + 22, j + 16, k + 9, 0);
        world.setBlock(i + 22, j + 16, k + 10, 0);
        world.setBlock(i + 22, j + 16, k + 11, 0);
        world.setBlock(i + 22, j + 16, k + 12, 0);
        world.setBlock(i + 22, j + 16, k + 13, 0);
        world.setBlock(i + 22, j + 16, k + 14, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 16, k + 15, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 16, k + 16, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 16, k + 17, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 16, k + 18, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 16, k + 19, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 16, k + 20, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 16, k + 21, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 16, k + 22, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 16, k + 23, Block.stoneBrick.blockID);
        world.setBlock(i + 22, j + 16, k + 24, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 16, k + 25, Fossil.ancientStonebrick.blockID);
        world.setBlock(i + 22, j + 16, k + 26, 0);
        world.setBlock(i + 22, j + 17, k + 0, 0);
        world.setBlock(i + 22, j + 17, k + 1, 0);
        world.setBlock(i + 22, j + 17, k + 2, 0);
        world.setBlock(i + 22, j + 17, k + 3, 0);
        world.setBlock(i + 22, j + 17, k + 4, 0);
        world.setBlock(i + 22, j + 17, k + 5, 0);
        world.setBlock(i + 22, j + 17, k + 6, 0);
        world.setBlock(i + 22, j + 17, k + 7, 0);
        world.setBlock(i + 22, j + 17, k + 8, 0);
        world.setBlock(i + 22, j + 17, k + 9, 0);
        world.setBlock(i + 22, j + 17, k + 10, 0);
        world.setBlock(i + 22, j + 17, k + 11, 0);
        world.setBlock(i + 22, j + 17, k + 12, 0);
        world.setBlock(i + 22, j + 17, k + 13, 0);
        world.setBlock(i + 22, j + 17, k + 14, 0);
        world.setBlock(i + 22, j + 17, k + 15, 0);
        world.setBlock(i + 22, j + 17, k + 16, 0);
        world.setBlock(i + 22, j + 17, k + 17, 0);
        world.setBlock(i + 22, j + 17, k + 18, 0);
        world.setBlock(i + 22, j + 17, k + 19, 0);
        world.setBlock(i + 22, j + 17, k + 20, 0);
        world.setBlock(i + 22, j + 17, k + 21, 0);
        world.setBlock(i + 22, j + 17, k + 22, 0);
        world.setBlock(i + 22, j + 17, k + 23, 0);
        world.setBlock(i + 22, j + 17, k + 24, 0);
        world.setBlock(i + 22, j + 17, k + 25, 0);
        world.setBlock(i + 22, j + 17, k + 26, 0);
        world.setBlock(i + 22, j + 18, k + 0, 0);
        world.setBlock(i + 22, j + 18, k + 1, 0);
        world.setBlock(i + 22, j + 18, k + 2, 0);
        world.setBlock(i + 22, j + 18, k + 3, 0);
        world.setBlock(i + 22, j + 18, k + 4, 0);
        world.setBlock(i + 22, j + 18, k + 5, 0);
        world.setBlock(i + 22, j + 18, k + 6, 0);
        world.setBlock(i + 22, j + 18, k + 7, 0);
        world.setBlock(i + 22, j + 18, k + 8, 0);
        world.setBlock(i + 22, j + 18, k + 9, 0);
        world.setBlock(i + 22, j + 18, k + 10, 0);
        world.setBlock(i + 22, j + 18, k + 11, 0);
        world.setBlock(i + 22, j + 18, k + 12, 0);
        world.setBlock(i + 22, j + 18, k + 13, 0);
        world.setBlock(i + 22, j + 18, k + 14, 0);
        world.setBlock(i + 22, j + 18, k + 15, 0);
        world.setBlock(i + 22, j + 18, k + 16, 0);
        world.setBlock(i + 22, j + 18, k + 17, 0);
        world.setBlock(i + 22, j + 18, k + 18, 0);
        world.setBlock(i + 22, j + 18, k + 19, 0);
        world.setBlock(i + 22, j + 18, k + 20, 0);
        world.setBlock(i + 22, j + 18, k + 21, 0);
        world.setBlock(i + 22, j + 18, k + 22, 0);
        world.setBlock(i + 22, j + 18, k + 23, 0);
        world.setBlock(i + 22, j + 18, k + 24, 0);
        world.setBlock(i + 22, j + 18, k + 25, 0);
        world.setBlock(i + 22, j + 18, k + 26, 0);
        world.setBlock(i + 22, j + 19, k + 0, 0);
        world.setBlock(i + 22, j + 19, k + 1, 0);
        world.setBlock(i + 22, j + 19, k + 2, 0);
        world.setBlock(i + 22, j + 19, k + 3, 0);
        world.setBlock(i + 22, j + 19, k + 4, 0);
        world.setBlock(i + 22, j + 19, k + 5, 0);
        world.setBlock(i + 22, j + 19, k + 6, 0);
        world.setBlock(i + 22, j + 19, k + 7, 0);
        world.setBlock(i + 22, j + 19, k + 8, 0);
        world.setBlock(i + 22, j + 19, k + 9, 0);
        world.setBlock(i + 22, j + 19, k + 10, 0);
        world.setBlock(i + 22, j + 19, k + 11, 0);
        world.setBlock(i + 22, j + 19, k + 12, 0);
        world.setBlock(i + 22, j + 19, k + 13, 0);
        world.setBlock(i + 22, j + 19, k + 14, 0);
        world.setBlock(i + 22, j + 19, k + 15, 0);
        world.setBlock(i + 22, j + 19, k + 16, 0);
        world.setBlock(i + 22, j + 19, k + 17, 0);
        world.setBlock(i + 22, j + 19, k + 18, 0);
        world.setBlock(i + 22, j + 19, k + 19, 0);
        world.setBlock(i + 22, j + 19, k + 20, 0);
        world.setBlock(i + 22, j + 19, k + 21, 0);
        world.setBlock(i + 22, j + 19, k + 22, 0);
        world.setBlock(i + 22, j + 19, k + 23, 0);
        world.setBlock(i + 22, j + 19, k + 24, 0);
        world.setBlock(i + 22, j + 19, k + 25, 0);
        world.setBlock(i + 22, j + 19, k + 26, 0);
        world.setBlock(i + 22, j + 20, k + 0, 0);
        world.setBlock(i + 22, j + 20, k + 1, 0);
        world.setBlock(i + 22, j + 20, k + 2, 0);
        world.setBlock(i + 22, j + 20, k + 3, 0);
        world.setBlock(i + 22, j + 20, k + 4, 0);
        world.setBlock(i + 22, j + 20, k + 5, 0);
        world.setBlock(i + 22, j + 20, k + 6, 0);
        world.setBlock(i + 22, j + 20, k + 7, 0);
        world.setBlock(i + 22, j + 20, k + 8, 0);
        world.setBlock(i + 22, j + 20, k + 9, 0);
        world.setBlock(i + 22, j + 20, k + 10, 0);
        world.setBlock(i + 22, j + 20, k + 11, 0);
        world.setBlock(i + 22, j + 20, k + 12, 0);
        world.setBlock(i + 22, j + 20, k + 13, 0);
        world.setBlock(i + 22, j + 20, k + 14, 0);
        world.setBlock(i + 22, j + 20, k + 15, 0);
        world.setBlock(i + 22, j + 20, k + 16, 0);
        world.setBlock(i + 22, j + 20, k + 17, 0);
        world.setBlock(i + 22, j + 20, k + 18, 0);
        world.setBlock(i + 22, j + 20, k + 19, 0);
        world.setBlock(i + 22, j + 20, k + 20, 0);
        world.setBlock(i + 22, j + 20, k + 21, 0);
        world.setBlock(i + 22, j + 20, k + 22, 0);
        world.setBlock(i + 22, j + 20, k + 23, 0);
        world.setBlock(i + 22, j + 20, k + 24, 0);
        world.setBlock(i + 22, j + 20, k + 25, 0);
        world.setBlock(i + 22, j + 20, k + 26, 0);
        world.setBlock(i + 22, j + 21, k + 0, 0);
        world.setBlock(i + 22, j + 21, k + 1, 0);
        world.setBlock(i + 22, j + 21, k + 2, 0);
        world.setBlock(i + 22, j + 21, k + 3, 0);
        world.setBlock(i + 22, j + 21, k + 4, 0);
        world.setBlock(i + 22, j + 21, k + 5, 0);
        world.setBlock(i + 22, j + 21, k + 6, 0);
        world.setBlock(i + 22, j + 21, k + 7, 0);
        world.setBlock(i + 22, j + 21, k + 8, 0);
        world.setBlock(i + 22, j + 21, k + 9, 0);
        world.setBlock(i + 22, j + 21, k + 10, 0);
        world.setBlock(i + 22, j + 21, k + 11, 0);
        world.setBlock(i + 22, j + 21, k + 12, 0);
        world.setBlock(i + 22, j + 21, k + 13, 0);
        world.setBlock(i + 22, j + 21, k + 14, 0);
        world.setBlock(i + 22, j + 21, k + 15, 0);
        world.setBlock(i + 22, j + 21, k + 16, 0);
        world.setBlock(i + 22, j + 21, k + 17, 0);
        world.setBlock(i + 22, j + 21, k + 18, 0);
        world.setBlock(i + 22, j + 21, k + 19, 0);
        world.setBlock(i + 22, j + 21, k + 20, 0);
        world.setBlock(i + 22, j + 21, k + 21, 0);
        world.setBlock(i + 22, j + 21, k + 22, 0);
        world.setBlock(i + 22, j + 21, k + 23, 0);
        world.setBlock(i + 22, j + 21, k + 24, 0);
        world.setBlock(i + 22, j + 21, k + 25, 0);
        world.setBlock(i + 22, j + 21, k + 26, 0);
        world.setBlock(i + 22, j + 22, k + 0, 0);
        world.setBlock(i + 22, j + 22, k + 1, 0);
        world.setBlock(i + 22, j + 22, k + 2, 0);
        world.setBlock(i + 22, j + 22, k + 3, 0);
        world.setBlock(i + 22, j + 22, k + 4, 0);
        world.setBlock(i + 22, j + 22, k + 5, 0);
        world.setBlock(i + 22, j + 22, k + 6, 0);
        world.setBlock(i + 22, j + 22, k + 7, 0);
        world.setBlock(i + 22, j + 22, k + 8, 0);
        world.setBlock(i + 22, j + 22, k + 9, 0);
        world.setBlock(i + 22, j + 22, k + 10, 0);
        world.setBlock(i + 22, j + 22, k + 11, 0);
        world.setBlock(i + 22, j + 22, k + 12, 0);
        world.setBlock(i + 22, j + 22, k + 13, 0);
        world.setBlock(i + 22, j + 22, k + 14, 0);
        world.setBlock(i + 22, j + 22, k + 15, 0);
        world.setBlock(i + 22, j + 22, k + 16, 0);
        world.setBlock(i + 22, j + 22, k + 17, 0);
        world.setBlock(i + 22, j + 22, k + 18, 0);
        world.setBlock(i + 22, j + 22, k + 19, 0);
        world.setBlock(i + 22, j + 22, k + 20, 0);
        world.setBlock(i + 22, j + 22, k + 21, 0);
        world.setBlock(i + 22, j + 22, k + 22, 0);
        world.setBlock(i + 22, j + 22, k + 23, 0);
        world.setBlock(i + 22, j + 22, k + 24, 0);
        world.setBlock(i + 22, j + 22, k + 25, 0);
        world.setBlock(i + 22, j + 22, k + 26, 0);
        world.setBlock(i + 22, j + 23, k + 0, 0);
        world.setBlock(i + 22, j + 23, k + 1, 0);
        world.setBlock(i + 22, j + 23, k + 2, 0);
        world.setBlock(i + 22, j + 23, k + 3, 0);
        world.setBlock(i + 22, j + 23, k + 4, 0);
        world.setBlock(i + 22, j + 23, k + 5, 0);
        world.setBlock(i + 22, j + 23, k + 6, 0);
        world.setBlock(i + 22, j + 23, k + 7, 0);
        world.setBlock(i + 22, j + 23, k + 8, 0);
        world.setBlock(i + 22, j + 23, k + 9, 0);
        world.setBlock(i + 22, j + 23, k + 10, 0);
        world.setBlock(i + 22, j + 23, k + 11, 0);
        world.setBlock(i + 22, j + 23, k + 12, 0);
        world.setBlock(i + 22, j + 23, k + 13, 0);
        world.setBlock(i + 22, j + 23, k + 14, 0);
        world.setBlock(i + 22, j + 23, k + 15, 0);
        world.setBlock(i + 22, j + 23, k + 16, 0);
        world.setBlock(i + 22, j + 23, k + 17, 0);
        world.setBlock(i + 22, j + 23, k + 18, 0);
        world.setBlock(i + 22, j + 23, k + 19, 0);
        world.setBlock(i + 22, j + 23, k + 20, 0);
        world.setBlock(i + 22, j + 23, k + 21, 0);
        world.setBlock(i + 22, j + 23, k + 22, 0);
        world.setBlock(i + 22, j + 23, k + 23, 0);
        world.setBlock(i + 22, j + 23, k + 24, 0);
        world.setBlock(i + 22, j + 23, k + 25, 0);
        world.setBlock(i + 22, j + 23, k + 26, 0);
        world.setBlock(i + 22, j + 24, k + 0, 0);
        world.setBlock(i + 22, j + 24, k + 1, 0);
        world.setBlock(i + 22, j + 24, k + 2, 0);
        world.setBlock(i + 22, j + 24, k + 3, 0);
        world.setBlock(i + 22, j + 24, k + 4, 0);
        world.setBlock(i + 22, j + 24, k + 5, 0);
        world.setBlock(i + 22, j + 24, k + 6, 0);
        world.setBlock(i + 22, j + 24, k + 7, 0);
        world.setBlock(i + 22, j + 24, k + 8, 0);
        world.setBlock(i + 22, j + 24, k + 9, 0);
        world.setBlock(i + 22, j + 24, k + 10, 0);
        world.setBlock(i + 22, j + 24, k + 11, 0);
        world.setBlock(i + 22, j + 24, k + 12, 0);
        world.setBlock(i + 22, j + 24, k + 13, 0);
        world.setBlock(i + 22, j + 24, k + 14, 0);
        world.setBlock(i + 22, j + 24, k + 15, 0);
        world.setBlock(i + 22, j + 24, k + 16, 0);
        world.setBlock(i + 22, j + 24, k + 17, 0);
        world.setBlock(i + 22, j + 24, k + 18, 0);
        world.setBlock(i + 22, j + 24, k + 19, 0);
        world.setBlock(i + 22, j + 24, k + 20, 0);
        world.setBlock(i + 22, j + 24, k + 21, 0);
        world.setBlock(i + 22, j + 24, k + 22, 0);
        world.setBlock(i + 22, j + 24, k + 23, 0);
        world.setBlock(i + 22, j + 24, k + 24, 0);
        world.setBlock(i + 22, j + 24, k + 25, 0);
        world.setBlock(i + 22, j + 24, k + 26, 0);
        world.setBlock(i + 22, j + 25, k + 0, 0);
        world.setBlock(i + 22, j + 25, k + 1, 0);
        world.setBlock(i + 22, j + 25, k + 2, 0);
        world.setBlock(i + 22, j + 25, k + 3, 0);
        world.setBlock(i + 22, j + 25, k + 4, 0);
        world.setBlock(i + 22, j + 25, k + 5, 0);
        world.setBlock(i + 22, j + 25, k + 6, 0);
        world.setBlock(i + 22, j + 25, k + 7, 0);
        world.setBlock(i + 22, j + 25, k + 8, 0);
        world.setBlock(i + 22, j + 25, k + 9, 0);
        world.setBlock(i + 22, j + 25, k + 10, 0);
        world.setBlock(i + 22, j + 25, k + 11, 0);
        world.setBlock(i + 22, j + 25, k + 12, 0);
        world.setBlock(i + 22, j + 25, k + 13, 0);
        world.setBlock(i + 22, j + 25, k + 14, 0);
        world.setBlock(i + 22, j + 25, k + 15, 0);
        world.setBlock(i + 22, j + 25, k + 16, 0);
        world.setBlock(i + 22, j + 25, k + 17, 0);
        world.setBlock(i + 22, j + 25, k + 18, 0);
        world.setBlock(i + 22, j + 25, k + 19, 0);
        world.setBlock(i + 22, j + 25, k + 20, 0);
        world.setBlock(i + 22, j + 25, k + 21, 0);
        world.setBlock(i + 22, j + 25, k + 22, 0);
        world.setBlock(i + 22, j + 25, k + 23, 0);
        world.setBlock(i + 22, j + 25, k + 24, 0);
        world.setBlock(i + 22, j + 25, k + 25, 0);
        world.setBlock(i + 22, j + 25, k + 26, 0);
        world.setBlock(i + 23, j + 0, k + 0, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 1, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 2, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 3, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 4, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 5, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 6, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 7, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 8, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 9, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 10, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 11, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 12, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 13, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 14, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 15, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 16, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 17, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 18, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 19, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 20, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 21, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 22, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 23, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 24, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 25, Block.dirt.blockID);
        world.setBlock(i + 23, j + 0, k + 26, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 0, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 1, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 2, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 3, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 4, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 5, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 6, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 7, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 8, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 9, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 10, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 11, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 12, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 13, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 14, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 15, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 16, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 17, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 18, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 19, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 20, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 21, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 22, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 23, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 24, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 25, Block.dirt.blockID);
        world.setBlock(i + 23, j + 1, k + 26, Block.dirt.blockID);
        world.setBlock(i + 23, j + 2, k + 0, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 1, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 2, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 3, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 4, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 5, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 6, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 7, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 8, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 9, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 10, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 11, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 12, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 13, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 14, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 15, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 16, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 17, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 18, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 19, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 20, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 21, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 22, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 23, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 24, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 25, Block.grass.blockID);
        world.setBlock(i + 23, j + 2, k + 26, Block.grass.blockID);
        world.setBlock(i + 23, j + 3, k + 1, 0);
        world.setBlock(i + 23, j + 3, k + 3, 0);
        world.setBlock(i + 23, j + 3, k + 4, 0);
        world.setBlock(i + 23, j + 3, k + 14, 0);
        world.setBlock(i + 23, j + 3, k + 20, 0);
        world.setBlock(i + 23, j + 3, k + 24, 0);
        world.setBlock(i + 23, j + 4, k + 0, 0);
        world.setBlock(i + 23, j + 4, k + 1, 0);
        world.setBlock(i + 23, j + 4, k + 2, 0);
        world.setBlock(i + 23, j + 4, k + 3, 0);
        world.setBlock(i + 23, j + 4, k + 4, 0);
        world.setBlock(i + 23, j + 4, k + 5, 0);
        world.setBlock(i + 23, j + 4, k + 6, 0);
        world.setBlock(i + 23, j + 4, k + 7, 0);
        world.setBlock(i + 23, j + 4, k + 8, 0);
        world.setBlock(i + 23, j + 4, k + 9, 0);
        world.setBlock(i + 23, j + 4, k + 10, 0);
        world.setBlock(i + 23, j + 4, k + 11, 0);
        world.setBlock(i + 23, j + 4, k + 12, 0);
        world.setBlock(i + 23, j + 4, k + 13, 0);
        world.setBlock(i + 23, j + 4, k + 14, 0);
        world.setBlock(i + 23, j + 4, k + 15, 0);
        world.setBlock(i + 23, j + 4, k + 16, 0);
        world.setBlock(i + 23, j + 4, k + 17, 0);
        world.setBlock(i + 23, j + 4, k + 18, 0);
        world.setBlock(i + 23, j + 4, k + 19, 0);
        world.setBlock(i + 23, j + 4, k + 20, 0);
        world.setBlock(i + 23, j + 4, k + 21, 0);
        world.setBlock(i + 23, j + 4, k + 22, 0);
        world.setBlock(i + 23, j + 4, k + 23, 0);
        world.setBlock(i + 23, j + 4, k + 24, 0);
        world.setBlock(i + 23, j + 4, k + 25, 0);
        world.setBlock(i + 23, j + 4, k + 26, 0);
        world.setBlock(i + 23, j + 5, k + 0, 0);
        world.setBlock(i + 23, j + 5, k + 1, 0);
        world.setBlock(i + 23, j + 5, k + 2, 0);
        world.setBlock(i + 23, j + 5, k + 3, 0);
        world.setBlock(i + 23, j + 5, k + 4, 0);
        world.setBlock(i + 23, j + 5, k + 5, 0);
        world.setBlock(i + 23, j + 5, k + 6, 0);
        world.setBlock(i + 23, j + 5, k + 7, 0);
        world.setBlock(i + 23, j + 5, k + 8, 0);
        world.setBlock(i + 23, j + 5, k + 9, 0);
        world.setBlock(i + 23, j + 5, k + 10, 0);
        world.setBlock(i + 23, j + 5, k + 11, 0);
        world.setBlock(i + 23, j + 5, k + 12, 0);
        world.setBlock(i + 23, j + 5, k + 13, 0);
        world.setBlock(i + 23, j + 5, k + 14, 0);
        world.setBlock(i + 23, j + 5, k + 15, 0);
        world.setBlock(i + 23, j + 5, k + 16, 0);
        world.setBlock(i + 23, j + 5, k + 17, 0);
        world.setBlock(i + 23, j + 5, k + 18, 0);
        world.setBlock(i + 23, j + 5, k + 19, 0);
        world.setBlock(i + 23, j + 5, k + 20, 0);
        world.setBlock(i + 23, j + 5, k + 21, 0);
        world.setBlock(i + 23, j + 5, k + 22, 0);
        world.setBlock(i + 23, j + 5, k + 23, 0);
        world.setBlock(i + 23, j + 5, k + 24, 0);
        world.setBlock(i + 23, j + 5, k + 25, 0);
        world.setBlock(i + 23, j + 5, k + 26, 0);
        world.setBlock(i + 23, j + 6, k + 0, 0);
        world.setBlock(i + 23, j + 6, k + 1, 0);
        world.setBlock(i + 23, j + 6, k + 2, 0);
        world.setBlock(i + 23, j + 6, k + 3, 0);
        world.setBlock(i + 23, j + 6, k + 4, 0);
        world.setBlock(i + 23, j + 6, k + 5, 0);
        world.setBlock(i + 23, j + 6, k + 6, 0);
        world.setBlock(i + 23, j + 6, k + 7, 0);
        world.setBlock(i + 23, j + 6, k + 8, 0);
        world.setBlock(i + 23, j + 6, k + 9, 0);
        world.setBlock(i + 23, j + 6, k + 10, 0);
        world.setBlock(i + 23, j + 6, k + 11, 0);
        world.setBlock(i + 23, j + 6, k + 12, 0);
        world.setBlock(i + 23, j + 6, k + 13, 0);
        world.setBlock(i + 23, j + 6, k + 14, 0);
        world.setBlock(i + 23, j + 6, k + 15, 0);
        world.setBlock(i + 23, j + 6, k + 16, 0);
        world.setBlock(i + 23, j + 6, k + 17, 0);
        world.setBlock(i + 23, j + 6, k + 18, 0);
        world.setBlock(i + 23, j + 6, k + 19, 0);
        world.setBlock(i + 23, j + 6, k + 20, 0);
        world.setBlock(i + 23, j + 6, k + 21, 0);
        world.setBlock(i + 23, j + 6, k + 22, 0);
        world.setBlock(i + 23, j + 6, k + 23, 0);
        world.setBlock(i + 23, j + 6, k + 24, 0);
        world.setBlock(i + 23, j + 6, k + 25, 0);
        world.setBlock(i + 23, j + 6, k + 26, 0);
        world.setBlock(i + 23, j + 7, k + 0, 0);
        world.setBlock(i + 23, j + 7, k + 1, 0);
        world.setBlock(i + 23, j + 7, k + 2, 0);
        world.setBlock(i + 23, j + 7, k + 3, 0);
        world.setBlock(i + 23, j + 7, k + 4, 0);
        world.setBlock(i + 23, j + 7, k + 5, 0);
        world.setBlock(i + 23, j + 7, k + 6, 0);
        world.setBlock(i + 23, j + 7, k + 7, 0);
        world.setBlock(i + 23, j + 7, k + 8, 0);
        world.setBlock(i + 23, j + 7, k + 9, 0);
        world.setBlock(i + 23, j + 7, k + 10, 0);
        world.setBlock(i + 23, j + 7, k + 11, 0);
        world.setBlock(i + 23, j + 7, k + 12, 0);
        world.setBlock(i + 23, j + 7, k + 13, 0);
        world.setBlock(i + 23, j + 7, k + 14, 0);
        world.setBlock(i + 23, j + 7, k + 15, 0);
        world.setBlock(i + 23, j + 7, k + 16, 0);
        world.setBlock(i + 23, j + 7, k + 17, 0);
        world.setBlock(i + 23, j + 7, k + 18, 0);
        world.setBlock(i + 23, j + 7, k + 19, 0);
        world.setBlock(i + 23, j + 7, k + 20, 0);
        world.setBlock(i + 23, j + 7, k + 21, 0);
        world.setBlock(i + 23, j + 7, k + 22, 0);
        world.setBlock(i + 23, j + 7, k + 23, 0);
        world.setBlock(i + 23, j + 7, k + 24, 0);
        world.setBlock(i + 23, j + 7, k + 25, 0);
        world.setBlock(i + 23, j + 7, k + 26, 0);
        world.setBlock(i + 23, j + 8, k + 0, 0);
        world.setBlock(i + 23, j + 8, k + 1, 0);
        world.setBlock(i + 23, j + 8, k + 2, 0);
        world.setBlock(i + 23, j + 8, k + 3, 0);
        world.setBlock(i + 23, j + 8, k + 4, 0);
        world.setBlock(i + 23, j + 8, k + 5, 0);
        world.setBlock(i + 23, j + 8, k + 6, 0);
        world.setBlock(i + 23, j + 8, k + 7, 0);
        world.setBlock(i + 23, j + 8, k + 8, 0);
        world.setBlock(i + 23, j + 8, k + 9, 0);
        world.setBlock(i + 23, j + 8, k + 10, 0);
        world.setBlock(i + 23, j + 8, k + 11, 0);
        world.setBlock(i + 23, j + 8, k + 12, 0);
        world.setBlock(i + 23, j + 8, k + 13, 0);
        world.setBlock(i + 23, j + 8, k + 14, 0);
        world.setBlock(i + 23, j + 8, k + 15, 0);
        world.setBlock(i + 23, j + 8, k + 16, 0);
        world.setBlock(i + 23, j + 8, k + 17, 0);
        world.setBlock(i + 23, j + 8, k + 18, 0);
        world.setBlock(i + 23, j + 8, k + 19, 0);
        world.setBlock(i + 23, j + 8, k + 20, 0);
        world.setBlock(i + 23, j + 8, k + 21, 0);
        world.setBlock(i + 23, j + 8, k + 22, 0);
        world.setBlock(i + 23, j + 8, k + 23, 0);
        world.setBlock(i + 23, j + 8, k + 24, 0);
        world.setBlock(i + 23, j + 8, k + 25, 0);
        world.setBlock(i + 23, j + 8, k + 26, 0);
        world.setBlock(i + 23, j + 9, k + 0, 0);
        world.setBlock(i + 23, j + 9, k + 1, 0);
        world.setBlock(i + 23, j + 9, k + 2, 0);
        world.setBlock(i + 23, j + 9, k + 3, 0);
        world.setBlock(i + 23, j + 9, k + 4, 0);
        world.setBlock(i + 23, j + 9, k + 5, 0);
        world.setBlock(i + 23, j + 9, k + 6, 0);
        world.setBlock(i + 23, j + 9, k + 7, 0);
        world.setBlock(i + 23, j + 9, k + 8, 0);
        world.setBlock(i + 23, j + 9, k + 9, 0);
        world.setBlock(i + 23, j + 9, k + 10, 0);
        world.setBlock(i + 23, j + 9, k + 11, 0);
        world.setBlock(i + 23, j + 9, k + 12, 0);
        world.setBlock(i + 23, j + 9, k + 13, 0);
        world.setBlock(i + 23, j + 9, k + 14, 0);
        world.setBlock(i + 23, j + 9, k + 15, 0);
        world.setBlock(i + 23, j + 9, k + 16, 0);
        world.setBlock(i + 23, j + 9, k + 17, 0);
        world.setBlock(i + 23, j + 9, k + 18, 0);
        world.setBlock(i + 23, j + 9, k + 19, 0);
        world.setBlock(i + 23, j + 9, k + 20, 0);
        world.setBlock(i + 23, j + 9, k + 21, 0);
        world.setBlock(i + 23, j + 9, k + 22, 0);
        world.setBlock(i + 23, j + 9, k + 23, 0);
        world.setBlock(i + 23, j + 9, k + 24, 0);
        world.setBlock(i + 23, j + 9, k + 25, 0);
        world.setBlock(i + 23, j + 9, k + 26, 0);
        world.setBlock(i + 23, j + 10, k + 0, 0);
        world.setBlock(i + 23, j + 10, k + 1, 0);
        world.setBlock(i + 23, j + 10, k + 2, 0);
        world.setBlock(i + 23, j + 10, k + 3, 0);
        world.setBlock(i + 23, j + 10, k + 4, 0);
        world.setBlock(i + 23, j + 10, k + 5, 0);
        world.setBlock(i + 23, j + 10, k + 6, 0);
        world.setBlock(i + 23, j + 10, k + 7, 0);
        world.setBlock(i + 23, j + 10, k + 8, 0);
        world.setBlock(i + 23, j + 10, k + 9, 0);
        world.setBlock(i + 23, j + 10, k + 10, 0);
        world.setBlock(i + 23, j + 10, k + 11, 0);
        world.setBlock(i + 23, j + 10, k + 12, 0);
        world.setBlock(i + 23, j + 10, k + 13, 0);
        world.setBlock(i + 23, j + 10, k + 14, 0);
        world.setBlock(i + 23, j + 10, k + 15, 0);
        world.setBlock(i + 23, j + 10, k + 16, 0);
        world.setBlock(i + 23, j + 10, k + 17, 0);
        world.setBlock(i + 23, j + 10, k + 18, 0);
        world.setBlock(i + 23, j + 10, k + 19, 0);
        world.setBlock(i + 23, j + 10, k + 20, 0);
        world.setBlock(i + 23, j + 10, k + 21, 0);
        world.setBlock(i + 23, j + 10, k + 22, 0);
        world.setBlock(i + 23, j + 10, k + 23, 0);
        world.setBlock(i + 23, j + 10, k + 24, 0);
        world.setBlock(i + 23, j + 10, k + 25, 0);
        world.setBlock(i + 23, j + 10, k + 26, 0);
        world.setBlock(i + 23, j + 11, k + 0, 0);
        world.setBlock(i + 23, j + 11, k + 1, 0);
        world.setBlock(i + 23, j + 11, k + 2, 0);
        world.setBlock(i + 23, j + 11, k + 3, 0);
        world.setBlock(i + 23, j + 11, k + 4, 0);
        world.setBlock(i + 23, j + 11, k + 5, 0);
        world.setBlock(i + 23, j + 11, k + 6, 0);
        world.setBlock(i + 23, j + 11, k + 7, 0);
        world.setBlock(i + 23, j + 11, k + 8, 0);
        world.setBlock(i + 23, j + 11, k + 9, 0);
        world.setBlock(i + 23, j + 11, k + 10, 0);
        world.setBlock(i + 23, j + 11, k + 11, 0);
        world.setBlock(i + 23, j + 11, k + 12, 0);
        world.setBlock(i + 23, j + 11, k + 13, 0);
        world.setBlock(i + 23, j + 11, k + 14, 0);
        world.setBlock(i + 23, j + 11, k + 15, 0);
        world.setBlock(i + 23, j + 11, k + 16, 0);
        world.setBlock(i + 23, j + 11, k + 17, 0);
        world.setBlock(i + 23, j + 11, k + 18, 0);
        world.setBlock(i + 23, j + 11, k + 19, 0);
        world.setBlock(i + 23, j + 11, k + 20, 0);
        world.setBlock(i + 23, j + 11, k + 21, 0);
        world.setBlock(i + 23, j + 11, k + 22, 0);
        world.setBlock(i + 23, j + 11, k + 23, 0);
        world.setBlock(i + 23, j + 11, k + 24, 0);
        world.setBlock(i + 23, j + 11, k + 25, 0);
        world.setBlock(i + 23, j + 11, k + 26, 0);
        world.setBlock(i + 23, j + 12, k + 0, 0);
        world.setBlock(i + 23, j + 12, k + 1, 0);
        world.setBlock(i + 23, j + 12, k + 2, 0);
        world.setBlock(i + 23, j + 12, k + 3, 0);
        world.setBlock(i + 23, j + 12, k + 4, 0);
        world.setBlock(i + 23, j + 12, k + 5, 0);
        world.setBlock(i + 23, j + 12, k + 6, 0);
        world.setBlock(i + 23, j + 12, k + 7, 0);
        world.setBlock(i + 23, j + 12, k + 8, 0);
        world.setBlock(i + 23, j + 12, k + 9, 0);
        world.setBlock(i + 23, j + 12, k + 10, 0);
        world.setBlock(i + 23, j + 12, k + 11, 0);
        world.setBlock(i + 23, j + 12, k + 12, 0);
        world.setBlock(i + 23, j + 12, k + 13, 0);
        world.setBlock(i + 23, j + 12, k + 14, 0);
        world.setBlock(i + 23, j + 12, k + 15, 0);
        world.setBlock(i + 23, j + 12, k + 16, 0);
        world.setBlock(i + 23, j + 12, k + 17, 0);
        world.setBlock(i + 23, j + 12, k + 18, 0);
        world.setBlock(i + 23, j + 12, k + 19, 0);
        world.setBlock(i + 23, j + 12, k + 20, 0);
        world.setBlock(i + 23, j + 12, k + 21, 0);
        world.setBlock(i + 23, j + 12, k + 22, 0);
        world.setBlock(i + 23, j + 12, k + 23, 0);
        world.setBlock(i + 23, j + 12, k + 24, 0);
        world.setBlock(i + 23, j + 12, k + 25, 0);
        world.setBlock(i + 23, j + 12, k + 26, 0);
        world.setBlock(i + 23, j + 13, k + 0, 0);
        world.setBlock(i + 23, j + 13, k + 1, 0);
        world.setBlock(i + 23, j + 13, k + 2, 0);
        world.setBlock(i + 23, j + 13, k + 3, 0);
        world.setBlock(i + 23, j + 13, k + 4, 0);
        world.setBlock(i + 23, j + 13, k + 5, 0);
        world.setBlock(i + 23, j + 13, k + 6, 0);
        world.setBlock(i + 23, j + 13, k + 7, 0);
        world.setBlock(i + 23, j + 13, k + 8, 0);
        world.setBlock(i + 23, j + 13, k + 9, 0);
        world.setBlock(i + 23, j + 13, k + 10, 0);
        world.setBlock(i + 23, j + 13, k + 11, 0);
        world.setBlock(i + 23, j + 13, k + 12, 0);
        world.setBlock(i + 23, j + 13, k + 13, 0);
        world.setBlock(i + 23, j + 13, k + 14, 0);
        world.setBlock(i + 23, j + 13, k + 15, 0);
        world.setBlock(i + 23, j + 13, k + 16, 0);
        world.setBlock(i + 23, j + 13, k + 17, 0);
        world.setBlock(i + 23, j + 13, k + 18, 0);
        world.setBlock(i + 23, j + 13, k + 19, 0);
        world.setBlock(i + 23, j + 13, k + 20, 0);
        world.setBlock(i + 23, j + 13, k + 21, 0);
        world.setBlock(i + 23, j + 13, k + 22, 0);
        world.setBlock(i + 23, j + 13, k + 23, 0);
        world.setBlock(i + 23, j + 13, k + 24, 0);
        world.setBlock(i + 23, j + 13, k + 25, 0);
        world.setBlock(i + 23, j + 13, k + 26, 0);
        world.setBlock(i + 23, j + 14, k + 0, 0);
        world.setBlock(i + 23, j + 14, k + 1, 0);
        world.setBlock(i + 23, j + 14, k + 2, 0);
        world.setBlock(i + 23, j + 14, k + 3, 0);
        world.setBlock(i + 23, j + 14, k + 4, 0);
        world.setBlock(i + 23, j + 14, k + 5, 0);
        world.setBlock(i + 23, j + 14, k + 6, 0);
        world.setBlock(i + 23, j + 14, k + 7, 0);
        world.setBlock(i + 23, j + 14, k + 8, 0);
        world.setBlock(i + 23, j + 14, k + 9, 0);
        world.setBlock(i + 23, j + 14, k + 10, 0);
        world.setBlock(i + 23, j + 14, k + 11, 0);
        world.setBlock(i + 23, j + 14, k + 12, 0);
        world.setBlock(i + 23, j + 14, k + 13, 0);
        world.setBlock(i + 23, j + 14, k + 14, 0);
        world.setBlock(i + 23, j + 14, k + 15, 0);
        world.setBlock(i + 23, j + 14, k + 16, 0);
        world.setBlock(i + 23, j + 14, k + 17, 0);
        world.setBlock(i + 23, j + 14, k + 18, 0);
        world.setBlock(i + 23, j + 14, k + 19, 0);
        world.setBlock(i + 23, j + 14, k + 20, 0);
        world.setBlock(i + 23, j + 14, k + 21, 0);
        world.setBlock(i + 23, j + 14, k + 22, 0);
        world.setBlock(i + 23, j + 14, k + 23, 0);
        world.setBlock(i + 23, j + 14, k + 24, 0);
        world.setBlock(i + 23, j + 14, k + 25, 0);
        world.setBlock(i + 23, j + 14, k + 26, 0);
        world.setBlock(i + 23, j + 15, k + 0, 0);
        world.setBlock(i + 23, j + 15, k + 1, 0);
        world.setBlock(i + 23, j + 15, k + 2, 0);
        world.setBlock(i + 23, j + 15, k + 3, 0);
        world.setBlock(i + 23, j + 15, k + 4, 0);
        world.setBlock(i + 23, j + 15, k + 5, 0);
        world.setBlock(i + 23, j + 15, k + 6, 0);
        world.setBlock(i + 23, j + 15, k + 7, 0);
        world.setBlock(i + 23, j + 15, k + 8, 0);
        world.setBlock(i + 23, j + 15, k + 9, 0);
        world.setBlock(i + 23, j + 15, k + 10, 0);
        world.setBlock(i + 23, j + 15, k + 11, 0);
        world.setBlock(i + 23, j + 15, k + 12, 0);
        world.setBlock(i + 23, j + 15, k + 13, 0);
        world.setBlock(i + 23, j + 15, k + 14, 0);
        world.setBlock(i + 23, j + 15, k + 15, 0);
        world.setBlock(i + 23, j + 15, k + 16, 0);
        world.setBlock(i + 23, j + 15, k + 17, 0);
        world.setBlock(i + 23, j + 15, k + 18, 0);
        world.setBlock(i + 23, j + 15, k + 19, 0);
        world.setBlock(i + 23, j + 15, k + 20, 0);
        world.setBlock(i + 23, j + 15, k + 21, 0);
        world.setBlock(i + 23, j + 15, k + 22, 0);
        world.setBlock(i + 23, j + 15, k + 23, 0);
        world.setBlock(i + 23, j + 15, k + 24, 0);
        world.setBlock(i + 23, j + 15, k + 25, 0);
        world.setBlock(i + 23, j + 15, k + 26, 0);
        world.setBlock(i + 23, j + 16, k + 0, 0);
        world.setBlock(i + 23, j + 16, k + 1, 0);
        world.setBlock(i + 23, j + 16, k + 2, 0);
        world.setBlock(i + 23, j + 16, k + 3, 0);
        world.setBlock(i + 23, j + 16, k + 4, 0);
        world.setBlock(i + 23, j + 16, k + 5, 0);
        world.setBlock(i + 23, j + 16, k + 6, 0);
        world.setBlock(i + 23, j + 16, k + 7, 0);
        world.setBlock(i + 23, j + 16, k + 8, 0);
        world.setBlock(i + 23, j + 16, k + 9, 0);
        world.setBlock(i + 23, j + 16, k + 10, 0);
        world.setBlock(i + 23, j + 16, k + 11, 0);
        world.setBlock(i + 23, j + 16, k + 12, 0);
        world.setBlock(i + 23, j + 16, k + 13, 0);
        world.setBlock(i + 23, j + 16, k + 14, 0);
        world.setBlock(i + 23, j + 16, k + 15, 0);
        world.setBlock(i + 23, j + 16, k + 16, 0);
        world.setBlock(i + 23, j + 16, k + 17, 0);
        world.setBlock(i + 23, j + 16, k + 18, 0);
        world.setBlock(i + 23, j + 16, k + 19, 0);
        world.setBlock(i + 23, j + 16, k + 20, 0);
        world.setBlock(i + 23, j + 16, k + 21, 0);
        world.setBlock(i + 23, j + 16, k + 22, 0);
        world.setBlock(i + 23, j + 16, k + 23, 0);
        world.setBlock(i + 23, j + 16, k + 24, 0);
        world.setBlock(i + 23, j + 16, k + 25, 0);
        world.setBlock(i + 23, j + 16, k + 26, 0);
        world.setBlock(i + 23, j + 17, k + 0, 0);
        world.setBlock(i + 23, j + 17, k + 1, 0);
        world.setBlock(i + 23, j + 17, k + 2, 0);
        world.setBlock(i + 23, j + 17, k + 3, 0);
        world.setBlock(i + 23, j + 17, k + 4, 0);
        world.setBlock(i + 23, j + 17, k + 5, 0);
        world.setBlock(i + 23, j + 17, k + 6, 0);
        world.setBlock(i + 23, j + 17, k + 7, 0);
        world.setBlock(i + 23, j + 17, k + 8, 0);
        world.setBlock(i + 23, j + 17, k + 9, 0);
        world.setBlock(i + 23, j + 17, k + 10, 0);
        world.setBlock(i + 23, j + 17, k + 11, 0);
        world.setBlock(i + 23, j + 17, k + 12, 0);
        world.setBlock(i + 23, j + 17, k + 13, 0);
        world.setBlock(i + 23, j + 17, k + 14, 0);
        world.setBlock(i + 23, j + 17, k + 15, 0);
        world.setBlock(i + 23, j + 17, k + 16, 0);
        world.setBlock(i + 23, j + 17, k + 17, 0);
        world.setBlock(i + 23, j + 17, k + 18, 0);
        world.setBlock(i + 23, j + 17, k + 19, 0);
        world.setBlock(i + 23, j + 17, k + 20, 0);
        world.setBlock(i + 23, j + 17, k + 21, 0);
        world.setBlock(i + 23, j + 17, k + 22, 0);
        world.setBlock(i + 23, j + 17, k + 23, 0);
        world.setBlock(i + 23, j + 17, k + 24, 0);
        world.setBlock(i + 23, j + 17, k + 25, 0);
        world.setBlock(i + 23, j + 17, k + 26, 0);
        world.setBlock(i + 23, j + 18, k + 0, 0);
        world.setBlock(i + 23, j + 18, k + 1, 0);
        world.setBlock(i + 23, j + 18, k + 2, 0);
        world.setBlock(i + 23, j + 18, k + 3, 0);
        world.setBlock(i + 23, j + 18, k + 4, 0);
        world.setBlock(i + 23, j + 18, k + 5, 0);
        world.setBlock(i + 23, j + 18, k + 6, 0);
        world.setBlock(i + 23, j + 18, k + 7, 0);
        world.setBlock(i + 23, j + 18, k + 8, 0);
        world.setBlock(i + 23, j + 18, k + 9, 0);
        world.setBlock(i + 23, j + 18, k + 10, 0);
        world.setBlock(i + 23, j + 18, k + 11, 0);
        world.setBlock(i + 23, j + 18, k + 12, 0);
        world.setBlock(i + 23, j + 18, k + 13, 0);
        world.setBlock(i + 23, j + 18, k + 14, 0);
        world.setBlock(i + 23, j + 18, k + 15, 0);
        world.setBlock(i + 23, j + 18, k + 16, 0);
        world.setBlock(i + 23, j + 18, k + 17, 0);
        world.setBlock(i + 23, j + 18, k + 18, 0);
        world.setBlock(i + 23, j + 18, k + 19, 0);
        world.setBlock(i + 23, j + 18, k + 20, 0);
        world.setBlock(i + 23, j + 18, k + 21, 0);
        world.setBlock(i + 23, j + 18, k + 22, 0);
        world.setBlock(i + 23, j + 18, k + 23, 0);
        world.setBlock(i + 23, j + 18, k + 24, 0);
        world.setBlock(i + 23, j + 18, k + 25, 0);
        world.setBlock(i + 23, j + 18, k + 26, 0);
        world.setBlock(i + 23, j + 19, k + 0, 0);
        world.setBlock(i + 23, j + 19, k + 1, 0);
        world.setBlock(i + 23, j + 19, k + 2, 0);
        world.setBlock(i + 23, j + 19, k + 3, 0);
        world.setBlock(i + 23, j + 19, k + 4, 0);
        world.setBlock(i + 23, j + 19, k + 5, 0);
        world.setBlock(i + 23, j + 19, k + 6, 0);
        world.setBlock(i + 23, j + 19, k + 7, 0);
        world.setBlock(i + 23, j + 19, k + 8, 0);
        world.setBlock(i + 23, j + 19, k + 9, 0);
        world.setBlock(i + 23, j + 19, k + 10, 0);
        world.setBlock(i + 23, j + 19, k + 11, 0);
        world.setBlock(i + 23, j + 19, k + 12, 0);
        world.setBlock(i + 23, j + 19, k + 13, 0);
        world.setBlock(i + 23, j + 19, k + 14, 0);
        world.setBlock(i + 23, j + 19, k + 15, 0);
        world.setBlock(i + 23, j + 19, k + 16, 0);
        world.setBlock(i + 23, j + 19, k + 17, 0);
        world.setBlock(i + 23, j + 19, k + 18, 0);
        world.setBlock(i + 23, j + 19, k + 19, 0);
        world.setBlock(i + 23, j + 19, k + 20, 0);
        world.setBlock(i + 23, j + 19, k + 21, 0);
        world.setBlock(i + 23, j + 19, k + 22, 0);
        world.setBlock(i + 23, j + 19, k + 23, 0);
        generate12(world, rand, i, j, k);
        return true;
    }

    public boolean generate12(World world, Random rand, int i, int j, int k)
    {
        world.setBlock(i + 23, j + 19, k + 24, 0);
        world.setBlock(i + 23, j + 19, k + 25, 0);
        world.setBlock(i + 23, j + 19, k + 26, 0);
        world.setBlock(i + 23, j + 20, k + 0, 0);
        world.setBlock(i + 23, j + 20, k + 1, 0);
        world.setBlock(i + 23, j + 20, k + 2, 0);
        world.setBlock(i + 23, j + 20, k + 3, 0);
        world.setBlock(i + 23, j + 20, k + 4, 0);
        world.setBlock(i + 23, j + 20, k + 5, 0);
        world.setBlock(i + 23, j + 20, k + 6, 0);
        world.setBlock(i + 23, j + 20, k + 7, 0);
        world.setBlock(i + 23, j + 20, k + 8, 0);
        world.setBlock(i + 23, j + 20, k + 9, 0);
        world.setBlock(i + 23, j + 20, k + 10, 0);
        world.setBlock(i + 23, j + 20, k + 11, 0);
        world.setBlock(i + 23, j + 20, k + 12, 0);
        world.setBlock(i + 23, j + 20, k + 13, 0);
        world.setBlock(i + 23, j + 20, k + 14, 0);
        world.setBlock(i + 23, j + 20, k + 15, 0);
        world.setBlock(i + 23, j + 20, k + 16, 0);
        world.setBlock(i + 23, j + 20, k + 17, 0);
        world.setBlock(i + 23, j + 20, k + 18, 0);
        world.setBlock(i + 23, j + 20, k + 19, 0);
        world.setBlock(i + 23, j + 20, k + 20, 0);
        world.setBlock(i + 23, j + 20, k + 21, 0);
        world.setBlock(i + 23, j + 20, k + 22, 0);
        world.setBlock(i + 23, j + 20, k + 23, 0);
        world.setBlock(i + 23, j + 20, k + 24, 0);
        world.setBlock(i + 23, j + 20, k + 25, 0);
        world.setBlock(i + 23, j + 20, k + 26, 0);
        world.setBlock(i + 23, j + 21, k + 0, 0);
        world.setBlock(i + 23, j + 21, k + 1, 0);
        world.setBlock(i + 23, j + 21, k + 2, 0);
        world.setBlock(i + 23, j + 21, k + 3, 0);
        world.setBlock(i + 23, j + 21, k + 4, 0);
        world.setBlock(i + 23, j + 21, k + 5, 0);
        world.setBlock(i + 23, j + 21, k + 6, 0);
        world.setBlock(i + 23, j + 21, k + 7, 0);
        world.setBlock(i + 23, j + 21, k + 8, 0);
        world.setBlock(i + 23, j + 21, k + 9, 0);
        world.setBlock(i + 23, j + 21, k + 10, 0);
        world.setBlock(i + 23, j + 21, k + 11, 0);
        world.setBlock(i + 23, j + 21, k + 12, 0);
        world.setBlock(i + 23, j + 21, k + 13, 0);
        world.setBlock(i + 23, j + 21, k + 14, 0);
        world.setBlock(i + 23, j + 21, k + 15, 0);
        world.setBlock(i + 23, j + 21, k + 16, 0);
        world.setBlock(i + 23, j + 21, k + 17, 0);
        world.setBlock(i + 23, j + 21, k + 18, 0);
        world.setBlock(i + 23, j + 21, k + 19, 0);
        world.setBlock(i + 23, j + 21, k + 20, 0);
        world.setBlock(i + 23, j + 21, k + 21, 0);
        world.setBlock(i + 23, j + 21, k + 22, 0);
        world.setBlock(i + 23, j + 21, k + 23, 0);
        world.setBlock(i + 23, j + 21, k + 24, 0);
        world.setBlock(i + 23, j + 21, k + 25, 0);
        world.setBlock(i + 23, j + 21, k + 26, 0);
        world.setBlock(i + 23, j + 22, k + 0, 0);
        world.setBlock(i + 23, j + 22, k + 1, 0);
        world.setBlock(i + 23, j + 22, k + 2, 0);
        world.setBlock(i + 23, j + 22, k + 3, 0);
        world.setBlock(i + 23, j + 22, k + 4, 0);
        world.setBlock(i + 23, j + 22, k + 5, 0);
        world.setBlock(i + 23, j + 22, k + 6, 0);
        world.setBlock(i + 23, j + 22, k + 7, 0);
        world.setBlock(i + 23, j + 22, k + 8, 0);
        world.setBlock(i + 23, j + 22, k + 9, 0);
        world.setBlock(i + 23, j + 22, k + 10, 0);
        world.setBlock(i + 23, j + 22, k + 11, 0);
        world.setBlock(i + 23, j + 22, k + 12, 0);
        world.setBlock(i + 23, j + 22, k + 13, 0);
        world.setBlock(i + 23, j + 22, k + 14, 0);
        world.setBlock(i + 23, j + 22, k + 15, 0);
        world.setBlock(i + 23, j + 22, k + 16, 0);
        world.setBlock(i + 23, j + 22, k + 17, 0);
        world.setBlock(i + 23, j + 22, k + 18, 0);
        world.setBlock(i + 23, j + 22, k + 19, 0);
        world.setBlock(i + 23, j + 22, k + 20, 0);
        world.setBlock(i + 23, j + 22, k + 21, 0);
        world.setBlock(i + 23, j + 22, k + 22, 0);
        world.setBlock(i + 23, j + 22, k + 23, 0);
        world.setBlock(i + 23, j + 22, k + 24, 0);
        world.setBlock(i + 23, j + 22, k + 25, 0);
        world.setBlock(i + 23, j + 22, k + 26, 0);
        world.setBlock(i + 23, j + 23, k + 0, 0);
        world.setBlock(i + 23, j + 23, k + 1, 0);
        world.setBlock(i + 23, j + 23, k + 2, 0);
        world.setBlock(i + 23, j + 23, k + 3, 0);
        world.setBlock(i + 23, j + 23, k + 4, 0);
        world.setBlock(i + 23, j + 23, k + 5, 0);
        world.setBlock(i + 23, j + 23, k + 6, 0);
        world.setBlock(i + 23, j + 23, k + 7, 0);
        world.setBlock(i + 23, j + 23, k + 8, 0);
        world.setBlock(i + 23, j + 23, k + 9, 0);
        world.setBlock(i + 23, j + 23, k + 10, 0);
        world.setBlock(i + 23, j + 23, k + 11, 0);
        world.setBlock(i + 23, j + 23, k + 12, 0);
        world.setBlock(i + 23, j + 23, k + 13, 0);
        world.setBlock(i + 23, j + 23, k + 14, 0);
        world.setBlock(i + 23, j + 23, k + 15, 0);
        world.setBlock(i + 23, j + 23, k + 16, 0);
        world.setBlock(i + 23, j + 23, k + 17, 0);
        world.setBlock(i + 23, j + 23, k + 18, 0);
        world.setBlock(i + 23, j + 23, k + 19, 0);
        world.setBlock(i + 23, j + 23, k + 20, 0);
        world.setBlock(i + 23, j + 23, k + 21, 0);
        world.setBlock(i + 23, j + 23, k + 22, 0);
        world.setBlock(i + 23, j + 23, k + 23, 0);
        world.setBlock(i + 23, j + 23, k + 24, 0);
        world.setBlock(i + 23, j + 23, k + 25, 0);
        world.setBlock(i + 23, j + 23, k + 26, 0);
        world.setBlock(i + 23, j + 24, k + 0, 0);
        world.setBlock(i + 23, j + 24, k + 1, 0);
        world.setBlock(i + 23, j + 24, k + 2, 0);
        world.setBlock(i + 23, j + 24, k + 3, 0);
        world.setBlock(i + 23, j + 24, k + 4, 0);
        world.setBlock(i + 23, j + 24, k + 5, 0);
        world.setBlock(i + 23, j + 24, k + 6, 0);
        world.setBlock(i + 23, j + 24, k + 7, 0);
        world.setBlock(i + 23, j + 24, k + 8, 0);
        world.setBlock(i + 23, j + 24, k + 9, 0);
        world.setBlock(i + 23, j + 24, k + 10, 0);
        world.setBlock(i + 23, j + 24, k + 11, 0);
        world.setBlock(i + 23, j + 24, k + 12, 0);
        world.setBlock(i + 23, j + 24, k + 13, 0);
        world.setBlock(i + 23, j + 24, k + 14, 0);
        world.setBlock(i + 23, j + 24, k + 15, 0);
        world.setBlock(i + 23, j + 24, k + 16, 0);
        world.setBlock(i + 23, j + 24, k + 17, 0);
        world.setBlock(i + 23, j + 24, k + 18, 0);
        world.setBlock(i + 23, j + 24, k + 19, 0);
        world.setBlock(i + 23, j + 24, k + 20, 0);
        world.setBlock(i + 23, j + 24, k + 21, 0);
        world.setBlock(i + 23, j + 24, k + 22, 0);
        world.setBlock(i + 23, j + 24, k + 23, 0);
        world.setBlock(i + 23, j + 24, k + 24, 0);
        world.setBlock(i + 23, j + 24, k + 25, 0);
        world.setBlock(i + 23, j + 24, k + 26, 0);
        world.setBlock(i + 23, j + 25, k + 0, 0);
        world.setBlock(i + 23, j + 25, k + 1, 0);
        world.setBlock(i + 23, j + 25, k + 2, 0);
        world.setBlock(i + 23, j + 25, k + 3, 0);
        world.setBlock(i + 23, j + 25, k + 4, 0);
        world.setBlock(i + 23, j + 25, k + 5, 0);
        world.setBlock(i + 23, j + 25, k + 6, 0);
        world.setBlock(i + 23, j + 25, k + 7, 0);
        world.setBlock(i + 23, j + 25, k + 8, 0);
        world.setBlock(i + 23, j + 25, k + 9, 0);
        world.setBlock(i + 23, j + 25, k + 10, 0);
        world.setBlock(i + 23, j + 25, k + 11, 0);
        world.setBlock(i + 23, j + 25, k + 12, 0);
        world.setBlock(i + 23, j + 25, k + 13, 0);
        world.setBlock(i + 23, j + 25, k + 14, 0);
        world.setBlock(i + 23, j + 25, k + 15, 0);
        world.setBlock(i + 23, j + 25, k + 16, 0);
        world.setBlock(i + 23, j + 25, k + 17, 0);
        world.setBlock(i + 23, j + 25, k + 18, 0);
        world.setBlock(i + 23, j + 25, k + 19, 0);
        world.setBlock(i + 23, j + 25, k + 20, 0);
        world.setBlock(i + 23, j + 25, k + 21, 0);
        world.setBlock(i + 23, j + 25, k + 22, 0);
        world.setBlock(i + 23, j + 25, k + 23, 0);
        world.setBlock(i + 23, j + 25, k + 24, 0);
        world.setBlock(i + 23, j + 25, k + 25, 0);
        world.setBlock(i + 23, j + 25, k + 26, 0);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 4, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 6, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 7, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 8, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 9, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 10, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 11, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 12, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 14, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 15, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 16, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 17, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 18, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 19, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 20, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 21, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 22, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 23, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 25, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 0, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 6, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 7, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 8, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 9, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 10, Block.tallGrass.blockID, 1);
        world.setBlock(i + 1, j + 3, k + 11, Block.mushroomBrown.blockID);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 12, Block.tallGrass.blockID, 1);
        world.setBlock(i + 1, j + 3, k + 13, Block.mushroomBrown.blockID);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 16, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 17, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 18, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 21, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 22, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 23, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 1, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 2, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 2, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 2, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 2, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 3, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 3, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlock(i + 3, j + 3, k + 4, Block.mushroomBrown.blockID);
        world.setBlock(i + 3, j + 3, k + 6, Block.mushroomBrown.blockID);
        world.setBlockMetadataWithNotify(i + 3, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlock(i + 3, j + 10, k + 15, Block.doorWood.blockID, 3, 0);
        world.setBlock(i + 3, j + 11, k + 15, Block.doorWood.blockID, 11, 0);
        world.setBlockMetadataWithNotify(i + 4, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 4, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 4, j + 3, k + 25, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 4, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 5, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 5, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 5, j + 3, k + 3, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 5, j + 3, k + 25, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 5, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 6, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 6, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 6, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 6, j + 3, k + 3, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 6, j + 3, k + 25, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 6, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlock(i + 7, j + 3, k + 1, Block.plantYellow.blockID);
        world.setBlockMetadataWithNotify(i + 7, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 7, j + 3, k + 3, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 7, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 8, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 8, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 8, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 9, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 9, j + 3, k + 25, Block.tallGrass.blockID, 1);
        world.setBlock(i + 10, j + 3, k + 26, Block.plantYellow.blockID);
        world.setBlock(i + 11, j + 1, k + 2, Block.redstoneWire.blockID);
        world.setBlock(i + 11, j + 1, k + 3, Block.redstoneWire.blockID);
        world.setBlock(i + 11, j + 1, k + 5, Block.torchRedstoneActive.blockID, 0, 3);
        world.setBlock(i + 11, j + 3, k + 5, Block.doorIron.blockID, 4, 0);
        world.setBlockMetadataWithNotify(i + 11, j + 3, k + 25, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 11, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlock(i + 11, j + 4, k + 5, Block.doorIron.blockID, 12, 0);
        world.setBlock(i + 11, j + 16, k + 13, Block.doorWood.blockID, 4, 0);
        world.setBlock(i + 11, j + 16, k + 21, Block.doorWood.blockID, 3, 0);
        world.setBlock(i + 11, j + 17, k + 13, Block.doorWood.blockID, 12, 0);
        world.setBlock(i + 11, j + 17, k + 21, Block.doorWood.blockID, 11, 0);
        world.setBlock(i + 12, j + 1, k + 2, Block.torchRedstoneIdle.blockID, 2, 0);
        world.setBlock(i + 12, j + 3, k + 4, Block.pressurePlateStone.blockID);
        world.setBlock(i + 12, j + 3, k + 5, Block.doorIron.blockID, 1, 0);
        world.setBlock(i + 12, j + 3, k + 6, Block.pressurePlateStone.blockID);
        world.setBlockMetadataWithNotify(i + 12, j + 3, k + 25, Block.tallGrass.blockID, 1);
        world.setBlock(i + 12, j + 4, k + 5, Block.doorIron.blockID, 9, 0);
        world.setBlock(i + 12, j + 16, k + 13, Block.doorWood.blockID, 1, 0);
        world.setBlock(i + 12, j + 16, k + 21, Block.doorWood.blockID, 6, 0);
        world.setBlock(i + 12, j + 17, k + 13, Block.doorWood.blockID, 9, 0);
        world.setBlock(i + 12, j + 17, k + 21, Block.doorWood.blockID, 14, 0);
        world.setBlock(i + 13, j + 1, k + 3, Block.redstoneWire.blockID, 14, 0);
        world.setBlock(i + 13, j + 1, k + 4, Block.redstoneWire.blockID, 15, 0);
        world.setBlock(i + 13, j + 2, k + 4, Block.torchRedstoneActive.blockID, 0, 1);
        world.setBlockMetadataWithNotify(i + 13, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 13, j + 3, k + 25, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 14, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 14, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 14, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlock(i + 14, j + 3, k + 25, Block.mushroomBrown.blockID);
        world.setBlockMetadataWithNotify(i + 14, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlock(i + 14, j + 16, k + 15, Block.ladder.blockID, 3, 0);
        world.setBlock(i + 14, j + 17, k + 15, Block.ladder.blockID, 3, 0);
        world.setBlock(i + 14, j + 18, k + 15, Block.ladder.blockID, 3, 0);
        world.setBlock(i + 14, j + 19, k + 15, Block.ladder.blockID, 3, 0);
        world.setBlock(i + 14, j + 20, k + 15, Block.ladder.blockID, 3, 0);
        world.setBlock(i + 14, j + 21, k + 15, Block.trapdoor.blockID, 2, 0);
        world.setBlockMetadataWithNotify(i + 15, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlock(i + 15, j + 3, k + 1, Block.plantYellow.blockID);
        world.setBlockMetadataWithNotify(i + 15, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 15, j + 3, k + 3, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 15, j + 3, k + 4, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 15, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 16, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 16, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 16, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 16, j + 3, k + 3, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 16, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 17, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 17, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlock(i + 17, j + 3, k + 25, Block.plantYellow.blockID);
        world.setBlockMetadataWithNotify(i + 18, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 18, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 18, j + 3, k + 3, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 18, j + 3, k + 25, Block.tallGrass.blockID, 1);
        world.setBlock(i + 19, j + 3, k + 1, Block.plantYellow.blockID);
        world.setBlockMetadataWithNotify(i + 19, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 19, j + 3, k + 3, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 19, j + 3, k + 4, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 19, j + 3, k + 25, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 19, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 20, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 20, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlock(i + 20, j + 3, k + 2, Block.plantRed.blockID);
        world.setBlock(i + 20, j + 3, k + 3, Block.plantYellow.blockID);
        world.setBlockMetadataWithNotify(i + 20, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlock(i + 20, j + 10, k + 15, Block.doorWood.blockID, 6, 0);
        world.setBlock(i + 20, j + 11, k + 15, Block.doorWood.blockID, 14, 0);
        world.setBlockMetadataWithNotify(i + 21, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 21, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 21, j + 3, k + 3, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 1, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 3, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 6, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 7, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 8, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 9, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 11, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 12, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 13, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 16, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 17, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 18, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 21, Block.tallGrass.blockID, 1);
        world.setBlock(i + 22, j + 3, k + 22, Block.mushroomBrown.blockID);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 23, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 22, j + 3, k + 26, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 0, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 2, Block.tallGrass.blockID, 1);
        world.setBlock(i + 23, j + 3, k + 5, Block.plantYellow.blockID);
        world.setBlock(i + 23, j + 3, k + 6, Block.plantYellow.blockID);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 7, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 8, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 9, Block.tallGrass.blockID, 1);
        world.setBlock(i + 23, j + 3, k + 10, Block.plantYellow.blockID);
        world.setBlock(i + 23, j + 3, k + 11, Block.plantYellow.blockID);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 12, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 13, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 15, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 16, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 17, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 18, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 19, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 21, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 22, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 23, Block.tallGrass.blockID, 1);
        world.setBlockMetadataWithNotify(i + 23, j + 3, k + 25, Block.tallGrass.blockID, 1);
        world.setBlock(i + 23, j + 3, k + 26, Block.plantYellow.blockID);
        return true;
    }
}